#include "f2c.h"

struct {
    int nr, nw, nh, ic1, ic2, iw1[21], iw2[21], ir1[21], ir2[21];
} aicom_i__;

#define aicom_i__1 aicom_i__

// These arrays look horrendously large, but probably ok. -rs
struct {
    real rincr, wincr, rl[31], wl[41], hl[21], a[53382],
    /* was [31][41][21][2] */ 
    ar[53382]	/* was [31][41][21][2] */, aw[53382]	/* 
    was [31][41][21][2] */, ah[53382]	/* was [31][41][21][2] */, 
    arw[53382]	/* was [31][41][21][2] */, arh[53382]	/* was [31][
    41][21][2] */, awh[53382]	/* was [31][41][21][2] */, arwh[53382]
    /* was [31][41][21][2] */;
} aicom_r__;

#define aicom_r__1 aicom_r__

/* Table of constant values */

static int c__1 = 1;
static int c__9 = 9;
static int c__3 = 3;

int osmap_(
           real *rsp, 
           real *wsp, 
           real *hsp, 
           real *alfr, 
           real *alfr_r__, 
           real *alfr_w__, 
           real *alfr_h__, 
           real *alfrw_r__, 
           real *	alfrw_w__, 
           real *alfrw_h__, 
           real *alfi, 
           real *alfi_r__, 
           real *	alfi_w__, 
           real *alfi_h__, 
           real *alfiw_r__, 
           real *alfiw_w__, 
           real *	alfiw_h__, 
           logical *ok)
{
  /* Initialized data */

  static char osfile[128] = "~/usr32/lib/orrs/osmapDP.dat                 "
    "                                                                "
    "                   ";
  static logical loaded = FALSE_;
  static real al10 = 2.302585093f;

  /* System generated locals */
  int i__1, i__2, i__3, i__4;
  real r__1, r__2, r__3;
  olist o__1;
  cllist cl__1;

  /* Local variables */
  static real aintw_hl__, aintw_rl__, aintw_wl__, b[4]	/* was [2][2] */, 
  c__[2], a1, a2, b1, b2, c1, c2, bh[4]	/* was [2][2] */, 
    ch[2];
  static int ic, ih, jh;
  static real br[4]	/* was [2][2] */, cr[2], 
    bw[4]	/* was [2][2] */, cw[2];
  static int ir;
  static real th;
  static int kh, lu, iw, kw;
  static real tr;
  static int jw;
  static real tw, da1, da2, db1, db2, ah1, ah2, bh1, bh2, ch1, ch2, dc1, 
    dc2, ar1, ar2, br1, br2, cr1, aw1, aw2, bw1, bw2, cw1, cr2, cw2, 
    dhl, brh[4]	/* was [2][2] */, crh[2], 
    bwh[4]	/* was [2][2] */, cwh[2], drl, dwl, 
    brw[4]	/* was [2][2] */, crw[2], dah1, dah2, dch1, dch2, 
    dbr1, dbr2, dcr1, arh1, arh2, daw1, daw2, 
    brh1, awh1, awh2, bwh1, brh2, bwh2, dbw1, dbw2, crh1, cwh1, crh2, 
    arw1, arw2, brw1, brw2, crw1, crw2, cwh2, dcr2;
  static int ir1x, ir2x, iw1x, iw2x;
  static real aint[2], brwh[4]	/* was [2][2] */, crwh[2], hlsp, rlsp,
    wlsp, dawh1, dawh2, dbrw1, dbrw2, arwh1, arwh2, brwh1, brwh2, 
    crwh1, crwh2, aint_h__[2], aint_r__[2], aint_w__[2], aint_hl__, 
    aintw_h__[2], aint_rl__, aint_wl__, aintw_r__[2], aintw_w__[2];

  /* Fortran I/O blocks */
  static cilist io___5 = { 0, 0, 0, 0, 0 };
  static cilist io___6 = { 0, 6, 0, 0, 0 };
  static cilist io___7 = { 0, 6, 0, 0, 0 };
  static cilist io___8 = { 0, 6, 0, 0, 0 };
  static cilist io___9 = { 0, 6, 0, 0, 0 };
  static cilist io___10 = { 0, 0, 0, 0, 0 };
  static cilist io___12 = { 0, 0, 0, 0, 0 };
  static cilist io___14 = { 0, 0, 0, 0, 0 };
  static cilist io___16 = { 0, 0, 0, 0, 0 };
  static cilist io___18 = { 0, 0, 1, 0, 0 };
  static cilist io___19 = { 0, 0, 0, 0, 0 };
  static cilist io___20 = { 0, 0, 0, 0, 0 };
  static cilist io___21 = { 0, 0, 0, 0, 0 };
  static cilist io___22 = { 0, 0, 0, 0, 0 };
  static cilist io___23 = { 0, 0, 0, 0, 0 };
  static cilist io___24 = { 0, 0, 0, 0, 0 };
  static cilist io___25 = { 0, 0, 0, 0, 0 };
  static cilist io___142 = { 0, 6, 0, 0, 0 };
  static cilist io___143 = { 0, 6, 0, 0, 0 };
  static cilist io___144 = { 0, 6, 0, 0, 0 };

/*     Returns real and imaginary parts of complex wavenumber (Alpha) */
/*     eigenvalue from Orr-Sommerfeld spatial-stability solution */
/*     with mean profiles characterized by shape parameter H. */
/*     Also returns the sensitivities of Alpha with respect to the */
/*     input parameters. */

/*     The eigenvalue Alpha(Rtheta,W,H) is stored as a 3-D array at */
/*     discrete points, which is then interpolated to any (Rtheta,W,H) */
/*     via a tricubic spline.  The spline coordinates actually used are: */

/*       RL = log10(Rtheta) */
/*       WL = log10(W) + 0.5 log10(Rtheta) */
/*       HL = H */


/*      Input: */
/*      ------ */
/*        RSP      momentum thickness Reynolds number  Rtheta = Theta Ue / v */
/*        WSP      normalized disturbance frequency         W = w Theta/Ue */
/*        HSP      shape parameter of mean profile          H = Dstar/Theta */

/*      Output: */
/*      ------- */
/*        ALFR     real part of complex wavenumber * Theta */
/*        ALFR_R   d(ALFR)/dRtheta */
/*        ALFR_W   d(ALFR)/dW */
/*        ALFR_H   d(ALFR)/dH */
/*        ALFRW_R  d(dALFR/dW)/dRtheta */
/*        ALFRW_W  d(dALFR/dW)/dW */
/*        ALFRW_H  d(dALFR/dW)/dH */

/*        ALFI     imag part of complex wavenumber * Theta */
/*        ALFI_R   d(ALFI)/dRtheta */
/*        ALFI_W   d(ALFI)/dW */
/*        ALFI_H   d(ALFI)/dH */
/*        ALFIW_R  d(dALFI/dW)/dRtheta */
/*        ALFIW_W  d(dALFI/dW)/dW */
/*        ALFIW_H  d(dALFI/dW)/dH */

/*        OK     T  if look up was successful; all values returned are valid */
/*               F  if point fell outside (RL,WL) spline domain limits; */
/*                  all values (ALFR, ALFR_R, etc.) are returned as zero. */
/*                  Exception: If points only falls outside HL spline limits, */
/*                  then the HL limit is used and an ALFR value is calculated, */
/*                  but OK is still returned as F. */

  if (loaded) 
  {
    goto L9;
  }

  /* ---- first time OSMAP is called ... load in 3-D spline data */

  aicom_i__1.nr = 0;
  aicom_i__1.nw = 0;
  aicom_i__1.nh = 0;
  lu = 31;
  o__1.oerr = 1;
  o__1.ounit = lu;
  o__1.ofnmlen = 128;
  o__1.ofnm = osfile;
  o__1.orl = 0;
  o__1.osta = "OLD";
  o__1.oacc = 0;
  o__1.ofm = "UNFORMATTED";
  o__1.oblnk = 0;
  i__1 = f_open(&o__1);
  if (i__1 != 0) 
  {
  	goto L900;
  }

  io___5.ciunit = lu;
  s_rsue(&io___5);
  do_uio(&c__1, (char *)&aicom_i__1.nr, (ftnlen)sizeof(int));
  do_uio(&c__1, (char *)&aicom_i__1.nw, (ftnlen)sizeof(int));
  do_uio(&c__1, (char *)&aicom_i__1.nh, (ftnlen)sizeof(int));
  e_rsue();

  if (aicom_i__1.nr > 31 || aicom_i__1.nw > 41 || aicom_i__1.nh > 21) 
  {
    s_wsle(&io___6);
    do_lio(&c__9, &c__1, "OSMAP: Array limit exceeded.", (ftnlen)28);
    e_wsle();
  	if (aicom_i__1.nr > 31) 
    {
	    s_wsle(&io___7);
	    do_lio(&c__9, &c__1, "       Increase NRX to", (ftnlen)22);
      do_lio(&c__3, &c__1, (char *)&aicom_i__1.nr, (ftnlen)sizeof(int));
	    e_wsle();
    }
    if (aicom_i__1.nw > 41) {
      s_wsle(&io___8);
      do_lio(&c__9, &c__1, "       Increase NWX to", (ftnlen)22);
      do_lio(&c__3, &c__1, (char *)&aicom_i__1.nw, (ftnlen)sizeof(int));
      e_wsle();
    }

    if (aicom_i__1.nh > 21) {
      s_wsle(&io___9);
      do_lio(&c__9, &c__1, "       Increase NHX to", (ftnlen)22);
      do_lio(&c__3, &c__1, (char *)&aicom_i__1.nh, (ftnlen)sizeof(int));
      e_wsle();
    }

    s_stop("", (ftnlen)0);
  }

  io___10.ciunit = lu;
  s_rsue(&io___10);
  i__1 = aicom_i__1.nr;
  for (ir = 1; ir <= i__1; ++ir) {
    do_uio(&c__1, (char *)&aicom_r__1.rl[ir - 1], (ftnlen)sizeof(real));
  }
  e_rsue();
  /*<       READ(LU) (WL(IW), IW=1,NW) >*/
  io___12.ciunit = lu;
  s_rsue(&io___12);
  i__1 = aicom_i__1.nw;
  for (iw = 1; iw <= i__1; ++iw) {
    do_uio(&c__1, (char *)&aicom_r__1.wl[iw - 1], (ftnlen)sizeof(real));
  }
  e_rsue();
  /*<       READ(LU) (HL(IH), IH=1,NH) >*/
  io___14.ciunit = lu;
  s_rsue(&io___14);
  i__1 = aicom_i__1.nh;
  for (ih = 1; ih <= i__1; ++ih) {
    do_uio(&c__1, (char *)&aicom_r__1.hl[ih - 1], (ftnlen)sizeof(real));
  }
  e_rsue();
  /*<       READ(LU) (IR1(IH),IR2(IH),IW1(IH),IW2(IH), IH=1,NH) >*/
  io___16.ciunit = lu;
  s_rsue(&io___16);
  i__1 = aicom_i__1.nh;
  for (ih = 1; ih <= i__1; ++ih) {
    do_uio(&c__1, (char *)&aicom_i__1.ir1[ih - 1], (ftnlen)sizeof(int)
          );
    do_uio(&c__1, (char *)&aicom_i__1.ir2[ih - 1], (ftnlen)sizeof(int)
          );
    do_uio(&c__1, (char *)&aicom_i__1.iw1[ih - 1], (ftnlen)sizeof(int)
          );
    do_uio(&c__1, (char *)&aicom_i__1.iw2[ih - 1], (ftnlen)sizeof(int)
          );
  }
  e_rsue();

  for (ic = 2; ic >= 1; --ic) {
    i__1 = aicom_i__1.nh;
    for (ih = 1; ih <= i__1; ++ih) {
      i__2 = aicom_i__1.iw2[ih - 1];
      for (iw = aicom_i__1.iw1[ih - 1]; iw <= i__2; ++iw) {
        io___18.ciunit = lu;
        i__3 = s_rsue(&io___18);
        if (i__3 != 0) {
          goto L5;
        }
        i__4 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__4; ++ir) {
          i__3 = do_uio(&c__1, (char *)&aicom_r__1.a[ir + (iw + (ih 
              + ic * 21) * 41) * 31 - 27994], (ftnlen)sizeof(
                                               real));
          if (i__3 != 0) {
            goto L5;
          }
        }
        i__3 = e_rsue();
        if (i__3 != 0) {
          goto L5;
        }
        io___19.ciunit = lu;
        s_rsue(&io___19);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.ar[ir + (iw + (ih + ic *
                21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___20.ciunit = lu;
        s_rsue(&io___20);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.aw[ir + (iw + (ih + ic *
                21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___21.ciunit = lu;
        s_rsue(&io___21);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.ah[ir + (iw + (ih + ic *
                21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___22.ciunit = lu;
        s_rsue(&io___22);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.arw[ir + (iw + (ih + ic 
                * 21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___23.ciunit = lu;
        s_rsue(&io___23);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.arh[ir + (iw + (ih + ic 
                * 21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___24.ciunit = lu;
        s_rsue(&io___24);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.awh[ir + (iw + (ih + ic 
                * 21) * 41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_rsue();

        io___25.ciunit = lu;
        s_rsue(&io___25);
        i__3 = aicom_i__1.ir2[ih - 1];
        for (ir = aicom_i__1.ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aicom_r__1.arwh[ir + (iw + (ih + 
                ic * 21) * 41) * 31 - 27994], (ftnlen)sizeof(real)
                );
        }
        e_rsue();
      }
    }
  }

L5:
    if (ih < aicom_i__1.nh) {
  /* ----- only imaginary part is available */
  aicom_i__1.ic1 = 2;
  aicom_i__1.ic2 = 2;
    } else {
      /* ----- both real and imaginary parts available */
      aicom_i__1.ic1 = 1;
      aicom_i__1.ic2 = 2;
    }
    cl__1.cerr = 0;
    cl__1.cunit = lu;
    cl__1.csta = 0;
    f_clos(&cl__1);


    aicom_r__1.rincr = (aicom_r__1.rl[aicom_i__1.nr - 1] - aicom_r__1.rl[0]) /
        (real) (aicom_i__1.nr - 1);

    aicom_r__1.wincr = (aicom_r__1.wl[aicom_i__1.nw - 1] - aicom_r__1.wl[0]) /
        (real) (aicom_i__1.nw - 1);

    loaded = TRUE_;
L9:


    /* ---- set returned variables in case of out-of-limits error */
    *alfr = 0.f;

    *alfr_r__ = 0.f;
    *alfr_w__ = 0.f;
    *alfr_h__ = 0.f;
    *alfrw_r__ = 0.f;
    *alfrw_w__ = 0.f;
    *alfrw_h__ = 0.f;

    *alfi = 0.f;
    *alfi_r__ = 0.f;
    *alfi_w__ = 0.f;
    *alfi_h__ = 0.f;
    *alfiw_r__ = 0.f;
    *alfiw_w__ = 0.f;
    *alfiw_h__ = 0.f;

    if (aicom_i__1.nr == 0 || aicom_i__1.nw == 0 || aicom_i__1.nh == 0) {
      /* ----- map not available for some reason (OPEN or READ error on osmap.dat?) */
      *ok = FALSE_;
      return 0;
    }

    /* ---- define specified spline coordinates */
    rlsp = r_lg10(rsp);
    wlsp = r_lg10(wsp) + rlsp * .5f;
    hlsp = *hsp;

    /* ---- assume map limits will not be exceeded */
    *ok = TRUE_;

    /* ---- find H interval */
    i__1 = aicom_i__1.nh;
    for (ih = 2; ih <= i__1; ++ih) {
      if (aicom_r__1.hl[ih - 1] >= hlsp) {
        goto L11;
      }
    }
    ih = aicom_i__1.nh;
L11:

    if (hlsp < aicom_r__1.hl[0] || hlsp > aicom_r__1.hl[aicom_i__1.nh - 1]) {
  /* Computing MAX */
  /* Computing MIN */
  r__3 = aicom_r__1.hl[aicom_i__1.nh - 1];
  r__1 = aicom_r__1.hl[0], r__2 = dmin(r__3,hlsp);
  hlsp = dmax(r__1,r__2);
    }

    /* ---- find R interval */
    ir = (int) ((rlsp - aicom_r__1.rl[0]) / aicom_r__1.rincr + 2.001f);
    /* Computing MAX */
    i__1 = aicom_i__1.ir1[ih - 1], i__2 = aicom_i__1.ir1[ih - 2];
    ir1x = max(i__1,i__2);
    /* Computing MIN */
    i__1 = aicom_i__1.ir2[ih - 1], i__2 = aicom_i__1.ir2[ih - 2];
    ir2x = min(i__1,i__2);
    if (ir - 1 < ir1x || ir > ir2x) {
      *ok = FALSE_;
      /* Computing MAX */
      i__1 = ir1x + 1, i__2 = min(ir2x,ir);
      ir = max(i__1,i__2);
      /*<        RLSP = MAX( RL(1) , MIN( RL(NR) , RLSP ) ) >*/
      /* Computing MAX */
      /* Computing MIN */
      r__3 = aicom_r__1.rl[aicom_i__1.nr - 1];
      r__1 = aicom_r__1.rl[0], r__2 = dmin(r__3,rlsp);
      rlsp = dmax(r__1,r__2);
    }

    /* ---- find W interval */
    iw = (int) ((wlsp - aicom_r__1.wl[0]) / aicom_r__1.wincr + 2.001f);
    /* Computing MAX */
    i__1 = aicom_i__1.iw1[ih - 1], i__2 = aicom_i__1.iw1[ih - 2];
    iw1x = max(i__1,i__2);
    /* Computing MIN */
    i__1 = aicom_i__1.iw2[ih - 1], i__2 = aicom_i__1.iw2[ih - 2];
    iw2x = min(i__1,i__2);
    
    if (iw - 1 < iw1x || iw > iw2x) {
      *ok = FALSE_;
      /* Computing MAX */
      i__1 = iw1x + 1, i__2 = min(iw2x,iw);
      iw = max(i__1,i__2);

      /* Computing MAX */
      /* Computing MIN */
      r__3 = aicom_r__1.wl[aicom_i__1.nw - 1];
      r__1 = aicom_r__1.wl[0], r__2 = dmin(r__3,wlsp);
      wlsp = dmax(r__1,r__2);
    }

    drl = aicom_r__1.rl[ir - 1] - aicom_r__1.rl[ir - 2];
    dwl = aicom_r__1.wl[iw - 1] - aicom_r__1.wl[iw - 2];
    dhl = aicom_r__1.hl[ih - 1] - aicom_r__1.hl[ih - 2];
    tr = (rlsp - aicom_r__1.rl[ir - 2]) / drl;
    tw = (wlsp - aicom_r__1.wl[iw - 2]) / dwl;
    th = (hlsp - aicom_r__1.hl[ih - 2]) / dhl;

    /* Computing MAX */
    r__1 = 0.f, r__2 = dmin(1.f,tr);
    tr = dmax(r__1,r__2);
    /* Computing MAX */
    r__1 = 0.f, r__2 = dmin(1.f,tw);
    tw = dmax(r__1,r__2);
    /* Computing MAX */
    r__1 = 0.f, r__2 = dmin(1.f,th);
    th = dmax(r__1,r__2);

    /* ---- compute real and imaginary parts */
    i__1 = aicom_i__1.ic2;
    for (ic = aicom_i__1.ic1; ic <= i__1; ++ic) {

      /* ---- evaluate spline in Rtheta at the corners of HL,WL cell */
      for (kh = 1; kh <= 2; ++kh) {
        jh = ih + kh - 2;
        for (kw = 1; kw <= 2; ++kw) {
          jw = iw + kw - 2;
          a1 = aicom_r__1.a[ir - 1 + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          ar1 = aicom_r__1.ar[ir - 1 + (jw + (jh + ic * 21) * 41) * 31 
              - 27994];
          aw1 = aicom_r__1.aw[ir - 1 + (jw + (jh + ic * 21) * 41) * 31 
              - 27994];
          ah1 = aicom_r__1.ah[ir - 1 + (jw + (jh + ic * 21) * 41) * 31 
              - 27994];
          arw1 = aicom_r__1.arw[ir - 1 + (jw + (jh + ic * 21) * 41) * 
              31 - 27994];
          arh1 = aicom_r__1.arh[ir - 1 + (jw + (jh + ic * 21) * 41) * 
              31 - 27994];
          awh1 = aicom_r__1.awh[ir - 1 + (jw + (jh + ic * 21) * 41) * 
              31 - 27994];
          arwh1 = aicom_r__1.arwh[ir - 1 + (jw + (jh + ic * 21) * 41) * 
              31 - 27994];

          a2 = aicom_r__1.a[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          ar2 = aicom_r__1.ar[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          aw2 = aicom_r__1.aw[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          ah2 = aicom_r__1.ah[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          arw2 = aicom_r__1.arw[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          arh2 = aicom_r__1.arh[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          awh2 = aicom_r__1.awh[ir + (jw + (jh + ic * 21) * 41) * 31 - 
              27994];
          arwh2 = aicom_r__1.arwh[ir + (jw + (jh + ic * 21) * 41) * 31 
              - 27994];

          da1 = drl * ar1 - a2 + a1;
          da2 = drl * ar2 - a2 + a1;
          daw1 = drl * arw1 - aw2 + aw1;
          daw2 = drl * arw2 - aw2 + aw1;
          dah1 = drl * arh1 - ah2 + ah1;
          dah2 = drl * arh2 - ah2 + ah1;
          dawh1 = drl * arwh1 - awh2 + awh1;
          dawh2 = drl * arwh2 - awh2 + awh1;

          /* -------- set  ALFI, dALFI/dWL, dALFI/dHL, d2ALFI/dHLdWL */
          b[kw + (kh << 1) - 3] = (1.f - tr) * a1 + tr * a2 + ((1.f - 
              tr) * da1 - tr * da2) * (tr - tr * tr);
          bw[kw + (kh << 1) - 3] = (1.f - tr) * aw1 + tr * aw2 + ((1.f 
              - tr) * daw1 - tr * daw2) * (tr - tr * tr);
          bh[kw + (kh << 1) - 3] = (1.f - tr) * ah1 + tr * ah2 + ((1.f 
              - tr) * dah1 - tr * dah2) * (tr - tr * tr);
          bwh[kw + (kh << 1) - 3] = (1.f - tr) * awh1 + tr * awh2 + ((
                    1.f - tr) * dawh1 - tr * dawh2) * (tr - tr * tr);

          /* -------- also, the RL derivatives of the quantities above */
          br[kw + (kh << 1) - 3] = (a2 - a1 + (1.f - tr * 4.f + tr * 
              3.f * tr) * da1 + (tr * 3.f - 2.f) * tr * da2) / drl;
          brw[kw + (kh << 1) - 3] = (aw2 - aw1 + (1.f - tr * 4.f + tr * 
              3.f * tr) * daw1 + (tr * 3.f - 2.f) * tr * daw2) / 
              drl;
          brh[kw + (kh << 1) - 3] = (ah2 - ah1 + (1.f - tr * 4.f + tr * 
              3.f * tr) * dah1 + (tr * 3.f - 2.f) * tr * dah2) / 
              drl;
          brwh[kw + (kh << 1) - 3] = (awh2 - awh1 + (1.f - tr * 4.f + 
              tr * 3.f * tr) * dawh1 + (tr * 3.f - 2.f) * tr * 
              dawh2) / drl;

        }
      }

      /* ---- evaluate spline in  HL  at the two WL-interval endpoints */
      for (kw = 1; kw <= 2; ++kw) {
        b1 = b[kw - 1];
        br1 = br[kw - 1];
        bw1 = bw[kw - 1];
        bh1 = bh[kw - 1];
        brw1 = brw[kw - 1];
        brh1 = brh[kw - 1];
        bwh1 = bwh[kw - 1];
        brwh1 = brwh[kw - 1];

        b2 = b[kw + 1];
        br2 = br[kw + 1];
        bw2 = bw[kw + 1];
        bh2 = bh[kw + 1];
        brw2 = brw[kw + 1];
        brh2 = brh[kw + 1];
        bwh2 = bwh[kw + 1];
        brwh2 = brwh[kw + 1];

        db1 = dhl * bh1 - b2 + b1;
        db2 = dhl * bh2 - b2 + b1;
        dbr1 = dhl * brh1 - br2 + br1;
        dbr2 = dhl * brh2 - br2 + br1;
        dbw1 = dhl * bwh1 - bw2 + bw1;
        dbw2 = dhl * bwh2 - bw2 + bw1;
        dbrw1 = dhl * brwh1 - brw2 + brw1;
        dbrw2 = dhl * brwh2 - brw2 + brw1;

        /* ------ set  ALFI, dALFI/dRL, dALFI/dWL */
        c__[kw - 1] = (1.f - th) * b1 + th * b2 + ((1.f - th) * db1 - th *
            db2) * (th - th * th);
        cr[kw - 1] = (1.f - th) * br1 + th * br2 + ((1.f - th) * dbr1 - 
            th * dbr2) * (th - th * th);
        cw[kw - 1] = (1.f - th) * bw1 + th * bw2 + ((1.f - th) * dbw1 - 
            th * dbw2) * (th - th * th);
        crw[kw - 1] = (1.f - th) * brw1 + th * brw2 + ((1.f - th) * dbrw1 
            - th * dbrw2) * (th - th * th);

        /* ------ also, the HL derivatives of the quantities above */
        ch[kw - 1] = (b2 - b1 + (1.f - th * 4.f + th * 3.f * th) * db1 + (
                      th * 3.f - 2.f) * th * db2) / dhl;
        crh[kw - 1] = (br2 - br1 + (1.f - th * 4.f + th * 3.f * th) * 
            dbr1 + (th * 3.f - 2.f) * th * dbr2) / dhl;
        cwh[kw - 1] = (bw2 - bw1 + (1.f - th * 4.f + th * 3.f * th) * 
            dbw1 + (th * 3.f - 2.f) * th * dbw2) / dhl;
        crwh[kw - 1] = (brw2 - brw1 + (1.f - th * 4.f + th * 3.f * th) * 
            dbrw1 + (th * 3.f - 2.f) * th * dbrw2) / dhl;
      }

      /* ---- evaluate cubic in  WL */
      c1 = c__[0];
      cr1 = cr[0];
      cw1 = cw[0];
      ch1 = ch[0];
      crw1 = crw[0];
      crh1 = crh[0];
      cwh1 = cwh[0];
      crwh1 = crwh[0];

      c2 = c__[1];
      cr2 = cr[1];
      cw2 = cw[1];
      ch2 = ch[1];
      crw2 = crw[1];
      crh2 = crh[1];
      cwh2 = cwh[1];
      crwh2 = crwh[1];

      dc1 = dwl * cw1 - c2 + c1;
      dc2 = dwl * cw2 - c2 + c1;
      dch1 = dwl * cwh1 - ch2 + ch1;
      dch2 = dwl * cwh2 - ch2 + ch1;
      dcr1 = dwl * crw1 - cr2 + cr1;
      dcr2 = dwl * crw2 - cr2 + cr1;
      /* C    DCRH1 = DWL*CRWH1 - CRH2 + CRH1 */
      /* C    DCRH2 = DWL*CRWH2 - CRH2 + CRH1 */

      /* ---- set  AINT, dAINT/dRL, dAINT/dHL */
      aint[ic - 1] = (1.f - tw) * c1 + tw * c2 + ((1.f - tw) * dc1 - tw * 
          dc2) * (tw - tw * tw);
      aint_rl__ = (1.f - tw) * cr1 + tw * cr2 + ((1.f - tw) * dcr1 - tw * 
          dcr2) * (tw - tw * tw);
      aint_hl__ = (1.f - tw) * ch1 + tw * ch2 + ((1.f - tw) * dch1 - tw * 
          dch2) * (tw - tw * tw);

      /* ---- also, the WL derivatives of the quantities above */
      aint_wl__ = (c2 - c1 + (1.f - tw * 4.f + tw * 3.f * tw) * dc1 + (tw * 
          3.f - 2.f) * tw * dc2) / dwl;
      aintw_rl__ = (cr2 - cr1 + (1.f - tw * 4.f + tw * 3.f * tw) * dcr1 + (
                    tw * 3.f - 2.f) * tw * dcr2) / dwl;
      aintw_hl__ = (ch2 - ch1 + (1.f - tw * 4.f + tw * 3.f * tw) * dch1 + (
                    tw * 3.f - 2.f) * tw * dch2) / dwl;

      /* Computing 2nd power */
      r__1 = dwl;
      aintw_wl__ = ((tw * 6.f - 4.f) * dc1 + (tw * 6.f - 2.f) * dc2) / (
                     r__1 * r__1);

      /* ---- convert derivatives wrt to spline coordinates (RL,WL,HL) into */
      /* -    derivatives wrt input variables (Rtheta,f,H) */
      aint_r__[ic - 1] = (aint_rl__ + aint_wl__ * .5f) / (al10 * *rsp);
      aint_w__[ic - 1] = aint_wl__ / (al10 * *wsp);
      aint_h__[ic - 1] = aint_hl__;

      /* Computing 2nd power */
      r__1 = al10;
      aintw_r__[ic - 1] = (aintw_rl__ + aintw_wl__ * .5f) / (r__1 * r__1 * *
          wsp * *rsp);
      r__1 = al10;
      aintw_w__[ic - 1] = (aintw_wl__ - al10 * aint_wl__) / (r__1 * r__1 * *
          wsp * *wsp);
      aintw_h__[ic - 1] = aintw_hl__ / (al10 * *wsp);
    }

  *alfr = aint[0];
  *alfr_r__ = aint_r__[0];
  *alfr_w__ = aint_w__[0];
  *alfr_h__ = aint_h__[0];
  *alfrw_r__ = aintw_r__[0];
  *alfrw_w__ = aintw_w__[0];
  *alfrw_h__ = aintw_h__[0];

  *alfi = aint[1];
  *alfi_r__ = aint_r__[1];
  *alfi_w__ = aint_w__[1];
  *alfi_h__ = aint_h__[1];
  *alfiw_r__ = aintw_r__[1];
  *alfiw_w__ = aintw_w__[1];
  *alfiw_h__ = aintw_h__[1];

  /* ---- if we're within the spline data space, the derivatives are valid */
  if (*ok) {
    return 0;
  }

  /* ---- if not, the  ai  value is clamped, and its derivatives are zero */
  *alfr_r__ = 0.f;
  *alfr_w__ = 0.f;
  *alfr_h__ = 0.f;
  *alfrw_r__ = 0.f;
  *alfrw_w__ = 0.f;
  *alfrw_h__ = 0.f;

  *alfi_r__ = 0.f;
  *alfi_w__ = 0.f;
  *alfi_h__ = 0.f;
  *alfiw_r__ = 0.f;
  *alfiw_w__ = 0.f;
  *alfiw_h__ = 0.f;

  return 0;

L900:
  /* ---- pick up here for file open error */
  s_wsle(&io___142);
  e_wsle();
  s_wsle(&io___143);
  do_lio(&c__9, &c__1, "OSMAP:  OS database file not found: ", (ftnlen)36);
  do_lio(&c__9, &c__1, osfile, (ftnlen)128);
  e_wsle();
  s_wsle(&io___144);
  do_lio(&c__9, &c__1, "        Will return zero amplification rates", (
          ftnlen)44);
  e_wsle();

  /* ---- assume file is loaded so the above error message doesn't appear again */
  loaded = TRUE_;
  *ok = FALSE_;

  return 0;
} /* osmap_ */

