/* f/gw_subs.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lprim_open__;
} pl_priml__;

#define pl_priml__1 pl_priml__

struct {
    int nprim_unit__, n_prim__, n_writ__, n_incore__, i_typ__[100000], 
	    i_prim__[100000];
} pl_primi__;

#define pl_primi__1 pl_primi__

struct {
    real x_prim__[100000], y_prim__[100000];
} pl_primr__;

#define pl_primr__1 pl_primr__

struct {
    int i_dev__, i_pagetype__, i_pen__, lst_pen__, i_pat__, lst_pat__, 
	    i_clr__, lst_clr__;
} pl_ploti__;

#define pl_ploti__1 pl_ploti__

struct {
    real x_scale__, y_scale__, x_org__, y_org__, x_lst__, y_lst__, x_page__, 
	    y_page__, x_wind__, y_wind__, clp_xmin__, clp_xmax__, clp_ymin__, 
	    clp_ymax__, xoff_zoom__, yoff_zoom__, xfac_zoom__, yfac_zoom__;
} pl_plotr__;

#define pl_plotr__1 pl_plotr__

struct {
    int n_color__, n_spectrum__, ifirst_spectrum__, color_rgb__[256];
} pl_colori__;

#define pl_colori__1 pl_colori__

struct {
    char color_name__[5632];
} pl_colorc__;

#define pl_colorc__1 pl_colorc__

struct {
    logical lgw_gen__, lgw_open__, lgw_color__, lgw_revvideo__, lgw_changed__,
	     lgw_resize__;
} pl_xwinl__;

#define pl_xwinl__1 pl_xwinl__

struct {
    int gx_loc__, gy_loc__, gx_org__, gy_org__, gx_siz__, gy_siz__, 
	    gx_crs__, gy_crs__, g_width__, g_height__, g_depth__, 
	    g_color_cindex__[256];
} pl_xwini__;

#define pl_xwini__1 pl_xwini__

struct {
    real g_scale__, g_scrnfrac__;
} pl_xwinr__;

#define pl_xwinr__1 pl_xwinr__

struct {
    logical lps_gen__, lps_open__, lps_color__, lps_unstroked__, 
	    lps_external__, lps_onefile__;
} pl_psl__;

#define pl_psl__1 pl_psl__

struct {
    int ips_mode__, nps_unit__, n_pages__, i_pages__, n_vecs__;
} pl_psi__;

#define pl_psi__1 pl_psi__

struct {
    real px_org__, py_org__, px_siz__, py_siz__, p_scale__, bb_xmin__, 
	    bb_xmax__, bb_ymin__, bb_ymax__, ps_lstx__, ps_lsty__;
} pl_psr__;

#define pl_psr__1 pl_psr__

struct {
    char ps_file__[80];
} pl_psc__;

#define pl_psc__1 pl_psc__

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;

/* *********************************************************************** */
/*    Module:  gw_subs.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 driver for X windows plotting to screen */

/*     Version 4.46 11/28/01 */

/*     Notes:  These routines handle the interface to the graphics screen */
/*             window.  Not normally called by the user. */
/*             The interface file Xwin.c is needed to link to X11 */
/* *********************************************************************** */
/* Subroutine */ int gw_setup__(real *scrn_fraction__)
{
    /* Initialized data */

    static real w1size = 11.f;
    static real w2size = 8.5f;

/* ---Sets default size of screen window */
/*    scrn_fraction   relative size (0->1) of graphics window to root window */
/*     size defaults to 520x670 if scrn_fraction<0.0 and aspect ratio is set */
/*     by 8.5"x11.0" page size. */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    pl_xwinr__1.g_scrnfrac__ = dabs(*scrn_fraction__);
    pl_xwinr__1.g_scrnfrac__ = dmin(1.f,pl_xwinr__1.g_scrnfrac__);
    if (*scrn_fraction__ == 0.f) {
	pl_xwinr__1.g_scrnfrac__ = .67f;
    }

/* ---set default window size */
    if (*scrn_fraction__ >= 0.f) {
	pl_plotr__1.x_page__ = w1size;
	pl_plotr__1.y_page__ = w2size;
	pl_ploti__1.i_pagetype__ = 1;
    } else {
	pl_plotr__1.x_page__ = w2size;
	pl_plotr__1.y_page__ = w1size;
	pl_ploti__1.i_pagetype__ = 0;
    }

/* ---window size in absolute units (pseudo-inches) */
    pl_plotr__1.x_wind__ = pl_plotr__1.x_page__;
    pl_plotr__1.y_wind__ = pl_plotr__1.y_page__;

/* ---location of upper left window corner */
    pl_xwini__1.gx_loc__ = 0;
    pl_xwini__1.gy_loc__ = 0;

/* ---location of plot origin on window */
    pl_xwini__1.gx_org__ = 0;
    pl_xwini__1.gy_org__ = 0;

    return 0;
} /* gw_setup__ */

/* Subroutine */ int gw_init__(void)
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real scrnfrac;
    extern /* Subroutine */ int gwxclear_(void), gwxresize_(int *, 
	    int *), gwxstatus_(int *, int *, int *, int *)
	    ;
    static int ix, iy;
    extern /* Subroutine */ int gwxwinopen_(int *, int *, int *, 
	    int *);
    static int ixsz, iysz, ixsiz, iysiz, idepth, iwidth, ixorig, iyorig;
    static real a_ratio__;
    static int iheight;
    extern /* Subroutine */ int gwxopen_(int *, int *, int *);
    static int ixstart, iystart;

    /* Fortran I/O blocks */
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___17 = { 0, 6, 0, 0, 0 };
    static cilist io___20 = { 0, 6, 0, 0, 0 };


/* ---Initializes graphics screen plotting and global plot variables */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ixsiz = pl_xwini__1.gx_siz__;
    iysiz = pl_xwini__1.gy_siz__;
    ixstart = pl_xwini__1.gx_loc__;
    iystart = pl_xwini__1.gy_loc__;
    scrnfrac = dmin(1.f,pl_xwinr__1.g_scrnfrac__);
    a_ratio__ = pl_plotr__1.y_wind__ / pl_plotr__1.x_wind__;

    if (! pl_xwinl__1.lgw_open__) {
/* ---Open display and window if not already open */
	gwxopen_(&iwidth, &iheight, &idepth);
	pl_xwini__1.g_width__ = iwidth;
	pl_xwini__1.g_height__ = iheight;
	pl_xwini__1.g_depth__ = idepth;
/* ---Adjust window size if fraction of root window is specified */
	if (scrnfrac > 0.f) {
	    ix = (integer) (scrnfrac * (real) pl_xwini__1.g_width__);
	    iy = (integer) (scrnfrac * (real) pl_xwini__1.g_height__);
	    if (ix * a_ratio__ < (real) iy) {
		ixsiz = ix;
		iysiz = (integer) (a_ratio__ * (real) ix);
	    } else {
		iysiz = iy;
		ixsiz = (integer) ((real) iy / a_ratio__);
	    }
	}
	ixsiz = min(ixsiz,pl_xwini__1.g_width__);
	iysiz = min(iysiz,pl_xwini__1.g_height__);
	gwxwinopen_(&ixstart, &iystart, &ixsiz, &iysiz);
/* ---Update flags for reference */
	pl_xwinl__1.lgw_open__ = TRUE_;
/* ---Graphics window color is not used if less than 4 bits (16 colors) */
/*   are available */
	pl_xwinl__1.lgw_color__ = pl_xwini__1.g_depth__ > 4;
	if (! pl_xwinl__1.lgw_color__) {
	    s_wsle(&io___14);
	    do_lio(&c__9, &c__1, "Warning: color depth < 4 bits, color not u"
		    "sed...", (ftnlen)48);
	    e_wsle();
	}

/* ---initial cursor warp will be to middle of window */
	pl_xwini__1.gx_siz__ = ixsiz;
	pl_xwini__1.gy_siz__ = iysiz;
	pl_xwini__1.gx_crs__ = pl_xwini__1.gx_org__ + pl_xwini__1.gx_siz__ / 
		2;
	pl_xwini__1.gy_crs__ = pl_xwini__1.gy_org__ + pl_xwini__1.gy_siz__ / 
		2;

    } else {

/* ---Window already open, resize if specified */
	if (pl_xwinl__1.lgw_resize__) {

	    ixorig = ixsiz;
	    iyorig = iysiz;
/* ---Resize window if new fractional size of root window is specified */
	    if (scrnfrac > 0.f) {
		ix = (integer) (scrnfrac * (real) pl_xwini__1.g_width__);
		iy = (integer) (scrnfrac * (real) pl_xwini__1.g_height__);
		if (ix * a_ratio__ < (real) iy) {
		    ixsiz = ix;
		    iysiz = (integer) (a_ratio__ * (real) ix);
		} else {
		    iysiz = iy;
		    ixsiz = (integer) ((real) iy / a_ratio__);
		}
	    } else {
		s_wsle(&io___17);
		do_lio(&c__9, &c__1, "Warning: scrnfrac=0 specified, ignorin"
			"g...", (ftnlen)42);
		e_wsle();
		s_stop("", (ftnlen)0);
	    }
	    ixsiz = min(ixsiz,pl_xwini__1.g_width__);
	    iysiz = min(iysiz,pl_xwini__1.g_height__);
	    gwxresize_(&ixsiz, &iysiz);
	    gwxstatus_(&ixstart, &iystart, &ixsz, &iysz);
	    if (ixsz != ixsiz || iysz != iysiz) {
		s_wsle(&io___20);
		do_lio(&c__9, &c__1, "Window resize fails, using old window "
			"size", (ftnlen)42);
		e_wsle();
		ixsiz = ixorig;
		iysiz = iyorig;
	    }
/* ---Update flags for reference */
	    pl_xwinl__1.lgw_resize__ = FALSE_;
	    pl_xwinl__1.lgw_changed__ = TRUE_;

	} else {

/* ...Graphics window can be moved & resized, so reset position & size parameters */
	    gwxstatus_(&ixstart, &iystart, &ixsiz, &iysiz);
	    pl_xwinl__1.lgw_changed__ = ixsiz != pl_xwini__1.gx_siz__ || 
		    iysiz != pl_xwini__1.gy_siz__;

	}

	gwxclear_();
    }

/* ---Update size and origin */
    pl_xwini__1.gx_loc__ = ixstart;
    pl_xwini__1.gy_loc__ = iystart;
    pl_xwini__1.gx_siz__ = ixsiz;
    pl_xwini__1.gy_siz__ = iysiz;

/* ---initial cursor warp will be to middle of window */
/* c      GX_CRS = GX_ORG + GX_SIZ/2 */
/* c      GY_CRS = GY_ORG + GY_SIZ/2 */

/* ...Set new scale so that each window dimension is as big as possible */
/*   but no bigger than X_PAGE or Y_PAGE. */
/* Computing MAX */
    r__1 = (real) (pl_xwini__1.gx_siz__ - 1) / pl_plotr__1.x_page__, r__2 = (
	    real) (pl_xwini__1.gy_siz__ - 1) / pl_plotr__1.y_page__;
    pl_xwinr__1.g_scale__ = dmax(r__1,r__2);

/* ...New window dimensions */
    pl_plotr__1.x_wind__ = (real) (pl_xwini__1.gx_siz__ - 1) / 
	    pl_xwinr__1.g_scale__;
    pl_plotr__1.y_wind__ = (real) (pl_xwini__1.gy_siz__ - 1) / 
	    pl_xwinr__1.g_scale__;

    return 0;
} /* gw_init__ */

/* Subroutine */ int gw_line__(real *x1, real *y1, real *x2, real *y2)
{
    static int ix1, ix2, iy1, iy2;
    extern /* Subroutine */ int gwxline_(int *, int *, int *, 
	    int *);

/* ---Plots line segment to screen, */
/*   specified in absolute coordinates from X1,Y1 to X2,Y2 */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
/* ...reverse Y axis for X11 plotting */
	ix1 = pl_xwini__1.gx_org__ + (integer) (pl_xwinr__1.g_scale__ * *x1);
	ix2 = pl_xwini__1.gx_org__ + (integer) (pl_xwinr__1.g_scale__ * *x2);
	iy1 = pl_xwini__1.gy_siz__ - (pl_xwini__1.gy_org__ + (integer) (
		pl_xwinr__1.g_scale__ * *y1)) - 1;
	iy2 = pl_xwini__1.gy_siz__ - (pl_xwini__1.gy_org__ + (integer) (
		pl_xwinr__1.g_scale__ * *y2)) - 1;
	gwxline_(&ix1, &iy1, &ix2, &iy2);
    }

    return 0;
} /* gw_line__ */

/* Subroutine */ int gw_curs__(real *x, real *y, int *kchar)
{
    static int ix, iy;
    extern /* Subroutine */ int gwxcurs_(int *, int *, int *);

/* ---Gets location of mouse click in graphics window in */
/* ---absolute coordinates */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {

/* ------ set previous cursor position (if any) for warping destination */
	ix = pl_xwini__1.gx_org__ + pl_xwini__1.gx_crs__;
	iy = pl_xwini__1.gy_siz__ - (pl_xwini__1.gy_org__ + 
		pl_xwini__1.gy_crs__);

	gwxcurs_(&ix, &iy, kchar);
	pl_xwini__1.gx_crs__ = ix - pl_xwini__1.gx_org__;
	pl_xwini__1.gy_crs__ = pl_xwini__1.gy_siz__ - iy - 
		pl_xwini__1.gy_org__;

	*x = (real) pl_xwini__1.gx_crs__ / pl_xwinr__1.g_scale__;
	*y = (real) pl_xwini__1.gy_crs__ / pl_xwinr__1.g_scale__;

    }
    return 0;
} /* gw_curs__ */

/* Subroutine */ int gw_revflag__(void)
{
    extern /* Subroutine */ int gwxrevflag_(int *);
    static int irev;

/* ---Gets reverse video flag from users environment settings */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    gwxrevflag_(&irev);
    pl_xwinl__1.lgw_revvideo__ = irev != 0;

    return 0;
} /* gw_revflag__ */

/* Subroutine */ int gw_endplot__(void)
{
    extern /* Subroutine */ int gwxflush_(void);

/* ---Flushes current graphics to window and returns control to */
/*   graphics window temporarily */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxflush_();
    }

    return 0;
} /* gw_endplot__ */

/* Subroutine */ int gw_pen__(int *ipen)
{
    /* Initialized data */

    static int ipmap[5] = { 0,0,1,1,2 };

    static int ip;
    extern /* Subroutine */ int gwxpen_(int *);

/* ...Sets pen width for screen display */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
/*     data ipmap / 0, 0, 2, 3, 4 /  <- too wide! */

    ip = max(1,*ipen);
    ip = min(5,ip);
    if (pl_xwinl__1.lgw_open__) {
	gwxpen_(&ipmap[ip - 1]);
    }

    return 0;
} /* gw_pen__ */

/* Subroutine */ int gw_linepattern__(int *ipat)
{
    extern /* Subroutine */ int gwxdash_(int *);

/* ...Sets pen width for screen display */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxdash_(ipat);
    }
    return 0;
} /* gw_linepattern__ */

/* Subroutine */ int gw_flush__(void)
{
    extern /* Subroutine */ int gwxflush_(void);

/* ...Flushes out buffered plotting calls to display */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxflush_();
    }
    return 0;
} /* gw_flush__ */

/* Subroutine */ int gw_drawtoscreen__(void)
{
    extern /* Subroutine */ int gwxdrawtowindow_(void);

/* ...Sets graphics destination to screen */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxdrawtowindow_();
    }
    return 0;
} /* gw_drawtoscreen__ */

/* Subroutine */ int gw_drawtobuffer__(void)
{
    extern /* Subroutine */ int gwxdrawtobuffer_(void);

/* ...Sets graphics destination to background buffer */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxdrawtobuffer_();
    }
    return 0;
} /* gw_drawtobuffer__ */

/* Subroutine */ int gw_showbuffer__(void)
{
    extern /* Subroutine */ int gwxdisplaybuffer_(void);

/* ...Displays graphics drawn into background buffer on screen */
/*   This does not change the current destination for drawing commands */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxdisplaybuffer_();
    }
    return 0;
} /* gw_showbuffer__ */

/* Subroutine */ int gw_clear__(void)
{
    extern /* Subroutine */ int gwxclear_(void);

/* ...Erases graphics display */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxclear_();
    }
    return 0;
} /* gw_clear__ */

/* Subroutine */ int gw_setsize__(int *nx, int *ny)
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int gwxresize_(int *, int *), gwxstatus_(
	    int *, int *, int *, int *);
    static int ixsz, iysz, ixsiz, iysiz;
    extern /* Subroutine */ int replot_(int *);
    static int ixstart, iystart;

    /* Fortran I/O blocks */
    static cilist io___30 = { 0, 6, 0, 0, 0 };
    static cilist io___37 = { 0, 6, 0, 0, 0 };


/* ...Resizes X-Window X,Y size to nx,ny in pixels */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (*nx <= 10) {
	s_wsle(&io___30);
	do_lio(&c__9, &c__1, "No Resize: Window size too small: ", (ftnlen)34)
		;
	do_lio(&c__3, &c__1, (char *)&(*nx), (ftnlen)sizeof(integer));
	do_lio(&c__3, &c__1, (char *)&(*ny), (ftnlen)sizeof(integer));
	e_wsle();
	return 0;
    }

/* ...Get current window parameters if display is open */
    if (pl_xwinl__1.lgw_open__) {
	gwxstatus_(&ixstart, &iystart, &ixsiz, &iysiz);
	pl_xwinl__1.lgw_changed__ = ixsiz != pl_xwini__1.gx_siz__ || iysiz != 
		pl_xwini__1.gy_siz__;
	pl_xwini__1.gx_loc__ = ixstart;
	pl_xwini__1.gy_loc__ = iystart;
	pl_xwini__1.gx_siz__ = ixsiz;
	pl_xwini__1.gy_siz__ = iysiz;
    }

/* ...Resize and replot the window contents */
    if (pl_xwinl__1.lgw_open__) {
	gwxresize_(nx, ny);
	gwxstatus_(&ixstart, &iystart, &ixsz, &iysz);
	if (ixsz != ixsiz || iysz != iysiz) {
	    s_wsle(&io___37);
	    do_lio(&c__9, &c__1, "Window resize fails, using old window size",
		     (ftnlen)42);
	    e_wsle();
	    ixsz = ixsiz;
	    iysz = iysiz;
	}
/* ---Update flags and size for reference */
	pl_xwinl__1.lgw_resize__ = FALSE_;
	pl_xwinl__1.lgw_changed__ = TRUE_;
	pl_xwini__1.gx_siz__ = ixsz;
	pl_xwini__1.gy_siz__ = iysz;

/* ---initial cursor warp will be to middle of window */
	pl_xwini__1.gx_crs__ = pl_xwini__1.gx_org__ + pl_xwini__1.gx_siz__ / 
		2;
	pl_xwini__1.gy_crs__ = pl_xwini__1.gy_org__ + pl_xwini__1.gy_siz__ / 
		2;
/* ---Set new scale so that each window dimension is as big as possible */
/*   but no bigger than X_PAGE or Y_PAGE. */
/* Computing MAX */
	r__1 = (real) (pl_xwini__1.gx_siz__ - 1) / pl_plotr__1.x_page__, r__2 
		= (real) (pl_xwini__1.gy_siz__ - 1) / pl_plotr__1.y_page__;
	pl_xwinr__1.g_scale__ = dmax(r__1,r__2);
/* ---New window dimensions */
	pl_plotr__1.x_wind__ = (real) (pl_xwini__1.gx_siz__ - 1) / 
		pl_xwinr__1.g_scale__;
	pl_plotr__1.y_wind__ = (real) (pl_xwini__1.gy_siz__ - 1) / 
		pl_xwinr__1.g_scale__;
/* ---refresh the newly sized window */
	replot_(&c__1);
    }
    return 0;
} /* gw_setsize__ */

/* Subroutine */ int gw_getsize__(int *nx, int *ny, real *ppi)
{
/* ...Returns X Window X,Y size in pixels, */
/*   and plotting scale in pixels/(absolute coordinate) */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	*nx = pl_xwini__1.gx_siz__;
	*ny = pl_xwini__1.gy_siz__;
	*ppi = pl_xwinr__1.g_scale__;
    }
    return 0;
} /* gw_getsize__ */

/* Subroutine */ int gw_close__(void)
{
    extern /* Subroutine */ int gwxclose_(void);

/* ---Closes graphics window */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__) {
	gwxclose_();
	pl_xwinl__1.lgw_open__ = FALSE_;
    }
    return 0;
} /* gw_close__ */

/* Subroutine */ int gw_cname2rgb__(char *colorname, int *ired, int *
	igrn, int *iblu, ftnlen colorname_len)
{
    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int gwxcolorname2rgb_(int *, int *, 
	    int *, int *, char *, ftnlen);
    static int nc;
    static char cname[80];
    extern /* Subroutine */ int g_strip__(char *, int *, ftnlen);

/* ...Determines RGB color components of color defined the color name */
/*   using the X window color database. */

/*    colorname = name of color (must be in X windows rgb.txt file) */

/*   The returned color components are */
/*    ired = 0-255 red   component (-1 for no color) */
/*    igrn = 0-255 green component */
/*    iblu = 0-255 blue  component */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    *ired = -1;
    *igrn = 0;
    *iblu = 0;
/* cc   nc = len(colorname) */
    s_copy(cname, colorname, (ftnlen)80, colorname_len);
    g_strip__(cname, &nc, (ftnlen)80);
    if (pl_xwinl__1.lgw_open__) {
	gwxcolorname2rgb_(ired, igrn, iblu, &nc, cname, (ftnlen)80);
    }
    return 0;
} /* gw_cname2rgb__ */

/* Subroutine */ int gw_allocrgbcolor__(int *ired, int *igrn, int 
	*iblu, int *icolorindex)
{
    extern /* Subroutine */ int gwxallocrgbcolor_(int *, int *, 
	    int *, int *);
    static int ib, ic, ig, ir;

/* ...Allocates plotting color as defined by RGB components */
/*   The component colors are */
/*    ired = 0-255 red   component */
/*    igrn = 0-255 green component */
/*    iblu = 0-255 blue  component */

/*    icolorindex = returned color index of allocated color in window colormap */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ic = -1;
    if (pl_xwinl__1.lgw_open__ && pl_xwinl__1.lgw_color__) {
	ir = *ired;
	ig = *igrn;
	ib = *iblu;
	gwxallocrgbcolor_(&ir, &ig, &ib, &ic);
	*icolorindex = ic;
    }
    return 0;
} /* gw_allocrgbcolor__ */

/* Subroutine */ int gw_color__(int *icolor)
{
    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int gw_allocrgbcolor__(int *, int *, 
	    int *, int *);
    static int ic, irg;
    extern /* Subroutine */ int gwxsetcolor_(int *);
    static int irgb, ired, icol, iblu, igrn;

    /* Fortran I/O blocks */
    static cilist io___45 = { 0, 6, 0, 0, 0 };


/* ...Sets foreground plotting color */
/*   The colors are defined by the colormap */

/*   The color in the colormap table and colorindex go from 0 -> N_COLOR */


/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__ && pl_xwinl__1.lgw_color__) {

	icol = *icolor % (pl_colori__1.n_color__ + 1);
	if (*icolor <= 0 || *icolor > pl_colori__1.n_color__) {
	    s_wsle(&io___45);
	    do_lio(&c__9, &c__1, "*** gw_color - color index out of bounds ", 
		    (ftnlen)41);
	    do_lio(&c__3, &c__1, (char *)&(*icolor), (ftnlen)sizeof(integer));
	    e_wsle();
	    return 0;
	}

/* ...Reverse white and black only in video window if LGW_REVVIDEO is set */
	if (pl_xwinl__1.lgw_revvideo__) {
	    if (*icolor == 2) {
		icol = 1;
	    }
	    if (*icolor == 1) {
		icol = 2;
	    }
	}

/* ...Check colorindex<0 for this color, if so this is an unallocated color */
	ic = pl_xwini__1.g_color_cindex__[icol - 1];

/* ...If color is unallocated, allocate it using the RGB components */
	if (ic < 0) {
	    irgb = pl_colori__1.color_rgb__[icol - 1];
	    irg = irgb / 256;
	    ired = irg / 256;
	    igrn = irg - (ired << 8);
	    iblu = irgb - (irg << 8);
	    gw_allocrgbcolor__(&ired, &igrn, &iblu, &ic);

/* ...This gives the colorindex in the screen colormap (or -1 for no allocation) */
	    if (ic >= 0) {
		pl_xwini__1.g_color_cindex__[icol - 1] = ic;
	    }
	}

/* ...Now, if colorindex is valid, set the color */
	if (ic >= 0) {
	    gwxsetcolor_(&ic);
	}

    }
    return 0;
} /* gw_color__ */

/* Subroutine */ int gw_bgcolor__(int *icolor)
{
    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int gw_allocrgbcolor__(int *, int *, 
	    int *, int *);
    static int ic, irg, irgb, ired, icol, iblu, igrn;
    extern /* Subroutine */ int gwxsetbgcolor_(int *);

    /* Fortran I/O blocks */
    static cilist io___53 = { 0, 6, 0, 0, 0 };


/* ...Sets background plotting color */
/*   The colors are defined by the colormap */

/*   The color in the colormap table and colorindex go from 0 -> N_COLOR */


/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__ && pl_xwinl__1.lgw_color__) {

	icol = *icolor % (pl_colori__1.n_color__ + 1);
	if (*icolor <= 0 || *icolor > pl_colori__1.n_color__) {
	    s_wsle(&io___53);
	    do_lio(&c__9, &c__1, "*** gw_bgcolor - color index out of bounds "
		    , (ftnlen)43);
	    do_lio(&c__3, &c__1, (char *)&(*icolor), (ftnlen)sizeof(integer));
	    e_wsle();
	    return 0;
	}

/* ...Reverse white and black only in video window if LGW_REVVIDEO is set */
	if (pl_xwinl__1.lgw_revvideo__) {
	    if (*icolor == 2) {
		icol = 1;
	    }
	    if (*icolor == 1) {
		icol = 2;
	    }
	}

/* ...Check colorindex<0 for this color, if so this is an unallocated color */
	ic = pl_xwini__1.g_color_cindex__[icol - 1];

/* ...If color is unallocated, allocate it using the RGB components */
	if (ic < 0) {
	    irgb = pl_colori__1.color_rgb__[icol - 1];
	    irg = irgb / 256;
	    ired = irg / 256;
	    igrn = irg - (ired << 8);
	    iblu = irgb - (irg << 8);
	    gw_allocrgbcolor__(&ired, &igrn, &iblu, &ic);

/* ...This gives the colorindex in the screen colormap (or -1 for no allocation) */
	    if (ic >= 0) {
		pl_xwini__1.g_color_cindex__[icol - 1] = ic;
	    }
	}

/* ...Now, if colorindex is valid, set the color */
	if (ic >= 0) {
	    gwxsetbgcolor_(&ic);
	}

    }
    return 0;
} /* gw_bgcolor__ */

/* Subroutine */ int gw_newcmap__(void)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, ic;
    extern /* Subroutine */ int gwxfreecolor_(int *);

/* ...Sets up new colormap, old colormap is flushed */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_xwinl__1.lgw_open__ && pl_xwinl__1.lgw_color__) {
	i__1 = pl_colori__1.n_color__;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ic = pl_xwini__1.g_color_cindex__[i__ - 1];
	    if (ic > 0) {
		gwxfreecolor_(&ic);
	    }
	}
    }
    return 0;
} /* gw_newcmap__ */

/* Subroutine */ int gw_polyline__(real *x, real *y, int *n, int *
	ifill)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int gwxlinez_(int *, int *, int *);
    static int i__, ix[501], iy[501];
    extern /* Subroutine */ int gwxpoly_(int *, int *, int *);

    /* Fortran I/O blocks */
    static cilist io___62 = { 0, 6, 0, 0, 0 };


/* ...Plots polyline (optionally filled) to screen in foreground color */
/*     X,Y    polyline  X,Y absolute coordinates */
/*     n      number of X,Y points */
/*     ifill  fill flag, 0 for no fill, 1 for filled polyline */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*n > 501) {
	s_wsle(&io___62);
	do_lio(&c__9, &c__1, "gw_polyline: array overflow.  Increase MaxPoly"
		"line.", (ftnlen)51);
	e_wsle();
	return 0;
    }

    if (*n <= 1) {
	return 0;
    }
    if (pl_xwinl__1.lgw_open__) {
/* ...reverse Y axis for X11 plotting */
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ix[i__ - 1] = pl_xwini__1.gx_org__ + (integer) (
		    pl_xwinr__1.g_scale__ * x[i__]);
	    iy[i__ - 1] = pl_xwini__1.gy_siz__ - (pl_xwini__1.gy_org__ + (
		    integer) (pl_xwinr__1.g_scale__ * y[i__])) - 1;
	}
	if (*ifill == 0) {
	    gwxlinez_(ix, iy, n);
	} else {
	    gwxpoly_(ix, iy, n);
	}
    }
    return 0;
} /* gw_polyline__ */

/* Subroutine */ int g_strip__(char *strng, int *n, ftnlen strng_len)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int i_len(char *, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, nc, ioff;


    nc = i_len(strng, strng_len);
    *n = nc;
    if (*n <= 1) {
	return 0;
    }

/* ---- Strips leading blanks off string */
    if (*(unsigned char *)strng == ' ') {

/* ---- find first non-blank character */
	i__1 = nc;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    if (*(unsigned char *)&strng[i__ - 1] != ' ') {
		goto L10;
	    }
	}
	goto L20;
L10:
	ioff = i__;

/* ---- shift STRNG so first character is non-blank */
	s_copy(strng, strng + (ioff - 1), nc - ioff, nc - (ioff - 1));
/* ---- pad tail of STRNG with blanks */
	i__1 = nc - ioff;
	s_copy(strng + i__1, " ", nc - i__1, (ftnlen)1);

    }

/* ---- find the index of the last non-blank charater in NAME */
L20:
    for (*n = nc; *n >= 1; --(*n)) {
	if (*(unsigned char *)&strng[*n - 1] != ' ') {
	    goto L40;
	}
    }
L40:
    return 0;
} /* g_strip__ */
