/* f/plt_color.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lprim_open__;
} pl_priml__;

#define pl_priml__1 pl_priml__

struct {
    int nprim_unit__, n_prim__, n_writ__, n_incore__, i_typ__[100000], 
	    i_prim__[100000];
} pl_primi__;

#define pl_primi__1 pl_primi__

struct {
    real x_prim__[100000], y_prim__[100000];
} pl_primr__;

#define pl_primr__1 pl_primr__

struct {
    int i_dev__, i_pagetype__, i_pen__, lst_pen__, i_pat__, lst_pat__, 
	    i_clr__, lst_clr__;
} pl_ploti__;

#define pl_ploti__1 pl_ploti__

struct {
    real x_scale__, y_scale__, x_org__, y_org__, x_lst__, y_lst__, x_page__, 
	    y_page__, x_wind__, y_wind__, clp_xmin__, clp_xmax__, clp_ymin__, 
	    clp_ymax__, xoff_zoom__, yoff_zoom__, xfac_zoom__, yfac_zoom__;
} pl_plotr__;

#define pl_plotr__1 pl_plotr__

struct {
    int n_color__, n_spectrum__, ifirst_spectrum__, color_rgb__[256];
} pl_colori__;

#define pl_colori__1 pl_colori__

struct {
    char color_name__[5632];
} pl_colorc__;

#define pl_colorc__1 pl_colorc__

struct {
    logical lgw_gen__, lgw_open__, lgw_color__, lgw_revvideo__, lgw_changed__,
	     lgw_resize__;
} pl_xwinl__;

#define pl_xwinl__1 pl_xwinl__

struct {
    int gx_loc__, gy_loc__, gx_org__, gy_org__, gx_siz__, gy_siz__, 
	    gx_crs__, gy_crs__, g_width__, g_height__, g_depth__, 
	    g_color_cindex__[256];
} pl_xwini__;

#define pl_xwini__1 pl_xwini__

struct {
    real g_scale__, g_scrnfrac__;
} pl_xwinr__;

#define pl_xwinr__1 pl_xwinr__

struct {
    logical lps_gen__, lps_open__, lps_color__, lps_unstroked__, 
	    lps_external__, lps_onefile__;
} pl_psl__;

#define pl_psl__1 pl_psl__

struct {
    int ips_mode__, nps_unit__, n_pages__, i_pages__, n_vecs__;
} pl_psi__;

#define pl_psi__1 pl_psi__

struct {
    real px_org__, py_org__, px_siz__, py_siz__, p_scale__, bb_xmin__, 
	    bb_xmax__, bb_ymin__, bb_ymax__, ps_lstx__, ps_lsty__;
} pl_psr__;

#define pl_psr__1 pl_psr__

struct {
    char ps_file__[80];
} pl_psc__;

#define pl_psc__1 pl_psc__

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static int c__6 = 6;
static real c_b17 = 0.f;

/* *********************************************************************** */
/*    Module: plt_color.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 color plotting routines */

/*     Version 4.46 11/28/01 */

/*     Note:  These routines implement the interface to setup, select and */
/*            query colors in the XPLOT11 plot package. */
/* *********************************************************************** */

/*   The default colormap defines these colors and associated color indices */
/*   (before the user defines any more)... */
/*        BLACK   =  1 */
/*        WHITE   =  2 */
/*        YELLOW  =  3 */
/*        ORANGE  =  4 */
/*        RED     =  5 */
/*        GREEN   =  6 */
/*        CYAN    =  7 */
/*        BLUE    =  8 */
/*        MAGENTA =  9 */
/*        VIOLET  =  10 */
/* Subroutine */ int newcolor_(int *icol)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int icindex;
    extern /* Subroutine */ int putprim_(int *, int *, real *, real *)
	    ;

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 6, 0, 0, 0 };
    static cilist io___3 = { 0, 6, 0, 0, 0 };


/* ...Sets color by composite color index */
/*   color is set by the map index (for +icol) */
/*   or spectrum index (for -icol) */
/*     Color map indices      run from 0  ->  N_COLORS */
/*     Color spectrum indices run from -1 -> -N_SPECTRUM */

/*    (see colormap subroutines below for setting colormap colors) */


/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (*icol > 0) {
	if (*icol > pl_colori__1.n_color__) {
	    s_wsle(&io___1);
	    do_lio(&c__9, &c__1, "NEWCOLOR: color index out of bounds: ", (
		    ftnlen)37);
	    do_lio(&c__3, &c__1, (char *)&(*icol), (ftnlen)sizeof(integer));
	    do_lio(&c__3, &c__1, (char *)&pl_colori__1.n_color__, (ftnlen)
		    sizeof(integer));
	    e_wsle();
	    return 0;
	}
	icindex = *icol;
    } else {
	if (-(*icol) > pl_colori__1.n_spectrum__) {
	    s_wsle(&io___3);
	    do_lio(&c__9, &c__1, "NEWCOLOR: spectrum index out of bounds: ", (
		    ftnlen)40);
	    i__1 = -(*icol);
	    do_lio(&c__3, &c__1, (char *)&i__1, (ftnlen)sizeof(integer));
	    do_lio(&c__3, &c__1, (char *)&pl_colori__1.n_spectrum__, (ftnlen)
		    sizeof(integer));
	    e_wsle();
	    return 0;
	}
	icindex = pl_colori__1.ifirst_spectrum__ - *icol - 1;
    }

/* ...Skip if this is the current color */
    if (icindex == pl_ploti__1.i_clr__) {
	return 0;
    }

/* ...Install color command into display primitives list */
    pl_ploti__1.i_clr__ = icindex;
    putprim_(&c__6, &pl_ploti__1.i_clr__, &c_b17, &c_b17);

    return 0;
} /* newcolor_ */

/* Subroutine */ int getcolor_(int *icol)
{
/* ...Returns current foreground color composite index */
/*   if icol>0 the index is the color table index (non-spectrum colors) */
/*   if icol<0 the index is -(color spectrum index) */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (pl_ploti__1.i_clr__ >= pl_colori__1.ifirst_spectrum__ && 
	    pl_ploti__1.i_clr__ <= pl_colori__1.ifirst_spectrum__ + 
	    pl_colori__1.n_spectrum__ - 1) {
	*icol = pl_colori__1.ifirst_spectrum__ - pl_ploti__1.i_clr__ - 1;
    } else {
	*icol = pl_ploti__1.i_clr__;
    }
    return 0;
} /* getcolor_ */

/* Subroutine */ int getcolorindex_(int *icindex)
{
/* ...Returns color table index (not spectrum color index) */
/*   of current foreground color table index (icindex runs from 0 -> N_COLOR) */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    *icindex = pl_ploti__1.i_clr__;
    return 0;
} /* getcolorindex_ */

/* Subroutine */ int newcolorname_(char *colorname, ftnlen colorname_len)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_cmp(char *, char *, ftnlen, ftnlen), s_wsle(cilist *), do_lio(
	    int *, int *, char *, ftnlen), e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int newcolor_(int *);
    static int n;
    extern /* Subroutine */ int convrt2uc_(char *, ftnlen);
    static int ic;
    extern /* Subroutine */ int gw_cname2rgb__(char *, int *, int *, 
	    int *, ftnlen);
    static int ired, iblue, igreen;
    static char colorin[22];

    /* Fortran I/O blocks */
    static cilist io___10 = { 0, 6, 0, 0, 0 };
    static cilist io___11 = { 0, 6, 0, 0, 0 };


/* ...Sets color for plotting by named string */
/*   (to circumvent knowing the color table index) */
/*   Valid color names (either upper or lower case) are found by */
/*   running the X11 command: showrgb */


/* ...Convert input color to uppercase */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    s_copy(colorin, colorname, (ftnlen)22, colorname_len);
    convrt2uc_(colorin, (ftnlen)22);

/* ...Search for color name in current colortable */
    i__1 = pl_colori__1.n_color__;
    for (ic = 1; ic <= i__1; ++ic) {
/*       write(*,*) 'colorbyname table ic=',ic,' ',colorin,' ', */
/*     &             COLOR_NAME(ic),' ci ',G_COLOR_CINDEX(ic) */
	if (s_cmp(colorin, pl_colorc__1.color_name__ + (ic - 1) * 22, (ftnlen)
		22, (ftnlen)22) == 0) {
	    newcolor_(&ic);
	    return 0;
	}
    }

/* ...Add new color to colortable */
/* ...Get RGB components for named color */
    gw_cname2rgb__(colorname, &ired, &igreen, &iblue, colorname_len);
/*      write(*,*) 'cname->rgb ',colorname, ired,igreen,iblue */

    if (ired >= 0) {
	n = pl_colori__1.n_color__ + 1;
	if (n > 256) {
	    s_wsle(&io___10);
	    do_lio(&c__9, &c__1, "NEWCOLORNAME: Colortable overflow. New col"
		    "or ignored.", (ftnlen)53);
	    e_wsle();
	    return 0;
	}
	pl_xwini__1.g_color_cindex__[n - 1] = -1;
	pl_colori__1.color_rgb__[n - 1] = iblue + (igreen + (ired << 8) << 8);
	s_copy(pl_colorc__1.color_name__ + (n - 1) * 22, colorin, (ftnlen)22, 
		(ftnlen)22);
	pl_colori__1.n_color__ = n;
	newcolor_(&n);
    } else {
	s_wsle(&io___11);
	do_lio(&c__9, &c__1, "NEWCOLORNAME: Color not found ", (ftnlen)30);
	do_lio(&c__9, &c__1, colorname, colorname_len);
	e_wsle();
    }

    return 0;
} /* newcolorname_ */

/* Subroutine */ int newcolorrgb_(int *ired, int *igreen, int *
	iblue)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int newcolor_(int *);
    static int n, ic, irgb;

    /* Fortran I/O blocks */
    static cilist io___15 = { 0, 6, 0, 0, 0 };


/* ...Sets color for plotting by R,G,B components */
/*   (to circumvent knowing the color table index) */
/*   Valid color components for red,green,blue run from 0-255 */


/* ...Search for r,g,b color in current colortable */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    i__1 = pl_colori__1.n_color__;
    for (ic = 1; ic <= i__1; ++ic) {
	irgb = *iblue + (*igreen + (*ired << 8) << 8);
/*        write(*,*) 'NEWCOLORRGB table ic=',ic,' ',irgb,' ', */
/*     &             COLOR_RGB(ic), */
/*     &             COLOR_NAME(ic),' ci ',G_COLOR_CINDEX(ic) */
	if (irgb == pl_colori__1.color_rgb__[ic - 1]) {
	    newcolor_(&ic);
	    return 0;
	}
    }

    n = pl_colori__1.n_color__ + 1;
    if (n > 256) {
	s_wsle(&io___15);
	do_lio(&c__9, &c__1, "NEWCOLORRGB: Colortable overflow. New color ig"
		"nored.", (ftnlen)52);
	e_wsle();
	return 0;
    }
    pl_xwini__1.g_color_cindex__[n - 1] = -1;
    pl_colori__1.color_rgb__[n - 1] = *iblue + (*igreen + (*ired << 8) << 8);
    s_copy(pl_colorc__1.color_name__ + (n - 1) * 22, "RGBCOLOR", (ftnlen)22, (
	    ftnlen)8);
    pl_colori__1.n_color__ = n;
    newcolor_(&n);
    return 0;
} /* newcolorrgb_ */

/* Subroutine */ int getcolorrgb_(int *icol, int *ired, int *igrn,
	 int *iblu, char *colorname, ftnlen colorname_len)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int ic, irg, irgb;

    /* Fortran I/O blocks */
    static cilist io___17 = { 0, 6, 0, 0, 0 };
    static cilist io___18 = { 0, 6, 0, 0, 0 };


/* ...Gets color information for color designated by index icol */
/*                 if icol<=0, color -icol in Spectrum is queried */
/*   Returns   ired    - red   color component (0-255)   (-1 if no color) */
/*             igrn    - green color component (0-255)   (-1 if no color) */
/*             iblu    - blue  color component (0-255)   (-1 if no color) */
/*             colorname - name of current color (lowercase) */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

/* ...First assume color "icol" does not exist */
    *ired = -1;
    *igrn = -1;
    *iblu = -1;
    s_copy(colorname, " ", colorname_len, (ftnlen)1);

    if (*icol > 0) {
	ic = *icol;
    } else {
	if (-(*icol) > pl_colori__1.n_spectrum__) {
	    s_wsle(&io___17);
	    do_lio(&c__9, &c__1, "GETCOLORRGB: spectrum index out of bounds: "
		    , (ftnlen)43);
	    i__1 = -(*icol);
	    do_lio(&c__3, &c__1, (char *)&i__1, (ftnlen)sizeof(integer));
	    do_lio(&c__3, &c__1, (char *)&pl_colori__1.n_spectrum__, (ftnlen)
		    sizeof(integer));
	    e_wsle();
	    return 0;
	}
	ic = pl_colori__1.ifirst_spectrum__ - *icol - 1;
    }

    if (ic > pl_colori__1.n_color__) {
	s_wsle(&io___18);
	do_lio(&c__9, &c__1, "GETCOLORRGB: color index out of bounds: ", (
		ftnlen)40);
	do_lio(&c__3, &c__1, (char *)&ic, (ftnlen)sizeof(integer));
	do_lio(&c__3, &c__1, (char *)&pl_colori__1.n_color__, (ftnlen)sizeof(
		integer));
	e_wsle();
	return 0;
    }

    irgb = pl_colori__1.color_rgb__[ic - 1];
    irg = irgb / 256;
    *ired = irg / 256;
    *igrn = irg - (*ired << 8);
    *iblu = irgb - (irg << 8);
    s_copy(colorname, pl_colorc__1.color_name__ + (ic - 1) * 22, 
	    colorname_len, (ftnlen)22);

    return 0;
} /* getcolorrgb_ */

/* Subroutine */ int convrt2uc_(char *input, ftnlen input_len)
{
    /* Initialized data */

    static char lcase[26] = "abcdefghijklmnopqrstuvwxyz";
    static char ucase[26] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, k, n;

/* ...Convert string to uppercase */
/*   Note that the string must be writeable (a variable, not a constant) */


    n = i_len(input, input_len);
    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = i_indx(lcase, input + (i__ - 1), (ftnlen)26, (ftnlen)1);
	if (k > 0) {
	    *(unsigned char *)&input[i__ - 1] = *(unsigned char *)&ucase[k - 
		    1];
	}
    }

    return 0;
} /* convrt2uc_ */

/* Subroutine */ int getnumcolor_(int *ncol)
{
/* ...Gets current number of defined colors */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    *ncol = pl_colori__1.n_color__;
    return 0;
} /* getnumcolor_ */

/* Subroutine */ int getnumspectrum_(int *nspec)
{
/* ...Gets current number of defined colors in Spectrum */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    *nspec = pl_colori__1.n_spectrum__;
    return 0;
} /* getnumspectrum_ */

/* Subroutine */ int colormapdefault_(void)
{
    /* Initialized data */

    static int ifirst = 0;
    static int defcmaprgb1[30]	/* was [3][10] */ = { 0,0,0,255,255,
	    255,255,0,0,255,165,0,255,255,0,0,255,0,0,255,255,30,140,255,205,
	    55,255,255,0,255 };
    static int defcmaprgb0[30]	/* was [3][10] */ = { 0,0,0,255,255,
	    255,255,0,0,255,165,0,220,220,0,0,225,0,0,210,210,30,140,255,205,
	    55,255,255,0,255 };
    static char defcmapnames[10*10] = "BLACK     " "WHITE     " "RED       " 
	    "ORANGE    " "YELLOW    " "GREEN     " "CYAN      " "BLUE      " 
	    "VIOLET    " "MAGENTA   ";

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int n;
    extern /* Subroutine */ int gw_newcmap__(void);
    static int ired, iblu, igrn;


/* ...Creates default colormap palette containing a small number of basic */
/*   colors defined in DATA statement below.  The first two colors */
/*   are used as the default foreground and background. */

/*   The default colormap contains these defined colors */
/*        BLACK   =  1 */
/*        WHITE   =  2 */
/*        YELLOW  =  3 */
/*        ORANGE  =  4 */
/*        RED     =  5 */
/*        GREEN   =  6 */
/*        CYAN    =  7 */
/*        BLUE    =  8 */
/*        MAGENTA =  9 */
/*        VIOLET  =  10 */

/*   These colors are then accessible by a normal NEWCOLOR(icol) call: */
/*       icol = 1 .. NCMAP */

/*   Also installs the RGB components of these colors and these color */
/*   names in the color table.  The colorindex is set to -1 to indicate */
/*   that the color has not yet been mapped to the screen color hardware */
/*   (this step happens the first time the color is actually used). */


/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */



/*      DATA  ((DEFCMAPRGB(L,I),L=1,3),I=1,NCMAP) */
/*     &              /    0,   0,   0,   ! black */
/*     &                 255, 255, 255,   ! white */
/*     &                 255,   0,   0,   ! red */
/*     &                 255, 165,   0,   ! orange */
/*     &                 255, 255,   0,   ! yellow */
/*     &                   0, 255,   0,   ! green */
/*     &                   0, 255, 255,   ! cyan */
/*     &                   0,   0, 255,   ! blue */
/*     &                 148,   0, 211 /  ! violet */
/*     &                 255,   0, 255,   ! magenta */

/* ---- hues for reverse-video (black background), use full saturation */

/* ---- hues for regular-video (white background), use partial saturation */



/* ---Initialize the colormap indices for first call */
    if (ifirst == 0) {
	pl_colori__1.n_color__ = 0;
	pl_colori__1.n_spectrum__ = 0;
	pl_colori__1.ifirst_spectrum__ = 0;
	ifirst = 1;
    }

/* --- Skip installing new default map if there already are NCMAP colors */
    if (pl_colori__1.n_color__ == 10) {
	return 0;
    }

/* --- Flush current colormap if any, to free up space for new map */
    if (pl_colori__1.n_color__ > 0) {
	gw_newcmap__();
    }

/* --- Fill in the colormap with with the default colors and set colorindex */
/*    to -1 to indicate that the color is still unallocated by hardware */
    if (pl_xwinl__1.lgw_revvideo__) {
	for (n = 1; n <= 10; ++n) {
	    ired = defcmaprgb1[n * 3 - 3];
	    igrn = defcmaprgb1[n * 3 - 2];
	    iblu = defcmaprgb1[n * 3 - 1];
	    pl_colori__1.color_rgb__[n - 1] = iblu + (igrn + (ired << 8) << 8)
		    ;
	    s_copy(pl_colorc__1.color_name__ + (n - 1) * 22, defcmapnames + (
		    n - 1) * 10, (ftnlen)22, (ftnlen)10);
	    pl_xwini__1.g_color_cindex__[n - 1] = -1;
	}
    } else {
	for (n = 1; n <= 10; ++n) {
	    ired = defcmaprgb0[n * 3 - 3];
	    igrn = defcmaprgb0[n * 3 - 2];
	    iblu = defcmaprgb0[n * 3 - 1];
	    pl_colori__1.color_rgb__[n - 1] = iblu + (igrn + (ired << 8) << 8)
		    ;
	    s_copy(pl_colorc__1.color_name__ + (n - 1) * 22, defcmapnames + (
		    n - 1) * 10, (ftnlen)22, (ftnlen)10);
	    pl_xwini__1.g_color_cindex__[n - 1] = -1;
	}
    }

    pl_colori__1.n_color__ = 10;
/*     write(*,*) 'COLORMAPDEFAULT: NCOLOR ',N_COLOR */

    return 0;
} /* colormapdefault_ */

/* Subroutine */ int colorspectrumhues_(int *ncols, char *huestr, ftnlen 
	huestr_len)
{
    /* Initialized data */

    static char colorchars[7] = "MBCGYOR";
    static int irgbtable[21]	/* was [3][7] */ = { 240,0,240,32,32,
	    255,0,240,240,32,255,32,240,240,0,255,160,0,255,32,32 };
    static real colorwidth[7] = { 1.5f,1.f,1.f,1.f,1.f,1.f,1.5f };

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static real huewidth[7];
    static int i__, k;
    extern /* Subroutine */ int convrt2uc_(char *, ftnlen), colorspectrumtrp_(
	    int *, int *, int *, real *);
    static int nhue, irgbhue[21]	/* was [3][7] */, nhuemax;


/* ...Sets up a color "Spectrum" table that gives a continuous */
/*   blend between a small number of base colors specified in the */
/*   character string HUESTR, which can be "RYGCBM" or any subset thereof. */

/*   The RGB components associated with each specified color are set in */
/*   the DATA statement below. These colors are appended to any existing */
/*   colormap data, typically set up by COLORMAPDEFAULT. */

/*   These Spectrum colors are then accessible by NEWCOLOR(-icol) */
/*       -icol = 1 .. ncols */

/* NOTE: The maximum number of colors available to the Spectrum is LESS */
/*       than the screen depth would indicate.  Some of the X colormap */
/*       is used by other X window applications, typically this will be */
/*       around 30-40 colormap entries. So, for an 8 bit depth, this */
/*       leaves around 220 or so available for use, only 210 or so after */
/*       the Palette colors (typ. 10) are assigned.  Less are available */
/*       if other applications are using the X colormap. */



/* ...RGB components of the Spectrum-defining base colors */
/*   COLWIDTH controls the relative extent of that defining color */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */


/*         Red   Green    Blue */

    convrt2uc_(huestr, huestr_len);
    nhuemax = i_len(huestr, huestr_len);

    nhue = 0;
    i__1 = nhuemax;
    for (k = 1; k <= i__1; ++k) {
	i__ = i_indx(colorchars, huestr + (k - 1), (ftnlen)7, (ftnlen)1);
	if (i__ != 0) {
	    ++nhue;
	    irgbhue[nhue * 3 - 3] = irgbtable[i__ * 3 - 3];
	    irgbhue[nhue * 3 - 2] = irgbtable[i__ * 3 - 2];
	    irgbhue[nhue * 3 - 1] = irgbtable[i__ * 3 - 1];
	    huewidth[nhue - 1] = colorwidth[i__ - 1];
	}
    }

    colorspectrumtrp_(ncols, &nhue, irgbhue, huewidth);

    return 0;
} /* colorspectrumhues_ */

/* Subroutine */ int colorspectrumtrp_(int *ncols, int *nbase, 
	int *irgbbase, real *colwidth)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static int i__;
    extern /* Subroutine */ int colorspectrumrgb_(int *, int *);
    static real w0, w1, red0, red1, blu0, blu1, grn0, grn1, frac, xcol;
    static int ibase;
    static real xnorm;
    static int irgbtbl[768]	/* was [3][256] */;
    static real colaxis[256];

    /* Fortran I/O blocks */
    static cilist io___43 = { 0, 6, 0, 0, 0 };


/* ...Interpolates a color "Spectrum" table of 1..ncols colors that are */
/*   a continuous blend between a small number of defined base colors. */
/*   The blending between the base colors is controlled by the color */
/*   "width" COLWIDTH. */

/*  Input: */
/*     ncols    number desired interpolated colors in spectrum */
/*     NBASE    number base colors defined in IRGBBASE */
/*     IRGBBASE array(3,*) of int RGB components for the base colors */
/*     COLWIDTH color pseudo "width" to use for interpolation */

/*   Overwrites the definition of any existing Spectrum. */




/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    /* Parameter adjustments */
    --colwidth;
    irgbbase -= 4;

    /* Function Body */
    if (*nbase > 256) {
	s_stop("COLORSPECTRUM: Local IRGBBASE array overflow.", (ftnlen)45);
    }


/* ---Don't allow less than 2 spectrum colors defined by interpolation table */
    if (*ncols < 2) {
	return 0;
    }

/* --- Check to make sure we have enough room in the color table */
    if (pl_colori__1.n_color__ + *ncols + 1 > 256) {
	s_wsle(&io___43);
	do_lio(&c__9, &c__1, "COLORSPECTRUMTRP: Too many colors specified.", (
		ftnlen)44);
	e_wsle();
	return 0;
    }

    colaxis[0] = 0.f;
    i__1 = *nbase;
    for (ibase = 2; ibase <= i__1; ++ibase) {
	colaxis[ibase - 1] = colaxis[ibase - 2] + (colwidth[ibase - 1] + 
		colwidth[ibase]) * .5f;
	if (colaxis[ibase - 1] <= colaxis[ibase - 2]) {
	    s_stop("COLORSPECTRUM: Non-monotonic color axis. Check COLWIDTH.",
		     (ftnlen)56);
	}
    }

/* --- Now fill in the rgb table for the Spectrum colors, */
/*    interpolating colors between the entries in the passed-in color table */
    ibase = 1;
    i__1 = *ncols;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xcol = colaxis[*nbase - 1] * (real) (i__ - 1) / (real) (*ncols - 1);

L5:
	xnorm = (xcol - colaxis[ibase - 1]) / (colaxis[ibase] - colaxis[ibase 
		- 1]);

	if (xnorm > 1.f && ibase < *nbase) {
	    ++ibase;
	    goto L5;
	}

	w0 = colwidth[ibase];
	w1 = colwidth[ibase + 1];
	frac = w1 * xnorm / (w0 + (w1 - w0) * xnorm);

	red0 = (real) irgbbase[ibase * 3 + 1];
	grn0 = (real) irgbbase[ibase * 3 + 2];
	blu0 = (real) irgbbase[ibase * 3 + 3];
	red1 = (real) irgbbase[(ibase + 1) * 3 + 1];
	grn1 = (real) irgbbase[(ibase + 1) * 3 + 2];
	blu1 = (real) irgbbase[(ibase + 1) * 3 + 3];

	irgbtbl[i__ * 3 - 3] = (integer) (red0 + frac * (red1 - red0) + .5f);
	irgbtbl[i__ * 3 - 2] = (integer) (grn0 + frac * (grn1 - grn0) + .5f);
	irgbtbl[i__ * 3 - 1] = (integer) (blu0 + frac * (blu1 - blu0) + .5f);
    }
    colorspectrumrgb_(ncols, irgbtbl);

    return 0;
} /* colorspectrumtrp_ */

/* Subroutine */ int colorspectrumrgb_(int *nrgb, int *irgb)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, ic, ired, iblu, igrn;
    extern /* Subroutine */ int colormapdefault_(void);

    /* Fortran I/O blocks */
    static cilist io___59 = { 0, 6, 0, 0, 0 };


/* ...Sets up a color "Spectrum" table for NRGB colors that are */
/*   defined by r,g,b values (0-255) in the IRGB array. */

/* Input: */
/*     NRGB    number r,g,b colors defined in IRGB */
/*     IRGB    array(3,*) of int RGB components for the colors */

/*   Overwrites any existing Spectrum. */



/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    /* Parameter adjustments */
    irgb -= 4;

    /* Function Body */
    if (pl_colori__1.n_color__ <= 0 || pl_colori__1.n_color__ > 10) {
	colormapdefault_();
    }

/* --- Check to make sure we have enough room in the color table */
    if (pl_colori__1.n_color__ + *nrgb > 256) {
	s_wsle(&io___59);
	do_lio(&c__9, &c__1, "COLORSPECTRUMRGB: Too many colors specified.", (
		ftnlen)44);
	e_wsle();
	return 0;
    }

/* --- starting index of Spectrum in colormap arrays */
    pl_colori__1.ifirst_spectrum__ = pl_colori__1.n_color__ + 1;

/* --- Now fill in the Spectrum colors from the passed-in color table */
    i__1 = *nrgb;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ired = irgb[i__ * 3 + 1];
	igrn = irgb[i__ * 3 + 2];
	iblu = irgb[i__ * 3 + 3];

	ic = pl_colori__1.ifirst_spectrum__ + i__ - 1;

	pl_colori__1.color_rgb__[ic - 1] = iblu + (igrn + (ired << 8) << 8);
	s_copy(pl_colorc__1.color_name__ + (ic - 1) * 22, "SPECTRUM", (ftnlen)
		22, (ftnlen)8);
	pl_xwini__1.g_color_cindex__[ic - 1] = -1;
    }

    pl_colori__1.n_spectrum__ = *nrgb;
    pl_colori__1.n_color__ = ic;
/*     write(*,*) 'COLORSPECTRUMRGB: NCOLOR,NSPECTRUM ',N_COLOR,N_SPECTRUM */

    return 0;
} /* colorspectrumrgb_ */

/* Subroutine */ int lwr2upr_(char *input, ftnlen input_len)
{
    /* Initialized data */

    static char lcase[26] = "abcdefghijklmnopqrstuvwxyz";
    static char ucase[26] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int i__, k, n;



    n = i_len(input, input_len);

    i__1 = n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = i_indx(lcase, input + (i__ - 1), (ftnlen)26, (ftnlen)1);
	if (k > 0) {
	    *(unsigned char *)&input[i__ - 1] = *(unsigned char *)&ucase[k - 
		    1];
	}
    }

    return 0;
} /* lwr2upr_ */
