/* f/gui.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    real xgui[40]	/* was [2][20] */, ygui[40]	/* was [2][20] */;
} com_gui__;

#define com_gui__1 com_gui__

/* Table of constant values */

static int c__3 = 3;
static int c__2 = 2;
static real c_b7 = 0.f;

/* Subroutine */ int guibox_(int *k, real *x1, real *x2, real *y1, real *
	y2, char *color, char *label, ftnlen color_len, ftnlen label_len)
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    int i_len(char *, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int getcolor_(int *), newcolor_(int *), 
	    getorigin_(real *, real *);
    static int nl;
    extern /* Subroutine */ int getfactors_(real *, real *);
    static real cha, xca, yca;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real xorg, yorg;
    static int icol0;
    extern /* Subroutine */ int newcolorname_(char *, ftnlen), plchar_(real *,
	     real *, real *, char *, real *, int *, ftnlen);
    static real xscale, yscale;

/* ---------------------------------------------------------- */
/*     Plots a GUI-button box with label string. */
/*     Places the box coordinates into the COM_GUI */
/*     arrays associated with the button index K. */
/*     FUNCTION LGUI can then determine if a cursor */
/*     falls within box K. */
/* ---------------------------------------------------------- */

    if (*k < 1 || *k > 20) {
	return 0;
    }

    getorigin_(&xorg, &yorg);
    getfactors_(&xscale, &yscale);

    getcolor_(&icol0);
    newcolorname_(color, color_len);

/* ---- set GUI window */
    com_gui__1.xgui[(*k << 1) - 2] = (*x1 - xorg) / xscale;
    com_gui__1.xgui[(*k << 1) - 1] = (*x2 - xorg) / xscale;
    com_gui__1.ygui[(*k << 1) - 2] = (*y1 - yorg) / yscale;
    com_gui__1.ygui[(*k << 1) - 1] = (*y2 - yorg) / yscale;

/* ---- plot GUI window */
    plot_(&com_gui__1.xgui[(*k << 1) - 2], &com_gui__1.ygui[(*k << 1) - 2], &
	    c__3);
    plot_(&com_gui__1.xgui[(*k << 1) - 1], &com_gui__1.ygui[(*k << 1) - 2], &
	    c__2);
    plot_(&com_gui__1.xgui[(*k << 1) - 1], &com_gui__1.ygui[(*k << 1) - 1], &
	    c__2);
    plot_(&com_gui__1.xgui[(*k << 1) - 2], &com_gui__1.ygui[(*k << 1) - 1], &
	    c__2);
    plot_(&com_gui__1.xgui[(*k << 1) - 2], &com_gui__1.ygui[(*k << 1) - 2], &
	    c__2);

    nl = i_len(label, label_len);
/* Computing MIN */
    r__1 = (com_gui__1.xgui[(*k << 1) - 1] - com_gui__1.xgui[(*k << 1) - 2]) /
	     (real) (nl + 1), r__2 = (com_gui__1.ygui[(*k << 1) - 1] - 
	    com_gui__1.ygui[(*k << 1) - 2]) / 1.8f;
    cha = dmin(r__1,r__2);
    xca = (com_gui__1.xgui[(*k << 1) - 1] + com_gui__1.xgui[(*k << 1) - 2]) * 
	    .5f - cha * .5f * (real) nl + cha * .2f;
    yca = (com_gui__1.ygui[(*k << 1) - 1] + com_gui__1.ygui[(*k << 1) - 2]) * 
	    .5f - cha * .6f;
    plchar_(&xca, &yca, &cha, label, &c_b7, &nl, label_len);

    newcolor_(&icol0);
    return 0;
} /* guibox_ */

logical lgui_(int *k, real *xc, real *yc)
{
    /* System generated locals */
    logical ret_val;

/* ----------------------------------------------- */
/*     Returns T if location XC,YC falls within */
/*     the GUI(K) window defined in GUIBOX. */
/* ----------------------------------------------- */

    ret_val = FALSE_;
    if (*k < 1 || *k > 20) {
	return ret_val;
    }

    ret_val = *xc > com_gui__1.xgui[(*k << 1) - 2] && *xc <= com_gui__1.xgui[(
	    *k << 1) - 1] && *yc > com_gui__1.ygui[(*k << 1) - 2] && *yc <= 
	    com_gui__1.ygui[(*k << 1) - 1];

    return ret_val;
} /* lgui_ */
