/* f/pxplot.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    int idev, idevrp, ipslu, n, naplt, na, matyp, retyp;
    logical lref, lforce, lmach, lises, lclfix, lalfix, lplot;
    int iaplt[80], nf, ii[160]	/* was [2][80] */, iib, ile[160]	
	    /* was [2][80] */, ite[160]	/* was [2][80] */, itran[160]	/* 
	    was [2][80] */;
    char code[8], name__[32];
} comi_;

#define comi_1 comi_

struct {
    real size, scrnfr, clmin, clmax, cdmin, cdmax, cmmin, cmmax, mach, reyn, 
	    acrit, gam, gm1, cpstar[80], ma[80], alfa[80], cl[80], cd[80], 
	    cdi[80], cm[80], aplt[80], xtr[160]	/* was [2][80] */, xf[500], 
	    mf[500], xb[250], yb[250], x[21120]	/* was [132][2][80] */, cp[
	    21120]	/* was [132][2][80] */, thet[21120]	/* was [132][
	    2][80] */, dstr[21120]	/* was [132][2][80] */, cf[21120]	
	    /* was [132][2][80] */, ctau[21120]	/* was [132][2][80] */, 
	    version;
} comr_;

#define comr_1 comr_

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static real c_b143 = .175f;
static int c_n3 = -3;
static real c_b145 = 0.f;
static real c_b156 = .58f;
static int c__2 = 2;
static int c__0 = 0;
static real c_b159 = .625f;
static real c_b160 = .2f;
static real c_b165 = 1.f;
static real c_b205 = .65f;
static int c__4 = 4;
static int c__8 = 8;
static int c__5 = 5;
static real c_b532 = 999.f;

/* Main program */ int MAIN__(void)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_cmp(char *, char *, ftnlen, ftnlen), s_wsle(cilist *), e_wsle(
	    void), do_lio(int *, int *, char *, ftnlen), s_rsle(
	    cilist *), e_rsle(void);
    /* Subroutine */ int s_stop(char *, ftnlen);
    int s_rsfe(cilist *), do_fio(int *, char *, ftnlen), e_rsfe(void);

    /* Local variables */
    static int narg, iopt;
    extern /* Subroutine */ int plinitialize_(void);
    static char fname[132];
    extern /* Subroutine */ int readit_(char *, ftnlen), selpnt_(void), 
	    pltpnt_(void), getarg0_(int *, char *, ftnlen), plclose_(void)
	    ;

    /* Fortran I/O blocks */
    static cilist io___3 = { 0, 6, 0, 0, 0 };
    static cilist io___4 = { 0, 6, 0, 0, 0 };
    static cilist io___5 = { 0, 6, 0, 0, 0 };
    static cilist io___6 = { 0, 6, 0, 0, 0 };
    static cilist io___7 = { 0, 6, 0, 0, 0 };
    static cilist io___8 = { 0, 6, 0, 0, 0 };
    static cilist io___9 = { 0, 6, 0, 0, 0 };
    static cilist io___10 = { 1, 5, 0, 0, 0 };
    static cilist io___12 = { 0, 6, 0, 0, 0 };
    static cilist io___13 = { 0, 5, 0, fmt_1000, 0 };


/* *********************************************************************** */
/*  Polar dump plotting facility for ISES and XFOIL */

/*    INPUT: */
/*     * Polar dump file generated by XFOIL (binary format) */
/* *********************************************************************** */

/* --- Uncomment for Win32/Compaq Visual Fortran compiler (needed for GETARG) */
/* cc      USE DFLIB */






/* ---- Plotting flag */
/* nothing here */
    comi_1.idev = 1;
/*     IDEV = 2   ! B&W PostScript output file only (no color) */
/*     IDEV = 3   ! both X11 and B&W PostScript file */
/*     IDEV = 4   ! Color PostScript output file only */
/*     IDEV = 5   ! both X11 and Color PostScript file */

/* ---- Re-plotting flag (for hardcopy) */
    comi_1.idevrp = 2;
/*     IDEVRP = 4   ! Color PostScript */

/* ---- PostScript output logical unit and file specification */
    comi_1.ipslu = 0;
/*     IPSLU = ?  ! output to file  plot?.ps  on LU 10+? */

/* ---- screen fraction taken up by plot window upon opening */
    comr_1.scrnfr = .7f;

/* ---- Default plot size in inches */
/* -    (Default plot window is 11.0 x 8.5) */
    comr_1.size = 8.f;

    comi_1.lref = FALSE_;
    comi_1.lforce = TRUE_;
    comi_1.lplot = FALSE_;

    plinitialize_();
    comi_1.na = 0;


/* ---- Check for dump file on command line */
    getarg0_(&narg, fname, (ftnlen)132);
    if (s_cmp(fname, " ", (ftnlen)132, (ftnlen)1) != 0) {
	goto L40;
    }

/* ======================================================= */
L2:
    s_wsle(&io___3);
    e_wsle();
    s_wsle(&io___4);
    do_lio(&c__9, &c__1, "Select option (0=quit):", (ftnlen)23);
    e_wsle();
    s_wsle(&io___5);
    e_wsle();
    s_wsle(&io___6);
    do_lio(&c__9, &c__1, "  1   Select point(s)", (ftnlen)21);
    e_wsle();
    s_wsle(&io___7);
    do_lio(&c__9, &c__1, "  2   Plot selected point(s)", (ftnlen)28);
    e_wsle();
    s_wsle(&io___8);
    do_lio(&c__9, &c__1, "  3   Load polar dump file", (ftnlen)26);
    e_wsle();
    s_wsle(&io___9);
    e_wsle();

    i__1 = s_rsle(&io___10);
    if (i__1 != 0) {
	goto L2;
    }
    i__1 = do_lio(&c__3, &c__1, (char *)&iopt, (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L2;
    }
    i__1 = e_rsle();
    if (i__1 != 0) {
	goto L2;
    }

    switch (iopt + 1) {
	case 1:  goto L5;
	case 2:  goto L10;
	case 3:  goto L20;
	case 4:  goto L30;
    }
    goto L2;

L5:
    plclose_();
    s_stop("", (ftnlen)0);

/* ---- Select alpha points for plotting */
L10:
    selpnt_();
    goto L2;

/* ---- Plot data for selected points */
L20:
    pltpnt_();
    goto L2;

/* ---- Load a polar dump file */
L30:
    s_wsle(&io___12);
    do_lio(&c__9, &c__1, "Enter polar dump filename", (ftnlen)25);
    e_wsle();
    s_rsfe(&io___13);
    do_fio(&c__1, fname, (ftnlen)132);
    e_rsfe();

L40:
    if (s_cmp(fname, " ", (ftnlen)132, (ftnlen)1) != 0) {
	readit_(fname, (ftnlen)132);
/* CC     CALL SORT */
    }
    goto L2;


} /* MAIN__ */

/* Subroutine */ int selpnt_(void)
{
    /* Format strings */
    static char fmt_9110[] = "(1x,f6.3,f8.3,f8.4,2f9.5,f8.4,2f7.4)";
    static char fmt_9120[] = "(1x,f7.3,f8.4,2f9.5,f8.4,2f7.4,f7.3)";
    static char fmt_9200[] = "(a80)";
    static char fmt_9500[] = "(1x,\002Mach  = \002,f6.3,\002  has not been c"
	    "omputed\002)";
    static char fmt_9600[] = "(1x,\002alpha = \002,f6.3,\002  has not been c"
	    "omputed\002)";

    /* System generated locals */
    int i__1, i__2;
    real r__1;

    /* Builtin functions */
    int s_wsle(cilist *), e_wsle(void), do_lio(int *, int *, char 
	    *, ftnlen), s_wsfe(cilist *), do_fio(int *, char *, ftnlen), 
	    e_wsfe(void), s_rsfe(cilist *), e_rsfe(void), s_cmp(char *, char *
	    , ftnlen, ftnlen);

    /* Local variables */
    static int i__, ia, ka, iia, nap, nin;
    static logical error;
    static char record[80];
    extern /* Subroutine */ int getflt_(char *, real *, int *, logical *, 
	    ftnlen);

    /* Fortran I/O blocks */
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___15 = { 0, 6, 0, 0, 0 };
    static cilist io___16 = { 0, 6, 0, 0, 0 };
    static cilist io___17 = { 0, 6, 0, 0, 0 };
    static cilist io___19 = { 0, 6, 0, fmt_9110, 0 };
    static cilist io___20 = { 0, 6, 0, 0, 0 };
    static cilist io___21 = { 0, 6, 0, fmt_9120, 0 };
    static cilist io___23 = { 0, 6, 0, 0, 0 };
    static cilist io___24 = { 0, 6, 0, 0, 0 };
    static cilist io___25 = { 0, 5, 0, fmt_9200, 0 };
    static cilist io___27 = { 0, 6, 0, 0, 0 };
    static cilist io___28 = { 0, 6, 0, 0, 0 };
    static cilist io___29 = { 0, 5, 0, fmt_9200, 0 };
    static cilist io___33 = { 0, 6, 0, fmt_9500, 0 };
    static cilist io___34 = { 0, 6, 0, fmt_9600, 0 };
    static cilist io___36 = { 0, 6, 0, 0, 0 };
    static cilist io___37 = { 0, 6, 0, 0, 0 };
    static cilist io___38 = { 0, 6, 0, 0, 0 };
    static cilist io___39 = { 0, 6, 0, 0, 0 };
    static cilist io___41 = { 0, 6, 0, fmt_9110, 0 };
    static cilist io___42 = { 0, 6, 0, 0, 0 };
    static cilist io___43 = { 0, 6, 0, fmt_9120, 0 };


/* ............................................. */
/*     Requests the user to select the target */
/*     points for all the surface plots. NAPLT */
/*     points are selected and their indices */
/*     are saved in the IAPLT array. */
/* ............................................. */





/* nothing here */
    s_wsle(&io___14);
    e_wsle();
    s_wsle(&io___15);
    do_lio(&c__9, &c__1, "Computed points are:", (ftnlen)20);
    e_wsle();
    s_wsle(&io___16);
    e_wsle();
    if (comi_1.lmach) {

	s_wsle(&io___17);
	do_lio(&c__9, &c__1, "  Mach   alpha    CL       CD      CDi      CM"
		"    S xtr  P xtr", (ftnlen)62);
	e_wsle();
/* CC       0.875 -10.111  1.1111  1.00000  1.00000  1.0000 1.0000 1.0000 */
	i__1 = comi_1.na;
	for (ia = 1; ia <= i__1; ++ia) {
	    s_wsfe(&io___19);
	    do_fio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}

    } else {

	s_wsle(&io___20);
	do_lio(&c__9, &c__1, "  alpha    CL       CD      CDi      CM    S x"
		"tr  P xtr   Mach", (ftnlen)62);
	e_wsle();
/* CC      -10.234  1.1111  1.00000  1.00000  1.0000 1.0000 1.0000  0.876 */
	i__1 = comi_1.na;
	for (ia = 1; ia <= i__1; ++ia) {
	    s_wsfe(&io___21);
	    do_fio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)sizeof(real));
	    e_wsfe();
	}

    }
    nap = 0;
    comi_1.naplt = 0;

L3:

    if (comi_1.lmach) {
	s_wsle(&io___23);
	e_wsle();
	s_wsle(&io___24);
	do_lio(&c__9, &c__1, "Enter Mach(s) of point(s) to be plotted:", (
		ftnlen)40);
	e_wsle();
	s_rsfe(&io___25);
	do_fio(&c__1, record, (ftnlen)80);
	e_rsfe();
    } else {
	s_wsle(&io___27);
	e_wsle();
	s_wsle(&io___28);
	do_lio(&c__9, &c__1, "Enter alpha(s) of point(s) to be plotted:", (
		ftnlen)41);
	e_wsle();
	s_rsfe(&io___29);
	do_fio(&c__1, record, (ftnlen)80);
	e_rsfe();
    }

/* ---- do not make any changes if just a <CR> was input */
    if (s_cmp(record, " ", (ftnlen)80, (ftnlen)1) == 0) {
	goto L80;
    }

    nin = 0;
    getflt_(record, &comr_1.aplt[nap], &nin, &error, (ftnlen)80);

/* ---- do not make any changes if just a <CR> was input */
    if (nin == 0) {
	goto L80;
    }
    comi_1.naplt += nin;

    if (comi_1.lmach) {

/* ---- save selected point indices and count up how many points there are */
	i__1 = comi_1.naplt;
	for (ka = nap + 1; ka <= i__1; ++ka) {
	    comi_1.iaplt[ka - 1] = 0;
	    i__2 = comi_1.na;
	    for (ia = 1; ia <= i__2; ++ia) {
		if ((r__1 = comr_1.aplt[ka - 1] - comr_1.ma[ia - 1], dabs(
			r__1)) <= .0011f) {
		    comi_1.iaplt[ka - 1] = ia;
		}
	    }
	    if (comi_1.iaplt[ka - 1] == 0) {
		s_wsfe(&io___33);
		do_fio(&c__1, (char *)&comr_1.aplt[ka - 1], (ftnlen)sizeof(
			real));
		e_wsfe();
	    }
/* L50: */
	}

    } else {

/* ---- save selected point indices and count up how many points there are */
	i__1 = comi_1.naplt;
	for (ka = nap + 1; ka <= i__1; ++ka) {
	    comi_1.iaplt[ka - 1] = 0;
	    i__2 = comi_1.na;
	    for (ia = 1; ia <= i__2; ++ia) {
		if ((r__1 = comr_1.aplt[ka - 1] - comr_1.alfa[ia - 1], dabs(
			r__1)) <= .0011f) {
		    comi_1.iaplt[ka - 1] = ia;
		}
	    }
	    if (comi_1.iaplt[ka - 1] == 0) {
		s_wsfe(&io___34);
		do_fio(&c__1, (char *)&comr_1.aplt[ka - 1], (ftnlen)sizeof(
			real));
		e_wsfe();
	    }
/* L60: */
	}

    }

/* --- Check for and eliminate invalid alpha or Mach points */
L70:
    i__1 = comi_1.naplt;
    for (ia = 1; ia <= i__1; ++ia) {
	if (comi_1.iaplt[ia - 1] <= 0) {
	    i__2 = comi_1.naplt;
	    for (iia = ia + 1; iia <= i__2; ++iia) {
		comr_1.aplt[iia - 2] = comr_1.aplt[iia - 1];
		comi_1.iaplt[iia - 2] = comi_1.iaplt[iia - 1];
	    }
	    --comi_1.naplt;
	    goto L70;
	}
    }

    nap = comi_1.naplt;
    goto L3;

/* ---- Display selected alphas/Machs */
L80:
    s_wsle(&io___36);
    e_wsle();
    s_wsle(&io___37);
    do_lio(&c__9, &c__1, "Selected points are:", (ftnlen)20);
    e_wsle();
    s_wsle(&io___38);
    e_wsle();
    if (comi_1.lmach) {
	s_wsle(&io___39);
	do_lio(&c__9, &c__1, "  Mach   alpha    CL       CD      CDi      CM"
		"    S xtr  P xtr", (ftnlen)62);
	e_wsle();
/* CC       0.875 -10.111  1.1111  1.00000  1.00000  1.0000 1.0000 1.0000 */
	i__1 = comi_1.naplt;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ia = comi_1.iaplt[i__ - 1];
	    s_wsfe(&io___41);
	    do_fio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}
    } else {
	s_wsle(&io___42);
	do_lio(&c__9, &c__1, "  alpha    CL       CD      CDi      CM    S x"
		"tr  P xtr   Mach", (ftnlen)62);
	e_wsle();
/* CC      -10.234  1.1111  1.00000  1.00000  1.0000 1.0000 1.0000  0.876 */
	i__1 = comi_1.naplt;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ia = comi_1.iaplt[i__ - 1];
	    s_wsfe(&io___43);
	    do_fio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)sizeof(real));
	    e_wsfe();
	}
    }

    return 0;
} /* selpnt_ */

/* Subroutine */ int pltpnt_(void)
{
    /* Format strings */
    static char fmt_9120[] = "(1x,f7.3,f7.3,f8.4,2f9.5,f8.4,2f7.4)";
    static char fmt_2000[] = "(/\002  1   Mach vs x\002/\002  2   Cp   vs "
	    "x\002/\002  3   Hk   vs x\002/\002  4   D,T  vs x (top    side"
	    ")\002/\002  5   D,T  vs x (bottom side)\002/\002  7   Cf   vs "
	    "x\002/\002  8   A/Ao vs x\002/\002  9   Ctau vs x\002/\002 12   "
	    "change settings\002/\002 13   annotate current plot\002/\002 14 "
	    "  hardcopy current plot\002//\002Select plot option (0 = return "
	    "to top level):  \002,$)";
    static char fmt_1200[] = "(1x,\002Current NAME: \002,a)";
    static char fmt_1210[] = "(a)";

    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2, r__3, r__4;
    doublereal d__1, d__2;

    /* Builtin functions */
    int s_wsle(cilist *), e_wsle(void), do_lio(int *, int *, char 
	    *, ftnlen), s_wsfe(cilist *), do_fio(int *, char *, ftnlen), 
	    e_wsfe(void), s_rsle(cilist *), e_rsle(void);
    double pow_dd(doublereal *, doublereal *), sqrt(doublereal), r_int(real *)
	    ;
    int s_rsfe(cilist *), e_rsfe(void);

    /* Local variables */
    static real h__;
    static int i__;
    static real w[21120]	/* was [132][2][80] */;
    static int ia;
    static real ch;
    static int ka, il;
    static real fn;
    static int is;
    static real xm, dma, dcp, ann;
    static int idt, itr, num;
    static real xsf, ysf, xax;
    static int iend;
    extern /* Subroutine */ int dash_(real *, real *, real *);
    static real yfac, dann, atmp, xoff, yoff;
    static int iopt;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real yaxt, cpmin, mamax;
    extern /* Subroutine */ int plend_(void), ident_(real *, real *);
    static real dyann, xwake;
    extern /* Subroutine */ int annot_(real *), xtick_(real *, real *, real *,
	     real *), yaxis_(real *, real *, real *, real *, real *, real *, 
	    real *, int *), xaxis_(real *, real *, real *, real *, real *,
	     real *, real *, int *), plchar_(real *, real *, real *, char 
	    *, real *, int *, ftnlen), airfoi_(real *, real *, real *), 
	    getref_(real *, real *, int *);
    static real machsq;
    extern /* Subroutine */ int scalit_(int *, real *, real *, real *), 
	    plmath_(real *, real *, real *, char *, real *, int *, ftnlen)
	    , newpen_(int *), pltini_(void);
    static real pratex;
    extern /* Subroutine */ int replot_(int *), rfplot_(int *, real *,
	     real *, real *, real *, real *, real *, real *, int *), 
	    pltfor_(real *, real *), xyline_(int *, real *, real *, real *
	    , real *, real *, real *, int *), plflush_(void);

    /* Fortran I/O blocks */
    static cilist io___50 = { 0, 6, 0, 0, 0 };
    static cilist io___51 = { 0, 6, 0, 0, 0 };
    static cilist io___52 = { 0, 6, 0, 0, 0 };
    static cilist io___53 = { 0, 6, 0, 0, 0 };
    static cilist io___56 = { 0, 6, 0, fmt_9120, 0 };
    static cilist io___57 = { 0, 6, 0, fmt_2000, 0 };
    static cilist io___58 = { 1, 5, 0, 0, 0 };
    static cilist io___83 = { 0, 6, 0, 0, 0 };
    static cilist io___84 = { 0, 6, 0, 0, 0 };
    static cilist io___85 = { 0, 6, 0, 0, 0 };
    static cilist io___86 = { 0, 6, 0, 0, 0 };
    static cilist io___87 = { 0, 6, 0, 0, 0 };
    static cilist io___88 = { 0, 6, 0, 0, 0 };
    static cilist io___89 = { 0, 6, 0, 0, 0 };
    static cilist io___90 = { 0, 6, 0, 0, 0 };
    static cilist io___91 = { 1, 5, 0, 0, 0 };
    static cilist io___93 = { 0, 6, 0, 0, 0 };
    static cilist io___94 = { 0, 6, 0, 0, 0 };
    static cilist io___95 = { 1, 5, 0, 0, 0 };
    static cilist io___96 = { 0, 6, 0, 0, 0 };
    static cilist io___97 = { 0, 6, 0, 0, 0 };
    static cilist io___98 = { 0, 6, 0, 0, 0 };
    static cilist io___99 = { 0, 6, 0, 0, 0 };
    static cilist io___100 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___101 = { 0, 6, 0, 0, 0 };
    static cilist io___102 = { 0, 5, 0, fmt_1210, 0 };
    static cilist io___103 = { 0, 6, 0, 0, 0 };








/* nothing here */
    ch = .015f;
    xwake = .3f;

/* ---- Cp amd Mach axis limits, increments */
    cpmin = -2.f;
    dcp = .5f;

    mamax = 1.4f;
    dma = .2f;

/* L6: */
    s_wsle(&io___50);
    e_wsle();
    s_wsle(&io___51);
    do_lio(&c__9, &c__1, "Selected points are:", (ftnlen)20);
    e_wsle();
    s_wsle(&io___52);
    e_wsle();
    s_wsle(&io___53);
    do_lio(&c__9, &c__1, "  alpha   Mach    CL       CD      CDi      CM    "
	    "S xtr  P xtr", (ftnlen)62);
    e_wsle();
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	if (ia != 0) {
	    s_wsfe(&io___56);
	    do_fio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)sizeof(
		    real));
	    do_fio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}
    }

/* L1100: */

L2:
    s_wsfe(&io___57);
    e_wsfe();
    i__1 = s_rsle(&io___58);
    if (i__1 != 0) {
	goto L2;
    }
    i__1 = do_lio(&c__3, &c__1, (char *)&iopt, (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L2;
    }
    i__1 = e_rsle();
    if (i__1 != 0) {
	goto L2;
    }

    if (iopt == 0) {
	if (comi_1.lplot) {
	    plend_();
	}
	comi_1.lplot = FALSE_;
	return 0;
    }


    switch (iopt) {
	case 1:  goto L10;
	case 2:  goto L20;
	case 3:  goto L30;
	case 4:  goto L40;
	case 5:  goto L50;
	case 6:  goto L2;
	case 7:  goto L70;
	case 8:  goto L80;
	case 9:  goto L90;
	case 10:  goto L2;
	case 11:  goto L2;
	case 12:  goto L120;
	case 13:  goto L130;
	case 14:  goto L140;
    }
/* CCC         1  2  3  4  5     7  8  9        12 */
    goto L2;

/* ============================================= */
/* **** Plot Mach vs x */

L10:
    comi_1.nf = 0;
    if (comi_1.lref) {
	getref_(comr_1.xf, comr_1.mf, &comi_1.nf);
    }

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
/* Computing 2nd power */
	r__1 = comr_1.ma[ia - 1];
	machsq = r__1 * r__1;
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		d__1 = (doublereal) (comr_1.cp[i__ + (is + (ia << 1)) * 132 - 
			397] * .5f * comr_1.gam * machsq + 1.f);
		d__2 = (doublereal) (comr_1.gm1 / comr_1.gam);
		pratex = pow_dd(&d__1, &d__2) / (comr_1.gm1 * .5f * machsq + 
			1.f);
		atmp = (r__1 = 1.f / pratex - 1.f, dabs(r__1));
		w[i__ + (is + (ka << 1)) * 132 - 397] = sqrt(atmp * 2.f / 
			comr_1.gm1);
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b143, &c_n3);

/* CC      CALL SCALIT(NX*2*NAPLT,W,0.0,YFAC) */
    yfac = 1.f / mamax;

    yaxt = .7f;

    xoff = -.1f;
    xsf = .75f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    r__1 = ysf * mamax;
    r__2 = ysf * dma;
    yaxis_(&c_b145, &c_b145, &r__1, &r__2, &c_b145, &dma, &ch, &c__1);
    newpen_(&c__3);
    r__1 = ch * -3.f;
    r__2 = yaxt * .8f;
    r__3 = ch * 1.4f;
    plchar_(&r__1, &r__2, &r__3, "M", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = ysf * .05f / xsf;
    airfoi_(&xoff, &r__1, &xsf);

    newpen_(&c__1);
    if (1.f <= mamax) {
	r__1 = (1.f - yoff) * ysf;
	dash_(&c_b145, &c_b156, &r__1);
    }
    r__1 = -ysf * comr_1.ma[ia - 1];
    r__2 = 1.f / xsf;
    xtick_(&xoff, &r__1, &xsf, &r__2);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    if (is == 1) {
		iend = comi_1.ite[is + (ia << 1) - 3];
	    }
	    xyline_(&iend, &comr_1.x[(is + (ia << 1)) * 132 - 396], &w[(is + (
		    ka << 1)) * 132 - 396], &xoff, &xsf, &yoff, &ysf, &ka);
	}
    }

    if (comi_1.lref) {
	r__1 = ch * .5f;
	rfplot_(&comi_1.nf, comr_1.xf, comr_1.mf, &xoff, &xsf, &yoff, &ysf, &
		r__1, &c__0);
    }

    pltfor_(&c_b159, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;


/* ============================================= */
/* **** Plot Cp vs x */

L20:
    comi_1.nf = 0;
    if (comi_1.lref) {
	getref_(comr_1.xf, comr_1.mf, &comi_1.nf);
    }

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		w[i__ + (is + (ka << 1)) * 132 - 397] = -comr_1.cp[i__ + (is 
			+ (ia << 1)) * 132 - 397];
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

/* CC      CALL SCALIT(NX*2*NAPLT,W,0.0,YFAC) */
    yfac = 1.f / (-cpmin);

    yaxt = .4f;

    xoff = -.1f;
    xsf = .75f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    plot_(&c_b145, &ysf, &c_n3);

    r__1 = -ysf;
    r__2 = ysf * (1.f - cpmin);
    r__3 = ysf * dcp;
    r__4 = -dcp;
    yaxis_(&c_b145, &r__1, &r__2, &r__3, &c_b165, &r__4, &ch, &c__1);
    newpen_(&c__3);
    r__1 = ch * -3.5f;
    r__2 = yaxt * .875f - ch * .3f;
    r__3 = ch * 1.4f;
    plchar_(&r__1, &r__2, &r__3, "C", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -2.4f;
    r__2 = yaxt * .875f - ch * .7f;
    r__3 = ch * .9f;
    plchar_(&r__1, &r__2, &r__3, "p", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    newpen_(&c__1);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	if (-comr_1.cpstar[ia - 1] <= -cpmin) {
	    r__1 = (-comr_1.cpstar[ia - 1] - yoff) * ysf;
	    dash_(&c_b145, &c_b156, &r__1);
	}
    }

    r__1 = ysf * 1.25f / xsf;
    airfoi_(&xoff, &r__1, &xsf);
    r__1 = 1.f / xsf;
    xtick_(&xoff, &c_b145, &xsf, &r__1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    if (is == 1) {
		iend = comi_1.ite[is + (ia << 1) - 3];
	    }
	    xyline_(&iend, &comr_1.x[(is + (ia << 1)) * 132 - 396], &w[(is + (
		    ka << 1)) * 132 - 396], &xoff, &xsf, &yoff, &ysf, &ka);
	}
    }

    if (comi_1.lref) {
	r__1 = -yoff;
	r__2 = -ysf;
	r__3 = ch * .5f;
	rfplot_(&comi_1.nf, comr_1.xf, comr_1.mf, &xoff, &xsf, &r__1, &r__2, &
		r__3, &c__0);
    }

    pltfor_(&c_b159, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** Plot H vs sb */

L30:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

/* ...... Find Hk for plotting */
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
/* Computing 2nd power */
	r__1 = comr_1.ma[ia - 1];
	machsq = r__1 * r__1;
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend;
	    for (i__ = comi_1.ile[is + (ia << 1) - 3] + 1; i__ <= i__2; ++i__)
		     {
		h__ = comr_1.dstr[i__ + (is + (ia << 1)) * 132 - 397] / 
			comr_1.thet[i__ + (is + (ia << 1)) * 132 - 397];
		d__1 = (doublereal) (comr_1.cp[i__ + (is + (ia << 1)) * 132 - 
			397] * .5f * comr_1.gam * machsq + 1.f);
		d__2 = (doublereal) (comr_1.gm1 / comr_1.gam);
		pratex = pow_dd(&d__1, &d__2) / (comr_1.gm1 * .5f * machsq + 
			1.f);
		atmp = (r__1 = 1.f / pratex - 1.f, dabs(r__1));
		xm = sqrt(atmp * 2.f / comr_1.gm1);
/* Computing 2nd power */
		r__1 = xm;
/* Computing 2nd power */
		r__2 = xm;
		w[i__ + (is + (ka << 1)) * 132 - 397] = (h__ - r__1 * r__1 * 
			.29f) / (r__2 * r__2 * .113f + 1.f);
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

/* CC      CALL SCALIT(NX*2*NAPLT,W,0.0,YFAC) */
    yfac = .16666666666666666f;

    ann = 1.f / yfac;
    yaxt = .6f;

    xoff = 0.f;
    xsf = .6f;

    yoff = 0.f;
    ysf = yfac * yaxt;
    xax = xsf * 1.4f;

    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    r__1 = yaxt / 6.f;
    r__2 = ann / 6.f;
    yaxis_(&c_b145, &c_b145, &yaxt, &r__1, &c_b145, &r__2, &ch, &c__1);

    newpen_(&c__3);
    r__1 = ch * -4.f;
    r__2 = yfac * 3.4f;
    r__3 = ch * 1.4f;
    plchar_(&r__1, &r__2, &r__3, "H", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -2.6f;
    r__2 = yfac * 3.4f - ch * .4f;
    plchar_(&r__1, &r__2, &ch, "k", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    il = comi_1.ile[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    if (is == 1) {
		iend = comi_1.ite[is + (ia << 1) - 3] + 1;
	    }
	    i__2 = iend - 1 - il;
	    xyline_(&i__2, &comr_1.x[il + 1 + (is + (ia << 1)) * 132 - 397], &
		    w[il + 1 + (is + (ka << 1)) * 132 - 397], &xoff, &xsf, &
		    yoff, &ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** plot top Dstar, Theta vs sb */

L40:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    is = 1;
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	i__2 = iend;
	for (i__ = comi_1.ile[is + (ia << 1) - 3] + 1; i__ <= i__2; ++i__) {
	    w[i__ + ((ka << 1) + 1) * 132 - 397] = comr_1.dstr[i__ + (is + (
		    ia << 1)) * 132 - 397];
	    w[i__ + ((ka << 1) + 2) * 132 - 397] = comr_1.thet[i__ + (is + (
		    ia << 1)) * 132 - 397];
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

    i__1 = comi_1.naplt * 264;
    scalit_(&i__1, w, &c_b145, &yfac);

    ann = 1.f / yfac;

    yaxt = .6f;
    xoff = 0.f;
    xsf = .6f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    xax = xsf * 1.4f;
    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    fn = 5.f;
    r__1 = yaxt / fn;
    r__2 = ann / fn;
    yaxis_(&c_b145, &c_b145, &yaxt, &r__1, &c_b145, &r__2, &ch, &c__3);

    newpen_(&c__3);
    r__1 = ch * -4.5f;
    r__2 = yaxt * 3.4f / fn;
    r__3 = ch * 1.3f;
    plchar_(&r__1, &r__2, &r__3, "Top", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -4.f;
    r__2 = yaxt * 2.4f / fn;
    r__3 = ch * 1.5f;
    plmath_(&r__1, &r__2, &r__3, "d", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -2.5f;
    r__2 = yaxt * 2.4f / fn + ch * 1.6f;
    r__3 = ch * .6f;
    plchar_(&r__1, &r__2, &r__3, "*", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -3.5f;
    r__2 = yaxt * 1.4f / fn;
    r__3 = ch * 1.5f;
    plmath_(&r__1, &r__2, &r__3, "q", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (idt = 1; idt <= 2; ++idt) {
	    il = comi_1.ile[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend - 1 - il;
	    xyline_(&i__2, &comr_1.x[il + 1 + ((ia << 1) + 1) * 132 - 397], &
		    w[il + 1 + (idt + (ka << 1)) * 132 - 397], &xoff, &xsf, &
		    yoff, &ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** plot bottom Dstar, Theta vs sb */

L50:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    is = 2;
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	i__2 = iend;
	for (i__ = comi_1.ile[is + (ia << 1) - 3] + 1; i__ <= i__2; ++i__) {
	    w[i__ + ((ka << 1) + 1) * 132 - 397] = comr_1.dstr[i__ + (is + (
		    ia << 1)) * 132 - 397];
	    w[i__ + ((ka << 1) + 2) * 132 - 397] = comr_1.thet[i__ + (is + (
		    ia << 1)) * 132 - 397];
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

    i__1 = comi_1.naplt * 264;
    scalit_(&i__1, w, &c_b145, &yfac);

    ann = 1.f / yfac;

    yaxt = .6f;
    xoff = 0.f;
    xsf = .6f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    xax = xsf * 1.4f;
    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    fn = 5.f;
    r__1 = yaxt / fn;
    r__2 = ann / fn;
    yaxis_(&c_b145, &c_b145, &yaxt, &r__1, &c_b145, &r__2, &ch, &c__3);

    newpen_(&c__3);
    r__1 = ch * -4.5f;
    r__2 = yaxt * 3.4f / fn;
    r__3 = ch * 1.3f;
    plchar_(&r__1, &r__2, &r__3, "Bot", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -4.f;
    r__2 = yaxt * 2.4f / fn;
    r__3 = ch * 1.5f;
    plmath_(&r__1, &r__2, &r__3, "d", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -2.5f;
    r__2 = yaxt * 2.4f / fn + ch * 1.6f;
    r__3 = ch * .6f;
    plchar_(&r__1, &r__2, &r__3, "*", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -3.5f;
    r__2 = yaxt * 1.4f / fn;
    r__3 = ch * 1.5f;
    plmath_(&r__1, &r__2, &r__3, "q", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (idt = 1; idt <= 2; ++idt) {
	    il = comi_1.ile[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend - 1 - il;
	    xyline_(&i__2, &comr_1.x[il + 1 + ((ia << 1) + 2) * 132 - 397], &
		    w[il + 1 + (idt + (ka << 1)) * 132 - 397], &xoff, &xsf, &
		    yoff, &ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** Plot Cf vs sb */

L70:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend;
	    for (i__ = comi_1.ile[is + (ia << 1) - 3] + 1; i__ <= i__2; ++i__)
		     {
		w[i__ + (is + (ka << 1)) * 132 - 397] = comr_1.cf[i__ + (is + 
			(ia << 1)) * 132 - 397];
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

    i__1 = comi_1.naplt * 264;
    scalit_(&i__1, w, &c_b145, &yfac);
    yfac *= 2.f;

    ann = 1.f / yfac;

    yaxt = .6f;

    xoff = 0.f;
    xsf = .6f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    fn = 5.f;
    r__1 = yaxt / fn;
    r__2 = ann / fn;
    yaxis_(&c_b145, &c_b145, &yaxt, &r__1, &c_b145, &r__2, &ch, &c__3);

    xax = xsf * 1.4f;
    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    newpen_(&c__3);
    r__1 = ch * -3.5f;
    r__2 = yaxt * 2.5f / fn;
    r__3 = ch * 1.4f;
    plchar_(&r__1, &r__2, &r__3, "C", &c_b145, &c__1, (ftnlen)1);
    r__1 = ch * -2.1f;
    r__2 = yaxt * 2.5f / fn - ch * .4f;
    r__3 = ch * 1.f;
    plchar_(&r__1, &r__2, &r__3, "f", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    il = comi_1.ile[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    if (is == 1) {
		iend = comi_1.ite[is + (ia << 1) - 3] + 1;
	    }
	    i__2 = iend - 1 - il;
	    xyline_(&i__2, &comr_1.x[il + 1 + (is + (ia << 1)) * 132 - 397], &
		    w[il + 1 + (is + (ka << 1)) * 132 - 397], &xoff, &xsf, &
		    yoff, &ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** plot A/Ao vs sb */
L80:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    itr = comi_1.itran[is + (ia << 1) - 3];
	    i__2 = itr - 1;
	    for (i__ = comi_1.ile[is + (ia << 1) - 3] + 1; i__ <= i__2; ++i__)
		     {
		w[i__ + (is + (ka << 1)) * 132 - 397] = comr_1.ctau[i__ + (is 
			+ (ia << 1)) * 132 - 397];
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

/* CC      CALL SCALIT(NX*2*NAPLT,W,0.0,YFAC) */
    r__1 = (comr_1.acrit + 1.f) * .5f;
    yfac = 1.f / (r_int(&r__1) * 2.f);

    ann = 1.f / yfac;

    yaxt = .6f;

    ysf = yfac * yaxt;
    yoff = 0.f;

    xoff = 0.f;
    xsf = .6f;
    xax = xsf * 1.4f;

    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    dann = 2.f;
    dyann = yaxt / (ann / dann);
    yaxis_(&c_b145, &c_b145, &yaxt, &dyann, &c_b145, &dann, &ch, &c__1);
    newpen_(&c__3);
    r__1 = ch * -4.5f;
    r__2 = dyann * 4.4f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "log", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -5.f;
    r__2 = dyann * 3.4f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "A/A", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -1.4f;
    r__2 = dyann * 3.4f - ch * .4f;
    r__3 = ch * .8f;
    plchar_(&r__1, &r__2, &r__3, "0", &c_b145, &c__1, (ftnlen)1);
    ident_(&c_b145, &yaxt);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    r__1 = (comr_1.acrit - yoff) * ysf;
    dash_(&c_b145, &c_b165, &r__1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    il = comi_1.ile[is + (ia << 1) - 3];
	    itr = comi_1.itran[is + (ia << 1) - 3];
	    i__2 = itr - (il + 1);
	    xyline_(&i__2, &comr_1.x[il + 1 + (is + (ia << 1)) * 132 - 397], &
		    w[il + 1 + (is + (ka << 1)) * 132 - 397], &xoff, &xsf, &
		    yoff, &ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** Plot Ctau vs sb */

L90:

    for (ia = 1; ia <= 80; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    for (i__ = 1; i__ <= 132; ++i__) {
		w[i__ + (is + (ia << 1)) * 132 - 397] = 0.f;
	    }
	}
    }

    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    itr = comi_1.itran[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    i__2 = iend;
	    for (i__ = itr; i__ <= i__2; ++i__) {
		w[i__ + (is + (ka << 1)) * 132 - 397] = comr_1.ctau[i__ + (is 
			+ (ia << 1)) * 132 - 397];
	    }
	}
    }

    pltini_();
    r__1 = ch * 6.f;
    plot_(&r__1, &c_b160, &c_n3);

    i__1 = comi_1.naplt * 264;
    scalit_(&i__1, w, &c_b145, &yfac);

    ann = 1.f / yfac;

    yaxt = .6f;

    xoff = 0.f;
    xsf = .6f;

    yoff = 0.f;
    ysf = yfac * yaxt;

    xax = xsf * 1.4f;
    r__1 = xsf * .2f;
    xaxis_(&c_b145, &c_b145, &xax, &r__1, &c_b145, &c_b160, &ch, &c__1);

    fn = 5.f;
    r__1 = yaxt / fn;
    r__2 = ann / fn;
    yaxis_(&c_b145, &c_b145, &yaxt, &r__1, &c_b145, &r__2, &ch, &c__2);
    newpen_(&c__3);
    r__1 = ch * -4.5f;
    r__2 = yaxt * 2.5f / fn;
    r__3 = ch * 1.4f;
    plmath_(&r__1, &r__2, &r__3, "R  ", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -4.5f;
    r__2 = yaxt * 2.5f / fn;
    r__3 = ch * 1.4f;
    plchar_(&r__1, &r__2, &r__3, " C ", &c_b145, &c__3, (ftnlen)3);
    r__1 = ch * -2.1f;
    r__2 = yaxt * 2.5f / fn - ch * .4f;
    r__3 = ch * 1.f;
    plmath_(&r__1, &r__2, &r__3, "  t", &c_b145, &c__3, (ftnlen)3);
    r__1 = ann * ysf;
    ident_(&c_b145, &r__1);

    r__1 = xsf * 1.1f - ch * .6f;
    r__2 = ch * -3.5f;
    r__3 = ch * 1.2f;
    plchar_(&r__1, &r__2, &r__3, "X", &c_b145, &c__1, (ftnlen)1);

    newpen_(&c__2);
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	for (is = 1; is <= 2; ++is) {
	    itr = comi_1.itran[is + (ia << 1) - 3];
	    iend = comi_1.ii[is + (ia << 1) - 3] - 1;
	    if (is == 1) {
		iend = comi_1.ite[is + (ia << 1) - 3] + 1;
	    }
	    i__2 = iend - itr;
	    xyline_(&i__2, &comr_1.x[itr + (is + (ia << 1)) * 132 - 397], &w[
		    itr + (is + (ka << 1)) * 132 - 397], &xoff, &xsf, &yoff, &
		    ysf, &ka);
	}
    }

    pltfor_(&c_b205, &yaxt);

    plflush_();
/* cc      WRITE(*,*) 'Hit <return>' */
/* cc      READ (*,1100) ANS */
    goto L2;

/* ============================================= */
/* **** Change settings */

L120:
    s_wsle(&io___83);
    e_wsle();
    s_wsle(&io___84);
    do_lio(&c__9, &c__1, "  0  Cancel", (ftnlen)11);
    e_wsle();
    s_wsle(&io___85);
    do_lio(&c__9, &c__1, "  1  SIZE    plot size", (ftnlen)22);
    e_wsle();
    s_wsle(&io___86);
    do_lio(&c__9, &c__1, "  2  LREF    reference solution plotting flag", (
	    ftnlen)45);
    e_wsle();
    s_wsle(&io___87);
    do_lio(&c__9, &c__1, "  3  LFORCE  force coefficient plotting flag", (
	    ftnlen)44);
    e_wsle();
    s_wsle(&io___88);
    do_lio(&c__9, &c__1, "  4  NAME    case name", (ftnlen)22);
    e_wsle();
    s_wsle(&io___89);
    e_wsle();
L129:
    s_wsle(&io___90);
    do_lio(&c__9, &c__1, "Change what ?", (ftnlen)13);
    e_wsle();
    i__1 = s_rsle(&io___91);
    if (i__1 != 0) {
	goto L129;
    }
    i__1 = do_lio(&c__3, &c__1, (char *)&num, (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L129;
    }
    i__1 = e_rsle();
    if (i__1 != 0) {
	goto L129;
    }
    if (num == 0) {
	return 0;
    }
    if (num == 1) {
	s_wsle(&io___93);
	do_lio(&c__9, &c__1, "Currently SIZE = ", (ftnlen)17);
	do_lio(&c__4, &c__1, (char *)&comr_1.size, (ftnlen)sizeof(real));
	e_wsle();
L121:
	s_wsle(&io___94);
	do_lio(&c__9, &c__1, "Enter new value:", (ftnlen)16);
	e_wsle();
	i__1 = s_rsle(&io___95);
	if (i__1 != 0) {
	    goto L121;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&comr_1.size, (ftnlen)sizeof(real)
		);
	if (i__1 != 0) {
	    goto L121;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L121;
	}
    } else if (num == 2) {
	comi_1.lref = ! comi_1.lref;
	if (comi_1.lref) {
	    s_wsle(&io___96);
	    do_lio(&c__9, &c__1, "Reference data will be overlaid", (ftnlen)
		    31);
	    e_wsle();
	}
	if (! comi_1.lref) {
	    s_wsle(&io___97);
	    do_lio(&c__9, &c__1, "Reference data will not be overlaid", (
		    ftnlen)35);
	    e_wsle();
	}
    } else if (num == 3) {
	comi_1.lforce = ! comi_1.lforce;
	if (comi_1.lforce) {
	    s_wsle(&io___98);
	    do_lio(&c__9, &c__1, "Force coeffs. will be plotted", (ftnlen)29);
	    e_wsle();
	}
	if (! comi_1.lforce) {
	    s_wsle(&io___99);
	    do_lio(&c__9, &c__1, "Force coeffs. will not be plotted", (ftnlen)
		    33);
	    e_wsle();
	}
    } else if (num == 4) {
	s_wsfe(&io___100);
	do_fio(&c__1, comi_1.name__, (ftnlen)32);
	e_wsfe();
	s_wsle(&io___101);
	do_lio(&c__9, &c__1, "Enter new name:", (ftnlen)15);
	e_wsle();
	s_rsfe(&io___102);
	do_fio(&c__1, comi_1.name__, (ftnlen)32);
	e_rsfe();
    }
    goto L2;

/* ============================================= */
/* **** annotate plot */
L130:
    if (! comi_1.lplot) {
	s_wsle(&io___103);
	do_lio(&c__9, &c__1, "No active plot to annotate", (ftnlen)26);
	e_wsle();
    } else {
	annot_(&ch);
    }
    goto L2;

/* ============================================= */
/* **** hardcopy output */
L140:
    if (comi_1.lplot) {
	plend_();
    }
    comi_1.lplot = FALSE_;
    replot_(&comi_1.idevrp);
    goto L2;

} /* pltpnt_ */

/* Subroutine */ int pltini_(void)
{
    extern /* Subroutine */ int newfactor_(real *), plend_(void), plopen_(
	    real *, int *, int *);






/* nothing here */
    if (comi_1.lplot) {
	plend_();
    }

    plopen_(&comr_1.scrnfr, &comi_1.ipslu, &comi_1.idev);
    comi_1.lplot = TRUE_;

    newfactor_(&comr_1.size);

    return 0;
} /* pltini_ */

/* Subroutine */ int xtick_(real *xoff, real *yoff, real *xsf, real *xlen)
{
    /* System generated locals */
    real r__1, r__2;

    /* Local variables */
    static int nt;
    static real xt;
    extern /* Subroutine */ int plot_(real *, real *, int *), newpen_(
	    int *);

    newpen_(&c__1);

    r__1 = -(*yoff);
    plot_(&c_b145, &r__1, &c__3);
    r__1 = -(*xoff) * *xsf;
    r__2 = -(*yoff);
    plot_(&r__1, &r__2, &c__2);

    r__1 = -(*xoff) * *xsf;
    r__2 = -(*yoff);
    plot_(&r__1, &r__2, &c__3);
    r__1 = (*xlen - *xoff) * *xsf;
    r__2 = -(*yoff);
    plot_(&r__1, &r__2, &c__2);
    for (nt = 1; nt <= 9; ++nt) {
	xt = (real) nt / 10.f;
	r__1 = (xt - *xoff) * *xsf;
	r__2 = -(*yoff) + .0025f;
	plot_(&r__1, &r__2, &c__3);
	r__1 = (xt - *xoff) * *xsf;
	r__2 = -(*yoff) - .0025f;
	plot_(&r__1, &r__2, &c__2);
/* L10: */
    }
    for (nt = 0; nt <= 2; ++nt) {
	xt = (real) nt / 2.f;
	r__1 = (xt - *xoff) * *xsf;
	r__2 = -(*yoff) + .005f;
	plot_(&r__1, &r__2, &c__3);
	r__1 = (xt - *xoff) * *xsf;
	r__2 = -(*yoff) - .005f;
	plot_(&r__1, &r__2, &c__2);
/* L20: */
    }
    return 0;
} /* xtick_ */

/* Subroutine */ int rfplot_(int *n, real *x, real *y, real *xoff, real *
	xwt, real *yoff, real *ywt, real *ch, int *id)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int i__, isym;
    static real xplt, yplt;
    extern /* Subroutine */ int plsymb_(real *, real *, real *, int *, 
	    real *, int *);


    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    isym = *id;
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xplt = *xwt * (x[i__] - *xoff);
	yplt = *ywt * (y[i__] - *yoff);
	if (x[i__] == 999.f) {
	    ++isym;
	} else {
	    plsymb_(&xplt, &yplt, ch, &isym, &c_b145, &c__0);
	}
/* L10: */
    }

    return 0;
} /* rfplot_ */

/* Subroutine */ int airfoi_(real *xoff, real *yoff, real *sf)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Local variables */
    static int ib, ipen;
    extern /* Subroutine */ int plot_(real *, real *, int *), newpen_(
	    int *);






/* nothing here */
    newpen_(&c__2);
    ipen = 3;
    i__1 = comi_1.iib;
    for (ib = 1; ib <= i__1; ++ib) {
	r__1 = (comr_1.xb[ib - 1] - *xoff) * *sf;
	r__2 = (comr_1.yb[ib - 1] - *yoff) * *sf;
	plot_(&r__1, &r__2, &ipen);
	ipen = 2;
/* L10: */
    }

    return 0;
} /* airfoi_ */

/* Subroutine */ int pltfor_(real *x1, real *y1)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;

    /* Local variables */
    static int ia, ka;
    static real ch2, ch3, xl1, xl2, xl3, xl4, xl5, xl6, chn;
    static int lnb;
    static real dxl1, dxl2, dxl3, dxl4, xlab, ylab;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static int ityp;
    extern /* Subroutine */ int plchar_(real *, real *, real *, char *, real *
	    , int *, ftnlen), plmath_(real *, real *, real *, char *, 
	    real *, int *, ftnlen), newpen_(int *), plnumb_(real *, 
	    real *, real *, real *, real *, int *);






/*      CH2 = 0.012 */
/*      CH3 = 0.010 */
/*      CHN = 0.015 */

/* nothing here */
    ch2 = .015f;
    ch3 = .013f;
    chn = .018f;

/* ---- find index of last non-blank character in NAME array */
    for (lnb = 32; lnb >= 1; --lnb) {
	if (*(unsigned char *)&comi_1.name__[lnb - 1] != ' ') {
	    goto L11;
	}
/* L10: */
    }
    lnb = 1;
L11:
/* CC      LNB = LNB-1 */

    xlab = *x1;
    ylab = *y1;

    if (lnb > 0) {
	newpen_(&c__4);
	plchar_(x1, &ylab, &chn, comi_1.name__, &c_b145, &lnb, (ftnlen)32);
	ylab -= ch2 * .5f;
    }

    if (comi_1.lmach) {
	if (comi_1.lclfix) {
	    xlab = *x1;
	    ylab -= ch2 * 2.2f;
	    newpen_(&c__3);
	    plchar_(&xlab, &ylab, &ch2, "CL    = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	    newpen_(&c__2);
	    r__1 = xlab + ch2 * 8.f;
	    plnumb_(&r__1, &ylab, &ch2, comr_1.cl, &c_b145, &c__4);
	} else {
	    xlab = *x1;
	    ylab -= ch2 * 2.2f;
	    newpen_(&c__3);
	    plchar_(&xlab, &ylab, &ch2, "Alfa  = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	    newpen_(&c__2);
	    r__1 = xlab + ch2 * 8.f;
	    plnumb_(&r__1, &ylab, &ch2, comr_1.alfa, &c_b145, &c__4);
	}
    } else {
	xlab = *x1;
	ylab -= ch2 * 2.2f;
	newpen_(&c__3);
	ityp = comi_1.matyp;
	if (ityp == 1) {
	    plchar_(&xlab, &ylab, &ch2, "Ma    = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 2) {
	    plchar_(&xlab, &ylab, &ch2, "Ma CL = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 2) {
	    plmath_(&xlab, &ylab, &ch2, "  R     ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 3) {
	    plchar_(&xlab, &ylab, &ch2, "Ma CL = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 3) {
	    plmath_(&xlab, &ylab, &ch2, "  #     ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	newpen_(&c__2);
	r__1 = xlab + ch2 * 8.f;
	plnumb_(&r__1, &ylab, &ch2, &comr_1.mach, &c_b145, &c__4);
    }

    if (comr_1.reyn != 0.f) {
	ylab -= ch2 * 2.f;
	newpen_(&c__3);
	ityp = comi_1.retyp;
	if (ityp == 1) {
	    plchar_(&xlab, &ylab, &ch2, "Re    = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 2) {
	    plchar_(&xlab, &ylab, &ch2, "Re CL = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 2) {
	    plmath_(&xlab, &ylab, &ch2, "  R     ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 3) {
	    plchar_(&xlab, &ylab, &ch2, "Re CL = ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	if (ityp == 3) {
	    plmath_(&xlab, &ylab, &ch2, "  #     ", &c_b145, &c__8, (ftnlen)8)
		    ;
	}
	newpen_(&c__2);
	r__1 = xlab + ch2 * 8.f;
	plnumb_(&r__1, &ylab, &ch2, &comr_1.reyn, &c_b145, &c__4);
	r__1 = xlab + ch2 * 14.f;
	r__2 = ylab + ch2 * .2f;
	r__3 = ch2 * .8f;
	plmath_(&r__1, &r__2, &r__3, " #   ", &c_b145, &c__5, (ftnlen)5);
	r__1 = xlab + ch2 * 14.f;
	plchar_(&r__1, &ylab, &ch2, "  10 ", &c_b145, &c__5, (ftnlen)5);
	r__1 = xlab + ch2 * 14.f;
	r__2 = ylab + ch2 * .6f;
	plmath_(&r__1, &r__2, &ch2, "    6", &c_b145, &c__5, (ftnlen)5);

	ylab -= ch2 * 2.f;
	newpen_(&c__3);
	plchar_(&xlab, &ylab, &ch2, "N", &c_b145, &c__1, (ftnlen)1);
	r__1 = xlab + ch2 * 1.f;
	r__2 = ch2 * .75f;
	plchar_(&r__1, &ylab, &r__2, "crit", &c_b145, &c__4, (ftnlen)4);
	r__1 = xlab + ch2 * 4.f;
	plchar_(&r__1, &ylab, &ch2, "  = ", &c_b145, &c__4, (ftnlen)4);
	newpen_(&c__2);
	r__1 = xlab + ch2 * 8.f;
	plnumb_(&r__1, &ylab, &ch2, &comr_1.acrit, &c_b145, &c__3);
    }

    xl1 = xlab;
    xl2 = xl1 + ch3 * 7.f;
    xl3 = xl2 + ch3 * 8.f;
    xl4 = xl3 + ch3 * 9.f;
    xl5 = xl4 + ch3 * 8.f;
    xl6 = xl5 + ch3 * 7.f;
    ylab -= ch3 * 2.7f;
    newpen_(&c__3);
    if (comi_1.lmach) {
	r__1 = xl1 + ch3 * .5f;
	plchar_(&r__1, &ylab, &ch3, "Mach", &c_b145, &c__4, (ftnlen)4);
	if (comi_1.lclfix) {
	    r__1 = xl2 + ch3 * .5f;
	    plchar_(&r__1, &ylab, &ch3, "Alfa", &c_b145, &c__4, (ftnlen)4);
	} else {
	    r__1 = xl2 + ch3 * .5f;
	    plchar_(&r__1, &ylab, &ch3, " CL ", &c_b145, &c__4, (ftnlen)4);
	}
    } else {
	r__1 = xl1 + ch3 * .5f;
	plchar_(&r__1, &ylab, &ch3, "Alfa", &c_b145, &c__4, (ftnlen)4);
	r__1 = xl2 + ch3 * .5f;
	plchar_(&r__1, &ylab, &ch3, " CL ", &c_b145, &c__4, (ftnlen)4);
    }
    r__1 = xl3 + ch3 * 2.5f;
    plchar_(&r__1, &ylab, &ch3, "CD", &c_b145, &c__2, (ftnlen)2);
    r__1 = xl4 + ch3 * 2.f;
    plchar_(&r__1, &ylab, &ch3, "CM", &c_b145, &c__2, (ftnlen)2);
    if (comr_1.reyn != 0.f) {
	r__1 = xl5 + ch3 * 1.5f;
	plchar_(&r__1, &ylab, &ch3, "Xtr", &c_b145, &c__3, (ftnlen)3);
	r__1 = ch3 * .6f;
	plchar_(&c_b532, &ylab, &r__1, "T", &c_b145, &c__1, (ftnlen)1);
	r__1 = xl6 + ch3 * 1.5f;
	plchar_(&r__1, &ylab, &ch3, "Xtr", &c_b145, &c__3, (ftnlen)3);
	r__1 = ch3 * .6f;
	plchar_(&c_b532, &ylab, &r__1, "B", &c_b145, &c__1, (ftnlen)1);
    }

    newpen_(&c__1);
    r__1 = ylab - ch3 * .4f;
    plot_(&xl1, &r__1, &c__3);
    r__1 = xl1 + ch3 * 5.f;
    r__2 = ylab - ch3 * .4f;
    plot_(&r__1, &r__2, &c__2);
    r__1 = ylab - ch3 * .4f;
    plot_(&xl2, &r__1, &c__3);
    r__1 = xl2 + ch3 * 6.f;
    r__2 = ylab - ch3 * .4f;
    plot_(&r__1, &r__2, &c__2);
    r__1 = ylab - ch3 * .4f;
    plot_(&xl3, &r__1, &c__3);
    r__1 = xl3 + ch3 * 7.f;
    r__2 = ylab - ch3 * .4f;
    plot_(&r__1, &r__2, &c__2);
    r__1 = ylab - ch3 * .4f;
    plot_(&xl4, &r__1, &c__3);
    r__1 = xl4 + ch3 * 6.f;
    r__2 = ylab - ch3 * .4f;
    plot_(&r__1, &r__2, &c__2);
    if (comr_1.reyn != 0.f) {
	r__1 = ylab - ch3 * .4f;
	plot_(&xl5, &r__1, &c__3);
	r__1 = xl5 + ch3 * 5.f;
	r__2 = ylab - ch3 * .4f;
	plot_(&r__1, &r__2, &c__2);
	r__1 = ylab - ch3 * .4f;
	plot_(&xl6, &r__1, &c__3);
	r__1 = xl6 + ch3 * 5.f;
	r__2 = ylab - ch3 * .4f;
	plot_(&r__1, &r__2, &c__2);
    }

    newpen_(&c__2);
    ylab -= ch3 * .5f;
    i__1 = comi_1.naplt;
    for (ka = 1; ka <= i__1; ++ka) {
	ia = comi_1.iaplt[ka - 1];
	dxl1 = 0.f;
	dxl2 = 0.f;
	dxl3 = 0.f;
	dxl4 = 0.f;
	if (comi_1.lmach) {
	    if (comi_1.lclfix) {
		if (comr_1.alfa[ia - 1] < 0.f) {
		    dxl2 = -ch3;
		}
	    } else {
		if (comr_1.cl[ia - 1] < 0.f) {
		    dxl2 = -ch3;
		}
	    }
	} else {
	    if (comr_1.alfa[ia - 1] < 0.f) {
		dxl1 = -ch3;
	    }
	    if (comr_1.cl[ia - 1] < 0.f) {
		dxl2 = -ch3;
	    }
	}
	if (comr_1.cd[ia - 1] < 0.f) {
	    dxl3 = -ch3;
	}
	if (comr_1.cm[ia - 1] < 0.f) {
	    dxl4 = -ch3;
	}
	ylab -= ch3 * 2.f;
	if (comi_1.lmach) {
	    r__1 = xl1 + dxl1;
	    plnumb_(&r__1, &ylab, &ch3, &comr_1.ma[ia - 1], &c_b145, &c__3);
	    if (comi_1.lclfix) {
		r__1 = xl2 + dxl2;
		plnumb_(&r__1, &ylab, &ch3, &comr_1.alfa[ia - 1], &c_b145, &
			c__3);
	    } else {
		r__1 = xl2 + dxl2;
		plnumb_(&r__1, &ylab, &ch3, &comr_1.cl[ia - 1], &c_b145, &
			c__4);
	    }
	} else {
	    r__1 = xl1 + dxl1;
	    plnumb_(&r__1, &ylab, &ch3, &comr_1.alfa[ia - 1], &c_b145, &c__3);
	    r__1 = xl2 + dxl2;
	    plnumb_(&r__1, &ylab, &ch3, &comr_1.cl[ia - 1], &c_b145, &c__4);
	}
	r__1 = xl3 + dxl3;
	plnumb_(&r__1, &ylab, &ch3, &comr_1.cd[ia - 1], &c_b145, &c__5);
	r__1 = xl4 + dxl3;
	plnumb_(&r__1, &ylab, &ch3, &comr_1.cm[ia - 1], &c_b145, &c__3);
	if (comr_1.reyn != 0.f) {
	    plnumb_(&xl5, &ylab, &ch3, &comr_1.xtr[(ia << 1) - 2], &c_b145, &
		    c__3);
	    plnumb_(&xl6, &ylab, &ch3, &comr_1.xtr[(ia << 1) - 1], &c_b145, &
		    c__3);
	}
/* L50: */
    }

    return 0;
} /* pltfor_ */

/* Subroutine */ int getref_(real *x, real *y, int *n)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    int i__1;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void), s_rsfe(cilist *), do_fio(int *, char *, ftnlen),
	     e_rsfe(void), f_open(olist *), f_clos(cllist *), s_rsle(cilist *)
	    , e_rsle(void);

    /* Local variables */
    static int i__;
    static char fname[132];

    /* Fortran I/O blocks */
    static cilist io___131 = { 0, 6, 0, 0, 0 };
    static cilist io___132 = { 0, 5, 0, fmt_1000, 0 };
    static cilist io___134 = { 0, 6, 0, 0, 0 };
    static cilist io___136 = { 0, 1, 1, 0, 0 };



    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    s_wsle(&io___131);
    do_lio(&c__9, &c__1, "Enter reference solution filename:", (ftnlen)34);
    e_wsle();
    s_rsfe(&io___132);
    do_fio(&c__1, fname, (ftnlen)132);
    e_rsfe();

    o__1.oerr = 1;
    o__1.ounit = 1;
    o__1.ofnmlen = 132;
    o__1.ofnm = fname;
    o__1.orl = 0;
    o__1.osta = "OLD";
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    i__1 = f_open(&o__1);
    if (i__1 != 0) {
	goto L5;
    }
    goto L10;

L5:
    s_wsle(&io___134);
    do_lio(&c__9, &c__1, "***   File open error   ***", (ftnlen)27);
    e_wsle();
    cl__1.cerr = 0;
    cl__1.cunit = 1;
    cl__1.csta = 0;
    f_clos(&cl__1);
    return 0;

L10:
    for (i__ = 1; i__ <= 500; ++i__) {
	i__1 = s_rsle(&io___136);
	if (i__1 != 0) {
	    goto L12;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&x[i__], (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L12;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&y[i__], (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L12;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L12;
	}
/* L11: */
    }
L12:
    *n = i__ - 1;

    cl__1.cerr = 0;
    cl__1.cunit = 1;
    cl__1.csta = 0;
    f_clos(&cl__1);
    return 0;
} /* getref_ */

/* Subroutine */ int readit_(char *fname, ftnlen fname_len)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    int i__1, i__2;
    real r__1;
    doublereal d__1, d__2;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    int s_cmp(char *, char *, ftnlen, ftnlen), s_wsle(cilist *), do_lio(
	    int *, int *, char *, ftnlen), e_wsle(void), s_rsfe(
	    cilist *), do_fio(int *, char *, ftnlen), e_rsfe(void), 
	    f_open(olist *), s_rsue(cilist *), do_uio(int *, char *, 
	    ftnlen), e_rsue(void);
    double sqrt(doublereal);
    /* Subroutine */ int s_stop(char *, ftnlen);
    int f_clos(cllist *);
    double pow_dd(doublereal *, doublereal *);

    /* Local variables */
    static int i__, ia, ib, is;
    static real adal, adcl;
    static int iitot;
    static real machsq;
    static int iletot, itetot;

    /* Fortran I/O blocks */
    static cilist io___137 = { 0, 6, 0, 0, 0 };
    static cilist io___138 = { 0, 5, 0, fmt_1000, 0 };
    static cilist io___139 = { 0, 11, 0, 0, 0 };
    static cilist io___140 = { 0, 11, 0, 0, 0 };
    static cilist io___141 = { 0, 11, 0, 0, 0 };
    static cilist io___142 = { 0, 11, 0, 0, 0 };
    static cilist io___146 = { 0, 11, 0, 0, 0 };
    static cilist io___149 = { 0, 11, 1, 0, 0 };
    static cilist io___150 = { 0, 11, 1, 0, 0 };
    static cilist io___151 = { 0, 11, 1, 0, 0 };
    static cilist io___152 = { 0, 11, 1, 0, 0 };
    static cilist io___154 = { 0, 11, 1, 0, 0 };
    static cilist io___156 = { 0, 6, 0, 0, 0 };
    static cilist io___160 = { 0, 6, 0, 0, 0 };



/* --- Uncomment for Win32/Compaq Visual Fortran compiler (needed for GETARG) */
/* cc      USE DFLIB */






/* nothing here */
/* L10: */
    if (s_cmp(fname, " ", (ftnlen)132, (ftnlen)1) == 0) {
	s_wsle(&io___137);
	do_lio(&c__9, &c__1, "Enter polar dump filename", (ftnlen)25);
	e_wsle();
	s_rsfe(&io___138);
	do_fio(&c__1, fname, (ftnlen)132);
	e_rsfe();
    }

    if (s_cmp(fname, " ", (ftnlen)132, (ftnlen)1) == 0) {
	return 0;
    }

    o__1.oerr = 1;
    o__1.ounit = 11;
    o__1.ofnmlen = 132;
    o__1.ofnm = fname;
    o__1.orl = 0;
    o__1.osta = "OLD";
    o__1.oacc = 0;
    o__1.ofm = "UNFORMATTED";
    o__1.oblnk = 0;
    i__1 = f_open(&o__1);
    if (i__1 != 0) {
	goto L800;
    }

    s_rsue(&io___139);
    do_uio(&c__1, comi_1.name__, (ftnlen)32);
    do_uio(&c__1, comi_1.code, (ftnlen)8);
    do_uio(&c__1, (char *)&comr_1.version, (ftnlen)sizeof(real));
    e_rsue();
    s_rsue(&io___140);
    do_uio(&c__1, (char *)&comr_1.mach, (ftnlen)sizeof(real));
    do_uio(&c__1, (char *)&comr_1.reyn, (ftnlen)sizeof(real));
    do_uio(&c__1, (char *)&comr_1.acrit, (ftnlen)sizeof(real));
    e_rsue();
    s_rsue(&io___141);
    do_uio(&c__1, (char *)&comi_1.matyp, (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&comi_1.retyp, (ftnlen)sizeof(integer));
    e_rsue();
    s_rsue(&io___142);
    do_uio(&c__1, (char *)&iitot, (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&iletot, (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&itetot, (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&comi_1.iib, (ftnlen)sizeof(integer));
    e_rsue();
    s_rsue(&io___146);
    i__1 = comi_1.iib;
    for (ib = 1; ib <= i__1; ++ib) {
	do_uio(&c__1, (char *)&comr_1.xb[ib - 1], (ftnlen)sizeof(real));
	do_uio(&c__1, (char *)&comr_1.yb[ib - 1], (ftnlen)sizeof(real));
    }
    e_rsue();

/* ---- T if this is an ISES polar, F if XFOIL polar */
    comi_1.lises = iitot != 0;

/* ---- T if this is a Mach sweep, F if alpha sweep */
    comi_1.lmach = comr_1.mach == 0.f && comi_1.lises;

    for (ia = 1; ia <= 80; ++ia) {

	if (comi_1.lises) {
/* ------- ISES dump file read */
	    if (comi_1.lmach) {
		i__1 = s_rsue(&io___149);
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (
			ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (
			ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.ma[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = e_rsue();
		if (i__1 != 0) {
		    goto L30;
		}
	    } else {
		i__1 = s_rsue(&io___150);
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (
			ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (
			ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = e_rsue();
		if (i__1 != 0) {
		    goto L30;
		}
		if (comi_1.matyp == 1) {
		    comr_1.ma[ia - 1] = comr_1.mach;
		}
		if (comi_1.matyp == 2) {
		    comr_1.ma[ia - 1] = comr_1.mach / sqrt(comr_1.cl[ia - 1]);
		}
		if (comi_1.matyp == 3) {
		    comr_1.ma[ia - 1] = comr_1.mach / comr_1.cl[ia - 1];
		}
	    }
	    comi_1.ii[(ia << 1) - 2] = iitot;
	    comi_1.ii[(ia << 1) - 1] = iitot;
	    comi_1.ile[(ia << 1) - 2] = iletot;
	    comi_1.ile[(ia << 1) - 1] = iletot;
	    comi_1.ite[(ia << 1) - 2] = itetot;
	    comi_1.ite[(ia << 1) - 1] = itetot;
	} else {
/* ------- XFOIL dump file read */
	    i__1 = s_rsue(&io___151);
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.alfa[ia - 1], (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.cl[ia - 1], (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.cd[ia - 1], (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.cdi[ia - 1], (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.cm[ia - 1], (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 2], (ftnlen)
		    sizeof(real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comr_1.xtr[(ia << 1) - 1], (ftnlen)
		    sizeof(real));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = e_rsue();
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = s_rsue(&io___152);
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comi_1.ii[(ia << 1) - 2], (ftnlen)
		    sizeof(integer));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comi_1.ii[(ia << 1) - 1], (ftnlen)
		    sizeof(integer));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comi_1.ite[(ia << 1) - 2], (ftnlen)
		    sizeof(integer));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = do_uio(&c__1, (char *)&comi_1.ite[(ia << 1) - 1], (ftnlen)
		    sizeof(integer));
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__1 = e_rsue();
	    if (i__1 != 0) {
		goto L30;
	    }
	    comi_1.ile[(ia << 1) - 2] = 1;
	    comi_1.ile[(ia << 1) - 1] = 1;
	    if (comi_1.matyp == 1) {
		comr_1.ma[ia - 1] = comr_1.mach;
	    }
	    if (comi_1.matyp == 2) {
		comr_1.ma[ia - 1] = comr_1.mach / sqrt(comr_1.cl[ia - 1]);
	    }
	    if (comi_1.matyp == 3) {
		comr_1.ma[ia - 1] = comr_1.mach / comr_1.cl[ia - 1];
	    }
	}

	for (is = 1; is <= 2; ++is) {
	    if (comi_1.ii[is + (ia << 1) - 3] > 132) {
		s_stop("Array overflow.  Increase NX.", (ftnlen)29);
	    }
	    i__1 = s_rsue(&io___154);
	    if (i__1 != 0) {
		goto L30;
	    }
	    i__2 = comi_1.ii[is + (ia << 1) - 3];
	    for (i__ = 1; i__ <= i__2; ++i__) {
		i__1 = do_uio(&c__1, (char *)&comr_1.x[i__ + (is + (ia << 1)) 
			* 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cp[i__ + (is + (ia << 1))
			 * 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.thet[i__ + (is + (ia << 
			1)) * 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.dstr[i__ + (is + (ia << 
			1)) * 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.cf[i__ + (is + (ia << 1))
			 * 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
		i__1 = do_uio(&c__1, (char *)&comr_1.ctau[i__ + (is + (ia << 
			1)) * 132 - 397], (ftnlen)sizeof(real));
		if (i__1 != 0) {
		    goto L30;
		}
	    }
	    i__1 = e_rsue();
	    if (i__1 != 0) {
		goto L30;
	    }
	}

    }
    s_wsle(&io___156);
    do_lio(&c__9, &c__1, "Point array limit NAX reached.", (ftnlen)30);
    e_wsle();

L30:
    comi_1.na = ia - 1;
    cl__1.cerr = 0;
    cl__1.cunit = 11;
    cl__1.csta = 0;
    f_clos(&cl__1);

    i__1 = comi_1.na;
    for (ia = 1; ia <= i__1; ++ia) {
	for (is = 1; is <= 2; ++is) {
	    i__2 = comi_1.ii[is + (ia << 1) - 3] - 1;
	    for (i__ = comi_1.ile[is + (ia << 1) - 3] + 2; i__ <= i__2; ++i__)
		     {
		if (comr_1.x[i__ - 1 + (is + (ia << 1)) * 132 - 397] < 
			comr_1.xtr[is + (ia << 1) - 3] && comr_1.x[i__ + (is 
			+ (ia << 1)) * 132 - 397] >= comr_1.xtr[is + (ia << 1)
			 - 3]) {
		    comi_1.itran[is + (ia << 1) - 3] = i__;
		    goto L40;
		}
	    }
L40:
	    ;
	}
    }

    comr_1.gam = 1.4f;
    comr_1.gm1 = comr_1.gam - 1.f;

    i__1 = comi_1.na;
    for (ia = 1; ia <= i__1; ++ia) {
	comr_1.cpstar[ia - 1] = -999.f;
	if (comr_1.ma[ia - 1] != 0.f) {
/* Computing 2nd power */
	    r__1 = comr_1.ma[ia - 1];
	    machsq = r__1 * r__1;
	    d__1 = (doublereal) ((comr_1.gm1 * .5f * machsq + 1.f) / (
		    comr_1.gm1 * .5f + 1.f));
	    d__2 = (doublereal) (comr_1.gam / comr_1.gm1);
	    comr_1.cpstar[ia - 1] = (pow_dd(&d__1, &d__2) - 1.f) / (
		    comr_1.gam * .5f * machsq);
	}
    }

    cl__1.cerr = 0;
    cl__1.cunit = 11;
    cl__1.csta = 0;
    f_clos(&cl__1);

/* ---- set flags indicating if CL or alpha have been held fixed (in Mach sweep) */
    comi_1.lclfix = TRUE_;
    comi_1.lalfix = TRUE_;
    i__1 = comi_1.na - 1;
    for (ia = 1; ia <= i__1; ++ia) {
	adcl = (r__1 = comr_1.cl[ia - 1] - comr_1.cl[ia], dabs(r__1));
	adal = (r__1 = comr_1.alfa[ia - 1] - comr_1.alfa[ia], dabs(r__1));
	if (adcl > .001f) {
	    comi_1.lclfix = FALSE_;
	}
	if (adal > .001f) {
	    comi_1.lalfix = FALSE_;
	}
    }
    goto L900;

L800:
    s_wsle(&io___160);
    do_lio(&c__9, &c__1, "Error opening polar dump file ", (ftnlen)30);
    e_wsle();

L900:
    return 0;

} /* readit_ */

/* Subroutine */ int ident_(real *xid, real *yid)
{
    /* System generated locals */
    real r__1, r__2;

    /* Local variables */
    static real chi;
    extern /* Subroutine */ int plchar_(real *, real *, real *, char *, real *
	    , int *, ftnlen), newpen_(int *), plnumb_(real *, real *, 
	    real *, real *, real *, int *);






/* ---- plot code and version identifier */
/* nothing here */
    newpen_(&c__1);
    chi = .012f;
    r__1 = *xid + chi;
    r__2 = *yid - chi * 1.f;
    plchar_(&r__1, &r__2, &chi, comi_1.code, &c_b145, &c__5, (ftnlen)8);
    r__1 = *xid + chi;
    r__2 = *yid - chi * 3.f;
    plchar_(&r__1, &r__2, &chi, "V", &c_b145, &c__1, (ftnlen)1);
    r__1 = *xid + chi * 3.f;
    r__2 = *yid - chi * 3.f;
    plnumb_(&r__1, &r__2, &chi, &comr_1.version, &c_b145, &c__2);

    return 0;
} /* ident_ */

/* Main program alias */ int pxplot_ () { MAIN__ (); return 0; }
