/* f/naca.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__4 = 4;
static int c__9 = 9;
static int c__1 = 1;
static int c__5 = 5;

/* *********************************************************************** */
/*    Module:  naca.f */

/*    Copyright (C) 2000 Mark Drela */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int naca4_(int *ides, real *xx, real *yt, real *yc, 
	int *nside, real *xb, real *yb, int *nb, char *name__, ftnlen 
	name_len)
{
    /* Initialized data */

    static char digits[10] = "0123456789";
    static real an = 1.5f;

    /* System generated locals */
    address a__1[4];
    int i__1, i__2, i__3, i__4, i__5[4];
    real r__1, r__2, r__3;
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    double pow_dd(doublereal *, doublereal *), sqrt(doublereal);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen), s_cat(char *,
	     char **, int *, int *, ftnlen);

    /* Local variables */
    static int i__;
    static real m, p, t;
    static int n1, n2, n3, n4, ib;
    static real anp, frac;


    /* Parameter adjustments */
    --yb;
    --xb;
    --yc;
    --yt;
    --xx;

    /* Function Body */

/* ---- TE point bunching parameter */

    n4 = *ides / 1000;
    n3 = (*ides - n4 * 1000) / 100;
    n2 = (*ides - n4 * 1000 - n3 * 100) / 10;
    n1 = *ides - n4 * 1000 - n3 * 100 - n2 * 10;

    m = (real) n4 / 100.f;
    p = (real) n3 / 10.f;
    t = (real) (n2 * 10 + n1) / 100.f;

    anp = an + 1.f;
    i__1 = *nside;
    for (i__ = 1; i__ <= i__1; ++i__) {
	frac = (real) (i__ - 1) / (real) (*nside - 1);
	if (i__ == *nside) {
	    xx[i__] = 1.f;
	} else {
	    d__1 = (doublereal) (1.f - frac);
	    d__2 = (doublereal) an;
	    d__3 = (doublereal) (1.f - frac);
	    d__4 = (doublereal) anp;
	    xx[i__] = 1.f - anp * frac * pow_dd(&d__1, &d__2) - pow_dd(&d__3, 
		    &d__4);
	}
/* Computing 2nd power */
	r__1 = xx[i__];
/* Computing 3rd power */
	r__2 = xx[i__];
/* Computing 4th power */
	r__3 = xx[i__], r__3 *= r__3;
	yt[i__] = (sqrt(xx[i__]) * .2969f - xx[i__] * .126f - r__1 * r__1 * 
		.3516f + r__2 * (r__2 * r__2) * .2843f - r__3 * r__3 * .1015f)
		 * t / .2f;
	if (xx[i__] < p) {
/* Computing 2nd power */
	    r__1 = p;
/* Computing 2nd power */
	    r__2 = xx[i__];
	    yc[i__] = m / (r__1 * r__1) * (p * 2.f * xx[i__] - r__2 * r__2);
	} else {
/* Computing 2nd power */
	    r__1 = 1.f - p;
/* Computing 2nd power */
	    r__2 = xx[i__];
	    yc[i__] = m / (r__1 * r__1) * (1.f - p * 2.f + p * 2.f * xx[i__] 
		    - r__2 * r__2);
	}
/* L10: */
    }

    ib = 0;
    for (i__ = *nside; i__ >= 1; --i__) {
	++ib;
	xb[ib] = xx[i__];
	yb[ib] = yc[i__] + yt[i__];
/* L20: */
    }
    i__1 = *nside;
    for (i__ = 2; i__ <= i__1; ++i__) {
	++ib;
	xb[ib] = xx[i__];
	yb[ib] = yc[i__] - yt[i__];
/* L30: */
    }
    *nb = ib;

    s_copy(name__, "NACA", name_len, (ftnlen)4);
    i__1 = n4;
    i__2 = n3;
    i__3 = n2;
    i__4 = n1;
/* Writing concatenation */
    i__5[0] = n4 + 1 - i__1, a__1[0] = digits + i__1;
    i__5[1] = n3 + 1 - i__2, a__1[1] = digits + i__2;
    i__5[2] = n2 + 1 - i__3, a__1[2] = digits + i__3;
    i__5[3] = n1 + 1 - i__4, a__1[3] = digits + i__4;
    s_cat(name__ + 5, a__1, i__5, &c__4, (ftnlen)4);

    return 0;
} /* naca4_ */

/* Subroutine */ int naca5_(int *ides, real *xx, real *yt, real *yc, 
	int *nside, real *xb, real *yb, int *nb, char *name__, ftnlen 
	name_len)
{
    /* Initialized data */

    static char digits[10] = "0123456789";
    static real an = 1.5f;

    /* System generated locals */
    address a__1[5];
    int i__1, i__2, i__3, i__4, i__5, i__6[5];
    real r__1, r__2, r__3;
    doublereal d__1, d__2, d__3, d__4;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    double pow_dd(doublereal *, doublereal *), sqrt(doublereal);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen), s_cat(char *,
	     char **, int *, int *, ftnlen);

    /* Local variables */
    static real c__;
    static int i__;
    static real m, t;
    static int n1, n2, n3, n4, n5, ib, n543;
    static real anp, frac;

    /* Fortran I/O blocks */
    static cilist io___24 = { 0, 6, 0, 0, 0 };
    static cilist io___25 = { 0, 6, 0, 0, 0 };




    /* Parameter adjustments */
    --yb;
    --xb;
    --yc;
    --yt;
    --xx;

    /* Function Body */

/* ---- TE point bunching parameter */

    n5 = *ides / 10000;
    n4 = (*ides - n5 * 10000) / 1000;
    n3 = (*ides - n5 * 10000 - n4 * 1000) / 100;
    n2 = (*ides - n5 * 10000 - n4 * 1000 - n3 * 100) / 10;
    n1 = *ides - n5 * 10000 - n4 * 1000 - n3 * 100 - n2 * 10;

    n543 = n5 * 100 + n4 * 10 + n3;

    if (n543 == 210) {
/* c     P = 0.05 */
	m = .058f;
	c__ = 361.4f;
    } else if (n543 == 220) {
/* c     P = 0.10 */
	m = .126f;
	c__ = 51.64f;
    } else if (n543 == 230) {
/* c     P = 0.15 */
	m = .2025f;
	c__ = 15.957f;
    } else if (n543 == 240) {
/* c     P = 0.20 */
	m = .29f;
	c__ = 6.643f;
    } else if (n543 == 250) {
/* c     P = 0.25 */
	m = .391f;
	c__ = 3.23f;
    } else {
	s_wsle(&io___24);
	do_lio(&c__9, &c__1, "Illegal 5-digit designation", (ftnlen)27);
	e_wsle();
	s_wsle(&io___25);
	do_lio(&c__9, &c__1, "First three digits must be 210, 220, ... 250", (
		ftnlen)44);
	e_wsle();
	*ides = 0;
	return 0;
    }


    t = (real) (n2 * 10 + n1) / 100.f;

    anp = an + 1.f;
    i__1 = *nside;
    for (i__ = 1; i__ <= i__1; ++i__) {
	frac = (real) (i__ - 1) / (real) (*nside - 1);
	if (i__ == *nside) {
	    xx[i__] = 1.f;
	} else {
	    d__1 = (doublereal) (1.f - frac);
	    d__2 = (doublereal) an;
	    d__3 = (doublereal) (1.f - frac);
	    d__4 = (doublereal) anp;
	    xx[i__] = 1.f - anp * frac * pow_dd(&d__1, &d__2) - pow_dd(&d__3, 
		    &d__4);
	}

/* Computing 2nd power */
	r__1 = xx[i__];
/* Computing 3rd power */
	r__2 = xx[i__];
/* Computing 4th power */
	r__3 = xx[i__], r__3 *= r__3;
	yt[i__] = (sqrt(xx[i__]) * .2969f - xx[i__] * .126f - r__1 * r__1 * 
		.3516f + r__2 * (r__2 * r__2) * .2843f - r__3 * r__3 * .1015f)
		 * t / .2f;
	if (xx[i__] < m) {
/* Computing 3rd power */
	    r__1 = xx[i__];
/* Computing 2nd power */
	    r__2 = xx[i__];
	    yc[i__] = c__ / 6.f * (r__1 * (r__1 * r__1) - m * 3.f * (r__2 * 
		    r__2) + m * m * (3.f - m) * xx[i__]);
	} else {
/* Computing 3rd power */
	    r__1 = m;
	    yc[i__] = c__ / 6.f * (r__1 * (r__1 * r__1)) * (1.f - xx[i__]);
	}
/* L10: */
    }

    ib = 0;
    for (i__ = *nside; i__ >= 1; --i__) {
	++ib;
	xb[ib] = xx[i__];
	yb[ib] = yc[i__] + yt[i__];
/* L20: */
    }
    i__1 = *nside;
    for (i__ = 2; i__ <= i__1; ++i__) {
	++ib;
	xb[ib] = xx[i__];
	yb[ib] = yc[i__] - yt[i__];
/* L30: */
    }
    *nb = ib;

    s_copy(name__, "NACA", name_len, (ftnlen)4);
    i__1 = n5;
    i__2 = n4;
    i__3 = n3;
    i__4 = n2;
    i__5 = n1;
/* Writing concatenation */
    i__6[0] = n5 + 1 - i__1, a__1[0] = digits + i__1;
    i__6[1] = n4 + 1 - i__2, a__1[1] = digits + i__2;
    i__6[2] = n3 + 1 - i__3, a__1[2] = digits + i__3;
    i__6[3] = n2 + 1 - i__4, a__1[3] = digits + i__4;
    i__6[4] = n1 + 1 - i__5, a__1[4] = digits + i__5;
    s_cat(name__ + 5, a__1, i__6, &c__5, (ftnlen)5);

    return 0;
} /* naca5_ */
