/* f/plutil.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__1 = 1;
static int c__9 = 9;
static real c_b56 = 2.f;
static real c_b57 = 5.f;
static doublereal c_b59 = 10.;
static int c__3 = 3;
static real c_b69 = 0.f;
static int c__0 = 0;
static int c__4 = 4;
static int c__2 = 2;

/* *********************************************************************** */
/*    Module:  plutil.f */

/*    Copyright (C) 2000 Mark Drela */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int oplset_(int *idev, int *idevrp, int *ipslu, 
	real *size, real *par, real *xmarg, real *ymarg, real *xpage, real *
	ypage, real *csize, real *scrnfr, logical *lcurs, logical *lland)
{
    /* Format strings */
    static char fmt_2000[] = "(\002 ........................................"
	    ".......\002//\002  G raphics-enable flag:       \002,l2,/\002  S"
	    " ize of plot object         \002,f6.2,\002\"\002/\002  A spect r"
	    "atio of plot object \002,f8.4/\002  P age dimensions             "
	    "\002,f6.2,\002 x\002,f6.2,\002\"\002/\002  M argins from page ed"
	    "ges     \002,f6.2,\002\",\002,f6.2,\002\"\002/\002  F ont size ("
	    "relative)        \002,f8.4/\002  W indow/screen size fraction"
	    " \002,f8.4/\002  B lowup input method:        \002,a/\002  O rie"
	    "ntation of plot:        \002,a/\002  C olor PostScript output?  "
	    "  \002,l2)";

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void),
	     i_indx(char *, char *, ftnlen, ftnlen), s_wsle(cilist *), e_wsle(
	    void), do_lio(int *, int *, char *, ftnlen);

    /* Local variables */
    static int i__;
    static char var[1];
    extern /* Subroutine */ int askc_(char *, char *, char *, ftnlen, ftnlen, 
	    ftnlen), askr_(char *, real *, ftnlen);
    static real xtmp, ytmp;
    static logical error;
    static char chland[10], comand[4], comarg[128];
    static logical lgraph;
    extern /* Subroutine */ int getflt_(char *, real *, int *, logical *, 
	    ftnlen);
    static char chcurs[10];
    static logical lcolor;
    extern /* Subroutine */ int getint_(char *, int *, int *, logical 
	    *, ftnlen);
    static int iinput[20], ninput;
    static real rinput[20];

    /* Fortran I/O blocks */
    static cilist io___5 = { 0, 6, 0, fmt_2000, 0 };
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___15 = { 0, 6, 0, 0, 0 };
    static cilist io___18 = { 0, 6, 0, 0, 0 };


/* ----------------------------------------------------------- */
/*     Allows user modification of various plot parameters. */
/* ----------------------------------------------------------- */


/* L1000: */
L1:
    if (*lcurs) {
	s_copy(chcurs, "Cursor    ", (ftnlen)10, (ftnlen)10);
    } else {
	s_copy(chcurs, "Keyboard  ", (ftnlen)10, (ftnlen)10);
    }

    if (*lland) {
	s_copy(chland, "Landscape ", (ftnlen)10, (ftnlen)10);
    } else {
	s_copy(chland, "Portrait  ", (ftnlen)10, (ftnlen)10);
    }

    lgraph = *idev >= 1;
    lcolor = *idevrp == 4;

    s_wsfe(&io___5);
    do_fio(&c__1, (char *)&lgraph, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&(*size), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*par), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*xpage), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*ypage), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*xmarg), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*ymarg), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*csize), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*scrnfr), (ftnlen)sizeof(real));
    do_fio(&c__1, chcurs, (ftnlen)10);
    do_fio(&c__1, chland, (ftnlen)10);
    do_fio(&c__1, (char *)&lcolor, (ftnlen)sizeof(logical));
    e_wsfe();

/* L5: */
    askc_("      Option, Value   (or <Return>) ^", comand, comarg, (ftnlen)37,
	     (ftnlen)4, (ftnlen)128);

    for (i__ = 1; i__ <= 20; ++i__) {
	iinput[i__ - 1] = 0.f;
	rinput[i__ - 1] = 0.f;
    }
    ninput = 0;
    getint_(comarg, iinput, &ninput, &error, (ftnlen)128);
    ninput = 0;
    getflt_(comarg, rinput, &ninput, &error, (ftnlen)128);

    *(unsigned char *)var = *(unsigned char *)comand;
    if (*(unsigned char *)var == '0' || *(unsigned char *)var == ' ') {
	return 0;

    } else if (i_indx("Gg", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (*idev == 0) {
	    *idev = 1;
	} else {
	    *idev = 0;
	}

    } else if (i_indx("Ss", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 1) {
	    *size = rinput[0];
	} else {
	    askr_("Enter size (in)^", size, (ftnlen)16);
	}

    } else if (i_indx("Aa", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 1) {
	    *par = rinput[0];
	} else {
	    askr_("Enter aspect ratio^", par, (ftnlen)19);
	}

    } else if (i_indx("Pp", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 2) {
	    *xpage = rinput[0];
	    *ypage = rinput[1];
	} else if (ninput >= 1) {
	    *xpage = rinput[0];
	    askr_("Enter page Y dimension (in)^", ypage, (ftnlen)28);
	} else {
	    askr_("Enter page X dimension (in)^", xpage, (ftnlen)28);
	    askr_("Enter page Y dimension (in)^", ypage, (ftnlen)28);
	}

    } else if (i_indx("Mm", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 2) {
	    *xmarg = rinput[0];
	    *ymarg = rinput[1];
	} else if (ninput >= 1) {
	    *xmarg = rinput[0];
	    askr_("Enter page Y margin (in)^", ymarg, (ftnlen)25);
	} else {
	    askr_("Enter page X margin (in)^", xmarg, (ftnlen)25);
	    askr_("Enter page Y margin (in)^", ymarg, (ftnlen)25);
	}

    } else if (i_indx("Ff", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 1) {
	    *csize = rinput[0];
	} else {
	    askr_("Enter character font size^", csize, (ftnlen)26);
	}

    } else if (i_indx("Ww", var, (ftnlen)2, (ftnlen)1) != 0) {
	if (ninput >= 1) {
	    *scrnfr = rinput[0];
	} else {
	    askr_("Enter window/screen size fraction^", scrnfr, (ftnlen)34);
	}

    } else if (i_indx("Bb", var, (ftnlen)2, (ftnlen)1) != 0) {
	*lcurs = ! (*lcurs);

    } else if (i_indx("Oo", var, (ftnlen)2, (ftnlen)1) != 0) {
	*lland = ! (*lland);
	s_wsle(&io___14);
	e_wsle();
	s_wsle(&io___15);
	do_lio(&c__9, &c__1, "Swapping X,Y page dimensions", (ftnlen)28);
	e_wsle();
	xtmp = *xpage;
	ytmp = *ypage;
	*xpage = ytmp;
	*ypage = xtmp;

    } else if (i_indx("Cc", var, (ftnlen)2, (ftnlen)1) != 0) {
	lcolor = ! lcolor;
	if (lcolor) {
	    *idevrp = 4;
	}
	if (! lcolor) {
	    *idevrp = 2;
	}

    } else {
	s_wsle(&io___18);
	do_lio(&c__9, &c__1, "*** Item not recognized ***", (ftnlen)27);
	e_wsle();
    }
    goto L1;

} /* oplset_ */

/* Subroutine */ int plsubs_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, S_fp plfont, ftnlen string_len)
{
    /* Initialized data */

    static real pi = 3.1415926535897932384f;
    static real chfac = .7f;
    static real chdx = .9f;
    static real chdy = -.4f;

    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);

    /* Local variables */
    static real x, y;
    extern /* Subroutine */ int getlastxy_(real *, real *);
    static real xx, yy, cosa, sina, xchr, ychr;

/* ---------------------------------------------------------------- */
/*     Plots character string as a subscript with font routine PLFONT. */

/*      XC,YC  = user coordinates of character to be subscripted */
/*      CHX    = character width (user coordinates) */
/*      STRING = subscript character string to plot with NC characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      NC     = number of subscript characters to plot */
/*               if NC<0 the length of the string is determined automatically */
/* ---------------------------------------------------------------- */

/* ---- subscript character reduction factor, and x,y-shift/chx */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;

    if (*xc == 999.f || *yc == 999.f) {
	getlastxy_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

    x = xx + *chx * (chdx * cosa - chdy * sina);
    y = yy + *chx * (chdx * sina + chdy * cosa);
    r__1 = *chx * chfac;
    (*plfont)(&x, &y, &r__1, string, angle, nc, string_len);

    return 0;
} /* plsubs_ */

/* Subroutine */ int plsups_(real *xc, real *yc, real *chx, char *string, 
	real *angle, int *nc, S_fp plfont, ftnlen string_len)
{
    /* Initialized data */

    static real pi = 3.1415926535897932384f;
    static real chfac = .7f;
    static real chdx = .95f;
    static real chdy = .7f;

    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sin(doublereal), cos(doublereal);

    /* Local variables */
    static real x, y;
    extern /* Subroutine */ int getlastxy_(real *, real *);
    static real xx, yy, cosa, sina, xchr, ychr;

/* ---------------------------------------------------------------- */
/*     Plots character string as a superscript with font routine PLFONT. */

/*      XC,YC  = user coordinates of character to be superscripted */
/*      CHX    = character width (user coordinates) */
/*      STRING = superscript character string to plot with NC characters */
/*      ANGLE  = angle of character (radians, positive is righthanded rotation) */
/*      NC     = number of superscript characters to plot */
/*               if NC<0 the length of the string is determined automatically */
/* ---------------------------------------------------------------- */

/* ---- superscript character reduction factor, and x,y-shift/chx */

    sina = sin(*angle * pi / 180.f);
    cosa = cos(*angle * pi / 180.f);

    xx = *xc;
    yy = *yc;

    if (*xc == 999.f || *yc == 999.f) {
	getlastxy_(&xchr, &ychr);
	if (*xc == 999.f) {
	    xx = xchr;
	}
	if (*yc == 999.f) {
	    yy = ychr;
	}
    }

    x = xx + *chx * (chdx * cosa - chdy * sina);
    y = yy + *chx * (chdx * sina + chdy * cosa);
    r__1 = *chx * chfac;
    (*plfont)(&x, &y, &r__1, string, angle, nc, string_len);

    return 0;
} /* plsups_ */

/* Subroutine */ int scalit_(int *ii, real *y, real *yoff, real *ysf)
{
    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3;
    doublereal d__1;

    /* Builtin functions */
    double r_lg10(real *), r_int(real *), pow_dd(doublereal *, doublereal *);

    /* Local variables */
    static int i__;
    static real ag2, ag5, gmin, ylog, ymax, ylog1, ylog2, ylog5;

/* ------------------------------------------------------------- */
/*     Y(1:II)  array whose scaling factor is to be determined */
/*     YOFF     offset of Y array  (Y-YOFF is actually scaled) */
/*     YSF      Y scaling factor */
/* ------------------------------------------------------------- */

    /* Parameter adjustments */
    --y;

    /* Function Body */
    ag2 = r_lg10(&c_b56);
    ag5 = r_lg10(&c_b57);

    ymax = (r__1 = y[1] - *yoff, dabs(r__1));
    i__1 = *ii;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* Computing MAX */
	r__2 = ymax, r__3 = (r__1 = y[i__] - *yoff, dabs(r__1));
	ymax = dmax(r__2,r__3);
/* L10: */
    }

    if (ymax == 0.f) {
	ymax = 1e-8f;
    }
    ylog = r_lg10(&ymax);

/* ---- find log of nearest power of 10 above YMAX */
    r__1 = ylog + 100.f;
    ylog1 = r_int(&r__1) - 99.f;
/* ---- find log of nearest 2x(power of 10) above YMAX */
    ylog2 = ylog1 + ag2;
    if (ylog2 - 1.f > ylog) {
	ylog2 += -1.f;
    }

/* ---- find log of nearest 5x(power of 10) above YMAX */
    ylog5 = ylog1 + ag5;
    if (ylog5 - 1.f > ylog) {
	ylog5 += -1.f;
    }

/* ---- find log of smallest upper bound */
/* Computing MIN */
    r__1 = min(ylog1,ylog2);
    gmin = dmin(r__1,ylog5);

/* ---- set scaling factor */
    d__1 = (doublereal) (-gmin);
    *ysf = pow_dd(&c_b59, &d__1);

    return 0;
} /* scalit_ */

/* Subroutine */ int offget_(real *xoff, real *yoff, real *xsf, real *ysf, 
	real *xwind, real *ywind, logical *lsame, logical *lcurs)
{
    /* Initialized data */

    static real sh = 2.f;

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), e_wsle(void), do_lio(int *, int *, char 
	    *, ftnlen), s_rsle(cilist *), e_rsle(void);

    /* Local variables */
    extern /* Subroutine */ int getcolor_(int *), newcolor_(int *);
    static real sf, xx1, xx2, yy1, yy2, xdif, ydif;
    extern /* Subroutine */ int getcursorxy_(real *, real *, char *, ftnlen);
    static real xcen, ycen;
    static int icol0;
    extern /* Subroutine */ int newcolorname_(char *, ftnlen);
    static char kchar[1];
    extern /* Subroutine */ int plsymb_(real *, real *, real *, int *, 
	    real *, int *), plflush_(void);

    /* Fortran I/O blocks */
    static cilist io___54 = { 0, 6, 0, 0, 0 };
    static cilist io___55 = { 0, 6, 0, 0, 0 };
    static cilist io___56 = { 0, 6, 0, 0, 0 };
    static cilist io___60 = { 0, 6, 0, 0, 0 };
    static cilist io___63 = { 0, 6, 0, 0, 0 };
    static cilist io___64 = { 0, 6, 0, 0, 0 };
    static cilist io___65 = { 0, 6, 0, 0, 0 };
    static cilist io___66 = { 0, 6, 0, 0, 0 };
    static cilist io___67 = { 0, 6, 0, 0, 0 };
    static cilist io___68 = { 0, 6, 0, 0, 0 };
    static cilist io___69 = { 1, 5, 0, 0, 0 };
    static cilist io___70 = { 0, 6, 0, 0, 0 };
    static cilist io___71 = { 1, 5, 0, 0, 0 };


/* --------------------------------------------------- */
/*     Sets new blowup parameters from cursor input. */
/* --------------------------------------------------- */

/* ---- crosshair "+" symbol size */

/* ---- get current color */
    getcolor_(&icol0);

/* ---- set new crosshair color */
    newcolorname_("red", (ftnlen)3);


    if (*lcurs) {

	s_wsle(&io___54);
	e_wsle();
	s_wsle(&io___55);
	do_lio(&c__9, &c__1, "Mark off corners of blowup area", (ftnlen)31);
	e_wsle();
	s_wsle(&io___56);
	do_lio(&c__9, &c__1, "(2 identical points default to current area)", (
		ftnlen)44);
	e_wsle();

	getcursorxy_(&xx1, &yy1, kchar, (ftnlen)1);
	plsymb_(&xx1, &yy1, &sh, &c__3, &c_b69, &c__0);
	plflush_();
	s_wsle(&io___60);
	do_lio(&c__9, &c__1, "x,y =", (ftnlen)5);
	r__1 = xx1 / *xsf + *xoff;
	do_lio(&c__4, &c__1, (char *)&r__1, (ftnlen)sizeof(real));
	r__2 = yy1 / *ysf + *yoff;
	do_lio(&c__4, &c__1, (char *)&r__2, (ftnlen)sizeof(real));
	e_wsle();

	getcursorxy_(&xx2, &yy2, kchar, (ftnlen)1);
	plsymb_(&xx2, &yy2, &sh, &c__3, &c_b69, &c__0);
	plflush_();
	s_wsle(&io___63);
	do_lio(&c__9, &c__1, "x,y =", (ftnlen)5);
	r__1 = xx2 / *xsf + *xoff;
	do_lio(&c__4, &c__1, (char *)&r__1, (ftnlen)sizeof(real));
	r__2 = yy2 / *ysf + *yoff;
	do_lio(&c__4, &c__1, (char *)&r__2, (ftnlen)sizeof(real));
	e_wsle();

    } else {

	s_wsle(&io___64);
	e_wsle();
	s_wsle(&io___65);
	do_lio(&c__9, &c__1, "Enter x,y coordinates of blowup area corners", (
		ftnlen)44);
	e_wsle();
	s_wsle(&io___66);
	do_lio(&c__9, &c__1, "(2 identical points default to current area)", (
		ftnlen)44);
	e_wsle();
	s_wsle(&io___67);
	e_wsle();
L1:
	s_wsle(&io___68);
	do_lio(&c__9, &c__1, "Point 1: ", (ftnlen)9);
	e_wsle();
	i__1 = s_rsle(&io___69);
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&xx1, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&yy1, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L1;
	}
L2:
	s_wsle(&io___70);
	do_lio(&c__9, &c__1, "Point 2: ", (ftnlen)9);
	e_wsle();
	i__1 = s_rsle(&io___71);
	if (i__1 != 0) {
	    goto L2;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&xx2, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L2;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&yy2, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L2;
	}
	i__1 = e_rsle();
	if (i__1 != 0) {
	    goto L2;
	}

    }

/* ---- restore to initial color */
    newcolor_(&icol0);

    if (xx1 == xx2 && yy1 == yy2) {
	return 0;
    }


    xcen = (xx1 + xx2) * .5f / *xsf + *xoff;
    ycen = (yy1 + yy2) * .5f / *ysf + *yoff;
    xdif = (r__1 = xx2 - xx1, dabs(r__1)) / *xsf;
    ydif = (r__1 = yy2 - yy1, dabs(r__1)) / *ysf;

    if (xdif == 0.f) {
	xdif = 1e-5f;
    }
    if (ydif == 0.f) {
	ydif = 1e-5f;
    }

    *xoff = dmin(xx1,xx2) / *xsf + *xoff;
    *yoff = dmin(yy1,yy2) / *ysf + *yoff;
    *xsf = *xwind / xdif;
    *ysf = *ywind / ydif;

    if (*lsame) {
/* ------ set equal x,y scales */
	sf = dmin(*xsf,*ysf);
	*xsf = sf;
	*ysf = sf;

/* ------ re-center the blowup */
	*xoff = xcen - xdif * .5f;
	*yoff = ycen - ydif * .5f;
    }

    return 0;
} /* offget_ */

/* Subroutine */ int pgui_(int *kbox, char *color, char *label, ftnlen 
	color_len, ftnlen label_len)
{
    extern /* Subroutine */ int getcolor_(int *), newcolor_(int *);
    static real x1, x2, y1, y2;
    extern /* Subroutine */ int getclipabs_(real *, real *, real *, real *), 
	    newclipabs_(real *, real *, real *, real *), getwinsize_(real *, 
	    real *);
    static real xmin, ymin, xmax, ymax, ybox;
    static int icol0;
    extern /* Subroutine */ int newcolorname_(char *, ftnlen);
    static real xwind, ywind;
    extern /* Subroutine */ int guibox_(int *, real *, real *, real *, 
	    real *, char *, char *, ftnlen, ftnlen), clrclip_(void);


    getwinsize_(&xwind, &ywind);
/* c      CALL GETORIGIN(XORG,YORG) */
/* c      CALL GETFACTORS(XSCALE,YSCALE) */

/* ---- save and disable current clipping */
    getclipabs_(&xmin, &xmax, &ymin, &ymax);
    clrclip_();

    getcolor_(&icol0);
    newcolorname_(color, color_len);

/* ---- set click box in lower right corner */
    ybox = (real) (*kbox - 1) * .5f;
    x1 = xwind - 1.f;
    x2 = xwind - .1f;
    y1 = ybox + .1f;
    y2 = ybox + .5f;
/* c      X1 = (XWIND - 1.0 - XORG)/XSCALE */
/* c      X2 = (XWIND - 0.1 - XORG)/XSCALE */
/* c      Y1 = (YBOX  + 0.1 - YORG)/YSCALE */
/* c      Y2 = (YBOX  + 0.5 - YORG)/YSCALE */

    guibox_(kbox, &x1, &x2, &y1, &y2, color, label, color_len, label_len);

/* ---- restore color and clipping */
    newcolor_(&icol0);
    newclipabs_(&xmin, &xmax, &ymin, &ymax);

    return 0;
} /* pgui_ */

/* Subroutine */ int arrow_(real *x, real *y, real *dx, real *dy)
{
    /* System generated locals */
    real r__1, r__2;

    /* Local variables */
    static real x1, y1, x2, y2;
    extern /* Subroutine */ int plot_(real *, real *, int *);

    plot_(x, y, &c__3);
    r__1 = *x + *dx;
    r__2 = *y + *dy;
    plot_(&r__1, &r__2, &c__2);
    x1 = *x + *dx * .85f + *dy * .02f;
    y1 = *y + *dy * .85f - *dx * .02f;
    x2 = *x + *dx * .85f - *dy * .02f;
    y2 = *y + *dy * .85f + *dx * .02f;
    plot_(&x1, &y1, &c__2);
    plot_(&x2, &y2, &c__2);
    r__1 = *x + *dx;
    r__2 = *y + *dy;
    plot_(&r__1, &r__2, &c__2);
    return 0;
} /* arrow_ */

/* Subroutine */ int dash_(real *x1, real *x2, real *y)
{
    /* System generated locals */
    real r__1;

    /* Local variables */
    static int i__;
    static real x, dx;
    extern /* Subroutine */ int plot_(real *, real *, int *), newpen_(
	    int *);

    newpen_(&c__1);
    dx = (*x2 - *x1) / 50.f;
    for (i__ = 1; i__ <= 51; ++i__) {
	x = *x1 + dx * (real) (i__ - 1);
	r__1 = x - dx * .08f;
	plot_(&r__1, y, &c__3);
	r__1 = x + dx * .08f;
	plot_(&r__1, y, &c__2);
/* L10: */
    }
    return 0;
} /* dash_ */
