#include "f2c.h"

/* Table of constant values */

static int c__1 = 1;
static int c__9 = 9;
static int c__257 = 257;
static int c__111 = 111;
static int c__91 = 91;
static int c__21 = 21;
static int c__3 = 3;

/* Main program */ 
int MAIN__(void)
{
  /* System generated locals */
  int i__1, i__2, i__3;
  real r__1, r__2;
  olist o__1;
  cllist cl__1;

  /* Local variables */
  static real a[53382]  /* was [31][41][21][2] */;
  static int n[21];
  static real s[5397] /* was [257][21] */, u[5397]  /* was [257][21] */, 
    ac[424242]  /* was [111][91][21][2] */, ah[53382] /* was [31][
    41][21][2] */;
  static int ic, ih;
  static real ar[53382] /* was [31][41][21][2] */, hl[21];
  static int nh;
  static real aw[53382] /* was [31][41][21][2] */;
  static int ir;
  static real rl[31];
  static int nr, iw, lu;
  static real wl[41];
  static int nw, ir1[21], ir2[21], iw1[21], iw2[21];
  static real eta[5397] /* was [257][21] */, arh[53382] /* was [31][
    41][21][2] */, hhl[21], awh[53382]  /* was [31][41][21][2] */;
  static int ihp, nhp;
  static real arw[53382]  /* was [31][41][21][2] */;
  static int irp, nrp[21];
  static real rtl[2331] /* was [111][21] */;
  static int iwp, nwp[21];
  static real wsl[1911] /* was [91][21] */;
  static int ihp1, ihp2, irp1[21], irp2[21], iwp1[21], iwp2[21];
  static real ac_h__[424242]  /* was [111][91][21][2] */, ac_r__[424242]  
    /* was [111][91][21][2] */, ac_w__[424242]  /* was [111][91][21][
    2] */, atmp[223], arwh[53382] /* was [31][41][21][2] */, 
    drtl, dwsl;
  static char argp1[80];
  static real ac_rh__[424242] /* was [111][91][21][2] */, ac_wh__[424242] 
    /* was [111][91][21][2] */;
  static real ac_rw__[424242] /* was [111][91][21][2] */;
  static int irinc;
  static real adtmp[223];
  static int iroff, iwinc, iwoff, iform;
  static real ac_rwh__[424242]  /* was [111][91][21][2] */;
  static int ihpnum;
  static real rtlmin, rtlmax, wslmin, wslmax;
  static int nrptot;
  static int nwptot;
  static logical lspline;
  
  /* Fortran I/O blocks */
  static cilist io___5 = { 0, 6, 0, 0, 0 };
  static cilist io___6 = { 0, 5, 0, "(A)", 0 };
  static cilist io___71 = { 0, 6, 0, 0, 0 };
  static cilist io___72 = { 0, 0, 0, 0, 0 };
  static cilist io___73 = { 0, 0, 0, 0, 0 };
  static cilist io___74 = { 0, 0, 0, 0, 0 };
  static cilist io___75 = { 0, 0, 0, 0, 0 };
  static cilist io___76 = { 0, 0, 0, 0, 0 };
  static cilist io___77 = { 0, 0, 0, 0, 0 };
  static cilist io___78 = { 0, 0, 0, 0, 0 };
  static cilist io___79 = { 0, 0, 0, 0, 0 };
  static cilist io___80 = { 0, 0, 0, 0, 0 };
  static cilist io___81 = { 0, 0, 0, 0, 0 };
  static cilist io___82 = { 0, 0, 0, 0, 0 };
  static cilist io___83 = { 0, 0, 0, 0, 0 };
  static cilist io___84 = { 0, 0, 0, 0, 0 };


/* ----------------------------------------------------------------------- */
/*     Reads OS amplification data alpha(R,w) stored in separate files, */
/*     one file for each H value. */

/*     Distills this data into arrays which define a tri-cubic spline */
/*     which can be efficiently interrogated to return the alpha(R,W,H) */
/*     function and its derivatives. */

/*     The tri-cubic spline data is written out as a binary file, */
/*     to be read and used in SUBROUTINE OSMAP. */

/*     Usage: */

/*       % osgen os_list_file */

/* ----------------------------------------------------------------------- */

/* ---- if T, use splines to compute derivatives, otherwise use finite-diff. */
  lspline = TRUE_;

/* ---- strides in R and W file values selected for storage in binary table */
/* -    (i.e. binary table can be less dense than the source storage files) */
  irinc = 4;
  iwinc = 2;

  getarg0_(&c__1, argp1, (ftnlen)80);

  if (s_cmp(argp1, " ", (ftnlen)80, (ftnlen)1) == 0) 
  {
    /*<        WRITE(*,*) 'Enter file containing list of OS datafiles' >*/
    s_wsle(&io___5);
    do_lio(&c__9, &c__1, "Enter file containing list of OS datafiles", (
            ftnlen)42);
    e_wsle();
    /*<        READ(*,'(A)') ARGP1 >*/
    s_rsfe(&io___6);
    do_fio(&c__1, argp1, (ftnlen)80);
    e_rsfe();
  }

  /* ---- set expeced format of source files */
  /*<       IFORM = -1 !  unknown >*/
  iform = -1;
  /* cc   IFORM = 0  !  binary */
  /* cc   IFORM = 1  !  ascii */

  /*<    >*/
  reados_(argp1, &iform, n, &c__257, eta, u, s, nrp, nwp, &nhp, rtl, wsl, 
          hhl, ac, &ac[212121], &c__111, &c__91, &c__21, (ftnlen)80);


  /*<       RTLMIN = RTL(1,1) >*/
  rtlmin = rtl[0];
  /*<       WSLMIN = WSL(1,1) >*/
  wslmin = wsl[0];
  /*<       RTLMAX = RTL(1,1) >*/
  rtlmax = rtl[0];
  /*<       WSLMAX = WSL(1,1) >*/
  wslmax = wsl[0];
  /*<       DO IHP=1, NHP >*/
  i__1 = nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) {
    /*<         RTLMIN = MIN( RTLMIN , RTL(1,IHP) ) >*/
    /* Computing MIN */
    r__1 = rtlmin, r__2 = rtl[ihp * 111 - 111];
    rtlmin = dmin(r__1,r__2);
    /*<         WSLMIN = MIN( WSLMIN , WSL(1,IHP) ) >*/
    /* Computing MIN */
    r__1 = wslmin, r__2 = wsl[ihp * 91 - 91];
    wslmin = dmin(r__1,r__2);
    /*<         RTLMAX = MAX( RTLMAX , RTL(NRP(IHP),IHP) ) >*/
    /* Computing MAX */
    r__1 = rtlmax, r__2 = rtl[nrp[ihp - 1] + ihp * 111 - 112];
    rtlmax = dmax(r__1,r__2);
    /*<         WSLMAX = MAX( WSLMAX , WSL(NWP(IHP),IHP) ) >*/
    /* Computing MAX */
    r__1 = wslmax, r__2 = wsl[nwp[ihp - 1] + ihp * 91 - 92];
    wslmax = dmax(r__1,r__2);
    /*<       ENDDO >*/
  }

  /*<       DRTL = RTL(2,1) - RTL(1,1) >*/
  drtl = rtl[1] - rtl[0];
  /*<       DWSL = WSL(2,1) - WSL(1,1) >*/
  dwsl = wsl[1] - wsl[0];

  /*<       NRPTOT = INT( (RTLMAX - RTLMIN)/DRTL + 1.001 ) >*/
  nrptot = (integer) ((rtlmax - rtlmin) / drtl + 1.001f);
  /*<       NWPTOT = INT( (WSLMAX - WSLMIN)/DWSL + 1.001 ) >*/
  nwptot = (integer) ((wslmax - wslmin) / dwsl + 1.001f);

  /*<       IF(NRPTOT .GT. NRX) STOP 'OSGEN: R index overflow' >*/
  if (nrptot > 111) {
    s_stop("OSGEN: R index overflow", (ftnlen)23);
  }
  /*<       IF(NWPTOT .GT. NWX) STOP 'OSGEN: W index overflow' >*/
  if (nwptot > 91) {
    s_stop("OSGEN: W index overflow", (ftnlen)23);
  }

  /* ---- move ar,ai array for each H to a common origin for splining */
  /*<       DO 20 IHP=1, NHP >*/
  i__1 = nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) {
    /*<         IROFF = INT( (RTL(1,IHP) - RTLMIN)/DRTL + 0.001 ) >*/
    iroff = (integer) ((rtl[ihp * 111 - 111] - rtlmin) / drtl + .001f);
    /*<         IWOFF = INT( (WSL(1,IHP) - WSLMIN)/DWSL + 0.001 ) >*/
    iwoff = (integer) ((wsl[ihp * 91 - 91] - wslmin) / dwsl + .001f);
    /*<         IF(IROFF.EQ.0 .AND. IWOFF.EQ.0) GO TO 19 >*/
    if (iroff == 0 && iwoff == 0) {
      goto L19;
    }

    /*<         DO IC = 1, 2 >*/
    for (ic = 1; ic <= 2; ++ic) {
      /*<         DO IRP=NRP(IHP), 1, -1 >*/
      for (irp = nrp[ihp - 1]; irp >= 1; --irp) {
        /*<           DO IWP=NWP(IHP), 1, -1 >*/
        for (iwp = nwp[ihp - 1]; iwp >= 1; --iwp) {
          /*<             AC(IRP+IROFF,IWP+IWOFF,IHP,IC) = AC(IRP,IWP,IHP,IC) >*/
          ac[irp + iroff + (iwp + iwoff + (ihp + ic * 21) * 91) * 
              111 - 222334] = ac[irp + (iwp + (ihp + ic * 21) * 
              91) * 111 - 222334];
          /*<             AC(IRP,IWP,IHP,IC) = 0.0 >*/
          ac[irp + (iwp + (ihp + ic * 21) * 91) * 111 - 222334] = 
              0.f;
          /*<           ENDDO >*/
        }
        /*<         ENDDO >*/
      }
      /*<         ENDDO >*/
    }

    /*<         IF(IROFF.GT.0) THEN >*/
    if (iroff > 0) {
      /*<          DO IRP=NRP(IHP), 1, -1 >*/
      for (irp = nrp[ihp - 1]; irp >= 1; --irp) {
        /*<            RTL(IRP+IROFF,IHP) = RTL(IRP,IHP) >*/
        rtl[irp + iroff + ihp * 111 - 112] = rtl[irp + ihp * 111 - 
            112];
        /*<            RTL(IRP,IHP) = 0.0 >*/
        rtl[irp + ihp * 111 - 112] = 0.f;
        /*<          ENDDO >*/
      }
      /*<         ENDIF >*/
    }

    /*<         IF(IWOFF.GT.0) THEN >*/
    if (iwoff > 0) {
      /*<          DO IWP=NWP(IHP), 1, -1 >*/
      for (iwp = nwp[ihp - 1]; iwp >= 1; --iwp) {
        /*<            WSL(IWP+IWOFF,IHP) = WSL(IWP,IHP) >*/
        wsl[iwp + iwoff + ihp * 91 - 92] = wsl[iwp + ihp * 91 - 92];
        /*<            WSL(IWP,IHP) = 0.0 >*/
        wsl[iwp + ihp * 91 - 92] = 0.f;
        /*<          ENDDO >*/
      }
      /*<         ENDIF >*/
    }

    /*<    19   IRP1(IHP) = IROFF + 1 >*/
L19:
    irp1[ihp - 1] = iroff + 1;
/*<         IWP1(IHP) = IWOFF + 1 >*/
  iwp1[ihp - 1] = iwoff + 1;
  /*<         IRP2(IHP) = IROFF + NRP(IHP) >*/
  irp2[ihp - 1] = iroff + nrp[ihp - 1];
  /*<         IWP2(IHP) = IWOFF + NWP(IHP) >*/
  iwp2[ihp - 1] = iwoff + nwp[ihp - 1];

  /* ------ set newly-defined R and W coordinate values */
  /*<         DO IRP=1, IRP1(IHP)-1 >*/
  i__2 = irp1[ihp - 1] - 1;
  for (irp = 1; irp <= i__2; ++irp) {
    /*<           RTL(IRP,IHP) = RTL(IRP1(IHP),IHP) + DRTL*FLOAT(IRP-IRP1(IHP)) >*/
    rtl[irp + ihp * 111 - 112] = rtl[irp1[ihp - 1] + ihp * 111 - 112] 
        + drtl * (real) (irp - irp1[ihp - 1]);
    /*<         ENDDO >*/
  }
  /*<         DO IRP=IRP2(IHP)+1, NRPTOT >*/
  i__2 = nrptot;
  for (irp = irp2[ihp - 1] + 1; irp <= i__2; ++irp) {
    /*<           RTL(IRP,IHP) = RTL(IRP2(IHP),IHP) + DRTL*FLOAT(IRP-IRP2(IHP)) >*/
    rtl[irp + ihp * 111 - 112] = rtl[irp2[ihp - 1] + ihp * 111 - 112] 
        + drtl * (real) (irp - irp2[ihp - 1]);
    /*<         ENDDO >*/
  }

  /*<         DO IWP=1, IWP1(IHP)-1 >*/
  i__2 = iwp1[ihp - 1] - 1;
  for (iwp = 1; iwp <= i__2; ++iwp) {
    /*<           WSL(IWP,IHP) = WSL(IWP1(IHP),IHP) + DWSL*FLOAT(IWP-IWP1(IHP)) >*/
    wsl[iwp + ihp * 91 - 92] = wsl[iwp1[ihp - 1] + ihp * 91 - 92] + 
        dwsl * (real) (iwp - iwp1[ihp - 1]);
    /*<         ENDDO >*/
  }
  /*<         DO IWP=IWP2(IHP)+1, NWPTOT >*/
  i__2 = nwptot;
  for (iwp = iwp2[ihp - 1] + 1; iwp <= i__2; ++iwp) {
    /*<           WSL(IWP,IHP) = WSL(IWP2(IHP),IHP) + DWSL*FLOAT(IWP-IWP2(IHP)) >*/
    wsl[iwp + ihp * 91 - 92] = wsl[iwp2[ihp - 1] + ihp * 91 - 92] + 
        dwsl * (real) (iwp - iwp2[ihp - 1]);
    /*<         ENDDO >*/
  }

  /*<    20 CONTINUE >*/
  /* L20: */
  }

  /* ---- differentiate in H with spline routine to get AC_H */
  /*<       DO 40 IRP=1, NRPTOT >*/
  i__1 = nrptot;
  for (irp = 1; irp <= i__1; ++irp) {
    /*<         DO 401 IWP=1, NWPTOT >*/
    i__2 = nwptot;
    for (iwp = 1; iwp <= i__2; ++iwp) {

      /* -------- find first H index at this R,w */
      /*<           DO IHP=1, NHP >*/
      i__3 = nhp;
      for (ihp = 1; ihp <= i__3; ++ihp) {
        /*<    >*/
        if (irp >= irp1[ihp - 1] && irp <= irp2[ihp - 1] && iwp >= 
            iwp1[ihp - 1] && iwp <= iwp2[ihp - 1]) {
          goto L4012;
            }
            /*<           ENDDO >*/
      }
      /*<           GO TO 401 >*/
      goto L401;
      /*<  4012     IHP1 = IHP >*/
L4012:
    ihp1 = ihp;

/* -------- find last H index at this R,w */
/*<           DO IHP=NHP, 1, -1 >*/
      for (ihp = nhp; ihp >= 1; --ihp) {
        /*<    >*/
        if (irp >= irp1[ihp - 1] && irp <= irp2[ihp - 1] && iwp >= 
            iwp1[ihp - 1] && iwp <= iwp2[ihp - 1]) {
          goto L4022;
            }
            /*<           ENDDO >*/
      }
      /*<           GO TO 401 >*/
      goto L401;
      /*<  4022     IHP2 = IHP >*/
L4022:
    ihp2 = ihp;

/*<           DO IC = 1, 2 >*/
      for (ic = 1; ic <= 2; ++ic) {
        /*<             DO IHP=IHP1, IHP2 >*/
        i__3 = ihp2;
        for (ihp = ihp1; ihp <= i__3; ++ihp) {
          /*<               ATMP(IHP) = AC(IRP,IWP,IHP,IC) >*/
          atmp[ihp - 1] = ac[irp + (iwp + (ihp + ic * 21) * 91) * 
              111 - 222334];
          /*<             ENDDO >*/
        }

        /*<             IHPNUM = IHP2 - IHP1 + 1 >*/
        ihpnum = ihp2 - ihp1 + 1;
        /*<             CALL SPLINE(ATMP(IHP1),ADTMP(IHP1),HHL(IHP1),IHPNUM) >*/
        spline_(&atmp[ihp1 - 1], &adtmp[ihp1 - 1], &hhl[ihp1 - 1], &
            ihpnum);

        /*<             DO IHP=IHP1, IHP2 >*/
        i__3 = ihp2;
        for (ihp = ihp1; ihp <= i__3; ++ihp) {
          /*<               AC_H(IRP,IWP,IHP,IC) = ADTMP(IHP) >*/
          ac_h__[irp + (iwp + (ihp + ic * 21) * 91) * 111 - 222334] 
              = adtmp[ihp - 1];
          /*<             ENDDO >*/
        }
        /*<           ENDDO >*/
      }

      /*<   401   CONTINUE >*/
L401:
    ;
    }
    /*<    40 CONTINUE >*/
    /* L40: */
  }


  /*<       DO 50 IC = 1, 2 >*/
  for (ic = 1; ic <= 2; ++ic) {
    /*<         IF(LSPLINE) THEN >*/
    if (lspline) {
      /* ------- calculate AC_R and AC_W arrays from spline coefficients */
      /*<    >*/
      rdiffs_(irp1, irp2, iwp1, iwp2, &nhp, rtl, &c__111, &c__91, &ac[((
              ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_r__[((ic * 21 
                  + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiffs_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &ac[((
              ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_w__[((ic * 21 
                  + 1) * 91 + 1) * 111 - 222333]);

      /*<    >*/
      rdiffs_(irp1, irp2, iwp1, iwp2, &nhp, rtl, &c__111, &c__91, &
          ac_h__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_rh__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiffs_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_h__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_wh__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiffs_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_r__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_rw__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);

      /*<    >*/
      wdiffs_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_rh__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &
              ac_rwh__[((ic * 21 + 1) * 91 + 1) * 111 - 222333]);

      /*<         ELSE >*/
    } 
    else 
    {
      /* ------- calculate AC_R and AC_W arrays by finite-differencing */
      /*<    >*/
      rdiff_(irp1, irp2, iwp1, iwp2, &nhp, rtl, &c__111, &c__91, &ac[((
             ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_r__[((ic * 21 
                 + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiff_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &ac[((
             ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_w__[((ic * 21 
                 + 1) * 91 + 1) * 111 - 222333]);

      /*<    >*/
      rdiff_(irp1, irp2, iwp1, iwp2, &nhp, rtl, &c__111, &c__91, &
          ac_h__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_rh__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiff_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_h__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_wh__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);
      /*<    >*/
      wdiff_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_r__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &ac_rw__[
              ((ic * 21 + 1) * 91 + 1) * 111 - 222333]);

      /*<    >*/
      wdiff_(irp1, irp2, iwp1, iwp2, &nhp, wsl, &c__111, &c__91, &
          ac_rh__[((ic * 21 + 1) * 91 + 1) * 111 - 222333], &
              ac_rwh__[((ic * 21 + 1) * 91 + 1) * 111 - 222333]);
      /*<         ENDIF >*/
    }
    /*<  50   CONTINUE >*/
    /* L50: */
  }


  /* ---- set coarsened array limits */
  /*<       NR = (NRPTOT-1)/IRINC + 1 >*/
  nr = (nrptot - 1) / irinc + 1;
  /*<       NW = (NWPTOT-1)/IWINC + 1 >*/
  nw = (nwptot - 1) / iwinc + 1;
  /*<       NH =  NHP >*/
  nh = nhp;

  /*<       DO 60 IHP=1, NHP >*/
  i__1 = nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) {
    /*<         IH = IHP >*/
    ih = ihp;
    /*<         IR1(IH) = (IRP1(IHP)-1)/IRINC + 1 >*/
    ir1[ih - 1] = (irp1[ihp - 1] - 1) / irinc + 1;
    /*<         IR2(IH) = (IRP2(IHP)-1)/IRINC + 1 >*/
    ir2[ih - 1] = (irp2[ihp - 1] - 1) / irinc + 1;
    /*<         IW1(IH) = (IWP1(IHP)-1)/IWINC + 1 >*/
    iw1[ih - 1] = (iwp1[ihp - 1] - 1) / iwinc + 1;
    /*<         IW2(IH) = (IWP2(IHP)-1)/IWINC + 1 >*/
    iw2[ih - 1] = (iwp2[ihp - 1] - 1) / iwinc + 1;

    /*<         DO IR=1, NR >*/
    i__2 = nr;
    for (ir = 1; ir <= i__2; ++ir) {
      /*<           IRP = IRINC*(IR-1) + 1 >*/
      irp = irinc * (ir - 1) + 1;
      /*<           DO IW=1, NW >*/
      i__3 = nw;
      for (iw = 1; iw <= i__3; ++iw) {
        /*<             IWP = IWINC*(IW-1) + 1 >*/
        iwp = iwinc * (iw - 1) + 1;
        /*<             DO IC = 1, 2 >*/
        for (ic = 1; ic <= 2; ++ic) {
          /*<               A   (IR,IW,IH,IC) = AC    (IRP,IWP,IHP,IC) >*/
          a[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = ac[irp 
              + (iwp + (ihp + ic * 21) * 91) * 111 - 222334];
          /*<               AR  (IR,IW,IH,IC) = AC_R  (IRP,IWP,IHP,IC) >*/
          ar[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = ac_r__[
              irp + (iwp + (ihp + ic * 21) * 91) * 111 - 222334]
              ;
          /*<               AW  (IR,IW,IH,IC) = AC_W  (IRP,IWP,IHP,IC) >*/
          aw[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = ac_w__[
              irp + (iwp + (ihp + ic * 21) * 91) * 111 - 222334]
              ;
          /*<               AH  (IR,IW,IH,IC) = AC_H  (IRP,IWP,IHP,IC) >*/
          ah[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = ac_h__[
              irp + (iwp + (ihp + ic * 21) * 91) * 111 - 222334]
              ;
          /*<               ARW (IR,IW,IH,IC) = AC_RW (IRP,IWP,IHP,IC) >*/
          arw[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = 
              ac_rw__[irp + (iwp + (ihp + ic * 21) * 91) * 111 
              - 222334];
          /*<               ARH (IR,IW,IH,IC) = AC_RH (IRP,IWP,IHP,IC) >*/
          arh[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = 
              ac_rh__[irp + (iwp + (ihp + ic * 21) * 91) * 111 
              - 222334];
          /*<               AWH (IR,IW,IH,IC) = AC_WH (IRP,IWP,IHP,IC) >*/
          awh[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = 
              ac_wh__[irp + (iwp + (ihp + ic * 21) * 91) * 111 
              - 222334];
          /*<               ARWH(IR,IW,IH,IC) = AC_RWH(IRP,IWP,IHP,IC) >*/
          arwh[ir + (iw + (ih + ic * 21) * 41) * 31 - 27994] = 
              ac_rwh__[irp + (iwp + (ihp + ic * 21) * 91) * 111 
              - 222334];
          /*<             ENDDO >*/
        }
        /*<           ENDDO >*/
	    }
      /*<         ENDDO >*/
    }
    /*<    60 CONTINUE >*/
    /* L60: */
  }

  /* ---- also set coarsened independent vaiable arrays */
  /*<       IHP = 1 >*/
  ihp = 1;

  /*<       DO IR=1, NR >*/
  i__1 = nr;
  for (ir = 1; ir <= i__1; ++ir) {
    /*<         IRP = IRINC*(IR-1) + 1 >*/
    irp = irinc * (ir - 1) + 1;
    /*<         RL(IR) = RTL(IRP,IHP) >*/
    rl[ir - 1] = rtl[irp + ihp * 111 - 112];
    /*<       ENDDO >*/
  }

  /*<       DO IW=1, NW >*/
  i__1 = nw;
  for (iw = 1; iw <= i__1; ++iw) {
    /*<         IWP = IWINC*(IW-1) + 1 >*/
    iwp = iwinc * (iw - 1) + 1;
    /*<         WL(IW) = WSL(IWP,IHP) >*/
    wl[iw - 1] = wsl[iwp + ihp * 91 - 92];
    /*<       ENDDO >*/
  }

  /*<       DO IH=1, NH >*/
  i__1 = nh;
  for (ih = 1; ih <= i__1; ++ih) {
    /*<         IHP = IH >*/
    ihp = ih;
    /*<         HL(IH) = HHL(IHP) >*/
    hl[ih - 1] = hhl[ihp - 1];
    /*<       ENDDO >*/
  }


  /* ---- write coarsened arrays into binary data file */
  /*<       LU = 30 >*/
  lu = 30;
  /*<       OPEN(LU,FILE='osmap.dat',STATUS='UNKNOWN',FORM='UNFORMATTED') >*/
  o__1.oerr = 0;
  o__1.ounit = lu;
  o__1.ofnmlen = 9;
  o__1.ofnm = "osmap.dat";
  o__1.orl = 0;
  o__1.osta = "UNKNOWN";
  o__1.oacc = 0;
  o__1.ofm = "UNFORMATTED";
  o__1.oblnk = 0;
  f_open(&o__1);

  /*<       WRITE(*,*) 'Writing  osmap.dat ...' >*/
  s_wsle(&io___71);
  do_lio(&c__9, &c__1, "Writing  osmap.dat ...", (ftnlen)22);
  e_wsle();

  /*<       WRITE(LU) NR, NW, NH >*/
  io___72.ciunit = lu;
  s_wsue(&io___72);
  do_uio(&c__1, (char *)&nr, (ftnlen)sizeof(integer));
  do_uio(&c__1, (char *)&nw, (ftnlen)sizeof(integer));
  do_uio(&c__1, (char *)&nh, (ftnlen)sizeof(integer));
  e_wsue();
  /*<       WRITE(LU) (RL(IR), IR=1,NR) >*/
  io___73.ciunit = lu;
  s_wsue(&io___73);
  i__1 = nr;
  for (ir = 1; ir <= i__1; ++ir) {
    do_uio(&c__1, (char *)&rl[ir - 1], (ftnlen)sizeof(real));
  }
  e_wsue();
  /*<       WRITE(LU) (WL(IW), IW=1,NW) >*/
  io___74.ciunit = lu;
  s_wsue(&io___74);
  i__1 = nw;
  for (iw = 1; iw <= i__1; ++iw) {
    do_uio(&c__1, (char *)&wl[iw - 1], (ftnlen)sizeof(real));
  }
  e_wsue();
  /*<       WRITE(LU) (HL(IH), IH=1,NH) >*/
  io___75.ciunit = lu;
  s_wsue(&io___75);
  i__1 = nh;
  for (ih = 1; ih <= i__1; ++ih) {
    do_uio(&c__1, (char *)&hl[ih - 1], (ftnlen)sizeof(real));
  }
  e_wsue();
  /*<       WRITE(LU) (IR1(IH),IR2(IH),IW1(IH),IW2(IH), IH=1,NH) >*/
  io___76.ciunit = lu;
  s_wsue(&io___76);
  i__1 = nh;
  for (ih = 1; ih <= i__1; ++ih) {
    do_uio(&c__1, (char *)&ir1[ih - 1], (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&ir2[ih - 1], (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&iw1[ih - 1], (ftnlen)sizeof(integer));
    do_uio(&c__1, (char *)&iw2[ih - 1], (ftnlen)sizeof(integer));
  }
  e_wsue();

  /* ---- write ai first, then ar */
  /*<       DO 70 IC = 2, 1, -1 >*/
  for (ic = 2; ic >= 1; --ic) {
    /*<         DO IH=1, NH >*/
    i__1 = nh;
    for (ih = 1; ih <= i__1; ++ih) {
      /*<           DO IW=IW1(IH), IW2(IH) >*/
      i__2 = iw2[ih - 1];
      for (iw = iw1[ih - 1]; iw <= i__2; ++iw) {
        /*<             WRITE(LU) (   A(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___77.ciunit = lu;
        s_wsue(&io___77);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&a[ir + (iw + (ih + ic * 21) * 41) *
                31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) (  AR(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___78.ciunit = lu;
        s_wsue(&io___78);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&ar[ir + (iw + (ih + ic * 21) * 41) 
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) (  AW(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___79.ciunit = lu;
        s_wsue(&io___79);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&aw[ir + (iw + (ih + ic * 21) * 41) 
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) (  AH(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___80.ciunit = lu;
        s_wsue(&io___80);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&ah[ir + (iw + (ih + ic * 21) * 41) 
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) ( ARW(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___81.ciunit = lu;
        s_wsue(&io___81);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&arw[ir + (iw + (ih + ic * 21) * 41)
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) ( ARH(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___82.ciunit = lu;
        s_wsue(&io___82);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&arh[ir + (iw + (ih + ic * 21) * 41)
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) ( AWH(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___83.ciunit = lu;
        s_wsue(&io___83);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&awh[ir + (iw + (ih + ic * 21) * 41)
                * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<             WRITE(LU) (ARWH(IR,IW,IH,IC), IR=IR1(IH),IR2(IH)) >*/
        io___84.ciunit = lu;
        s_wsue(&io___84);
        i__3 = ir2[ih - 1];
        for (ir = ir1[ih - 1]; ir <= i__3; ++ir) {
          do_uio(&c__1, (char *)&arwh[ir + (iw + (ih + ic * 21) * 
                41) * 31 - 27994], (ftnlen)sizeof(real));
        }
        e_wsue();
        /*<           ENDDO >*/
      }
      /*<         ENDDO >*/
    }
    /*<  70   CONTINUE >*/
    /* L70: */
  }

  /*<       CLOSE(LU) >*/
  cl__1.cerr = 0;
  cl__1.cunit = lu;
  cl__1.csta = 0;
  f_clos(&cl__1);

  /*<       STOP >*/
  s_stop("", (ftnlen)0);
  return 0;
} /* MAIN__ */

int rdiff_(
           int *irp1, 
           int *irp2, 
           int *iwp1, 
           int *iwp2, 
           int *nhp, 
           real *rtl, 
           int *nrx, 
           int *nwx, 
           real *ac, 
           real *ac_r__)
{
  /* System generated locals */
  int ac_dim1, ac_dim2, ac_offset, ac_r_dim1, ac_r_dim2, ac_r_offset, 
    rtl_dim1, rtl_offset, i__1, i__2, i__3;

  /* Local variables */
  static int ihp, irp, iwp;
  static real delr;

  /* Parameter adjustments */
  --irp1;
  --irp2;
  --iwp1;
  --iwp2;
  rtl_dim1 = *nrx;
  rtl_offset = 1 + rtl_dim1;
  rtl -= rtl_offset;
  ac_r_dim1 = *nrx;
  ac_r_dim2 = *nwx;
  ac_r_offset = 1 + ac_r_dim1 * (1 + ac_r_dim2);
  ac_r__ -= ac_r_offset;
  ac_dim1 = *nrx;
  ac_dim2 = *nwx;
  ac_offset = 1 + ac_dim1 * (1 + ac_dim2);
  ac -= ac_offset;

  /* Function Body */
  i__1 = *nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) 
  {

    /* ------ differentiate in R with finite differences */
    i__2 = iwp2[ihp];
    for (iwp = iwp1[ihp]; iwp <= i__2; ++iwp) 
    {
      irp = irp1[ihp];
      delr = rtl[irp + 1 + ihp * rtl_dim1] - rtl[irp + ihp * rtl_dim1];
      ac_r__[irp + (iwp + ihp * ac_r_dim2) * ac_r_dim1] = (ac[irp + (
                    iwp + ihp * ac_dim2) * ac_dim1] * -3.f + ac[irp + 1 + (
          iwp + ihp * ac_dim2) * ac_dim1] * 4.f - ac[irp + 2 + (iwp 
          + ihp * ac_dim2) * ac_dim1]) / delr;
      irp = irp2[ihp];
      delr = rtl[irp + ihp * rtl_dim1] - rtl[irp - 1 + ihp * rtl_dim1];
      ac_r__[irp + (iwp + ihp * ac_r_dim2) * ac_r_dim1] = (ac[irp + (
                    iwp + ihp * ac_dim2) * ac_dim1] * 3.f - ac[irp - 1 + (iwp 
          + ihp * ac_dim2) * ac_dim1] * 4.f + ac[irp - 2 + (iwp + 
          ihp * ac_dim2) * ac_dim1]) / delr;
      i__3 = irp2[ihp] - 1;
      for (irp = irp1[ihp] + 1; irp <= i__3; ++irp) 
      {
        delr = rtl[irp + 1 + ihp * rtl_dim1] - rtl[irp - 1 + ihp * 
            rtl_dim1];
        ac_r__[irp + (iwp + ihp * ac_r_dim2) * ac_r_dim1] = (ac[irp + 
            1 + (iwp + ihp * ac_dim2) * ac_dim1] - ac[irp - 1 + 
            (iwp + ihp * ac_dim2) * ac_dim1]) / delr;
      }
    }
  }
  return 0;
} /* rdiff_ */

int wdiff_(
           int *irp1, 
           int *irp2, 
           int *iwp1,
           int *iwp2, 
           int *nhp, 
           real *wsl, 
           int *nrx, 
           int *nwx, 
           real *ac, 
           real *ac_w__)
{
  /* System generated locals */
  int ac_dim1, ac_dim2, ac_offset, ac_w_dim1, ac_w_dim2, ac_w_offset, 
    wsl_dim1, wsl_offset, i__1, i__2, i__3;

  /* Local variables */
  static int ihp, irp, iwp;
  static real delf;

  /* Parameter adjustments */
  --irp1;
  --irp2;
  --iwp1;
  --iwp2;
  ac_w_dim1 = *nrx;
  ac_w_dim2 = *nwx;
  ac_w_offset = 1 + ac_w_dim1 * (1 + ac_w_dim2);
  ac_w__ -= ac_w_offset;
  ac_dim1 = *nrx;
  ac_dim2 = *nwx;
  ac_offset = 1 + ac_dim1 * (1 + ac_dim2);
  ac -= ac_offset;
  wsl_dim1 = *nwx;
  wsl_offset = 1 + wsl_dim1;
  wsl -= wsl_offset;

  /* Function Body */
  i__1 = *nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) 
  {

    /* ------ differentiate in F with finite differences */
    i__2 = irp2[ihp];
    for (irp = irp1[ihp]; irp <= i__2; ++irp) 
    {
      iwp = iwp1[ihp];
      delf = wsl[iwp + 1 + ihp * wsl_dim1] - wsl[iwp + ihp * wsl_dim1];
      ac_w__[irp + (iwp + ihp * ac_w_dim2) * ac_w_dim1] = (ac[irp + (
                    iwp + ihp * ac_dim2) * ac_dim1] * -3.f + ac[irp + (iwp + 
          1 + ihp * ac_dim2) * ac_dim1] * 4.f - ac[irp + (iwp + 2 + 
          ihp * ac_dim2) * ac_dim1]) / delf;
      iwp = iwp2[ihp];
      delf = wsl[iwp + ihp * wsl_dim1] - wsl[iwp - 1 + ihp * wsl_dim1];
      ac_w__[irp + (iwp + ihp * ac_w_dim2) * ac_w_dim1] = (ac[irp + (
                    iwp + ihp * ac_dim2) * ac_dim1] * 3.f - ac[irp + (iwp - 1 
          + ihp * ac_dim2) * ac_dim1] * 4.f + ac[irp + (iwp - 2 + 
          ihp * ac_dim2) * ac_dim1]) / delf;
      i__3 = iwp2[ihp] - 1;
      for (iwp = iwp1[ihp] + 1; iwp <= i__3; ++iwp) {
        /*<             DELF = WSL(IWP+1,IHP) - WSL(IWP-1,IHP) >*/
        delf = wsl[iwp + 1 + ihp * wsl_dim1] - wsl[iwp - 1 + ihp * 
            wsl_dim1];
        /*<    >*/
        ac_w__[irp + (iwp + ihp * ac_w_dim2) * ac_w_dim1] = (ac[irp + 
            (iwp + 1 + ihp * ac_dim2) * ac_dim1] - ac[irp + (iwp 
            - 1 + ihp * ac_dim2) * ac_dim1]) / delf;
      }
    }
  }
  return 0;
} /* wdiff_ */


int rdiffs_(
            int *irp1, 
            int *irp2, 
            int *iwp1, 
            int *iwp2, 
            int *nhp, 
            real *rtl, 
            int *nrx, 
            int *nwx, 
            real *ac, 
            real *ac_r__)
{
  /* System generated locals */
  int ac_dim1, ac_dim2, ac_offset, ac_r_dim1, ac_r_dim2, ac_r_offset, 
  rtl_dim1, rtl_offset, i__1, i__2, i__3;

  /* Local variables */
  static int ihp, irp, iwp, num;
  static real atmp[500], adtmp[500];

  /* Fortran I/O blocks */
  static cilist io___94 = { 0, 6, 0, 0, 0 };

  /* Parameter adjustments */
  --irp1;
  --irp2;
  --iwp1;
  --iwp2;
  rtl_dim1 = *nrx;
  rtl_offset = 1 + rtl_dim1;
  rtl -= rtl_offset;
  ac_r_dim1 = *nrx;
  ac_r_dim2 = *nwx;
  ac_r_offset = 1 + ac_r_dim1 * (1 + ac_r_dim2);
  ac_r__ -= ac_r_offset;
  ac_dim1 = *nrx;
  ac_dim2 = *nwx;
  ac_offset = 1 + ac_dim1 * (1 + ac_dim2);
  ac -= ac_offset;

  /* Function Body */
  i__1 = *nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) 
  {
    if (irp2[ihp] > 500) 
    {
      s_wsle(&io___94);
      do_lio(&c__9, &c__1, "RDIFFS: Array overflow. Increase NDIM to", (
              ftnlen)40);
      do_lio(&c__3, &c__1, (char *)&irp2[ihp], (ftnlen)sizeof(integer));
      e_wsle();
      /*<          STOP >*/
      s_stop("", (ftnlen)0);
    }
    /* ------ differentiate in R with spline */
    i__2 = iwp2[ihp];
    for (iwp = iwp1[ihp]; iwp <= i__2; ++iwp) 
    {
      i__3 = irp2[ihp];
      for (irp = irp1[ihp]; irp <= i__3; ++irp) 
      {
        atmp[irp - 1] = ac[irp + (iwp + ihp * ac_dim2) * ac_dim1];
      }
      irp = irp1[ihp];
      num = irp2[ihp] - irp1[ihp] + 1;
      spline_(&atmp[irp - 1], &adtmp[irp - 1], &rtl[irp + ihp * 
          rtl_dim1], &num);

      i__3 = irp2[ihp];
      for (irp = irp1[ihp]; irp <= i__3; ++irp) 
      {
        ac_r__[irp + (iwp + ihp * ac_r_dim2) * ac_r_dim1] = adtmp[irp - 1];
      }
    }
  }
  return 0;
} /* rdiffs_ */


int wdiffs_(
            int *irp1, 
            int *irp2, 
            int *iwp1, 
            int *iwp2, 
            int *nhp, 
            real *wsl, 
            int *nrx, 
            int *nwx, 
            real *ac, 
            real *ac_w__)
{
  /* System generated locals */
  int ac_dim1, ac_dim2, ac_offset, ac_w_dim1, ac_w_dim2, ac_w_offset, 
  wsl_dim1, wsl_offset, i__1, i__2, i__3;

  /* Local variables */
  static int ihp, irp, iwp, num;
  static real atmp[500], adtmp[500];

  /* Fortran I/O blocks */
  static cilist io___101 = { 0, 6, 0, 0, 0 };

  /* Parameter adjustments */
  --irp1;
  --irp2;
  --iwp1;
  --iwp2;
  ac_w_dim1 = *nrx;
  ac_w_dim2 = *nwx;
  ac_w_offset = 1 + ac_w_dim1 * (1 + ac_w_dim2);
  ac_w__ -= ac_w_offset;
  ac_dim1 = *nrx;
  ac_dim2 = *nwx;
  ac_offset = 1 + ac_dim1 * (1 + ac_dim2);
  ac -= ac_offset;
  wsl_dim1 = *nwx;
  wsl_offset = 1 + wsl_dim1;
  wsl -= wsl_offset;

  /* Function Body */
  i__1 = *nhp;
  for (ihp = 1; ihp <= i__1; ++ihp) 
  {
    if (iwp2[ihp] > 500) 
    {
	    s_wsle(&io___101);
	    do_lio(&c__9, &c__1, "WDIFFS: Array overflow. Increase NDIM to", (
		    ftnlen)40);
	    do_lio(&c__3, &c__1, (char *)&iwp2[ihp], (ftnlen)sizeof(integer));
	    e_wsle();
      /*<          STOP >*/
      s_stop("", (ftnlen)0);
    }

    /* ------ differentiate in F with spline */
    i__2 = irp2[ihp];
    for (irp = irp1[ihp]; irp <= i__2; ++irp) 
    {
      i__3 = iwp2[ihp];
      for (iwp = iwp1[ihp]; iwp <= i__3; ++iwp) {
        atmp[iwp - 1] = ac[irp + (iwp + ihp * ac_dim2) * ac_dim1];
      }

      iwp = iwp1[ihp];
      num = iwp2[ihp] - iwp1[ihp] + 1;
      spline_(&atmp[iwp - 1], &adtmp[iwp - 1], &wsl[iwp + ihp * 
          wsl_dim1], &num);
      i__3 = iwp2[ihp];
      for (iwp = iwp1[ihp]; iwp <= i__3; ++iwp) {
        /*<             AC_W(IRP,IWP,IHP) = ADTMP(IWP) >*/
        ac_w__[irp + (iwp + ihp * ac_w_dim2) * ac_w_dim1] = adtmp[iwp - 1];
      }
    }
  }
  return 0;
} /* wdiffs_ */

/* Main program alias */ 
int osgen_ () { MAIN__ (); return 0; }
