/* f/plt_old.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lprim_open__;
} pl_priml__;

#define pl_priml__1 pl_priml__

struct {
    int nprim_unit__, n_prim__, n_writ__, n_incore__, i_typ__[100000], 
	    i_prim__[100000];
} pl_primi__;

#define pl_primi__1 pl_primi__

struct {
    real x_prim__[100000], y_prim__[100000];
} pl_primr__;

#define pl_primr__1 pl_primr__

struct {
    int i_dev__, i_pagetype__, i_pen__, lst_pen__, i_pat__, lst_pat__, 
	    i_clr__, lst_clr__;
} pl_ploti__;

#define pl_ploti__1 pl_ploti__

struct {
    real x_scale__, y_scale__, x_org__, y_org__, x_lst__, y_lst__, x_page__, 
	    y_page__, x_wind__, y_wind__, clp_xmin__, clp_xmax__, clp_ymin__, 
	    clp_ymax__, xoff_zoom__, yoff_zoom__, xfac_zoom__, yfac_zoom__;
} pl_plotr__;

#define pl_plotr__1 pl_plotr__

struct {
    int n_color__, n_spectrum__, ifirst_spectrum__, color_rgb__[256];
} pl_colori__;

#define pl_colori__1 pl_colori__

struct {
    char color_name__[5632];
} pl_colorc__;

#define pl_colorc__1 pl_colorc__

struct {
    logical lgw_gen__, lgw_open__, lgw_color__, lgw_revvideo__, lgw_changed__,
	     lgw_resize__;
} pl_xwinl__;

#define pl_xwinl__1 pl_xwinl__

struct {
    int gx_loc__, gy_loc__, gx_org__, gy_org__, gx_siz__, gy_siz__, 
	    gx_crs__, gy_crs__, g_width__, g_height__, g_depth__, 
	    g_color_cindex__[256];
} pl_xwini__;

#define pl_xwini__1 pl_xwini__

struct {
    real g_scale__, g_scrnfrac__;
} pl_xwinr__;

#define pl_xwinr__1 pl_xwinr__

struct {
    logical lps_gen__, lps_open__, lps_color__, lps_unstroked__, 
	    lps_external__, lps_onefile__;
} pl_psl__;

#define pl_psl__1 pl_psl__

struct {
    int ips_mode__, nps_unit__, n_pages__, i_pages__, n_vecs__;
} pl_psi__;

#define pl_psi__1 pl_psi__

struct {
    real px_org__, py_org__, px_siz__, py_siz__, p_scale__, bb_xmin__, 
	    bb_xmax__, bb_ymin__, bb_ymax__, ps_lstx__, ps_lsty__;
} pl_psr__;

#define pl_psr__1 pl_psr__

struct {
    char ps_file__[80];
} pl_psc__;

#define pl_psc__1 pl_psc__

struct {
    int ncols_old__, icolmap_old__[256];
} plt10_old__;

#define plt10_old__1 plt10_old__

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static real c_b28 = 0.f;
static doublereal c_b52 = 10.;
static real c_b54 = .105f;
static int c__2 = 2;
static real c_b56 = .14f;
static real c_b57 = 999.f;
static int c__5 = 5;
static real c_b62 = .07f;
static int c_n1 = -1;
static int c__6 = 6;
static real c_b85 = 10.f;
static int c__0 = 0;
static real c_b99 = 360.f;
static int c__4 = 4;

/* *********************************************************************** */
/*    Module:  plt_old.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 "old Versatec-like" routines */

/*     Version 4.46 11/28/01 */

/*     Xplot11 interface for older plot routines (similar to that for */
/*     Versatec graphics) as a bridge to backwards compatibility with */
/*     old programs. */

/*     These routines are not preferred for creating a new application, */
/*     although they will work.  Use the equivalent routines in */
/*     plt_base.f, plt_util.f, etc. if you want more capability. */

/* ...Note: */
/*   If your compiler supports passing character data as integers without */
/*   complaining and you want old style Versatec SYMBOL compatibility (so */
/*   you can call SYMBOL with either characters stuffed into an int */
/*   array or with int arguments to specify plot symbols) you can use */
/*   the sections of the following code marked with C+++OldVersatec comments. */
/*   In that case you don't need the SYMBL routine, just call SYMBOL with */
/*   int arguments.  You also need to switch marked statements in */
/*   SYMBOL, NUMBER and LINE. */

/* *********************************************************************** */


/* Subroutine */ int plots_(int *idummy, int *ihard, int *ldev)
{
    /* Initialized data */

    static int ifirst = 0;

    static int idev;
    extern /* Subroutine */ int plinitialize_(void);
    static int nunit;
    extern /* Subroutine */ int plopen_(real *, int *, int *);
    static real relsize;

/* --- Open plotting */
/*     IHARD - sets hardcopy option */
/*             IHARD=>0   hardcopy on */
/*             IHARD <0   hardcopy off (typically IHARD=-999 sets no hardcopy) */

/*     LDEV  - output device (used to be LDEV=6 for Xwindows) */
/*             currently LDEV =0 gives BW hardcopy only */
/*             currently LDEV<>0 gives Xwindow (+ BW    hardcopy if IHARD>0) */

/*    This routine uses IHARD>=0 to select hardcopy output */
/*    The Xwindow defaults to 2/3 of the root window, landscape mode */


    if (ifirst == 0) {
	ifirst = 1;
	plinitialize_();
	relsize = .6666f;
	nunit = 0;
    }

    idev = 0;
    if (*ldev != 0) {
	idev = 1;
    }
    if (*ihard >= 0) {
	idev += 2;
    }
/* c      write(*,*) 'calling plopen with ',relsize,nunit,idev */
    plopen_(&relsize, &nunit, &idev);

    return 0;
} /* plots_ */

/* Subroutine */ int ploton_(void)
{
    return 0;
} /* ploton_ */

/* Subroutine */ int plotof_(void)
{
    extern /* Subroutine */ int plflush_(void);

    plflush_();
    return 0;
} /* plotof_ */

/* Subroutine */ int erase_(void)
{
    extern /* Subroutine */ int winerase_(void);

    winerase_();
    return 0;
} /* erase_ */

/* Subroutine */ int factor_(real *scl)
{
    extern /* Subroutine */ int newfactor_(real *);

    newfactor_(scl);
    return 0;
} /* factor_ */

/* Subroutine */ int where_(real *xnow, real *ynow, real *fact)
{
    extern /* Subroutine */ int getlastxy_(real *, real *), getfactors_(real *
	    , real *);
    static real dum;

/* --- Returns last x,y position and scale factor */
    getlastxy_(xnow, ynow);
    getfactors_(fact, &dum);
    return 0;
} /* where_ */

/* Subroutine */ int wherec_(real *xcurs, real *ycurs)
{
    extern /* Subroutine */ int getcursorxy_(real *, real *, char *, ftnlen);
    static char chkey[1];

    getcursorxy_(xcurs, ycurs, chkey, (ftnlen)1);
    return 0;
} /* wherec_ */

/* Subroutine */ int winpix_(int *nxpix, int *nypix, real *ppi)
{
/* --- Returns Xwindow size in pixels and the pixels per inch of */
/*    postsript output (not pixels/inch on the screen!) */
/* --- WINPIX has been officially replaced by GETWINSIZEABS in XPLOT11 */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    *nxpix = pl_xwini__1.gx_siz__;
    *nypix = pl_xwini__1.gy_siz__;
    *ppi = pl_xwinr__1.g_scale__;
    return 0;
} /* winpix_ */

/* Subroutine */ int getwinpix_(int *nxpix, int *nypix, real *ppi)
{
    extern /* Subroutine */ int winpix_(int *, int *, real *);

/* --- Same as WINPIX */
    winpix_(nxpix, nypix, ppi);
    return 0;
} /* getwinpix_ */

/* Subroutine */ int grid_(real *x, real *y, int *nx, real *xd, int *
	ny, real *yd, int *lmask)
{
    extern /* Subroutine */ int plgrid_(real *, real *, int *, real *, 
	    int *, real *, int *);

    plgrid_(x, y, nx, xd, ny, yd, lmask);
    return 0;
} /* grid_ */

/* Subroutine */ int color_(int *icol)
{
    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int newcolor_(int *);
    static int ic;

    /* Fortran I/O blocks */
    static cilist io___7 = { 0, 6, 0, 0, 0 };
    static cilist io___8 = { 0, 6, 0, 0, 0 };


/* --- Selects a foreground color for defined (old-style) colormap */

    if (plt10_old__1.ncols_old__ <= 0) {
	s_wsle(&io___7);
	do_lio(&c__9, &c__1, "*** COLOR no colormap defined", (ftnlen)29);
	e_wsle();
    }
    if (*icol < 0 || *icol > plt10_old__1.ncols_old__) {
	s_wsle(&io___8);
	do_lio(&c__9, &c__1, "*** COLOR out of bounds: ", (ftnlen)25);
	do_lio(&c__3, &c__1, (char *)&(*icol), (ftnlen)sizeof(integer));
	e_wsle();
    }
/* --- Use colormap entry */
    ic = plt10_old__1.icolmap_old__[*icol];
/*      write(*,*) 'COLOR ',icol,ic */
    newcolor_(&ic);
    return 0;
} /* color_ */

/* Subroutine */ int setcol_(int *icol, real *red, real *grn, real *blu)
{
    /* Initialized data */

    static int ifirst = 0;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int getcolor_(int *);
    static int ic;
    extern /* Subroutine */ int newcolorrgb_(int *, int *, int *);
    static int ired, iblu, igrn;

    /* Fortran I/O blocks */
    static cilist io___11 = { 0, 6, 0, 0, 0 };


/* --- Set up a colormap entry */
/*    The "old" color routines simply set up rgb entries in the regular */
/*    colormap.  They do not use the spectrum colors. */
/*    Note: repeated calls to SETCOL without reseting the colormap will */
/*          (eventually) fill up the allocated 'old-style' colormap. */

/*          To reset the 'old-style' colormap give a color */
/*          index icol<0, this resets the number of allocated colors to 0. */


    if (ifirst == 0) {
	ifirst = 1;
	plt10_old__1.ncols_old__ = 0;
    }

    if (plt10_old__1.ncols_old__ >= 256) {
	s_wsle(&io___11);
	do_lio(&c__9, &c__1, "*** SETCOL no more colors available: ", (ftnlen)
		37);
	do_lio(&c__3, &c__1, (char *)&plt10_old__1.ncols_old__, (ftnlen)
		sizeof(integer));
	e_wsle();
	return 0;
    }

/* --- Reset the colormap if icol<0 */
    if (plt10_old__1.ncols_old__ < 0) {
	plt10_old__1.ncols_old__ = 0;
	return 0;
    }

    ired = (integer) (*red * 255.f);
    igrn = (integer) (*grn * 255.f);
    iblu = (integer) (*blu * 255.f);
/* --- Install as a regular colormap color */
    newcolorrgb_(&ired, &igrn, &iblu);
    getcolor_(&ic);
/*      write(*,*) 'SETCOL ',icol,ired,igrn,iblu,ic */
    ++plt10_old__1.ncols_old__;
    plt10_old__1.icolmap_old__[*icol] = ic;
    return 0;
} /* setcol_ */

/* *********************************************************** */
/*  Versatec-style Utility routines */
/*    LINE */
/*    CURVE */
/*    AXIS */
/*    AXIS2 */
/*    SCALE */
/*    SYMBL  - plots graphics symbol given by int argument */
/*    SYMBOL - plots character symbol using stroke graphics that */
/*             call the basic PLOT plotting function */
/*    NUMBER - plots numbers using a format conversion to characters */
/* *********************************************************** */
/* Subroutine */ int line_(real *xarray, real *yarray, int *npts, int 
	*inc, int *lintyp, int *isym)
{
    /* Initialized data */

    static real symsize = .08f;

    /* System generated locals */
    int i__1;
    real r__1, r__2, r__3, r__4;

    /* Local variables */
    static int i__;
    extern /* Subroutine */ int getlastxy_(real *, real *);
    static real df;
    static int na;
    static real dl;
    static int nf, kk, nl, nt;
    static real xn, yn;
    static int ldx, lsw, ipen, lmin;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static int icode, ipena;
    extern /* Subroutine */ int symbl_(real *, real *, real *, int *, 
	    real *, int *);
    static int icodea;
    static real deltax, deltay;
    extern /* Subroutine */ int plotof_(void);
    static real firstx, firsty;

/* ...Plots array of x,y data as a piecewise linear set of line segments */

/*    Input:   XARRAY   is an array of coordinate points to be joined */
/*             YARRAY   by smooth curve. */

/*             NPTS     ABS(NPTS) is the number of points to plot from points */
/*                      in XARRAY and YARRAY. */
/*                  NPTS<0  indicates that scale factors are located as the */
/*                       last two elements of each data array (i.e. */
/*                       NPTS+1 AND NPTS+2). */
/*                  NPTS>0 indicates that the coordinate points are already */
/*                       scaled for plotting (no scale factors). */

/*             INC      increment used to access points in XARRAY,YARRAY */
/*             LINTYP   Plotting flag, ABS(LINTYP) is the symbol plotting */
/*                      increment (i.e. +2 gives a symbol at every other point) */
/*                         LINTYP<0  symbols only */
/*                         LINTYP=0  lines only */
/*                         LINTYP>0  lines and symbols */
/*             ISYM     Symbol index to be used for points with symbols */

/*  Calls:   PLOT */

/* ...Note: */
/*   You might need to change the SYMBL call below to SYMBOL if your compiler */
/*   supports passing character literals as integers without complaining */
/*   and you enable old style Versatec SYMBOL calls with int arguments. */
/*   See SYMBOL below... */

    /* Parameter adjustments */
    --yarray;
    --xarray;

    /* Function Body */

/* ...Initialize subscripts */
    lmin = *npts * *inc + 1;
    ldx = lmin + *inc;
    nl = lmin - *inc;

/* ...Set limits and scaling factors */
    firstx = xarray[lmin];
    deltax = xarray[ldx];
    firsty = yarray[lmin];
    deltay = yarray[ldx];

/* ...Current plotting location */
    getlastxy_(&xn, &yn);
/* Computing MAX */
    r__3 = (r__1 = (xarray[1] - firstx) / deltax - xn, dabs(r__1)), r__4 = (
	    r__2 = (yarray[1] - firsty) / deltay - yn, dabs(r__2));
    df = dmax(r__3,r__4);
/* Computing MAX */
    r__3 = (r__1 = (xarray[nl] - firstx) / deltax - xn, dabs(r__1)), r__4 = (
	    r__2 = (yarray[nl] - firsty) / deltay - yn, dabs(r__2));
    dl = dmax(r__3,r__4);
    ipen = 3;
    icode = -1;
    nt = abs(*lintyp);

/* ...Symbols plotted? */
    if (*lintyp == 0) {
	nt = 1;
    }


    if (dl >= df) {
/* ...Ascending order */
	nf = 1;
	na = nt;
	kk = *inc;
    } else {
/* ...Descending order */
	nf = nl;
	na = (*npts - 1) / nt * nt + nt - (*npts - 1);
	kk = -(*inc);
    }


    if (*lintyp < 0) {
/* ...Symbols only */
	ipena = 3;
	icodea = -1;
	lsw = 1;
    } else {
/* ...Symbols */
	ipena = 2;
	icodea = -2;
	lsw = 0;
/* ...Lines only */
	if (*lintyp == 0) {
	    na = ldx;
	}
    }

/* ...Plot data */
    i__1 = *npts;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xn = (xarray[nf] - firstx) / deltax;
	yn = (yarray[nf] - firsty) / deltay;
/* ...Plot symbol */
	if (na == nt) {
/* ---For new style SYMBL call (character string input to SYMBOL) */
	    symbl_(&xn, &yn, &symsize, isym, &c_b28, &icode);
/* +++OldVersatec (int variable as input to SYMBOL) */
/*          CALL SYMBL(XN,YN,SYMSIZE,ISYM,0.0,ICODE) */
/* +++OldVersatec */
	    na = 1;
	    goto L110;
	}
/* ...Or lines between symbols */
	if (na < nt && lsw != 0) {
	    goto L100;
	}

/* ...Plot line to new point */
	plot_(&xn, &yn, &ipen);

/* ...Counters for plotting points and symbols */
L100:
	++na;
L110:
	nf += kk;
	icode = icodea;
	ipen = ipena;
/* L120: */
    }
    plotof_();

    return 0;
} /* line_ */

/* Subroutine */ int curve_(real *x, real *y, int *ne, real *delta)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static real a, b, c__, e, f, g, h__;
    static int k;
    static real t, u, v, c1, c2, s1, t1, t2, t3, s2, x1, x2, y2, y1;
    static int net;
    static real xfac, yfac, delt;
    static int ipen, mpen;
    static real xoff, yoff;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real dltx1, dlty1, dltx2, dlty2, dltsq;
    extern /* Subroutine */ int plotof_(void);

/* ...Plots curve with solid or dashed lines */

/*    Input:  X,Y  is an array of coordinate points to be joined */
/*                  by smooth curve. */

/*            NE  ABS(NE) is the number of coordinate points in X and Y. */
/*              NE<0  indicates that scale factors are located as the */
/*                    last two elements of each data array (i.e. NE+1 AND NE+2). */
/*              NE>0  indicates that the coordinate points are already */
/*                    scaled for plotting (no scale factors). */

/*            DELTA  ABS(DELTA) is the segment length for approximating */
/*                   the curve. */
/*              DELTA<0  indicates that the curve is plotted with dashed lines */
/*                       of 'delta' length. */
/*              DELTA>0  indicates that the curve is plotted with a solid line. */

/*  Calls:   PLOT */


/* ...Default scale factors */
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    xoff = 0.f;
    yoff = 0.f;
    xfac = 1.f;
    yfac = 1.f;
    net = *ne;
    if (net == 0) {
	return 0;
    }

    if (*ne < 0) {
/* ...Scale factors in last two array elements */
	net = -net;
	xoff = x[net + 1];
	yoff = y[net + 1];
	xfac = x[net + 2];
	yfac = y[net + 2];
    }

/* ...Solid or dashed lines? */
    if (*delta == 0.f) {
	return 0;
    }
    mpen = 4;
    delt = *delta;
    if (delt < 0.f) {
	delt = -delt;
	mpen = 5;
    }

/* ...Initialize everything */
    k = 1;
    ipen = 3;
    dltsq = *delta * *delta;


/* ...Begin main loop. */
/*   (X1,Y1) is joined to (X2,Y2) by arc with direction cosines */
/*   (C1,S1) and (C2,S2) at end points.  Final values for previous */
/*   arc are initial values for new arc. */

/* ...New end point */
L110:
    x2 = (x[k] - xoff) / xfac;
    y2 = (y[k] - yoff) / yfac;
    if (k == net) {
	goto L130;
    }
    if (k > 1) {
	goto L140;
    }

/* ...First data point (K=1) */
/* L120: */
    if ((i__1 = net - 2) < 0) {
	goto L122;
    } else if (i__1 == 0) {
	goto L124;
    } else {
	goto L126;
    }
L122:
    x1 = (x[1] - xoff) / xfac;
    y1 = (y[1] - yoff) / yfac;
    plot_(&x1, &y1, &c__3);
    goto L500;
L124:
    dltx1 = (x[2] - x[1]) / xfac;
    dlty1 = (y[2] - y[1]) / yfac;
    dltx2 = dltx1;
    dlty2 = dlty1;
    goto L128;
L126:
    dltx1 = (x[2] - x[1]) / xfac;
    dlty1 = (y[2] - y[1]) / yfac;
    dltx2 = (x[3] - x[2]) / xfac;
    dlty2 = (y[3] - y[2]) / yfac;
L128:
    t1 = dltx1 * dltx1 + dlty1 * dlty1;
    t2 = dltx2 * dltx2 + dlty2 * dlty2;
    t3 = sqrt(t1 * t2) * 2.f;
    t1 = -t1;
    t2 = t3 + t2;
    goto L150;

/* ...Last data point (K=NET) */
L130:
    dltx1 = x1 - (x[k - 2] - xoff) / xfac;
    dlty1 = y1 - (y[k - 2] - yoff) / yfac;
    dltx2 = x2 - x1;
    dlty2 = y2 - y1;
    t1 = dltx1 * dltx1 + dlty1 * dlty1;
    t2 = dltx2 * dltx2 + dlty2 * dlty2;
    t3 = sqrt(t1 * t2) * 2.f;
    t2 = -t2;
    t1 = t3 + t1;
    goto L150;

/* ...Intermediate data point (1<K<NET) */
L140:
    dltx1 = x2 - x1;
    dlty1 = y2 - y1;
    dltx2 = (x[k + 1] - x[k]) / xfac;
    dlty2 = (y[k + 1] - y[k]) / yfac;
    t1 = dltx1 * dltx1 + dlty1 * dlty1;
    t2 = dltx2 * dltx2 + dlty2 * dlty2;

L150:
    e = dltx1 * t2 + dltx2 * t1;
    f = dlty1 * t2 + dlty2 * t1;
    g = sqrt(e * e + f * f);
    if (g != 0.f) {
	g = 1.f / g;
    }
    c2 = g * e;
    s2 = g * f;
    if (k == 1) {
	goto L180;
    }

    u = x2 - x1;
    v = y2 - y1;
    g = u * u + v * v;
    a = c1 * c2 + s1 * s2;

/* ...Check if (X2,Y2) is more than 'DELTA' from (X1,Y1) */
    if (g >= dltsq) {
	goto L200;
    }

/* ...Distinguish between close points and coincident points */
    if (g > 0.f) {
	goto L170;
    }

/* ...Test for matching tangents */
    if (a <= .99996f) {
	goto L180;
    }

/* ...(X1,Y1),(X2,Y2) less than 'DELTA' apart, hop to next point. */
L170:
    ++k;
    if (k <= net) {
	goto L110;
    }

L180:
    plot_(&x2, &y2, &ipen);
    h__ = delt;
    ipen = 2;
    goto L320;

/* ...Cubic coefficients for X and Y */
L200:
    a = 7.f - a;
    e = c1 + c2;
    f = s1 + s2;
    b = u * e + v * f;
    t = sqrt(b * b + a * 2.f * g);
    c__ = (t + b) / g;
    t = (t - b) * 3.f / a;
    g = c__ / 12.f;
    a = g * (c__ * u - e * 3.f);
    b = g * (c__ * v - f * 3.f);
    u = g * (c2 - c1) + a;
    v = g * (s2 - s1) + b;
    c__ = -c__ / 9.f;
    a *= c__;
    b *= c__;
    g = h__;

/* ...X AND Y coordinates of arc are given as parametric cubics with */
/*   parameter going from zero to T and held in G.  The increment is DELTA. */
/*   G is set initially to space the first point of the new arc */
/*   at distance DELTA from the last point of the previous arc. */

/* ...Generate approximation for each segment */
L220:
    e = g * (g * (a * g + u) + c1) + x1;
    f = g * (g * (b * g + v) + s1) + y1;
    plot_(&e, &f, &ipen);
    ipen = mpen - ipen;
    g += delt;
    h__ = g - t;
    if (h__ <= 0.f) {
	goto L220;
    }

/* ...Arc (X1,Y1) to (X2,Y2) complete, setup for next arc */
L320:
    x1 = x2;
    y1 = y2;
    c1 = c2;
    s1 = s2;
    ++k;
    if (k <= net) {
	goto L110;
    }


/* ...Close to last point of curve */
    plot_(&x2, &y2, &ipen);
L500:
    plotof_();
    return 0;
} /* curve_ */

/* Subroutine */ int axis_(real *x, real *y, char *label, int *nchar, 
	real *axlen, real *angle, real *fval, real *dv, ftnlen label_len)
{
    /* Initialized data */

    static real radn = .01745329f;

    /* System generated locals */
    int i__1;
    real r__1, r__2;
    doublereal d__1;

    /* Builtin functions */
    double pow_dd(doublereal *, doublereal *), sin(doublereal), cos(
	    doublereal);

    /* Local variables */
    static int i__;
    static real t2;
    static int nc;
    static real dx, dy, xx, yy, adv, val, exp__, side, cosa, sina;
    static int ntic;
    extern /* Subroutine */ int plot_(real *, real *, int *), number_(
	    real *, real *, real *, real *, real *, int *), plotof_(void),
	     symbol_(real *, real *, real *, char *, real *, int *, 
	    ftnlen);

/* ...Plots labeled axis with tic marks and annotations */

/*    Input:   X,Y    Starting coordinates for axis (REAL) */

/*             LABEL  Text string for labeling the axis */

/*             NCHAR  Number of characters in the axis label (INTEGER) */
/*                NCHAR>0 annotations generated above axis */
/*                NCHAR<0 annotations generated below axis */

/*             AXLEN  Axis length in inches (REAL) */
/*             ANGLE  Axis angle in degrees (positive CCW) (REAL) */

/*             FVAL   First annotation value (REAL) */
/*             DV     Delta annotation value (REAL) */

/*        Calls:  NUMBER, SYMBOL */

/* ...Note: */
/*   If your compiler supports passing character data as integers without */
/*   complaining and you want old style Versatec SYMBOL compatibility (so */
/*   you can call SYMBOL with either characters stuffed into an int */
/*   array or with int arguments to specify plot symbols) you can use */
/*   the sections of the following code marked with C+++OldVersatec comments. */

/* ---Declaration as a character variable */
/* ---Declaration of as int or byte variable */
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*      LOGICAL*1 LABEL(1) */
/*      INTEGER*1 LABEL(1) */
/*      BYTE      LABEL(1) */
/* +++OldVersatec */



/* ...Side of axis to annotate and label */
    side = 1.f;
    nc = *nchar;
/* ...NCHAR<0 means plot below axis */
    if (nc < 0) {
	nc = -nc;
	side = -1.f;
    }

/* ...Value of 'DV' exponent */
    exp__ = 0.f;
    adv = dabs(*dv);

/* ...Check for zero delta annotation value? */
    if (adv != 0.f) {

/* ...Get exponent by dividing by decades */
L20:
	if (adv < 99.f) {
	    goto L40;
	}
	adv /= 10.f;
	exp__ += 1.f;
	goto L20;

L30:
	adv *= 10.f;
	exp__ += -1.f;
/* ...If too small cut the exponent */
L40:
	if (adv < .01f) {
	    goto L30;
	}

    }

/* ...Normalized 'FVAL' and 'DV' */
    d__1 = (doublereal) (-exp__);
    val = *fval * pow_dd(&c_b52, &d__1);
    d__1 = (doublereal) (-exp__);
    adv = *dv * pow_dd(&c_b52, &d__1);

/* ...Angular orientation variables */
    t2 = *angle * radn;
    sina = sin(t2);
    cosa = cos(t2);

    dx = -.1f;
    dy = side * .15f - .05f;
    xx = *x + dx * cosa - dy * sina;
    yy = *y + dy * cosa + dx * sina;

/* ...Annotate axis */
    ntic = *axlen + 1.f;
    i__1 = ntic;
    for (i__ = 1; i__ <= i__1; ++i__) {
	number_(&xx, &yy, &c_b54, &val, angle, &c__2);
	val += adv;
	xx += cosa;
	yy += sina;
    }

/* ...Label axis */
    t2 = (real) nc;

/* ...Do we have a valid exponent? */
    if (exp__ != 0.f) {
	t2 = (real) (nc + 6);
    }

    dx = t2 * -.07f + *axlen * .5f;
    dy = side * .325f - .075f;
    xx = *x + dx * cosa - dy * sina;
    yy = *y + dy * cosa + dx * sina;
    symbol_(&xx, &yy, &c_b56, label, angle, &nc, label_len);

/* ...Plot exponent */
    if (exp__ != 0.f) {
	symbol_(&c_b57, &c_b57, &c_b56, "  *10", angle, &c__5, (ftnlen)5);
	t2 = (real) (nc + 5);
	xx += (t2 * cosa - sina * .8f) * .14f;
	yy += (t2 * sina + cosa * .8f) * .14f;
	number_(&xx, &yy, &c_b62, &exp__, angle, &c_n1);
    }

/* ...Draw axis and tic marks */
    dx = side * -.07f * sina;
    dy = side * .07f * cosa;
    xx = *x;
    yy = *y;
    plot_(&xx, &yy, &c__3);
    i__1 = ntic;
    for (i__ = 1; i__ <= i__1; ++i__) {
	plot_(&xx, &yy, &c__2);
	r__1 = xx + dx;
	r__2 = yy + dy;
	plot_(&r__1, &r__2, &c__2);
	plot_(&xx, &yy, &c__3);
	xx += cosa;
	yy += sina;
    }

    plotof_();
    return 0;
} /* axis_ */

/* Subroutine */ int axis2_(real *x, real *y, char *label, int *nchar, 
	real *cscal, real *axlen, real *dax, real *angle, real *fval, real *
	dv, ftnlen label_len)
{
    /* Initialized data */

    static real radn = .01745329f;

    /* System generated locals */
    int i__1;
    real r__1, r__2;
    doublereal d__1;

    /* Builtin functions */
    double pow_dd(doublereal *, doublereal *), sin(doublereal), cos(
	    doublereal);

    /* Local variables */
    static int i__;
    static real t2;
    static int nc;
    static real dx, dy, xx, yy, adv, val;
    static int nv10;
    static real exp__, rnt, adax;
    static int ndig;
    static real side, cosa, sina;
    static int ntic;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static real charh, afval, rnumh;
    extern /* Subroutine */ int number_(real *, real *, real *, real *, real *
	    , int *), plotof_(void), symbol_(real *, real *, real *, char 
	    *, real *, int *, ftnlen);
    static int istart;

/* ...Plots labeled axis with tic marks and annotations */

/*    Input:   X,Y    Starting coordinates for axis (REAL) */

/*             LABEL  Text string for labeling the axis */

/*             NCHAR  Number of characters in the axis label (INTEGER) */
/*                NCHAR>0 annotations generated above axis */
/*                NCHAR<0 annotations generated below axis */

/*             CSCAL  Character height scale factor */
/*             AXLEN  Axis length in inches (REAL) */
/*             DAX    Distance between annotations in inches */
/*                DAX>0 first annotation value plotted */
/*                DAX<0 first annotation value not plotted */
/*                (using DAX=1.0 corresponds to AXIS routine) */
/*             ANGLE  Axis angle in degrees (positive CCW) (REAL) */

/*             FVAL   First annotation value (REAL) [not plotted if DAX < 0] */
/*             DV     Delta annotation value (REAL) */

/*        Calls:  NUMBER, SYMBOL */

/* ...Note: */
/*   If your compiler supports passing character data as integers without */
/*   complaining and you want old style Versatec SYMBOL compatibility (so */
/*   you can call SYMBOL with either characters stuffed into an int */
/*   array or with int arguments to specify plot symbols) you can use */
/*   the sections of the following code marked with C+++OldVersatec comments. */

/* ---Declaration as a character variable */
/* ---Declaration of as int or byte variable */
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*      LOGICAL*1 LABEL(1) */
/*      INTEGER*1 LABEL(1) */
/*      BYTE      LABEL(1) */
/* +++OldVersatec */


    adax = dabs(*dax);
    istart = 1;
    if (*dax < 0.f) {
	istart = 2;
    }

/* ...Character heights */
    charh = adax * .14f * *cscal;
    rnumh = adax * .105f * *cscal;


/* ...Side of axis to annotate and label */
    side = 1.f;
    nc = *nchar;
/* ...NCHAR<0 is lower side */
    if (nc < 0) {
	nc = -nc;
	side = -1.f;
    }

/* ...Exponent? */
    exp__ = 0.f;
    adv = dabs(*dv);

/* ...Check for zero delta annotation value? */
    if (adv != 0.f) {

/* ...Check exponent by dividing by decades */
L20:
	if (adv < 99.f) {
	    goto L40;
	}
	adv /= 10.f;
	exp__ += 1.f;
	goto L20;

L30:
	adv *= 10.f;
	exp__ += -1.f;
/* ...If too small cut the exponent */
L40:
	if (adv < .01f) {
	    goto L30;
	}

    }

/* ...Normalize 'FVAL' AND 'DV' */
    d__1 = (doublereal) (-exp__);
    afval = *fval * pow_dd(&c_b52, &d__1);
    d__1 = (doublereal) (-exp__);
    adv = *dv * pow_dd(&c_b52, &d__1);

/* ...Angular orientation variables */
    t2 = *angle * radn;
    sina = sin(t2);
    cosa = cos(t2);

    dy = rnumh * 1.4f * side - rnumh * .5f;

/* ...Annotate axis */
    ntic = (integer) (*axlen / adax) + 1;
    i__1 = ntic;
    for (i__ = istart; i__ <= i__1; ++i__) {
	rnt = (real) (i__ - 1);
	val = afval + adv * rnt;
/* ...Number of digits before decimal point */
	nv10 = (integer) (dabs(val) / 10.f);
	ndig = 1;
	if (nv10 > 0) {
	    ++ndig;
	}
/* ...Add one for minus sign */
	if (val < 0.f) {
	    ++ndig;
	}

	dx = -((real) ndig + .5f) * .84f * rnumh;
	xx = *x + dx * cosa - dy * sina + adax * cosa * rnt;
	yy = *y + dy * cosa + dx * sina + adax * sina * rnt;
	number_(&xx, &yy, &rnumh, &val, angle, &c__2);
    }

/* ...Label axis */
    t2 = (real) nc;

/* ...Do we have a valid exponent? */
    if (exp__ != 0.f) {
	t2 = (real) (nc + 6);
    }

    dx = charh * -.5f * t2 + *axlen * .5f;
    dy = (rnumh * 1.5f + charh * 1.5f) * side - charh * .5f;
    xx = *x + dx * cosa - dy * sina;
    yy = *y + dy * cosa + dx * sina;
    symbol_(&xx, &yy, &charh, label, angle, &nc, label_len);

/* ...Plot exponent */
    if (exp__ != 0.f) {
	symbol_(&c_b57, &c_b57, &charh, "  X 10", angle, &c__6, (ftnlen)6);
	t2 = (real) (nc + 6);
	xx += (t2 * cosa - sina * .75f) * charh;
	yy += (t2 * sina + cosa * .75f) * charh;
	r__1 = charh * .5f;
	number_(&xx, &yy, &r__1, &exp__, angle, &c_n1);
    }

/* ...Tic marks */
    dx = rnumh * -.4f * side * sina;
    dy = rnumh * .4f * side * cosa;
    i__1 = ntic;
    for (i__ = 1; i__ <= i__1; ++i__) {
	rnt = (real) (i__ - 1);
	xx = *x + cosa * adax * rnt;
	yy = *y + sina * adax * rnt;
	plot_(&xx, &yy, &c__3);
	r__1 = xx + dx;
	r__2 = yy + dy;
	plot_(&r__1, &r__2, &c__2);
    }

/* ...Axis */
    xx = *x + cosa * *axlen;
    yy = *y + sina * *axlen;
    plot_(x, y, &c__3);
    plot_(&xx, &yy, &c__2);

    plotof_();
    return 0;
} /* axis2_ */

/* Subroutine */ int scale_(real *array, real *axlen, int *npts, int *
	inc)
{
    /* Initialized data */

    static real units[7] = { 1.f,2.f,4.f,5.f,8.f,10.f,20.f };

    /* System generated locals */
    int i__1, i__2;
    real r__1;

    /* Builtin functions */
    double r_lg10(real *), pow_ri(real *, int *), r_int(real *);

    /* Local variables */
    static real a;
    static int i__, j, k;
    static real ar, dv, sgnf, tmin, armin, armax;

/* ...Determines scale factor and offset for elements in array and */
/*   installs values in last 2 array elements */

/*    Input:  ARRAY  is an array of data points (REAL) */

/*            AXLEN  Axis length in inches (REAL) */
/*            NPTS   Number of data points to be scaled (INTEGER) */
/*            INC    Increment between points in ARRAY (INTEGER) */


    /* Parameter adjustments */
    --array;

    /* Function Body */


/* ...Min and max values of 'ARRAY' accessed by 'INC' stride */
    k = abs(*inc);
    j = *npts * k;
    armin = array[1];
    armax = armin;
    i__1 = j;
    i__2 = k;
    for (i__ = 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2) {
	ar = array[i__];
	armin = dmin(armin,ar);
	armax = dmax(armax,ar);
    }

/* ...Delta value for unit interval */
    dv = (armax - armin) / *axlen;

/* ...If negative or zero scale use the sum of min and max */
    if (dv <= 0.f) {
	dv = (r__1 = (armin + armin) / *axlen, dabs(r__1)) + 1.f;
    }

/* ...Exponent for DV */
    i__2 = (integer) (r_lg10(&dv) + 1e3f) - 1000;
    a = pow_ri(&c_b85, &i__2);

/* ...Normalized 'DV' value (1<DV<10) */
    dv = dv / a - .01f;
/* ...Find appropriate unit and range for DV value from desirable unit list */
    for (i__ = 1; i__ <= 6; ++i__) {
	if (units[i__ - 1] >= dv) {
	    goto L40;
	}
    }

/* ...Set direction for rounding */
L40:
    sgnf = .01f;
    if (armin < 0.f) {
	sgnf = -.99f;
    }

/* ...Delta value and min value from normalized unit and exponent */
L50:
    dv = units[i__ - 1] * a;
    r__1 = armin / dv + sgnf;
    tmin = dv * r_int(&r__1);

/* ...Check to make sure the selected scale is big enough */
    if (tmin + (*axlen + .01f) * dv >= armax) {
	goto L60;
    }
    r__1 = armin / a + sgnf;
    tmin = r_int(&r__1) * a;
    if (tmin + (*axlen + .01f) * dv >= armax) {
	goto L60;
    }
    ++i__;
    goto L50;


/* ...Recompute min value */
L60:
    r__1 = (*axlen + (tmin - armax) / dv) / 2.f;
    tmin -= dv * r_int(&r__1);
    if (armin * tmin <= 0.f) {
	tmin = 0.f;
    }

/* ...Reverse direction if necessary */
    if (*inc <= 0) {
	r__1 = *axlen + .5f;
	tmin += dv * r_int(&r__1);
	dv = -dv;
    }

/* ...Install scale and offset into array */
    ++j;
    array[j] = tmin;
    k = j + k;
    array[k] = dv;

    return 0;
} /* scale_ */

/* Subroutine */ int symbl_(real *x, real *y, real *hgt, int *isym, real *
	angle, int *nc)
{
    /* System generated locals */
    char ch__1[1];

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int symbol_(real *, real *, real *, char *, real *
	    , int *, ftnlen);

    /* Fortran I/O blocks */
    static cilist io___122 = { 0, 6, 0, 0, 0 };


/* ...Plot a symbol at the specified location with specified size and angle */

/*      This routine accepts an int symbol selector */
/*      instead of a character string as its argument */

/*             X,Y     starting coordinate for the symbol */
/*             HGT     symbol height specification (in inches) */
/*             ISYM    int index corresponding to the symbol */
/*             ANGLE   angle at which the symbol is plotted */
/*             NC      NC must be NC<0 */
/*                 NC=-1  move to x,y with 'pen' up;   plot symbol #ISYM */
/*                 NC<-1  move to x,y with 'pen' down; plot symbol #ISYM */
/* C...Note: */
/*   You might not need the SYMBL routine, if your compiler supports passing */
/*   character literals as integers without complaining and you enable old */
/*   style Versatec SYMBOL calls with int arguments.  See SYMBOL below... */

    if (*nc == 0) {
	return 0;
    }
    if (*nc > 0) {
	s_wsle(&io___122);
	do_lio(&c__9, &c__1, "Bad NC argument to SYMBL ", (ftnlen)25);
	do_lio(&c__3, &c__1, (char *)&(*nc), (ftnlen)sizeof(integer));
	e_wsle();
	return 0;
    }
    *(unsigned char *)&ch__1[0] = *isym;
    symbol_(x, y, hgt, ch__1, angle, nc, (ftnlen)1);
    return 0;
} /* symbl_ */

/* Subroutine */ int symbol_(real *xz, real *yz, real *hgt, char *itext, real 
	*angle, int *nz, ftnlen itext_len)
{
    /* Initialized data */

    static int nbits = 16;
    static int nbytes = 2;
    static int nchrs = 128;
    static real radco = .01745329f;
    static real epsil = 2.77e-5f;
    static real asin__[5] = { 0.f,1.f,0.f,-1.f,0.f };
    static real acos__[5] = { 1.f,0.f,-1.f,0.f,1.f };
    static int mskall = -1;
    static int msk4 = 15;
    static int msk5 = 31;
    static int msk7 = 127;
    static int msk8 = 255;
    static int msk11 = 2047;
    static real fctr = .7f;
    static real facc = 0.f;
    static real theta = 0.f;
    static real ancc = 1.f;
    static real ancs = 0.f;
    static real xc = 0.f;
    static real yc = 0.f;
    static real xt = 0.f;
    static real yt = 0.f;
    static real xo = 0.f;
    static real yo = 0.f;
    static real xa[14] = { 0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
	    0.f,0.f };
    static real ya[14] = { 0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
	    0.f,0.f };
    static int khar[128] = { 7,267,645,839,1095,1350,1574,1797,1991,2247,
	    2513,3086,3557,3747,3877,4065,4129,4192,4232,4519,4772,4928,4967,
	    5223,5480,5760,5793,5863,6117,6306,6405,6604,7008,7046,7272,7562,
	    7915,8301,8745,9059,9187,9315,9447,9700,9861,10049,10116,10273,
	    10344,10629,10823,11084,11498,11848,12138,12484,12655,13163,13546,
	    13899,14274,14372,14530,14636,15055,15561,15883,16263,16518,16743,
	    16998,17225,17543,17799,18052,18215,18466,18564,18723,18859,19238,
	    19467,19849,20171,20548,20709,20898,20996,21156,21317,21510,21731,
	    21857,21923,22050,22145,22224,22754,22856,23143,23403,23787,24169,
	    24486,24712,24998,25229,25675,26056,26343,26592,26624,26660,26829,
	    27269,27461,27651,27786,28129,28193,28263,28516,28679,28938,29284,
	    29444,29604,29764 };
    static struct {
	int e_1[480];
	} equiv_2 = { 8740, 1024, 16452, 9250, 8740, 5123, 272, 12353, 17204, 
		9250, 8740, 321, 9250, 8770, -4060, 8432, 546, 8772, -4092, 
		16624, 34, 8740, 544, 16932, 8738, 8228, 578, 9250, 8704, 
		17412, 16418, 8772, 1092, 64, 34, 8772, -4092, 8944, 8226, 
		8772, -4045, 12608, -4096, 4371, 1264, 4401, -4077, 13090, 
		8770, -4060, 8432, 546, 17648, 1088, -4096, 8738, 17412, 
		16384, 8738, 9248, 8754, 22642, 9862, 12834, 25122, 9972, 
		8497, 16965, 22087, 19003, 11047, 26608, 25893, -4061, 25365, 
		30038, 21621, -3292, 25840, 26150, -4045, 22307, 25584, 17480,
		 -4058, 26209, 20802, 17718, 18250, 23403, -2790, -30190, 
		8497, 16969, 23146, 31012, 21605, 26199, 10022, 16998, 5157, 
		13651, 25460, 5157, 13651, 25460, -3978, 25941, 14119, 5872, 
		18756, -4046, 17234, 12887, 18777, 22512, 14121, 14647, 9316, 
		21587, 22358, 26150, 13879, 13129, 17136, 9043, 25701, 22070, 
		10040, 26680, 10281, 14648, -3991, 8944, 21347, 25170, 21346, 
		14136, 18776, 9508, 13123, 25687, 18777, 22377, 22611, 25129, 
		14387, 8741, 26096, 9063, -4057, 25412, 18672, 9830, 16946, 
		13123, 16945, 9573, 16946, 13123, 16930, 26984, 22841, 10275, 
		12882, 25448, 14409, 17136, 12882, 10297, 22888, 26148, 8802, 
		10297, 22888, 26454, 13910, 25955, 21042, 8996, 25840, 22866, 
		-4055, 9456, 16994, 9010, 21091, 25942, 9769, 26934, 22117, 
		25426, 12835, 10297, 22888, 10601, 26691, 16982, 26472, 22841,
		 10279, 13910, 25955, 21042, 8997, 13859, 12882, 25448, 22841,
		 10278, 13653, 26165, 13894, 17717, -4030, 12851, 17218, 
		13622, 17989, 13808, 16946, 13123, 16945, 26662, 25636, 25840,
		 26150, 9318, 10290, 17234, 13040, 17478, 22119, 26713, 14632,
		 26199, 18230, 13636, 21605, 26456, 14375, 9267, 21348, 8741, 
		26096, 9512, 14681, 26722, 25445, 22054, 22119, 26713, 10530, 
		21091, 26713, 14632, 9010, 21091, 26713, 10530, 21091, 26729, 
		10534, 22256, 9762, 25193, 10534, 22256, 9762, 26713, 14632, 
		9010, 21091, 25941, 8745, -4058, 26352, 26978, 12882, -4030, 
		18928, 14681, 9010, 21091, 26921, 8944, 9577, -4025, 25129, 
		8802, 8745, 17769, 25193, 25129, 8775, 27120, 26713, 14632, 
		9010, 21091, 26658, 10585, 26727, 22054, 26713, 14632, 9010, 
		21091, 26864, 17506, 8745, 22888, 26454, 9814, 25954, 26713, 
		14632, 10038, 22117, 25426, 12835, 10601, -4023, 16937, 9010, 
		21091, 26921, 17001, 10530, 18018, 26921, 25328, 8809, 10567, 
		17136, 18281, 10601, 8802, -4042, 22121, 10530, 25129, 25122, 
		25193, 10530, 18018, 4481, 26455, 17975, 10006, 5412, 13381, 
		17989, 21604, 30070, 26405, 30068, 8759, 13379, 21348, 26468, 
		29491, 14320, 10087, -4009, 21314, 18672, 14118, 9267, 21348, 
		26199, 14135, 9764, 13139, 25702, 22327, -4075, 29990, 13876, 
		17236, 22118, -4030, 18467, 26352, 9782, 21347, 10020, 13124, 
		18244, 21348, 26408, 14149, 25584, 8773, 26455, 17975, 10006, 
		5412, 13381, 17989, 21604, 22600, 14150, 22117, 25683, 17204, 
		13638, 26439, 13876, 17251, -3995, 9766, 14150, 13382, 22374, 
		21233, -3471, 8534, 10874, 5477, -4045, 13380, 17203, -4042, 
		14151, 17974, 26662, 25840, 25379, 25379, -4060, 26152, 4679, 
		29202, 26199, 14118, 9267, 21348, -4030, 18453, 29985, 10792, 
		14664, 17136, 18521, 26659, 13378, 19066, 16969, -4044, 21744,
		 14424, 16969, -4044, 21744, 14424, -4042, 22037, 13876, 5493,
		 9063, -4057, 25410, 18743, 22345, 16948, 21570, 18688, 0, 0, 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };


    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double r_mod(real *, real *), sin(doublereal), cos(doublereal);

    /* Local variables */
    static real a;
    static int i__, k;
    static real x, y;
    static int ic, nc, ncc;
    static real ang, fct, div;
    static int nbt, nwd, msk;
#define nod1 ((int *)&equiv_2)
#define nod2 ((int *)&equiv_2 + 160)
#define nod3 ((int *)&equiv_2 + 320)
#define node ((int *)&equiv_2)
    extern int iram_(int *, int *, int *);
    static int nchr, kval, kdex, indx;
    extern /* Subroutine */ int plot_(real *, real *, int *);
    static int imask, nodes, ndknt, nodey, nodex, istat;
    extern /* Subroutine */ int getpat_(int *), newpat_(int *), 
	    soffset_(real *, real *, real *, real *, real *);

/* ...Plots characters using stroke representation of char. set */

/*        XZ,YZ  starting coordinate for the text */
/*        HGT    character height (in inches) */
/*        ITEXT   alphanumeric text to be generated */
/*        ANGLE  angle at which the character line is plotted */
/*        NC     number of characters to be plotted */
/*          NC>0   alpha text, number of characters to be plotted */
/*          NC=0   plot single character,right-justified in text */
/*          NC=-1  move to x,y with 'pen' up;   plot symbol #TEXT */
/*          NC<-1  move to x,y with 'pen' down; plot symbol #TEXT */

/* ...Note: */
/*   If your compiler supports passing character data as integers without */
/*   complaining and you want old style Versatec SYMBOL compatibility (so */
/*   you can call SYMBOL with either characters stuffed into an int */
/*   array or with int arguments to specify plot symbols) you can use */
/*   the sections of the following code marked with C+++OldVersatec comments. */
/*   In that case you don't need the SYMBL routine, just call SYMBOL with */
/*   int arguments.  However, with int arguments, you lose some of */
/*   the nice things about character string manipulation. */

/* ---Declaration of ITEXT as a character variable */

/* ---Declaration of ITEXT as int or byte variable */
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*      LOGICAL*1 ITEXT(1) */
/*      INTEGER*1 ITEXT(1) */
/*      BYTE      ITEXT(1) */
/* +++OldVersatec */


/* ...Assemble the NODE array (this silliness necessary because of f77 */
/*   limitation on number of continuation lines) */
/* ...Constants */
/* ...Static variables (changed within SYMBOL) */

/* ...Characters encoding stroke commands for drawing */

/* ...Node data for stroked characters (in 3 separate arrays due to problem */
/*   with some f77 compilers for continuation lines...).  You could assemble */
/*   these all into one array and dispense with the equivalence statements if */
/*   your compiler supported lots of continuation lines. */



    x = *xz;
    y = *yz;
    nc = *nz;

/* ...Save and set line pattern, Symbols/text only drawn with solid lines */
/* ...Process a draw to character position before switching line pattern */
    getpat_(&imask);
    if (nc < -1) {
	plot_(&x, &y, &c__2);
    }
    if (imask != -1) {
	msk = mskall;
	newpat_(&msk);
    }


/* ...Get set to loop through the text array character by character */
    k = 0;
    ic = 3;
    div = 7.f;


/* ...Extract next character from text array, masking off high bit */
L180:
    ++k;

/* ---For declaration of ITEXT as a character variable */
    nchr = *(unsigned char *)&itext[k - 1];
/* ---Declaration of ITEXT as int or byte variable */
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*      NCHR = ITEXT(K) */
/* +++OldVersatec */


    nchr = iram_(&nchr, &c__0, &msk7);

/* ...NC<0 Centered symbol */
/*   NC=0 Right-justified symbol */
/*   NC>0 Regular left-justified text */

    if (nc < 0) {
	if (nchr <= 13) {
	    div = 4.f;
	}
    }
    ncc = nchr;

/* ...On first character, set character height, angle and position */

    if (k == 1) {
/* ...Use current height and angle? */
	if (*hgt > 0.f) {
	    istat = 1;
	    fct = *hgt / div;
/* ...Calculate a new theta if necessary */
/*   use stored quadrant angles if at n(90 deg). */
	    if (*angle != theta) {
		facc = fct;
		theta = *angle;
		ang = r_mod(angle, &c_b99);
		if (ang < 0.f) {
		    ang = 360.f - ang;
		}
		i__ = (ang + epsil) / 90.f;
		a = i__ * 90.f;
		if ((r__1 = ang - a, dabs(r__1)) > epsil) {
		    ancc = theta * radco;
		    ancs = sin(ancc);
		    ancc = cos(ancc);
		} else {
		    ancs = asin__[i__];
		    ancc = acos__[i__];
		}
		soffset_(&facc, &ancc, &ancs, xa, ya);
	    }
/* ...Calculate offsets for new FACC and/or ANGLE */
	    if (fct != facc) {
		facc = fct;
		soffset_(&facc, &ancc, &ancs, xa, ya);
	    }
	}
/* ...Set character position */
/* ...If X,Y coordinate = 999.0; use previous value(s) of X and/or Y */
	if (x != 999.f) {
	    xo = x - xa[2] + ya[2];
	    xc = xo;
	}
	if (y != 999.f) {
	    yo = y - xa[2] - ya[2];
	    yc = yo;
	}
	x = xc;
	y = yc;
    }


/* ...Extract node count (5 bits) and index (11 bits) into node array */
    kdex = ncc % nchrs + 1;
    kval = khar[kdex - 1];
    ndknt = kval & msk5;
    indx = iram_(&kval, &c__5, &msk11);

/* ...Compute word index into node array for first node */
    nwd = indx / nbytes + 1;

/* ...Compute byte index(NBT = shift count)into node word for node start */
    nbt = indx % nbytes * -8 - 8;

/* ...Node processing loop */
L210:
    if (nbt + nbits < 0) {
	++nwd;
	nbt = -8;
    }

/* ...Extract the next node. */
    nodes = iram_(&node[nwd - 1], &nbt, &msk8);
    nbt += -8;
    nodey = nodes & msk4;
    nodex = iram_(&nodes, &c__4, &msk4);

/* ...Check for special control functions (NODEX = 15) */
    if (nodex >= 15) {
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* ...Decode special function (y-offset) */
/* ...Blank,superscript,subscript,carriage return,back space,null char? */

/* ...Blank character */
	if (nodey == 0) {
	    ic = 3;
	    goto L245;
/* ...Superscript set/reset code: (first test existing state) */
	} else if (nodey == 1) {
	    if (istat == 0) {
/* - For ISTAT=0 return to normal STATE=1 */
		istat = 1;
		facc /= fctr;
		soffset_(&facc, &ancc, &ancs, xa, ya);
		x -= ya[1];
		y += xa[1];
	    } else if (istat == 1) {
/* - For ISTAT=1 Set superscript mode,ISTAT=2 */
		istat = 2;
		x -= ya[4];
		y += xa[4];
		facc *= fctr;
		soffset_(&facc, &ancc, &ancs, xa, ya);
	    }
/* - For ISTAT=2 do nothing and branch to next character */


/* ...Subscript set/reset code: (first test existing state) */
	} else if (nodey == 2) {
/* - For ISTAT=0  branch to next character */
/* - For ISTAT=1) set subscript mode, ISTAT=0 */
	    if (istat == 1) {
		istat = 0;
		x += ya[1];
		y -= xa[1];
		facc *= fctr;
		soffset_(&facc, &ancc, &ancs, xa, ya);
/* - For ISTAT=2 return to normal mode, ISTAT=1 */
	    } else if (istat == 2) {
		istat = 1;
		facc /= fctr;
		soffset_(&facc, &ancc, &ancs, xa, ya);
		x += ya[4];
		y -= xa[4];
	    }
/* ...Carriage return */
	} else if (nodey == 3) {
	    x = xo + ya[12];
	    y = yo - xa[12];
	    xo = x;
	    yo = y;
/* ...Backspace */
	} else if (nodey == 4) {
	    x -= xa[7];
	    y -= ya[7];
/* ...Null character */
	} else if (nodey == 5) {
	}

/* ...Go on to next character */
	goto L260;
    }
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* ...Process move to node */
    ++nodex;
    ++nodey;
    yt = y + ya[nodex - 1] + xa[nodey - 1];
    xt = x + xa[nodex - 1] - ya[nodey - 1];


/* ...Plot the character stroke */
    plot_(&xt, &yt, &ic);
    ic = 2;
    x = xc;
    y = yc;

/* ...Decrement and test node count */
L245:
    --ndknt;

/* ...Any nodes yet to be processed? */
    if (ndknt >= 0) {
	goto L210;
    }
    x += xa[7];
    y += ya[7];

/* ...Decrement and test symbol count */
L260:
    xc = x;
    yc = y;
    ic = 3;
    --nc;

/* ...Any symbols yet to be plotted? */
    if (nc > 0) {
	goto L180;
    }

/* ...End of SYMBOL processing, if necessary restore line pattern */
    if (imask != -1) {
	newpat_(&imask);
    }
    return 0;
} /* symbol_ */

#undef node
#undef nod3
#undef nod2
#undef nod1


/* Subroutine */ int soffset_(real *facc, real *ancc, real *ancs, real *xa, 
	real *ya)
{
    static int l;
    static real w, z__, xi, yi;

/* ...Calculates character offsets using current factor and direction */
/*   sine and cosine */

    /* Parameter adjustments */
    --ya;
    --xa;

    /* Function Body */
    z__ = *facc * *ancc;
    w = *facc * *ancs;
    xi = z__;
    yi = w;
    for (l = 2; l <= 14; ++l) {
	xa[l] = z__;
	ya[l] = w;
	z__ += xi;
	w += yi;
    }
    return 0;
} /* soffset_ */

/* Subroutine */ int number_(real *x, real *y, real *height, real *fpn, real *
	angle, int *ndig)
{
    /* Initialized data */

    static char minus[1] = "-";
    static char ipoint[1] = ".";

    /* Builtin functions */
    double pow_ri(real *, int *);

    /* Local variables */
    static real t1, t2;
    static int nd, nl, np;
    static real xz, yz;
    static int idig;
    static char chdig[1];
    static int izero;
    extern /* Subroutine */ int symbol_(real *, real *, real *, char *, real *
	    , int *, ftnlen);

/* ...Plot number as a string of characters */

/*     (X,Y) = starting coordinates for 1st char (real) */
/*    HEIGHT = character height (real) */
/*       FPN = number to be converted to digits and plotted (real) */
/*     ANGLE = angle at which numeric string is to be plotted */
/*             in degrees measured from the x-axis (real) */
/*      NDIG = specification of the number of digits and the type */
/*             of numeric string to be plotted (integer) */
/*             > 0 = number of digits to the right of the decimal */
/*                   point to be plotted (last digit is rounded) */
/*             = 0 = rounded int portion of fpn is plotted */
/*                   with a decimal point */
/*            = -1 = rounded int portion of fpn is plotted */
/*                   without the decimal point */
/*            < -1 = rounded int portion of fpn is plotted */
/*                   after having the least significant digits */
/*                   truncated (IABS(NDEC)-1 digits are truncated) */

/*        CALLS:  SYMBOL */

/* ...Note: */
/*   If your compiler supports passing character data as integers without */
/*   complaining and you want old style Versatec SYMBOL compatibility (so */
/*   you can call SYMBOL with either characters stuffed into an int */
/*   array or with int arguments to specify plot symbols) you can use */
/*   the sections of the following code marked with C+++OldVersatec comments. */

/* ---Declaration using character variables */
/* ---Declaration of ITEXT as int or byte variable */
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*      LOGICAL*1 MINUS, IPOINT, CHDIG */
/*      INTEGER*1 MINUS, IPOINT, CHDIG */
/*      BYTE      MINUS, IPOINT, CHDIG */
/* +++OldVersatec */


    izero = '0';

    t1 = *fpn;
    xz = *x;
    yz = *y;
/* ...Number negative? */
    if (t1 < 0.f) {
	symbol_(&xz, &yz, height, minus, angle, &c__1, (ftnlen)1);
	xz = 999.f;
	yz = 999.f;
	t1 = -t1;
    }

/* ...Set working digit count */
    nd = -(*ndig);

/* ...Integer only to be plotted? */
    if (*ndig <= 0) {
/* ...Round and truncate for int */
	if (*ndig == 0) {
	    nd = 1;
	}
	--nd;
	t2 = (real) ((integer) ((t1 + .5f) / pow_ri(&c_b85, &nd))) + .5f;
	nd = 0;
	if (*ndig == 0) {
	    nd = -1;
	}
    } else {
/* ...Round for fraction */
	t2 = t1 + .5f / pow_ri(&c_b85, ndig);
    }

/* ...Find number of digits to the left of decimal point */
    nl = 1;
/* ...Any more digits to the left of the d.p. */
L60:
    if (t2 >= 10.f) {
	t2 /= 10.f;
	++nl;
	goto L60;
    }

/* ...Set plottable digit count */
    np = nl - nd;
/* ...Bad digit count? */
    if (np <= 0) {
	np = 1;
    }

/* ...Plot decimal point (NL=0) */
L80:
    if (nl == 0) {
/* ...No decimal point? */
	if (*ndig < 0) {
	    goto L120;
	}
	symbol_(&xz, &yz, height, ipoint, angle, &c__1, (ftnlen)1);
	if (*ndig != 0) {
	    ++np;
	}
    } else {
/* ...Plot digit */
	idig = (integer) t2;
	t2 = (t2 - (real) idig) * 10.f;
/* ---For declaration of CHDIG as character variable */
	*(unsigned char *)chdig = (char) (idig + izero);
/* +++OldVersatec (use either LOGICAL*1, INTEGER*1 or BYTE declaration) */
/*        CHDIG = IDIG + IZERO */
/* +++OldVersatec */
	symbol_(&xz, &yz, height, chdig, angle, &c_n1, (ftnlen)1);
    }
    xz = 999.f;
    yz = 999.f;

/* ...Count digit */
    --np;
L120:
    --nl;

/* ...More digits to plot? */
    if (np > 0) {
	goto L80;
    }
    return 0;
} /* number_ */

int iram_(int *iword, int *k, int *mask)
{
    /* System generated locals */
    int ret_val, i__1;

    /* Local variables */
    static int i3, i4, it1, it2;

/* ...Rotate And Mask 16 bits of a word and mask */
/*   Note that all inputs and outputs are I*4 (32bit) */
/*   New 32 bit version of IRAM   HHY 4/1/96 */
    i4 = *iword << 16;
    i3 = *mask << 16;

    if (*k != 0) {

	if (*k < 0) {
	    it1 = i4 << -(*k);
	} else {
	    it1 = i4 >> *k;
	}

	if (*k > 0) {
	    it2 = i4 << 16 - *k;
	} else {
	    it2 = i4 >> (i__1 = -(*k) - 16, abs(i__1));
	}

	i4 = it1 + it2;
    }

    i4 &= i3;
    ret_val = i4 >> 16;

    return ret_val;
} /* iram_ */
