/* f/ps_subs.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lprim_open__;
} pl_priml__;

#define pl_priml__1 pl_priml__

struct {
    int nprim_unit__, n_prim__, n_writ__, n_incore__, i_typ__[100000], 
	    i_prim__[100000];
} pl_primi__;

#define pl_primi__1 pl_primi__

struct {
    real x_prim__[100000], y_prim__[100000];
} pl_primr__;

#define pl_primr__1 pl_primr__

struct {
    int i_dev__, i_pagetype__, i_pen__, lst_pen__, i_pat__, lst_pat__, 
	    i_clr__, lst_clr__;
} pl_ploti__;

#define pl_ploti__1 pl_ploti__

struct {
    real x_scale__, y_scale__, x_org__, y_org__, x_lst__, y_lst__, x_page__, 
	    y_page__, x_wind__, y_wind__, clp_xmin__, clp_xmax__, clp_ymin__, 
	    clp_ymax__, xoff_zoom__, yoff_zoom__, xfac_zoom__, yfac_zoom__;
} pl_plotr__;

#define pl_plotr__1 pl_plotr__

struct {
    int n_color__, n_spectrum__, ifirst_spectrum__, color_rgb__[256];
} pl_colori__;

#define pl_colori__1 pl_colori__

struct {
    char color_name__[5632];
} pl_colorc__;

#define pl_colorc__1 pl_colorc__

struct {
    logical lgw_gen__, lgw_open__, lgw_color__, lgw_revvideo__, lgw_changed__,
	     lgw_resize__;
} pl_xwinl__;

#define pl_xwinl__1 pl_xwinl__

struct {
    int gx_loc__, gy_loc__, gx_org__, gy_org__, gx_siz__, gy_siz__, 
	    gx_crs__, gy_crs__, g_width__, g_height__, g_depth__, 
	    g_color_cindex__[256];
} pl_xwini__;

#define pl_xwini__1 pl_xwini__

struct {
    real g_scale__, g_scrnfrac__;
} pl_xwinr__;

#define pl_xwinr__1 pl_xwinr__

struct {
    logical lps_gen__, lps_open__, lps_color__, lps_unstroked__, 
	    lps_external__, lps_onefile__;
} pl_psl__;

#define pl_psl__1 pl_psl__

struct {
    int ips_mode__, nps_unit__, n_pages__, i_pages__, n_vecs__;
} pl_psi__;

#define pl_psi__1 pl_psi__

struct {
    real px_org__, py_org__, px_siz__, py_siz__, p_scale__, bb_xmin__, 
	    bb_xmax__, bb_ymin__, bb_ymax__, ps_lstx__, ps_lsty__;
} pl_psr__;

#define pl_psr__1 pl_psr__

struct {
    char ps_file__[80];
} pl_psc__;

#define pl_psc__1 pl_psc__

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static int c__80 = 80;

/* *********************************************************************** */
/*    Module:  ps_subs.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 driver for postscript output to file */

/*     Version 4.46 11/28/01 */

/*     Notes:  PS Plotting coordinates in points (1pt=1/72in.) */
/*             are multiplied by 10 and truncated as integers to */
/*             eliminate extra characters (decimal pts.) in plot file. */
/*             Coordinates are converted to points again by output macros. */

/*             Landscape orientation is done by translation and rotation */
/*             of upright plot. */

/*             The option exists to check before overwriting all old */
/*             postscript output files (including the default file */
/*             "plot.ps") see the commented section below. */
/* *********************************************************************** */
/* Subroutine */ int ps_setup__(int *nunit)
{
    /* Format strings */
    static char fmt_10[] = "(i3.3)";

    /* System generated locals */
    address a__1[3];
    int i__1[3];

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void), s_wsfi(icilist *), do_fio(int *, char *, ftnlen)
	    , e_wsfi(void);
    /* Subroutine */ int s_cat(char *, char **, int *, int *, ftnlen);

    /* Local variables */
    static int nunit0;
    static char numunit[3];

    /* Fortran I/O blocks */
    static cilist io___2 = { 0, 6, 0, 0, 0 };
    static cilist io___3 = { 0, 6, 0, 0, 0 };
    static cilist io___4 = { 0, 6, 0, 0, 0 };
    static icilist io___6 = { 0, numunit, 0, fmt_10, 3, 1 };



/* ---Sets defaults for Postscript output */

/*    nunit   specifies logical unit and suffix for name for .ps output file */
/*            if nunit<0 output file is named "plotXXX.ps" where XXX is the */
/*               plot sequential number (i.e. separate plot files are created */
/*               for each plot) */
/*            if nunit=0 output file is named "plot.ps" */
/*            if nunit>0  output file is named "plotUUU.ps" where UUU is the */
/*               nunit unit number */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    pl_psr__1.px_org__ = 10.f;
    pl_psr__1.py_org__ = 10.f;
    pl_psr__1.p_scale__ = 0.f;
    pl_psl__1.lps_open__ = FALSE_;
    pl_psl__1.lps_unstroked__ = FALSE_;
    pl_psl__1.lps_external__ = FALSE_;
    pl_psl__1.lps_onefile__ = TRUE_;
    pl_psi__1.i_pages__ = 0;

/* ---Default postscript output file is "plot.ps", specified if nunit=0, */
/*   with logical IO to Fortran unit NPS_UNIT_DEFAULT. */
/*   (Note that unit NPRIM_UNIT_DEFAULT is also reserved and is dedicated */
/*    to the primitives overflow file) */

/*   If user specifies nunit<0 each plot will be printed to a separate */
/*   file with name assigned as "plotNNN.ps" where NNN is the sequential */
/*   plot number */

/*   If user specifies a logical unit to use for the plot file the logical */
/*   unit is used for IO and the name assigned is "plotNNN.ps" where */
/*   NNN is the logical unit number (0>NNN<1000) */

    nunit0 = *nunit;
    if (*nunit == 0) {
	nunit0 = 80;
	s_copy(pl_psc__1.ps_file__, "plot.ps", (ftnlen)80, (ftnlen)7);
    } else if (*nunit == 81 || *nunit > 999) {
	s_wsle(&io___2);
	do_lio(&c__9, &c__1, "PS_SETUP: PS file unit out of bounds: ", (
		ftnlen)38);
	do_lio(&c__3, &c__1, (char *)&(*nunit), (ftnlen)sizeof(integer));
	e_wsle();
	s_wsle(&io___3);
	do_lio(&c__9, &c__1, "          Using default unit ", (ftnlen)29);
	do_lio(&c__3, &c__1, (char *)&c__80, (ftnlen)sizeof(integer));
	e_wsle();
	s_wsle(&io___4);
	do_lio(&c__9, &c__1, "          Using default file \"plot.ps\"", (
		ftnlen)38);
	e_wsle();
	nunit0 = 80;
	s_copy(pl_psc__1.ps_file__, "plot.ps", (ftnlen)80, (ftnlen)7);
    } else if (*nunit < 0) {
/*       write(*,*) 'PS_SETUP: separate PS files used for each plot' */
/*       write(*,*) '          Using unit ',NPS_UNIT_DEFAULT */
/*       write(*,*) '          Using file "plot###.ps"' */
	nunit0 = 80;
	s_copy(pl_psc__1.ps_file__, "plot000.ps", (ftnlen)80, (ftnlen)10);
	pl_psl__1.lps_onefile__ = FALSE_;
    } else {
	s_wsfi(&io___6);
	do_fio(&c__1, (char *)&nunit0, (ftnlen)sizeof(integer));
	e_wsfi();
/* Writing concatenation */
	i__1[0] = 8, a__1[0] = "plotunit";
	i__1[1] = 3, a__1[1] = numunit;
	i__1[2] = 3, a__1[2] = ".ps";
	s_cat(pl_psc__1.ps_file__, a__1, i__1, &c__3, (ftnlen)80);
    }
    pl_psi__1.nps_unit__ = nunit0;

    return 0;
} /* ps_setup__ */

/* Subroutine */ int ps_init__(void)
{
    extern /* Subroutine */ int ps_open__(void);

/* ---Initializes Postscript plotting and global plot variables */

/* ---Change page orientation if required */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_psi__1.ips_mode__ = 0;
    if (pl_ploti__1.i_pagetype__ == 1) {
	pl_psi__1.ips_mode__ = 1;
    }

    pl_psi__1.n_vecs__ = 0;
/* ...P_SCALE set so user graphics scales to 1.0inch/(absolute unit) on page */
    if (pl_psr__1.p_scale__ == 0.f) {
	pl_psr__1.p_scale__ = 72.f;
    }
    pl_psr__1.px_siz__ = pl_psr__1.p_scale__ * pl_plotr__1.x_page__;
    pl_psr__1.py_siz__ = pl_psr__1.p_scale__ * pl_plotr__1.y_page__;
    ps_open__();

    return 0;
} /* ps_init__ */

/* Subroutine */ int ps_open__(void)
{
    /* Format strings */
    static char fmt_100[] = "(i3.3)";
    static char fmt_1020[] = "(\002 Specify new output file: \002,$)";
    static char fmt_1100[] = "(a)";
    static char fmt_1030[] = "(\002%!PS-Adobe-2.0\002/\002%%Title: \002,a"
	    "/\002%%Creator: Xplot11\002/\002%%Pages: (atend)\002/\002%%Bound"
	    "ingBox: (atend)\002)";
    static char fmt_1040[] = "(\002%%Orientation: Landscape\002)";
    static char fmt_1050[] = "(\002%%EndComments\002/)";
    static char fmt_1064[] = "(\002 Appending PostScript to external file "
	    "...\002)";
    static char fmt_1065[] = "(\002 Appending PostScript to file  \002,a,"
	    "\002 ...\002)";
    static char fmt_1059[] = "(\002 Writing   PostScript to external file "
	    "...\002)";
    static char fmt_1060[] = "(\002 Writing   PostScript to file  \002,a,"
	    "\002 ...\002)";
    static char fmt_1070[] = "(\002%%Page: \002,i4,2x,i4/\002gsave  %Save cu"
	    "rrent context\002/\002% Define macros for drawing\002/\002/rscal"
	    " {10 div exch 10 div exch } bind def\002/\002/M { rscal moveto }"
	    " bind def\002/\002/L { rscal lineto } bind def\002/\002/SG { set"
	    "gray } bind def\002/\002/NP { newpath } bind def\002/\002/SL { s"
	    "etlinewidth } bind def\002/\002/CPSM { currentpoint stroke movet"
	    "o } bind def\002/\002/CFS  { closepath fill stroke } bind def"
	    "\002/\002/CO { 2 index 255 div 2 index 255 div 2 index 255 di"
	    "v\002/\002      setrgbcolor pop pop pop } bind def\002/\002/LAND"
	    " { 0 790 translate -90 rotate } bind def\002//\002% Set up for d"
	    "efault line type and width\002/\002 1 setlinejoin 0.25 SL [ ] 0 "
	    "setdash 0 SG\002)";
    static char fmt_1080[] = "(\002% Rotate and translate for Landscape form"
	    "at\002/i4,1x,i4,\002 translate \002,i4,\002 rotate\002)";

    /* System generated locals */
    address a__1[3];
    int i__1, i__2[3];
    olist o__1;
    alist al__1;
    inlist ioin__1;

    /* Builtin functions */
    int i_indx(char *, char *, ftnlen, ftnlen), f_inqu(inlist *), s_wsfi(
	    icilist *), do_fio(int *, char *, ftnlen), e_wsfi(void);
    /* Subroutine */ int s_cat(char *, char **, int *, int *, ftnlen);
    int f_open(olist *), f_rew(alist *), s_wsfe(cilist *), e_wsfe(void), 
	    s_rsfe(cilist *), e_rsfe(void), s_cmp(char *, char *, ftnlen, 
	    ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int nch;
    static logical lopen;
    static char numpage[3];
    extern /* Subroutine */ int a_strip__(char *, char *, ftnlen, ftnlen);
    static int irotate, ixtrans, iytrans;
    static char ps_file2__[80];

    /* Fortran I/O blocks */
    static icilist io___10 = { 0, numpage, 0, fmt_100, 3, 1 };
    static cilist io___11 = { 0, 6, 0, fmt_1020, 0 };
    static cilist io___12 = { 0, 5, 0, fmt_1100, 0 };
    static cilist io___14 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___15 = { 0, 0, 0, fmt_1040, 0 };
    static cilist io___16 = { 0, 0, 0, fmt_1050, 0 };
    static cilist io___17 = { 0, 6, 0, fmt_1064, 0 };
    static cilist io___18 = { 0, 6, 0, fmt_1065, 0 };
    static cilist io___19 = { 0, 6, 0, fmt_1059, 0 };
    static cilist io___20 = { 0, 6, 0, fmt_1060, 0 };
    static cilist io___21 = { 0, 0, 0, fmt_1070, 0 };
    static cilist io___25 = { 0, 0, 0, fmt_1080, 0 };


/* ...Initializes PostScript file for plotting commands */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    lopen = pl_psl__1.lps_open__;
    a_strip__(" ", pl_psc__1.ps_file__, (ftnlen)1, (ftnlen)80);
    nch = i_indx(pl_psc__1.ps_file__, " ", (ftnlen)80, (ftnlen)1) - 1;

/* ---Check status on PS file */
/* ---PS file NOT OPENED. */
    if (! pl_psl__1.lps_open__) {

/* ---Check unit to see if user opened it already (set status flag LPS_EXTERNAL) */
/*   if file is already open skip opening the file, just use it */
/*   if unit is unopened then open a file for output */
	if (pl_psl__1.lps_external__) {
	    goto L10;
	}
/* ---Check if file pre-opened outside of Xplot11 */
	ioin__1.inerr = 1;
	ioin__1.inunit = pl_psi__1.nps_unit__;
	ioin__1.infile = 0;
	ioin__1.inex = 0;
	ioin__1.inopen = &pl_psl__1.lps_external__;
	ioin__1.innum = 0;
	ioin__1.innamed = 0;
	ioin__1.inname = 0;
	ioin__1.inacc = 0;
	ioin__1.inseq = 0;
	ioin__1.indir = 0;
	ioin__1.infmt = 0;
	ioin__1.inform = 0;
	ioin__1.inunf = 0;
	ioin__1.inrecl = 0;
	ioin__1.innrec = 0;
	ioin__1.inblank = 0;
	i__1 = f_inqu(&ioin__1);
	if (i__1 != 0) {
	    goto L1;
	}

L1:
	if (! pl_psl__1.lps_external__) {

/* ---If we are writing separate plotxxx.ps files create plot file name for */
/*   this plot using cumulative plot number */
	    if (! pl_psl__1.lps_onefile__) {
		s_wsfi(&io___10);
		do_fio(&c__1, (char *)&pl_psi__1.n_pages__, (ftnlen)sizeof(
			integer));
		e_wsfi();
/* Writing concatenation */
		i__2[0] = 4, a__1[0] = "plot";
		i__2[1] = 3, a__1[1] = numpage;
		i__2[2] = 3, a__1[2] = ".ps";
		s_cat(pl_psc__1.ps_file__, a__1, i__2, &c__3, (ftnlen)80);
	    }


/* .....PS_FILE doesn't exist, so open it and proceed */
L2:
	    o__1.oerr = 1;
	    o__1.ounit = pl_psi__1.nps_unit__;
	    o__1.ofnmlen = 80;
	    o__1.ofnm = pl_psc__1.ps_file__;
	    o__1.orl = 0;
	    o__1.osta = "UNKNOWN";
	    o__1.oacc = 0;
	    o__1.ofm = 0;
	    o__1.oblnk = 0;
	    i__1 = f_open(&o__1);
	    if (i__1 != 0) {
		goto L3;
	    }
	    al__1.aerr = 0;
	    al__1.aunit = pl_psi__1.nps_unit__;
	    f_rew(&al__1);
	    goto L10;
/* ....On open error get some other name and try again... */
L3:
	    s_wsfe(&io___11);
	    e_wsfe();
	    s_rsfe(&io___12);
	    do_fio(&c__1, ps_file2__, (ftnlen)80);
	    e_rsfe();
	    a_strip__(" ", ps_file2__, (ftnlen)1, (ftnlen)80);
	    if (s_cmp(ps_file2__, " ", (ftnlen)80, (ftnlen)1) == 0) {
		goto L3;
	    }
	    s_copy(pl_psc__1.ps_file__, ps_file2__, (ftnlen)80, (ftnlen)80);
	    nch = i_indx(pl_psc__1.ps_file__, " ", (ftnlen)80, (ftnlen)1) - 1;
	    goto L2;

	}

/* L1010: */

/* ...Write Postscript file header to identify this as a .ps file */
L10:
	io___14.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___14);
	do_fio(&c__1, pl_psc__1.ps_file__, (ftnlen)80);
	e_wsfe();
	if (pl_psi__1.ips_mode__ == 1) {
	    io___15.ciunit = pl_psi__1.nps_unit__;
	    s_wsfe(&io___15);
	    e_wsfe();
	}
	io___16.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___16);
	e_wsfe();


	pl_psl__1.lps_open__ = TRUE_;

    }


/* ...For any ps_open -> Initialize Postscript last point and bounding box */
    pl_psr__1.ps_lstx__ = -99999.f;
    pl_psr__1.ps_lsty__ = -99999.f;
    pl_psr__1.bb_xmin__ = 99999.f;
    pl_psr__1.bb_ymin__ = 99999.f;
    pl_psr__1.bb_xmax__ = -99999.f;
    pl_psr__1.bb_ymax__ = -99999.f;

    if (lopen) {
	if (pl_psl__1.lps_external__) {
	    s_wsfe(&io___17);
	    e_wsfe();
	} else {
	    s_wsfe(&io___18);
	    do_fio(&c__1, pl_psc__1.ps_file__, nch);
	    e_wsfe();
	}
    } else {
	if (pl_psl__1.lps_external__) {
	    s_wsfe(&io___19);
	    e_wsfe();
	} else {
	    s_wsfe(&io___20);
	    do_fio(&c__1, pl_psc__1.ps_file__, nch);
	    e_wsfe();
	}
    }

/* ...Put out a page preamble */
    ++pl_psi__1.n_pages__;
    ++pl_psi__1.i_pages__;
    io___21.ciunit = pl_psi__1.nps_unit__;
    s_wsfe(&io___21);
    do_fio(&c__1, (char *)&pl_psi__1.i_pages__, (ftnlen)sizeof(integer));
    do_fio(&c__1, (char *)&pl_psi__1.i_pages__, (ftnlen)sizeof(integer));
    e_wsfe();

/* ---Use one of these sets for rotating/translating to landscape, depending */
/*   on your postscript screen viewer (right-side up/upside-down) */
/* -------------------------------------------------------------- */
/*      ixtrans =  0 */
/*      iytrans =  ifix(P_SCALE*X_PAGE) */
/*      irotate = -90 */
/* -------------------------------------------------------------- */
    ixtrans = (integer) (pl_psr__1.p_scale__ * pl_plotr__1.y_page__);
    iytrans = 0;
    irotate = 90;
/* -------------------------------------------------------------- */
/* L1080: */
    if (pl_psi__1.ips_mode__ == 1) {
	io___25.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___25);
	do_fio(&c__1, (char *)&ixtrans, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&iytrans, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&irotate, (ftnlen)sizeof(integer));
	e_wsfe();
    }

    pl_psl__1.lps_unstroked__ = TRUE_;
    pl_psi__1.n_vecs__ = 0;

    return 0;
} /* ps_open__ */

/* Subroutine */ int a_strip__(char *alph, char *string, ftnlen alph_len, 
	ftnlen string_len)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int i_len(char *, ftnlen), i_indx(char *, char *, ftnlen, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int k, num;


/* ---- Strips all leading ALPH characters from STRING */

    num = i_len(string, string_len);
    i__1 = num;
    for (k = 1; k <= i__1; ++k) {
	if (i_indx(string + (k - 1), alph, (ftnlen)1, (ftnlen)1) == 0) {
	    goto L10;
	}
    }
    return 0;

L10:
    s_copy(string, string + (k - 1), string_len, num - (k - 1));
    return 0;
} /* a_strip__ */

/* Subroutine */ int ps_close__(void)
{
    /* Format strings */
    static char fmt_30[] = "(\002%%Trailer\002/\002%%Pages: \002,i4)";

    /* System generated locals */
    cllist cl__1;

    /* Builtin functions */
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void),
	     f_clos(cllist *);

    /* Fortran I/O blocks */
    static cilist io___28 = { 0, 0, 0, fmt_30, 0 };


/* ...Closes PostScript file for plotting */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (! pl_psl__1.lps_open__) {
	return 0;
    }

/* ...Put out page count */
    io___28.ciunit = pl_psi__1.nps_unit__;
    s_wsfe(&io___28);
    do_fio(&c__1, (char *)&pl_psi__1.i_pages__, (ftnlen)sizeof(integer));
    e_wsfe();

/* ...Don't mess with external supplied units */
    if (! pl_psl__1.lps_external__) {
	cl__1.cerr = 0;
	cl__1.cunit = pl_psi__1.nps_unit__;
	cl__1.csta = 0;
	f_clos(&cl__1);
	pl_psi__1.nps_unit__ = -1;
    }

    pl_psl__1.lps_open__ = FALSE_;
    return 0;
} /* ps_close__ */

/* Subroutine */ int ps_endpage__(void)
{
    /* Format strings */
    static char fmt_20[] = "(\002stroke showpage grestore\002/\002%%Bounding"
	    "Box: \002,4f8.1/)";

    /* Builtin functions */
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void);

    /* Fortran I/O blocks */
    static cilist io___29 = { 0, 0, 0, fmt_20, 0 };


/* ...Ends PostScript page */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (! pl_psl__1.lps_open__) {
	return 0;
    }
    if (! pl_psl__1.lps_unstroked__) {
	return 0;
    }

/* ...If a page has already been plotted, finish it */
    if (pl_psi__1.i_pages__ > 0) {
	io___29.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___29);
	do_fio(&c__1, (char *)&pl_psr__1.bb_xmin__, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&pl_psr__1.bb_ymin__, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&pl_psr__1.bb_xmax__, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&pl_psr__1.bb_ymax__, (ftnlen)sizeof(real));
	e_wsfe();
    }

    pl_psl__1.lps_unstroked__ = FALSE_;
    pl_psi__1.n_vecs__ = 0;

    return 0;
} /* ps_endpage__ */

/* Subroutine */ int ps_flush__(void)
{
/* ...Flushes out buffered plot output to PostScript file */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    return 0;
} /* ps_flush__ */

/* Subroutine */ int ps_color__(int *icolor)
{
    /* Format strings */
    static char fmt_10[] = "(\002 CPSM\002)";
    static char fmt_20[] = "(\002 \002,3(i5),\002 CO\002)";

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), do_fio(int *, char *, ftnlen);

    /* Local variables */
    static char colorname[22];
    extern /* Subroutine */ int getcolorrgb_(int *, int *, int *, 
	    int *, char *, ftnlen);
    static int ired, icol, iblu, igrn;

    /* Fortran I/O blocks */
    static cilist io___30 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___36 = { 0, 0, 0, fmt_20, 0 };


/* ...Sets PostScript foreground color from stored RGB colormap */
/*   Note: The background color for PS is always white */
/*         the foreground color is normally black */
/*         you get color when color PS printing is enabled */
/*         and the color is set to one of the colors in the color tables */
/*    icolor =  1 mapped to black */
/*    icolor =  2 mapped to white */
/*     ... */
/*    icolor =  N_COLOR mapped to last color in color table */
/*   See the colormapping routines in plt_color.f for assigned colors */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    if (! pl_psl__1.lps_open__ || ! pl_psl__1.lps_color__) {
	return 0;
    }

/* ...Flush out existing lines at old color */
    if (pl_psi__1.n_vecs__ > 0) {
	io___30.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___30);
	e_wsfe();
	pl_psi__1.n_vecs__ = 0;
    }

/* ---Consult color map for RGB values */
    icol = *icolor;
    if (pl_colori__1.n_color__ <= 0) {
	icol = 1;
    }
    getcolorrgb_(&icol, &ired, &igrn, &iblu, colorname, (ftnlen)22);

/* ---RGB goes directly into postscript as color spec */
    io___36.ciunit = pl_psi__1.nps_unit__;
    s_wsfe(&io___36);
    do_fio(&c__1, (char *)&ired, (ftnlen)sizeof(integer));
    do_fio(&c__1, (char *)&igrn, (ftnlen)sizeof(integer));
    do_fio(&c__1, (char *)&iblu, (ftnlen)sizeof(integer));
    e_wsfe();

    return 0;
} /* ps_color__ */

/* Subroutine */ int ps_pen__(int *jpen)
{
    /* Format strings */
    static char fmt_10[] = "(\002 CPSM\002)";
    static char fmt_20[] = "(\002 \002,f5.2,\002 SL\002)";

    /* System generated locals */
    real r__1;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), do_fio(int *, char *, ftnlen);

    /* Fortran I/O blocks */
    static cilist io___37 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___38 = { 0, 0, 0, fmt_20, 0 };


/* ...Sets PostScript line width */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (! pl_psl__1.lps_open__) {
	return 0;
    }

/* ...Change the line width for new lines */
    if (pl_psi__1.n_vecs__ > 0) {
	io___37.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___37);
	e_wsfe();
	pl_psi__1.n_vecs__ = 0;
    }

    io___38.ciunit = pl_psi__1.nps_unit__;
    s_wsfe(&io___38);
    r__1 = (real) (*jpen) * .25f;
    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsfe();

    return 0;
} /* ps_pen__ */

/* Subroutine */ int ps_linepattern__(int *lmask)
{
    /* Initialized data */

    static int mskall = -1;
    static int nsegmax = 8;

    /* Format strings */
    static char fmt_10[] = "(\002 CPSM\002)";
    static char fmt_20[] = "(\002 [ ] 0 setdash\002)";
    static char fmt_30[] = "(\002 [\002,10i3)";
    static char fmt_40[] = "(\002 ] 0 setdash\002)";

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), do_fio(int *, char *, ftnlen);

    /* Local variables */
    static int i__, nsg, iseg[32], nseg;
    extern /* Subroutine */ int bitpat_(int *, int *, int *);

    /* Fortran I/O blocks */
    static cilist io___41 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___42 = { 0, 0, 0, fmt_20, 0 };
    static cilist io___46 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___47 = { 0, 0, 0, fmt_30, 0 };
    static cilist io___49 = { 0, 0, 0, fmt_40, 0 };


/* ...Sets Postscript line pattern */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    if (! pl_psl__1.lps_open__) {
	return 0;
    }

    if (*lmask == 0 || *lmask == mskall) {
	if (pl_psi__1.n_vecs__ > 0) {
	    io___41.ciunit = pl_psi__1.nps_unit__;
	    s_wsfe(&io___41);
	    e_wsfe();
	}
	io___42.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___42);
	e_wsfe();

    } else {
/* ...Set line pattern from lower 16 bits of line mask (integer) */
/*   Note: no more than 10 pattern elements can be written to PS! */
	bitpat_(lmask, &nseg, iseg);
	nsg = min(nseg,nsegmax);
/*< 	if(N_VECS.GT.0) write(NPS_UNIT,10) >*/
	if (pl_psi__1.n_vecs__ > 0) {
	    io___46.ciunit = pl_psi__1.nps_unit__;
	    s_wsfe(&io___46);
	    e_wsfe();
	}
/*< 	write(NPS_UNIT,30) (iseg(i),i=1,nsg) >*/
	io___47.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___47);
	i__1 = nsg;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    do_fio(&c__1, (char *)&iseg[i__ - 1], (ftnlen)sizeof(integer));
	}
	e_wsfe();
/*< 	write(NPS_UNIT,40) >*/
	io___49.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___49);
	e_wsfe();
    }

    pl_psi__1.n_vecs__ = 0;

    return 0;
} /* ps_linepattern__ */

/* Subroutine */ int ps_line__(real *x1, real *y1, real *x2, real *y2)
{
    /* Format strings */
    static char fmt_10[] = "(\002 CPSM\002)";
    static char fmt_30[] = "(i5,1x,i5,\002 L\002)";
    static char fmt_20[] = "(i5,1x,i5,\002 M \002,i5,1x,i5,\002 L\002)";

    /* System generated locals */
    int i__1;
    real r__1;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), do_fio(int *, char *, ftnlen);

    /* Local variables */
    static real px1, py1, px2, py2;
    static int idx, idy, ipx1, ipy1, ipx2, ipy2;

    /* Fortran I/O blocks */
    static cilist io___60 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___61 = { 0, 0, 0, fmt_30, 0 };
    static cilist io___62 = { 0, 0, 0, fmt_20, 0 };



/* ...Plots vector in absolute coordinates to PostScript file */

/*   Note: coordinates are multiplied by 10 and truncated to integers (now */
/*         accurate to 1/10 of a point, or 1/720 in) to reduce the size of */
/*         the ascii plot file.  Note that the moveto and lineto commands */
/*         defined in the preamble divide these by 10 before they hit the */
/*         paper. */


/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    if (! pl_psl__1.lps_open__) {
	return 0;
    }

    px1 = *x1 * pl_psr__1.p_scale__ + pl_psr__1.px_org__;
    py1 = *y1 * pl_psr__1.p_scale__ + pl_psr__1.py_org__;
    px2 = *x2 * pl_psr__1.p_scale__ + pl_psr__1.px_org__;
    py2 = *y2 * pl_psr__1.p_scale__ + pl_psr__1.py_org__;
/* Computing MAX */
    r__1 = max(pl_psr__1.bb_xmax__,px1);
    pl_psr__1.bb_xmax__ = dmax(r__1,px2);
/* Computing MIN */
    r__1 = min(pl_psr__1.bb_xmin__,px1);
    pl_psr__1.bb_xmin__ = dmin(r__1,px2);
/* Computing MAX */
    r__1 = max(pl_psr__1.bb_ymax__,py1);
    pl_psr__1.bb_ymax__ = dmax(r__1,py2);
/* Computing MIN */
    r__1 = min(pl_psr__1.bb_ymin__,py1);
    pl_psr__1.bb_ymin__ = dmin(r__1,py2);
    ipx1 = (integer) (px1 * 10.f);
    ipy1 = (integer) (py1 * 10.f);
    ipx2 = (integer) (px2 * 10.f);
    ipy2 = (integer) (py2 * 10.f);

    idx = (i__1 = (integer) (pl_psr__1.ps_lstx__ * 10.f) - ipx1, abs(i__1));
    idy = (i__1 = (integer) (pl_psr__1.ps_lsty__ * 10.f) - ipy1, abs(i__1));

    if (pl_psi__1.n_vecs__ >= 500) {
/*< 	write(NPS_UNIT,10) >*/
	io___60.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___60);
	e_wsfe();
/*< 	N_VECS = 0 >*/
	pl_psi__1.n_vecs__ = 0;
    }

    if (idx <= 1 && idy <= 1 && pl_psi__1.n_vecs__ != 0) {
/* CC   if(PX1.EQ.PS_LSTX .AND. PY1.EQ.PS_LSTY .AND. N_VECS.NE.0) then */
	io___61.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___61);
	do_fio(&c__1, (char *)&ipx2, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&ipy2, (ftnlen)sizeof(integer));
	e_wsfe();
    } else {
/*< 	write(NPS_UNIT,20) ipx1,ipy1,ipx2,ipy2 >*/
	io___62.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___62);
	do_fio(&c__1, (char *)&ipx1, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&ipy1, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&ipx2, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&ipy2, (ftnlen)sizeof(integer));
	e_wsfe();
    }

    pl_psr__1.ps_lstx__ = px2;
    pl_psr__1.ps_lsty__ = py2;
    ++pl_psi__1.n_vecs__;


    return 0;
} /* ps_line__ */

/* Subroutine */ int ps_setscale__(real *factor)
{
/* ---Resets postscript plot scaling to factor*72pts/in */
/* ...P_SCALE set so user graphics scales to factor of 1.0inch/(absolute unit) */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_psr__1.p_scale__ = *factor * 72.f;
    pl_psr__1.px_siz__ = pl_psr__1.p_scale__ * pl_plotr__1.x_page__;
    pl_psr__1.py_siz__ = pl_psr__1.p_scale__ * pl_plotr__1.y_page__;
    return 0;
} /* ps_setscale__ */

/* Subroutine */ int ps_polyline__(real *x, real *y, int *n, int *
	ifill)
{
    /* Initialized data */

    static real mingrey = .1f;
    static real maxgrey = .95f;

    /* Format strings */
    static char fmt_10[] = "(\002 CPSM\002)";
    static char fmt_15[] = "(\002 \002,f5.2,\002 SG\002)";
    static char fmt_20[] = "(\002 CFS\002)";

    /* System generated locals */
    int i__1;

    /* Builtin functions */
    int s_wsfe(cilist *), e_wsfe(void), do_fio(int *, char *, ftnlen);

    /* Local variables */
    static real greyfrac;
    extern /* Subroutine */ int getcolor_(int *);
    static int i__;
    static real x1, y1, x2, y2;
    static int icol;
    static real grey;
    static int ispec;
    extern /* Subroutine */ int ps_line__(real *, real *, real *, real *);

    /* Fortran I/O blocks */
    static cilist io___65 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___71 = { 0, 0, 0, fmt_10, 0 };
    static cilist io___76 = { 0, 0, 0, fmt_15, 0 };
    static cilist io___77 = { 0, 0, 0, fmt_20, 0 };
    static cilist io___78 = { 0, 0, 0, fmt_15, 0 };


/* ...Plots polyline to postscript output */

/*   Note for non-color postscript plots, colors in the colormap spectrum */
/*   can be used to shade filled polylines with a grey fill spectrum. */

/*   Note: this simply uses the ps_line routine to put up the path, */
/*         then fills and strokes the path.  It is important that */
/*         the number of points not exceed the stroke limit in ps_line */
/*         or it will try to stroke the path we need to fill... */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*n <= 1) {
	return 0;
    }

/* ...If this is a filled polyline flush out existing lines */
    if (pl_psi__1.n_vecs__ > 0) {
	io___65.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___65);
	e_wsfe();
	pl_psi__1.n_vecs__ = 0;
    }

    x1 = x[1];
    y1 = y[1];
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	x2 = x[i__];
	y2 = y[i__];
	ps_line__(&x1, &y1, &x2, &y2);
	x1 = x2;
	y1 = y2;
    }

/* ...If this is not a color PS plot, shade any Spectrum color indices with */
/*   a grey shade from light grey to near black to replace the color shading */
    if (*ifill == 0) {
	io___71.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___71);
	e_wsfe();
    } else {
	grey = 0.f;
	if (! pl_psl__1.lps_color__ && pl_colori__1.n_color__ > 0) {
	    getcolor_(&icol);
	    if (icol == 2) {
		grey = 1.f;
	    } else if (icol < 0) {
		ispec = -icol;
		greyfrac = (real) (ispec - 1) / (real) (
			pl_colori__1.n_spectrum__ - 1);
		grey = mingrey + (maxgrey - mingrey) * greyfrac;
	    } else {
		grey = 0.f;
	    }
	    io___76.ciunit = pl_psi__1.nps_unit__;
	    s_wsfe(&io___76);
	    do_fio(&c__1, (char *)&grey, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	io___77.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___77);
	e_wsfe();
    }
/* ...Flush vector count since we are shading this now */
    pl_psi__1.n_vecs__ = 0;
    if (grey != 0.f) {
	grey = 0.f;
	io___78.ciunit = pl_psi__1.nps_unit__;
	s_wsfe(&io___78);
	do_fio(&c__1, (char *)&grey, (ftnlen)sizeof(real));
	e_wsfe();
    }

    return 0;
} /* ps_polyline__ */

/* Subroutine */ int bitpat_(int *mask, int *nout, int *iout)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int n, ibit, imask, nbits, nshft, ibitold;


/* --- Takes an int mask and returns an int array which contains */
/*    the on/off bit pattern, */
/*     for example:  a mask with 0001000100010001 returns 8 integers */
/*                   in the iout array (1,3,1,3,1,3,1,3) */
/*                   a mask with 1110111011101110 returns 8 integers */
/*                   in the iout array (3,1,3,1,3,1,3,1) */
/*     Note: the bit mask is shifted to always start counting on a '1' bit. */

/* ---  Uses the library routines and() and rshift() for bit manipulation */
/*     which are present in most fortran libraries as extensions to f77. */


/* --- Shift the mask until the low order bit is 1 to start... */
    /* Parameter adjustments */
    --iout;

    /* Function Body */
    imask = *mask;
    for (n = 1; n <= 16; ++n) {
	ibitold = 1 & imask;
	if (ibitold != 0) {
	    goto L5;
	}
	nshft = n;
	imask = imask >> 1;
    }

L5:
    *nout = 0;
    if (nshft >= 16) {
	return 0;
    }
    nbits = 0;

/* --- Cycle through 16 shifts to the right looking at the lower bit */
/*    and comparing with the previous one. If the bit changes record */
/*    the number of preceding contiguous bits in the output array. */

    i__1 = 16 - nshft;
    for (n = 1; n <= i__1; ++n) {
	ibit = 1 & imask;
/* cc        write(*,*) 'n, imask,ibit,ibitold ',n,imask,ibit,ibitold */

	if (ibit != ibitold) {
	    ++(*nout);
	    iout[*nout] = nbits;
/* cc          write(*,*) 'nout ',nout,' adding nbits to iout ',nbits */
	    nbits = 0;
	}

	ibitold = ibit;
	++nbits;
	imask = imask >> 1;
    }
/* --- Add final bit(s) to end of 16 bits checked */
/* --- Now append any zero bits shifted out originally */
    if (ibit == 1) {
	++(*nout);
	iout[*nout] = nbits;
	if (nshft > 0) {
	    ++(*nout);
	    iout[*nout] = nshft;
	}
    } else {
	++(*nout);
	iout[*nout] = nbits + nshft;
    }

    return 0;
} /* bitpat_ */
