/* f/set_subs.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lprim_open__;
} pl_priml__;

#define pl_priml__1 pl_priml__

struct {
    int nprim_unit__, n_prim__, n_writ__, n_incore__, i_typ__[100000], 
	    i_prim__[100000];
} pl_primi__;

#define pl_primi__1 pl_primi__

struct {
    real x_prim__[100000], y_prim__[100000];
} pl_primr__;

#define pl_primr__1 pl_primr__

struct {
    int i_dev__, i_pagetype__, i_pen__, lst_pen__, i_pat__, lst_pat__, 
	    i_clr__, lst_clr__;
} pl_ploti__;

#define pl_ploti__1 pl_ploti__

struct {
    real x_scale__, y_scale__, x_org__, y_org__, x_lst__, y_lst__, x_page__, 
	    y_page__, x_wind__, y_wind__, clp_xmin__, clp_xmax__, clp_ymin__, 
	    clp_ymax__, xoff_zoom__, yoff_zoom__, xfac_zoom__, yfac_zoom__;
} pl_plotr__;

#define pl_plotr__1 pl_plotr__

struct {
    int n_color__, n_spectrum__, ifirst_spectrum__, color_rgb__[256];
} pl_colori__;

#define pl_colori__1 pl_colori__

struct {
    char color_name__[5632];
} pl_colorc__;

#define pl_colorc__1 pl_colorc__

struct {
    logical lgw_gen__, lgw_open__, lgw_color__, lgw_revvideo__, lgw_changed__,
	     lgw_resize__;
} pl_xwinl__;

#define pl_xwinl__1 pl_xwinl__

struct {
    int gx_loc__, gy_loc__, gx_org__, gy_org__, gx_siz__, gy_siz__, 
	    gx_crs__, gy_crs__, g_width__, g_height__, g_depth__, 
	    g_color_cindex__[256];
} pl_xwini__;

#define pl_xwini__1 pl_xwini__

struct {
    real g_scale__, g_scrnfrac__;
} pl_xwinr__;

#define pl_xwinr__1 pl_xwinr__

struct {
    logical lps_gen__, lps_open__, lps_color__, lps_unstroked__, 
	    lps_external__, lps_onefile__;
} pl_psl__;

#define pl_psl__1 pl_psl__

struct {
    int ips_mode__, nps_unit__, n_pages__, i_pages__, n_vecs__;
} pl_psi__;

#define pl_psi__1 pl_psi__

struct {
    real px_org__, py_org__, px_siz__, py_siz__, p_scale__, bb_xmin__, 
	    bb_xmax__, bb_ymin__, bb_ymax__, ps_lstx__, ps_lsty__;
} pl_psr__;

#define pl_psr__1 pl_psr__

struct {
    char ps_file__[80];
} pl_psc__;

#define pl_psc__1 pl_psc__

/* Table of constant values */

static int c_b10 = 100000;
static int c__1 = 1;
static int c__9 = 9;
static int c__3 = 3;
static int c__4 = 4;
static real c_b49 = 1.f;
static real c_b51 = -1.f;
static int c__2 = 2;
static real c_b109 = 0.f;

/* *********************************************************************** */
/*    Module: plt_set.f */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */

/* *********************************************************************** */
/* --- Xplot11 internal processing routines */

/*     Version 4.46 11/28/01 */

/*     Note:  These are plot-handling routines intended only */
/*            for internal use, including handling the replot buffer, */
/*            internal plot calls and clipping and zooming (the "set_xxx" */
/*            routines).  Not intended for general consumption. */
/* *********************************************************************** */
/* Subroutine */ int set_pen__(int *ipen)
{
    extern /* Subroutine */ int gw_pen__(int *), ps_pen__(int *);

/* ...Sets current pen width in pixels */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_ploti__1.lst_pen__ = *ipen;
    if (pl_xwinl__1.lgw_gen__) {
	gw_pen__(ipen);
    }
    if (pl_psl__1.lps_gen__) {
	ps_pen__(ipen);
    }
    return 0;
} /* set_pen__ */

/* Subroutine */ int set_pat__(int *ipat)
{
    extern /* Subroutine */ int gw_linepattern__(int *), ps_linepattern__(
	    int *);

/* ...Sets current line pattern as int bit pattern */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_ploti__1.lst_pat__ = *ipat;
    if (pl_xwinl__1.lgw_gen__) {
	gw_linepattern__(ipat);
    }
    if (pl_psl__1.lps_gen__) {
	ps_linepattern__(ipat);
    }
    return 0;
} /* set_pat__ */

/* Subroutine */ int set_color__(int *icolor)
{
    extern /* Subroutine */ int gw_color__(int *), ps_color__(int *);

/* ...Sets foreground color for plotting */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_ploti__1.lst_clr__ = *icolor;
    if (pl_xwinl__1.lgw_gen__) {
	gw_color__(icolor);
    }
    if (pl_psl__1.lps_gen__) {
	ps_color__(icolor);
    }
    return 0;
} /* set_color__ */

/* Subroutine */ int set_scl__(real *xscale, real *yscale)
{
/* ...Sets user's plotting scale factors to xscale,yscale */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_plotr__1.x_scale__ = *xscale;
    pl_plotr__1.y_scale__ = *yscale;
    return 0;
} /* set_scl__ */

/* Subroutine */ int putprim_(int *ityp, int *ival, real *xval, real *
	yval)
{
    /* System generated locals */
    int i__1;
    olist o__1;
    alist al__1;

    /* Builtin functions */
    int f_open(olist *), f_rew(alist *), s_wsue(cilist *), do_uio(int 
	    *, char *, ftnlen), e_wsue(void), s_wsle(cilist *), do_lio(
	    int *, int *, char *, ftnlen), e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int wr_array__(int *, int *, int *, 
	    int *, real *, real *);
    static int incore;

    /* Fortran I/O blocks */
    static cilist io___2 = { 0, 0, 0, 0, 0 };
    static cilist io___3 = { 0, 6, 0, 0, 0 };


/* ...Installs plot primitive in save arrays */
/*   If the save arrays fill, the arrays are dumped to a temporary logfile */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    if (pl_primi__1.n_prim__ == 0) {
	pl_primi__1.n_writ__ = 0;
	incore = 0;
    }

/* ...Don't put primitives if at end of arrays and logging has been disabled */
    if (pl_primi__1.n_prim__ > 100000 && ! pl_priml__1.lprim_open__) {
	return 0;
    }

/* ...Check number of primitives in in-core save arrays for full arrays */
    if (incore == 100000 && pl_primi__1.n_prim__ != 0) {

/* ...Primitives arrays are full, how about writing it out to logfile? */
	if (! pl_priml__1.lprim_open__) {
/* ...Open new dump file, or overwrite existing one */
	    o__1.oerr = 1;
	    o__1.ounit = pl_primi__1.nprim_unit__;
	    o__1.ofnmlen = 15;
	    o__1.ofnm = "xplot11_logfile";
	    o__1.orl = 0;
	    o__1.osta = "UNKNOWN";
	    o__1.oacc = 0;
	    o__1.ofm = "UNFORMATTED";
	    o__1.oblnk = 0;
	    i__1 = f_open(&o__1);
	    if (i__1 != 0) {
		goto L10;
	    }
	    al__1.aerr = 0;
	    al__1.aunit = pl_primi__1.nprim_unit__;
	    f_rew(&al__1);
	    pl_priml__1.lprim_open__ = TRUE_;
	    pl_primi__1.n_writ__ = 0;
	}

/* ...Append in-core save arrays to disk file */
/*    first  record is number of elements in this save block, */
/*    second record is int type and int value arrays, */
/*    third  record is x,y value arrays */
	io___2.ciunit = pl_primi__1.nprim_unit__;
	s_wsue(&io___2);
	do_uio(&c__1, (char *)&c_b10, (ftnlen)sizeof(integer));
	e_wsue();
	wr_array__(&pl_primi__1.nprim_unit__, &c_b10, pl_primi__1.i_typ__, 
		pl_primi__1.i_prim__, pl_primr__1.x_prim__, 
		pl_primr__1.y_prim__);
	pl_primi__1.n_writ__ += 100000;
/* ...incore index is rolled over to 0 and resumes counting up as index */
/*   in the save arrays */
	incore = 0;
    }

    ++pl_primi__1.n_prim__;
    ++incore;

    pl_primi__1.i_typ__[incore - 1] = *ityp;
    pl_primi__1.i_prim__[incore - 1] = *ival;
    pl_primr__1.x_prim__[incore - 1] = *xval;
    pl_primr__1.y_prim__[incore - 1] = *yval;

    return 0;

L10:
    s_wsle(&io___3);
    do_lio(&c__9, &c__1, "*** Open error on xplot11_logfile, logging disabled"
	    , (ftnlen)51);
    e_wsle();
/* ...This will disable future logging (see first statement above) */
    pl_primi__1.n_prim__ = 100001;
    return 0;
} /* putprim_ */

/* Subroutine */ int getprim_(int *icount, int *ityp, int *ival, 
	real *xval, real *yval)
{
    /* System generated locals */
    int i__1;
    alist al__1;

    /* Builtin functions */
    int s_wsue(cilist *), do_uio(int *, char *, ftnlen), e_wsue(void),
	     f_rew(alist *), s_rsue(cilist *), e_rsue(void), s_wsle(cilist *),
	     do_lio(int *, int *, char *, ftnlen), e_wsle(void);

    /* Local variables */
    extern /* Subroutine */ int rd_array__(int *, int *, int *, 
	    int *, real *, real *), wr_array__(int *, int *, 
	    int *, int *, real *, real *);
    static int imax, incore;

    /* Fortran I/O blocks */
    static cilist io___5 = { 0, 0, 0, 0, 0 };
    static cilist io___6 = { 1, 0, 0, 0, 0 };
    static cilist io___8 = { 1, 0, 0, 0, 0 };
    static cilist io___9 = { 0, 6, 0, 0, 0 };
    static cilist io___10 = { 0, 6, 0, 0, 0 };


/* ...Gets plot primitive from saved plot array or from log file */

/*   Input:  icount  int giving primitive count */
/*                   icount<=0 as input indicates restart on prims */
/*                             list, rewind external prim file, if used */
/*   Output:         icount is incremented each fetch until the prims */
/*                   list is exhausted, then icount is returned as -1 to */
/*                   signal that no more prims are available */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    if (*icount < 0) {
/* ...primitives-fetching is to be restarted from beginning */

	if (pl_priml__1.lprim_open__) {
	    if (pl_primi__1.n_writ__ < pl_primi__1.n_prim__) {
/* ...append rest of save arrays to disk, so arrays can be used as i/o buffers */
		imax = pl_primi__1.n_prim__ - pl_primi__1.n_writ__;
		io___5.ciunit = pl_primi__1.nprim_unit__;
		s_wsue(&io___5);
		do_uio(&c__1, (char *)&imax, (ftnlen)sizeof(integer));
		e_wsue();
		wr_array__(&pl_primi__1.nprim_unit__, &imax, 
			pl_primi__1.i_typ__, pl_primi__1.i_prim__, 
			pl_primr__1.x_prim__, pl_primr__1.y_prim__);
		pl_primi__1.n_writ__ += imax;
	    }
	    al__1.aerr = 0;
	    al__1.aunit = pl_primi__1.nprim_unit__;
	    f_rew(&al__1);
/* ...now read a buffer of stored prims */
	    io___6.ciunit = pl_primi__1.nprim_unit__;
	    i__1 = s_rsue(&io___6);
	    if (i__1 != 0) {
		goto L10;
	    }
	    i__1 = do_uio(&c__1, (char *)&imax, (ftnlen)sizeof(integer));
	    if (i__1 != 0) {
		goto L10;
	    }
	    i__1 = e_rsue();
	    if (i__1 != 0) {
		goto L10;
	    }
	    rd_array__(&pl_primi__1.nprim_unit__, &imax, pl_primi__1.i_typ__, 
		    pl_primi__1.i_prim__, pl_primr__1.x_prim__, 
		    pl_primr__1.y_prim__);
	} else {
/* ...No prim file used initialize incore to total # of prims */
	    imax = pl_primi__1.n_prim__;
	}
	pl_primi__1.n_incore__ = imax;
	incore = 0;
	*icount = 0;

    } else if (*icount == pl_primi__1.n_prim__) {
/* ...no more primitives are available */
	*icount = -1;
	return 0;
    }

/* ...Note:  icount  has the same meaning as N_PRIM in putprim */
/* ...       incore  has the same meaning as incore in putprim */

    if (incore == pl_primi__1.n_incore__ && *icount != 0) {
	if (pl_priml__1.lprim_open__) {
/* ...Read next chunk of primitives from file if opened */
	    io___8.ciunit = pl_primi__1.nprim_unit__;
	    i__1 = s_rsue(&io___8);
	    if (i__1 != 0) {
		goto L10;
	    }
	    i__1 = do_uio(&c__1, (char *)&imax, (ftnlen)sizeof(integer));
	    if (i__1 != 0) {
		goto L10;
	    }
	    i__1 = e_rsue();
	    if (i__1 != 0) {
		goto L10;
	    }
	    rd_array__(&pl_primi__1.nprim_unit__, &imax, pl_primi__1.i_typ__, 
		    pl_primi__1.i_prim__, pl_primr__1.x_prim__, 
		    pl_primr__1.y_prim__);
	    pl_primi__1.n_incore__ = imax;
	    incore = 0;
	} else {
/* ...Shouldn't get to here if all went OK. */
	    s_wsle(&io___9);
	    do_lio(&c__9, &c__1, "Xplot11: Cannot read log file.", (ftnlen)30)
		    ;
	    e_wsle();
	    *icount = -1;
	    return 0;
	}
    }

/* ...Set the values for returning */
    ++(*icount);
    ++incore;
    *ityp = pl_primi__1.i_typ__[incore - 1];
    *ival = pl_primi__1.i_prim__[incore - 1];
    *xval = pl_primr__1.x_prim__[incore - 1];
    *yval = pl_primr__1.y_prim__[incore - 1];

    return 0;

L10:
    s_wsle(&io___10);
    do_lio(&c__9, &c__1, "? Xplot11: Error on reading log file.", (ftnlen)37);
    e_wsle();
    return 0;
} /* getprim_ */

/* Subroutine */ int rd_array__(int *lunit, int *n, int *ityp, 
	int *iprim, real *xprim, real *yprim)
{
    /* System generated locals */
    int ityp_dim1, iprim_dim1, xprim_dim1, yprim_dim1, i__1, i__2, i__3;

    /* Builtin functions */
    int s_rsue(cilist *), do_uio(int *, char *, ftnlen), e_rsue(void),
	     s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Fortran I/O blocks */
    static cilist io___11 = { 1, 0, 0, 0, 0 };
    static cilist io___12 = { 1, 0, 0, 0, 0 };
    static cilist io___13 = { 0, 6, 0, 0, 0 };


/* --- Fast unformatted reading of 2 int and 2 real arrays from log file */
    /* Parameter adjustments */
    yprim_dim1 = *n;
    --yprim;
    xprim_dim1 = *n;
    --xprim;
    iprim_dim1 = *n;
    --iprim;
    ityp_dim1 = *n;
    --ityp;

    /* Function Body */
    io___11.ciunit = *lunit;
    i__1 = s_rsue(&io___11);
    if (i__1 != 0) {
	goto L10;
    }
    i__2 = 1 * ityp_dim1;
    i__1 = do_uio(&i__2, (char *)&ityp[1], (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L10;
    }
    i__3 = 1 * iprim_dim1;
    i__1 = do_uio(&i__3, (char *)&iprim[1], (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L10;
    }
    i__1 = e_rsue();
    if (i__1 != 0) {
	goto L10;
    }
    io___12.ciunit = *lunit;
    i__1 = s_rsue(&io___12);
    if (i__1 != 0) {
	goto L10;
    }
    i__2 = 1 * xprim_dim1;
    i__1 = do_uio(&i__2, (char *)&xprim[1], (ftnlen)sizeof(real));
    if (i__1 != 0) {
	goto L10;
    }
    i__3 = 1 * yprim_dim1;
    i__1 = do_uio(&i__3, (char *)&yprim[1], (ftnlen)sizeof(real));
    if (i__1 != 0) {
	goto L10;
    }
    i__1 = e_rsue();
    if (i__1 != 0) {
	goto L10;
    }
    goto L20;
L10:
    s_wsle(&io___13);
    do_lio(&c__9, &c__1, "? Xplot11: Error on reading log file.", (ftnlen)37);
    e_wsle();
L20:
    return 0;
} /* rd_array__ */

/* Subroutine */ int wr_array__(int *lunit, int *n, int *ityp, 
	int *iprim, real *xprim, real *yprim)
{
    /* System generated locals */
    int ityp_dim1, iprim_dim1, xprim_dim1, yprim_dim1, i__1, i__2;

    /* Builtin functions */
    int s_wsue(cilist *), do_uio(int *, char *, ftnlen), e_wsue(void);

    /* Fortran I/O blocks */
    static cilist io___14 = { 0, 0, 0, 0, 0 };
    static cilist io___15 = { 0, 0, 0, 0, 0 };


/* --- Fast unformatted writing of 2 int and 2 real arrays to log file */
    /* Parameter adjustments */
    yprim_dim1 = *n;
    --yprim;
    xprim_dim1 = *n;
    --xprim;
    iprim_dim1 = *n;
    --iprim;
    ityp_dim1 = *n;
    --ityp;

    /* Function Body */
    io___14.ciunit = *lunit;
    s_wsue(&io___14);
    i__1 = 1 * ityp_dim1;
    do_uio(&i__1, (char *)&ityp[1], (ftnlen)sizeof(integer));
    i__2 = 1 * iprim_dim1;
    do_uio(&i__2, (char *)&iprim[1], (ftnlen)sizeof(integer));
    e_wsue();
    io___15.ciunit = *lunit;
    s_wsue(&io___15);
    i__1 = 1 * xprim_dim1;
    do_uio(&i__1, (char *)&xprim[1], (ftnlen)sizeof(real));
    i__2 = 1 * yprim_dim1;
    do_uio(&i__2, (char *)&yprim[1], (ftnlen)sizeof(real));
    e_wsue();
    return 0;
} /* wr_array__ */

/* Subroutine */ int set_clip__(real *xmin, real *ymin, real *xmax, real *
	ymax)
{

/* ... clip to at least window limits */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    pl_plotr__1.clp_xmin__ = dmax(*xmin,0.f);
    pl_plotr__1.clp_ymin__ = dmax(*ymin,0.f);
    pl_plotr__1.clp_xmax__ = dmin(*xmax,pl_plotr__1.x_page__);
    pl_plotr__1.clp_ymax__ = dmin(*ymax,pl_plotr__1.y_page__);

    return 0;
} /* set_clip__ */

/* Subroutine */ int plot_1__(real *x, real *y, int *icode)
{
    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    static logical lcode_ok__;
    extern /* Subroutine */ int set_color__(int *);
    static real x1, y1, x2, y2, xx1, xx2, yy1, yy2;
    static int ivis, icabs;
    extern /* Subroutine */ int clip_ls__(real *, real *, real *, real *, 
	    int *), gw_line__(real *, real *, real *, real *), ps_line__(
	    real *, real *, real *, real *), set_pen__(int *), set_pat__(
	    int *);

    /* Fortran I/O blocks */
    static cilist io___18 = { 0, 6, 0, 0, 0 };
    static cilist io___19 = { 0, 6, 0, 0, 0 };


/* ...Processing routine for internal plotting calls, absolute coordinates */

/*    X,Y    absolute coordinates */
/*    icode  function code (integer) */

/*          3   move to X,Y (move in absolute coordinates) */
/*          2   line to X,Y (line in absolute coordinates) */

/*         -2   line to X,Y (line and re-origin in absolute coordinates) */
/*         -3   move to X,Y (move and re-origin in absolute coordinates) */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

    icabs = abs(*icode);
    lcode_ok__ = icabs == 2 || icabs == 3;

    if (! lcode_ok__) {
	s_wsle(&io___18);
	do_lio(&c__9, &c__1, "PLOTABS_1: unknown function code ", (ftnlen)33);
	do_lio(&c__3, &c__1, (char *)&(*icode), (ftnlen)sizeof(integer));
	e_wsle();
	s_wsle(&io___19);
	do_lio(&c__9, &c__1, "       at point X,Y =", (ftnlen)21);
	do_lio(&c__4, &c__1, (char *)&(*x), (ftnlen)sizeof(real));
	do_lio(&c__4, &c__1, (char *)&(*y), (ftnlen)sizeof(real));
	e_wsle();
	return 0;
    }

/* ...use absolute coordinates to call device plotting */
    x1 = pl_plotr__1.x_lst__;
    y1 = pl_plotr__1.y_lst__;
    x2 = *x;
    y2 = *y;

    if (icabs == 2) {
/* ...make copy of vector for zoomed clipping */
	xx1 = x1;
	yy1 = y1;
	xx2 = x2;
	yy2 = y2;
/* ...clip vector to user plot limits (CLP_XMIN,CLP_XMAX,CLP_YMIN,CLP_YMAX) */
	clip_ls__(&xx1, &yy1, &xx2, &yy2, &ivis);

	if (ivis != 0) {
/* ...check for change in pen, line pattern or color */
	    if (pl_ploti__1.i_pen__ != pl_ploti__1.lst_pen__) {
		set_pen__(&pl_ploti__1.i_pen__);
	    }
	    if (pl_ploti__1.i_pat__ != pl_ploti__1.lst_pat__) {
		set_pat__(&pl_ploti__1.i_pat__);
	    }
	    if (pl_ploti__1.i_clr__ != pl_ploti__1.lst_clr__) {
		set_color__(&pl_ploti__1.i_clr__);
	    }

/* ...plot line segment in page coordinates */
	    if (pl_xwinl__1.lgw_gen__) {
		gw_line__(&xx1, &yy1, &xx2, &yy2);
	    }
	    if (pl_psl__1.lps_gen__) {
		ps_line__(&xx1, &yy1, &xx2, &yy2);
	    }
	}
    }

/* ...passed-in endpoint (absolute coordinates) now becomes "last" location */
    pl_plotr__1.x_lst__ = x2;
    pl_plotr__1.y_lst__ = y2;

    if (*icode < 0) {
/* ...re-origin */
	pl_plotr__1.x_org__ = x2;
	pl_plotr__1.y_org__ = y2;
    }

    return 0;
} /* plot_1__ */

/* Subroutine */ int clip_ls__(real *x1, real *y1, real *x2, real *y2, 
	int *ivis)
{
    /* System generated locals */
    real r__1;

    /* Local variables */
    extern doublereal x_abs2zm__(real *), y_abs2zm__(real *);
    extern int iclip_1__(real *, real *, real *, real *, real *, real *);
    static real clpxmin, clpymin, clpxmax, clpymax;

/* ...Clips line segment against the clip window defined by */
/*     CLP_XMIN,CLP_XMAX,CLP_YMIN,CLP_YMAX returning visibility flag ivis. */
/*      ivis=0 for no visible line segment */
/*      ivis=1 for a  visible line segment */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

/* ... clip to zoomed clipping window or page limits */
/* Computing MAX */
    r__1 = x_abs2zm__(&pl_plotr__1.clp_xmin__);
    clpxmin = dmax(r__1,0.f);
/* Computing MAX */
    r__1 = y_abs2zm__(&pl_plotr__1.clp_ymin__);
    clpymin = dmax(r__1,0.f);
/* Computing MIN */
    r__1 = x_abs2zm__(&pl_plotr__1.clp_xmax__);
    clpxmax = dmin(r__1,pl_plotr__1.x_page__);
/* Computing MIN */
    r__1 = y_abs2zm__(&pl_plotr__1.clp_ymax__);
    clpymax = dmin(r__1,pl_plotr__1.y_page__);

/* ... zoomed coordinates for clipping */
    *x1 = x_abs2zm__(x1);
    *y1 = y_abs2zm__(y1);
    *x2 = x_abs2zm__(x2);
    *y2 = y_abs2zm__(y2);

    *ivis = 0;
    if (iclip_1__(x1, y1, x2, y2, &clpxmin, &c_b49) == 0) {
	return 0;
    }
    if (iclip_1__(y1, x1, y2, x2, &clpymin, &c_b49) == 0) {
	return 0;
    }
    if (iclip_1__(x1, y1, x2, y2, &clpxmax, &c_b51) == 0) {
	return 0;
    }
    if (iclip_1__(y1, x1, y2, x2, &clpymax, &c_b51) == 0) {
	return 0;
    }
    *ivis = 1;
    return 0;
} /* clip_ls__ */

int iclip_1__(real *x1, real *y1, real *x2, real *y2, real *xlim, real *
	dir)
{
    /* System generated locals */
    int ret_val;

    /* Local variables */
    static real d1, d2, d12, dy;

/* ...Basic line clipping, clips line segment against line x=xlim */
/*   with visible side determined by dir (+1. or -1.) */
/*     dir=+1.  x>xlim is visible */
/*     dir=-1   x<xlim is visible */

    ret_val = 0;
    d1 = *dir * (*x1 - *xlim);
    d2 = *dir * (*x2 - *xlim);
    if (d1 == 0.f && d2 == 0.f) {
	return ret_val;
    }

    if (d1 >= 0.f || d2 >= 0.f) {
	ret_val = 1;
	if (d1 * d2 <= 0.f) {
	    dy = *y2 - *y1;
	    d12 = d1 - d2;
	    if (d1 < 0.f) {
		*x1 = *xlim;
		*y1 += dy * d1 / d12;
	    }
	    if (d2 < 0.f) {
		*x2 = *xlim;
		*y2 += dy * d2 / d12;
	    }
	}
    }
    return ret_val;
} /* iclip_1__ */

/* Subroutine */ int polyline_1__(real *x, real *y, int *n, int *
	ifill)
{
    /* System generated locals */
    int i__1;
    real r__1;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);

    /* Local variables */
    extern doublereal x_abs2zm__(real *), y_abs2zm__(real *);
    static int i__;
    extern /* Subroutine */ int set_color__(int *), clip_poly0__(real *, 
	    real *, int *, real *, real *, int *, real *, real *, 
	    int *);
    static int nz;
    static real xz[501], yz[501];
    extern /* Subroutine */ int gw_polyline__(real *, real *, int *, 
	    int *), ps_polyline__(real *, real *, int *, int *);
    static int nclp;
    static real xclp[5], yclp[5];
    static int nout;
    static real xout[501], yout[501];
    extern /* Subroutine */ int plot_1__(real *, real *, int *);
    static real xbbmin, ybbmin, xbbmax, ybbmax;
    extern /* Subroutine */ int set_pen__(int *), set_pat__(int *);
    static real clpxmin, clpymin, clpxmax, clpymax;

    /* Fortran I/O blocks */
    static cilist io___38 = { 0, 6, 0, 0, 0 };


/* ...Processing routine for polyline calls, inputs in absolute coordinates */
/*    X,Y    coordinate arrays in absolute units */
/*    n      number of x,y points */
/*    ifill  fill flag, 0 for no fill, 1 for filled polygon */

/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */

/* ...For unfilled polyline treat this as a set of standard line segments */
/*   This avoids putting an unfilled polyline into the more complex filled */
/*   polyline clipper. */
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*ifill <= 0) {
	if (*n > 1) {
	    plot_1__(&x[1], &y[1], &c__3);
	    i__1 = *n;
	    for (i__ = 2; i__ <= i__1; ++i__) {
		plot_1__(&x[i__], &y[i__], &c__2);
	    }
	}
	return 0;
    }

    if (*n > 501) {
	s_wsle(&io___38);
	do_lio(&c__9, &c__1, "polyline_1: array overflow.  Increase MaxPolyl"
		"ine.", (ftnlen)50);
	e_wsle();
	return 0;
    }

    if (*n <= 1) {
	return 0;
    }

/* ...save last point for next draw command, just in case */
    pl_plotr__1.x_lst__ = x[*n];
    pl_plotr__1.y_lst__ = y[*n];

/* ...convert to absolute, zoomed coordinates, check for bounding box */
    xz[0] = x_abs2zm__(&x[1]);
    yz[0] = y_abs2zm__(&y[1]);
    xbbmin = xz[0];
    ybbmin = yz[0];
    xbbmax = xbbmin;
    ybbmax = ybbmin;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	xz[i__ - 1] = x_abs2zm__(&x[i__]);
	yz[i__ - 1] = y_abs2zm__(&y[i__]);
	if (xz[i__ - 1] < xbbmin) {
	    xbbmin = xz[i__ - 1];
	}
	if (yz[i__ - 1] < ybbmin) {
	    ybbmin = yz[i__ - 1];
	}
	if (xz[i__ - 1] > xbbmax) {
	    xbbmax = xz[i__ - 1];
	}
	if (yz[i__ - 1] > ybbmax) {
	    ybbmax = yz[i__ - 1];
	}
    }
    nz = *n;

/* ...Clip to zoomed clipping window or page limits */
/* Computing MAX */
    r__1 = x_abs2zm__(&pl_plotr__1.clp_xmin__);
    clpxmin = dmax(r__1,0.f);
/* Computing MAX */
    r__1 = y_abs2zm__(&pl_plotr__1.clp_ymin__);
    clpymin = dmax(r__1,0.f);
/* Computing MIN */
    r__1 = x_abs2zm__(&pl_plotr__1.clp_xmax__);
    clpxmax = dmin(r__1,pl_plotr__1.x_page__);
/* Computing MIN */
    r__1 = y_abs2zm__(&pl_plotr__1.clp_ymax__);
    clpymax = dmin(r__1,pl_plotr__1.y_page__);

/* ...Check for polygon outside clipping window, skip plotting */
    if (xbbmin > clpxmax || xbbmax < clpxmin || ybbmin > clpymax || ybbmax < 
	    clpymin) {
	return 0;
    }

/* ...Is polygon fully inside clipping window? */
    if (xbbmax > clpxmax || xbbmin < clpxmin || xbbmax > clpymax || ybbmin < 
	    clpymin) {

/* ...If polygon is not fully inside clipping window, clip it. */
/*   Get window vertices of clipping window assembled as a polygon, */
/*   these must be in clockwise order to clip inside the window */
	xclp[0] = clpxmin;
	yclp[0] = clpymin;
	xclp[1] = clpxmin;
	yclp[1] = clpymax;
	xclp[2] = clpxmax;
	yclp[2] = clpymax;
	xclp[3] = clpxmax;
	yclp[3] = clpymin;
	xclp[4] = clpxmin;
	yclp[4] = clpymin;
	nclp = 5;
/* ...use special clipping for polylines that returns a clipped polyline */
	clip_poly0__(xz, yz, &nz, xclp, yclp, &nclp, xout, yout, &nout);

/* ...Or if fully inside clip box, just plot the polyline as it is.. */
    } else {
	i__1 = nz;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    xout[i__ - 1] = xz[i__ - 1];
	    yout[i__ - 1] = yz[i__ - 1];
	}
	nout = nz;
    }

    if (nout > 1) {
/* ...check for change in pen, line pattern or color */
	if (pl_ploti__1.i_pen__ != pl_ploti__1.lst_pen__) {
	    set_pen__(&pl_ploti__1.i_pen__);
	}
	if (pl_ploti__1.i_pat__ != pl_ploti__1.lst_pat__) {
	    set_pat__(&pl_ploti__1.i_pat__);
	}
	if (pl_ploti__1.i_clr__ != pl_ploti__1.lst_clr__) {
	    set_color__(&pl_ploti__1.i_clr__);
	}
/* ...plot polyline in page coordinates */
	if (pl_xwinl__1.lgw_gen__) {
	    gw_polyline__(xout, yout, &nout, ifill);
	}
	if (pl_psl__1.lps_gen__) {
	    ps_polyline__(xout, yout, &nout, ifill);
	}
    }
    return 0;
} /* polyline_1__ */

/* Subroutine */ int clip_poly0__(real *xp, real *yp, int *np, real *xclp,
	 real *yclp, int *nclp, real *xout, real *yout, int *nout)
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    static int n;
    static real x, y;
    extern /* Subroutine */ int clip_poly1__(real *, real *, int *, real *
	    , real *, int *, real *, real *, int *, real *, real *, 
	    real *, real *, int *, int *);
    static int ivis[5], nlvl;
    static real xlst[5], ylst[5];
    static int ilast;
    static real xfrst[5], yfrst[5];

/* ...Clips polyline xx,yy,nn against the clip window defined by */
/*   xclp,yclp,nclp with output clipped polyline in xout,yout,nout */

/*   Clipping algorithm is a Sutherland-Hodgman clipper, implemented here */
/*   as a recursive (in Fortran!!) routine that clips each vertex in order */
/*   against each of the window edges. */


    /* Parameter adjustments */
    --yp;
    --xp;
    --yclp;
    --xclp;
    --yout;
    --xout;

    /* Function Body */
    i__1 = *nclp;
    for (n = 1; n <= i__1; ++n) {
	ivis[n - 1] = -1;
    }
    *nout = 0;
    nlvl = 0;
    ilast = 0;

/* --- Feed the polyline points through the clipper point by point */
    i__1 = *np;
    for (n = 1; n <= i__1; ++n) {
	x = xp[n];
	y = yp[n];
	clip_poly1__(&x, &y, &ilast, &xclp[1], &yclp[1], nclp, &xout[1], &
		yout[1], nout, xfrst, yfrst, xlst, ylst, ivis, &nlvl);
    }
/* ... Now do finish the clipping with a final call with last flag set */
    ilast = 1;
    clip_poly1__(&x, &y, &ilast, &xclp[1], &yclp[1], nclp, &xout[1], &yout[1],
	     nout, xfrst, yfrst, xlst, ylst, ivis, &nlvl);

    return 0;
} /* clip_poly0__ */

/* Subroutine */ int clip_poly1__(real *x, real *y, int *ilast, real *
	xclp, real *yclp, int *nclp, real *xout, real *yout, int *
	nout, real *xfrst, real *yfrst, real *xlst, real *ylst, int *ivis,
	 int *nlvl)
{
    static real d1, d2, x1, y1;
    extern /* Subroutine */ int clip_poly2__(real *, real *, int *, real *
	    , real *, int *, real *, real *, int *, real *, real *, 
	    real *, real *, int *, int *);
    static real dx, dy, frac, xint, yint;
    static int ivisp;
    static logical intsct;

/* ...Clipping routine for polylines clipped by polyline xclp,yclp,nclp */
/*   This routine is a recursive (via a faked-out call of clip_poly2) */


/* ... Check for end of clipping process (ilast>0) */
    /* Parameter adjustments */
    --yclp;
    --xclp;
    --yout;
    --xout;
    --xfrst;
    --yfrst;
    --xlst;
    --ylst;
    --ivis;

    /* Function Body */
    if (*nlvl >= *nclp - 1) {
	if (*ilast <= 0) {
	    ++(*nout);
	    xout[*nout] = *x;
	    yout[*nout] = *y;
/*          write(*,*) 'out ',nout,x,y */
	}
	return 0;
    }
/* ... Set clipping edge (same as recursion depth) */
    ++(*nlvl);

/* ... Check for closing flag (ilast=1) */
/*    Use first point as last vertex */
    if (*ilast > 0) {
	*x = xfrst[*nlvl];
	*y = yfrst[*nlvl];
    }

/* ... Check point visibility */
    x1 = xclp[*nlvl];
    y1 = yclp[*nlvl];
    dx = xclp[*nlvl + 1] - x1;
    dy = yclp[*nlvl + 1] - y1;
    d2 = dy * (*x - x1) - dx * (*y - y1);
    ivisp = 0;
    if (d2 > 0.f) {
	ivisp = 1;
    }

/* ... Check for intersection, save first point in this level if ivis=-1 */
    intsct = FALSE_;
    if (ivis[*nlvl] < 0) {
	xfrst[*nlvl] = *x;
	yfrst[*nlvl] = *y;
	goto L20;
    }
    if (ivisp + ivis[*nlvl] == 1) {
	d1 = dy * (xlst[*nlvl] - x1) - dx * (ylst[*nlvl] - y1);
	if (d1 - d2 != 0.f) {
	    intsct = TRUE_;
	    frac = d1 / (d1 - d2);
	    xint = xlst[*nlvl] + frac * (*x - xlst[*nlvl]);
	    yint = ylst[*nlvl] + frac * (*y - ylst[*nlvl]);
	}
    }

/* ... Save point for next call to this level */
/*    If the close level flag is set (ilast=1) save it in ivis */
L20:
    xlst[*nlvl] = *x;
    ylst[*nlvl] = *y;
    ivis[*nlvl] = ivisp;
    if (*ilast == 1) {
	ivis[*nlvl] = 2;
    }

/* ... Recurse to next level with intersection... */
    if (intsct) {
	*ilast = 0;
	*x = xint;
	*y = yint;
	clip_poly2__(x, y, ilast, &xclp[1], &yclp[1], nclp, &xout[1], &yout[1]
		, nout, &xfrst[1], &yfrst[1], &xlst[1], &ylst[1], &ivis[1], 
		nlvl);
    }

/* ... Call next level with vertex (if visible) or to close next level */
    if (ivis[*nlvl] >= 1) {
	*x = xlst[*nlvl];
	*y = ylst[*nlvl];
	if (ivis[*nlvl] == 2) {
	    *ilast = 1;
	}
	clip_poly2__(x, y, ilast, &xclp[1], &yclp[1], nclp, &xout[1], &yout[1]
		, nout, &xfrst[1], &yfrst[1], &xlst[1], &ylst[1], &ivis[1], 
		nlvl);
    }

    --(*nlvl);
    return 0;
} /* clip_poly1__ */

/* Subroutine */ int clip_poly2__(real *x, real *y, int *ilast, real *
	xclp, real *yclp, int *nclp, real *xout, real *yout, int *
	nout, real *xfrst, real *yfrst, real *xlst, real *ylst, int *ivis,
	 int *nlvl)
{
    extern /* Subroutine */ int clip_poly1__(real *, real *, int *, real *
	    , real *, int *, real *, real *, int *, real *, real *, 
	    real *, real *, int *, int *);

/* ...Dummy calling routine to allow recursion of clip_poly1 */

    /* Parameter adjustments */
    --yclp;
    --xclp;
    --yout;
    --xout;
    --xfrst;
    --yfrst;
    --xlst;
    --ylst;
    --ivis;

    /* Function Body */
    clip_poly1__(x, y, ilast, &xclp[1], &yclp[1], nclp, &xout[1], &yout[1], 
	    nout, &xfrst[1], &yfrst[1], &xlst[1], &ylst[1], &ivis[1], nlvl);
    return 0;
} /* clip_poly2__ */

/* Subroutine */ int set_zoom__(real *xoff_zoom__, real *yoff_zoom__, real *
	xfac_zoom__, real *yfac_zoom__, logical *lsame, logical *lcurs)
{
    /* Format strings */
    static char fmt_110[] = "(\002 Pt \002,a,2x,\002usr x,y\002,2(2x,f11.6),"
	    "3x,\002abs X,Y\002,2(2x,f11.6))";
    static char fmt_100[] = "(a)";

    /* System generated locals */
    int i__1;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), e_wsle(void), do_lio(int *, int *, char 
	    *, ftnlen), s_wsfe(cilist *), do_fio(int *, char *, ftnlen), 
	    e_wsfe(void), s_rsfe(cilist *), e_rsfe(void), s_cmp(char *, char *
	    , ftnlen, ftnlen), s_rsli(icilist *), e_rsli(void);

    /* Local variables */
    extern doublereal x_abs2zm__(real *), y_abs2zm__(real *), xabs2usr_(real *
	    ), yabs2usr_(real *), xusr2abs_(real *), yusr2abs_(real *);
    static int icolsave;
    extern /* Subroutine */ int gw_color__(int *), gw_flush__(void);
    static real x1, y1, x2, y2, xz, yz;
    extern /* Subroutine */ int getwinsize_(real *, real *);
    static real fac;
    static int icol;
    static char line[80];
    static real xdif, ydif, xabs1, yabs1, xabs2, yabs2;
    static char chkey[1];
    static real xsize, ysize;
    extern /* Subroutine */ int getcolorindex_(int *), getcursorxyabs_(
	    real *, real *, char *, ftnlen), gw_line__(real *, real *, real *,
	     real *);

    /* Fortran I/O blocks */
    static cilist io___81 = { 0, 6, 0, 0, 0 };
    static cilist io___82 = { 0, 6, 0, 0, 0 };
    static cilist io___83 = { 0, 6, 0, 0, 0 };
    static cilist io___84 = { 0, 6, 0, 0, 0 };
    static cilist io___85 = { 0, 6, 0, 0, 0 };
    static cilist io___86 = { 0, 6, 0, 0, 0 };
    static cilist io___87 = { 0, 6, 0, 0, 0 };
    static cilist io___91 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___92 = { 0, 6, 0, 0, 0 };
    static cilist io___93 = { 0, 5, 1, fmt_100, 0 };
    static icilist io___95 = { 1, line, 0, 0, 80, 1 };
    static icilist io___98 = { 1, line+3, 0, 0, 77, 1 };
    static cilist io___103 = { 0, 6, 0, fmt_110, 0 };
    static cilist io___104 = { 0, 6, 0, 0, 0 };
    static cilist io___105 = { 0, 5, 1, fmt_100, 0 };
    static icilist io___106 = { 1, line, 0, 0, 80, 1 };
    static icilist io___109 = { 1, line+3, 0, 0, 77, 1 };


/* --------------------------------------------------------------- */
/*     Sets new zoom parameters from cursor or keyboard input. */

/*     Input/   XOFF_ZOOM  zoom offsets */
/*     output:  YOFF_ZOOM */
/*              XFAC_ZOOM  zoom scaling factors */
/*              YFAC_ZOOM */

/*     Input:   LSAME   T if new zoom factors (XFAC,YFAC) must be the same */
/*              LSAME   F if new zoom factor XFAC can be different than YFAC */
/*              LCURS   T if input for zoom box comes from graphics input */
/*              LCURS   F if input for zoom box comes from keyboard */
/* --------------------------------------------------------------- */

    getwinsize_(&xsize, &ysize);
    getcolorindex_(&icolsave);
/* --- Set zoom lines in default foreground color (black) */
    icol = 1;

    s_wsle(&io___81);
    e_wsle();
    if (*lcurs) {
	s_wsle(&io___82);
	do_lio(&c__9, &c__1, "Mark off corners of blowup area", (ftnlen)31);
	e_wsle();
	s_wsle(&io___83);
	do_lio(&c__9, &c__1, "(2 identical points default to current area)", (
		ftnlen)44);
	e_wsle();
    } else {
	s_wsle(&io___84);
	do_lio(&c__9, &c__1, "Enter x,y  coordinates of blowup area corners", 
		(ftnlen)45);
	e_wsle();
	s_wsle(&io___85);
	do_lio(&c__9, &c__1, "(2 identical points default to current area)", (
		ftnlen)44);
	e_wsle();
	s_wsle(&io___86);
	do_lio(&c__9, &c__1, "(default is     user coords, use input \"x y\")"
		, (ftnlen)45);
	e_wsle();
	s_wsle(&io___87);
	do_lio(&c__9, &c__1, "(to specify absolute coords, use input \"abs x"
		" y\")", (ftnlen)49);
	e_wsle();
    }

/* ...Get first point */
    if (*lcurs) {
	getcursorxyabs_(&xabs1, &yabs1, chkey, (ftnlen)1);
	s_wsfe(&io___91);
	do_fio(&c__1, "1", (ftnlen)1);
	r__1 = xabs2usr_(&xabs1);
	do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	r__2 = yabs2usr_(&yabs1);
	do_fio(&c__1, (char *)&r__2, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&xabs1, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&yabs1, (ftnlen)sizeof(real));
	e_wsfe();
    } else {
L1:
	s_wsle(&io___92);
	do_lio(&c__9, &c__1, "point 1: ", (ftnlen)9);
	e_wsle();
	i__1 = s_rsfe(&io___93);
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = do_fio(&c__1, line, (ftnlen)80);
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = e_rsfe();
	if (i__1 != 0) {
	    goto L1;
	}
	if (s_cmp(line, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    xabs1 = 0.f;
	    yabs1 = 0.f;
	} else if (s_cmp(line, "abs", (ftnlen)3, (ftnlen)3) != 0 && s_cmp(
		line, "ABS", (ftnlen)3, (ftnlen)3) != 0) {
	    i__1 = s_rsli(&io___95);
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&x1, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&y1, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L1;
	    }
	    xabs1 = xusr2abs_(&x1);
	    yabs1 = yusr2abs_(&y1);
	} else {
	    i__1 = s_rsli(&io___98);
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&xabs1, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&yabs1, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L1;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L1;
	    }
	}
    }
    xz = x_abs2zm__(&xabs1);
    yz = y_abs2zm__(&yabs1);
/* ... Use direct plotting calls to Xwindow to put crosshairs on screen */
    gw_color__(&icol);
    gw_line__(&xz, &c_b109, &xz, &ysize);
    gw_line__(&c_b109, &yz, &xsize, &yz);
    gw_flush__();

/* ...Get second point */
    if (*lcurs) {
	getcursorxyabs_(&xabs2, &yabs2, chkey, (ftnlen)1);
	s_wsfe(&io___103);
	do_fio(&c__1, "2", (ftnlen)1);
	r__1 = xabs2usr_(&xabs2);
	do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	r__2 = yabs2usr_(&yabs2);
	do_fio(&c__1, (char *)&r__2, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&xabs2, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&yabs2, (ftnlen)sizeof(real));
	e_wsfe();
    } else {
L2:
	s_wsle(&io___104);
	do_lio(&c__9, &c__1, "point 2: ", (ftnlen)9);
	e_wsle();
	i__1 = s_rsfe(&io___105);
	if (i__1 != 0) {
	    goto L2;
	}
	i__1 = do_fio(&c__1, line, (ftnlen)80);
	if (i__1 != 0) {
	    goto L2;
	}
	i__1 = e_rsfe();
	if (i__1 != 0) {
	    goto L2;
	}
	if (s_cmp(line, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    xabs2 = 0.f;
	    yabs2 = 0.f;
	} else if (s_cmp(line, "abs", (ftnlen)3, (ftnlen)3) != 0 && s_cmp(
		line, "ABS", (ftnlen)3, (ftnlen)3) != 0) {
	    i__1 = s_rsli(&io___106);
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&x2, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&y2, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L2;
	    }
	    xabs2 = xusr2abs_(&x2);
	    yabs2 = yusr2abs_(&y2);
	} else {
	    i__1 = s_rsli(&io___109);
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&xabs2, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&yabs2, (ftnlen)sizeof(real));
	    if (i__1 != 0) {
		goto L2;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L2;
	    }
	}
    }
    xz = x_abs2zm__(&xabs2);
    yz = y_abs2zm__(&yabs2);
/* ... Use direct plotting calls to Xwindow to put crosshairs on screen */
    gw_line__(&xz, &c_b109, &xz, &ysize);
    gw_line__(&c_b109, &yz, &xsize, &yz);
    gw_flush__();
    gw_color__(&icolsave);


/* ... Skip zooming stuff if points are the same */
    if (xabs1 == xabs2 && yabs1 == yabs2) {
	return 0;
    }

    xdif = (r__1 = xabs2 - xabs1, dabs(r__1));
    ydif = (r__1 = yabs2 - yabs1, dabs(r__1));
    if (xdif == 0.f) {
	xdif = xsize * 1e-4f;
    }
    if (ydif == 0.f) {
	ydif = ysize * 1e-4f;
    }

    *xoff_zoom__ = -dmin(xabs1,xabs2);
    *yoff_zoom__ = -dmin(yabs1,yabs2);
    *xfac_zoom__ = xsize / xdif;
    *yfac_zoom__ = ysize / ydif;

    if (*lsame) {
/* ... set equal x,y zoom factors */
	fac = dmin(*xfac_zoom__,*yfac_zoom__);
	*xfac_zoom__ = fac;
	*yfac_zoom__ = fac;

/* ... re-center the zoom region */
	*xoff_zoom__ += (xsize / fac - xdif) * .5f;
	*yoff_zoom__ += (ysize / fac - ydif) * .5f;
    }

    return 0;
} /* set_zoom__ */

/* ***Zoom transformation functions - to and from absolute<->zoomed */
doublereal x_abs2zm__(real *x)
{
    /* System generated locals */
    real ret_val;

/* ...Converts absolute X to zoomed X' */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ret_val = pl_plotr__1.xfac_zoom__ * (*x + pl_plotr__1.xoff_zoom__);
    return ret_val;
} /* x_abs2zm__ */

doublereal y_abs2zm__(real *y)
{
    /* System generated locals */
    real ret_val;

/* ...Converts absolute Y to zoomed Y' */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ret_val = pl_plotr__1.yfac_zoom__ * (*y + pl_plotr__1.yoff_zoom__);
    return ret_val;
} /* y_abs2zm__ */

doublereal x_zm2abs__(real *x)
{
    /* System generated locals */
    real ret_val;

/* ...Converts zoomed X' to absolute X */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ret_val = *x / pl_plotr__1.xfac_zoom__ - pl_plotr__1.xoff_zoom__;
    return ret_val;
} /* x_zm2abs__ */

doublereal y_zm2abs__(real *y)
{
    /* System generated locals */
    real ret_val;

/* ...Converts zoomed Y' to absolute Y */
/* *********************************************************************** */
/*    Module:  pltlib.inc */

/*    Copyright (C) 1996 Harold Youngren, Mark Drela */

/*    This library is free software; you can redistribute it and/or */
/*    modify it under the terms of the GNU Library General Public */
/*    License as published by the Free Software Foundation; either */
/*    version 2 of the License, or (at your option) any later version. */

/*    This library is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU */
/*    Library General Public License for more details. */

/*    You should have received a copy of the GNU Library General Public */
/*    License along with this library; if not, write to the Free */
/*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

/*    Report problems to:    guppy@maine.com */
/*                        or drela@mit.edu */
/* *********************************************************************** */


/* ******************************* */
/* --- Global data for Xplot11 */
/*     Version 4.46 11/28/01 */
/* ******************************* */



/* ---Set paper size here */
/* c      parameter (DEFAULT_PAGEHEIGHT     = 11.65,  ! A4 European */
/* c     &           DEFAULT_PAGEWIDTH      =  8.25, */
/* c     &           DEFAULT_SCREENFRACTION =  0.67) */








/* ...Common storing current plot primitives */

/* ...Global data for plotting, clipping, etc. */

/* ...Global data for color definition */

/* ...Global data for X-window output */

/* ...Global data for PostScript output */

/*   LPRIM_OPEN         T if primitives file is open */
/*   NPRIM_UNIT         Fortran logical unit for primitives file (unit# 0) */
/*   N_PRIM             Number of accumulated primitives */
/*   N_WRIT             Number of primitives written to logfile */
/*   N_INCORE           Number of primitives in buffer array */
/*   I_TYP(.)           type-of-primitive index */
/*   I_PRIM(.)          primitive data */
/*   X_PRIM(.)              " */
/*   Y_PRIM(.)              " */

/*   I_DEV              "Device" index, specifies X-graphics, PostScript output */
/*   I_PAGETYPE        = Page_Landscape or Page_Portrait */
/*   I_PEN, LST_PEN      current and previous pen thickness */
/*   I_PAT, LST_PAT      current and previous pen pattern */
/*   I_CLR, LST_CLR      current and previous color */

/*   X_SCALE,Y_SCALE     absolute-unit/user-unit scale factors */
/*   X_ORG, Y_ORG        user x,y-axis origin in absolute coordinates */
/*   X_LST, Y_LST        last pen location  in absolute coordinates */

/*   X_PAGE, Y_PAGE      plot page size in absolute units (typ. 11.0"x8.5") */
/*   X_WIND, Y_WIND      X-window size in absolute units */
/*                         (will not exceed X_PAGE,Y_PAGE upon window resizing) */

/*   CLP_XMIN, CLP_XMAX  user-specified clipping limits */
/*   CLP_YMIN, CLP_YMAX  (in absolute coordinates) */

/*   XOFF_ZOOM           zoom offsets */
/*   YOFF_ZOOM */
/*   XFAC_ZOOM           zoom scaling factors */
/*   YFAC_ZOOM */

/*   N_COLOR             total number of defined colors        1..i..N_COLORS */
/*   N_SPECTRUM          number of defined colors in Spectrum  0..s..N_SPECTRUM */
/*   IFIRST_SPECTRUM     gives index i of first Spectrum color */
/*   COLOR_RGB(i)        rgb color index */
/*   COLOR_NAME(i)       color name string */

/*   LGW_GEN             T if X-window graphics are to be generated */
/*   LGW_OPEN            T is X-window is currently open */
/*   LGW_COLOR           T if X-window has color capability */
/*   LGW_RESIZE          T if X-window is to be resized */
/*   LGW_REVVIDEO        T if X-window is in reverse-video (swap white,black) */

/*   GX_LOC, GY_LOC      location of upper-left window corner in screen pixels */
/*   GX_ORG, GY_ORG      user-specified origin in window pixels */
/*   GX_SIZ, GY_SIZ      window size in pixels */
/*   GX_CRS, GY_CRS      user-specified cursor location */

/*   G_SCALE             # pixels / user plot unit */
/*   G_SCRNFRAC          fraction of screen taken up by X-window on opening */
/*   G_WIDTH             pixel width  of root X window display */
/*   G_HEIGHT            pixel height of root X window display */
/*   G_DEPTH             color bit depth of screen */
/*   G_COLOR_CINDEX(i)   X-colormap index of Xplot11 color i */

/*   LPS_GEN             T if PostScript output is to be generated */
/*   LPS_OPEN            T is PostScript file is currently open */
/*   LPS_COLOR           T if color PostScript is to be generated */
/*   LPS_UNSTROKED       T if current PostScript page has not been stroked */
/*   LPS_EXTERNAL        T if postscript file opened/closed outside of Xplot11 */
/*   LPS_ONEFILE         T if one postscript file used for each plot, otherwise */
/*                         separate numbered plot files will be used for each */
/*                         plot */

/*   IPS_MODE            0 if Portrait PostScript, 1 if Lansdcape PostScript */

/*   PX_ORG, PY_ORG      location of user-specified origin (in points) */
/*   PX_SIZ, PY_SIZ      size of PostScript page (in points) */
/*   P_SCALE             # points / user plot unit */

/*   NPS_UNIT            Fortran logical unit of PostScript file */
/*   N_PAGES             Cumulative count of PS pages generated */
/*   I_PAGES             Number of PS pages generated for current plot file */
/*   N_VECS              Number of PS vectors generated so far */

/*   BB_XMIN, BB_XMAX    PostScript Bounding Box limits */
/*   BB_YMIN, BB_YMAX */

/*   PS_LSTX, PS_LSTY    last PostScript move-to or line-to location */
/*   PS_FILE             PostScript output filename */
    ret_val = *y / pl_plotr__1.yfac_zoom__ - pl_plotr__1.yoff_zoom__;
    return ret_val;
} /* y_zm2abs__ */
