/* f/pplot.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    logical lgrid, lplot, lcdw, llist, legnd, lclen, laecen, lcdh, lcmdot, 
	    lauto;
} ppcom_l__;

#define ppcom_l__1 ppcom_l__

struct {
    int idev, idevrp, ipslu, icol0, ncolor, na[20], npol, icol[20], ilin[
	    20], nf[80]	/* was [4][20] */, ndat, ifcol[20], ifsym[20], nbl[20]
	    , iretyp[20], imatyp[20], nclen;
} ppcom_i__;

#define ppcom_i__1 ppcom_i__

struct {
    real plotar, ch, ch2, size, scrnfr, cpolplf[42]	/* was [3][14] */, 
	    vpolplf[6]	/* was [3][2] */, xcd, xal, xoc, mach[20], reyn[20], 
	    acrit[20], ptrat[20], etap[20], xtrip[200]	/* was [10][20] */, 
	    cpol[140000]	/* was [500][14][20] */, cpolsd[200000]	/* 
	    was [500][10][2][20] */, cdlmod[100]	/* was [5][20] */, 
	    cdlfit[100]	/* was [5][20] */, vppars[120]	/* was [6][20] */, 
	    dxmref[20], xyref[20480]	/* was [128][2][4][20] */, version;
} ppcom_r__;

#define ppcom_r__1 ppcom_r__

struct {
    char fnpol[1600], name__[640], fnref[1600], labref[640], title[32], code[
	    16], cclen[16], fname[80];
} ppcom_c__;

#define ppcom_c__1 ppcom_c__

/* Table of constant values */

static int c__9 = 9;
static int c__1 = 1;
static int c__3 = 3;
static int c__500 = 500;
static int c__10 = 10;
static int c__128 = 128;
static real c_b93 = .3f;
static int c_n3 = -3;
static logical c_false = FALSE_;
static logical c_true = TRUE_;
static int c__5 = 5;
static int c__6 = 6;
static int c__4 = 4;
static int c__8 = 8;
static int c__2 = 2;
static doublereal c_b533 = 10.;

/* *********************************************************************** */
/*  POLAR PLOTTING FACILITY FOR MSES AND XFOIL */

/*    INPUT: */
/*     * Polar file(s) generated by MSES or XFOIL */
/*     * Reference data files in the format: */

/*         CD(1)  CL(1) */
/*         CD(2)  CL(2) */
/*          .      . */
/*          .      . */
/*         999.0  999.0 */
/*         alpha(1)  CL(1) */
/*         alpha(2)  CL(2) */
/*           .       . */
/*           .       . */
/*         999.0   999.0 */
/*         alpha(1)  Cm(1) */
/*         alpha(2)  Cm(2) */
/*           .       . */
/*           .       . */
/*         999.0   999.0 */
/*         Xtr/c(1)  CL(1) */
/*         Xtr/c(2)  CL(2) */
/*           .        . */
/*           .        . */
/*         999.0   999.0 */

/*         The number of points in each set (CD-CL, alpha-CL, etc.) */
/*         is arbitrary, and can be zero. */

/*     * pplot.def  plot parameter file (optional) */

/* *********************************************************************** */

/* Main program */ int MAIN__(void)
{
    /* Format strings */
    static char fmt_1000[] = "(/\002  1  Read polars          (-1 for new se"
	    "t)\002/\002  2  Read reference data  (-2 for new set)\002//\002 "
	    " 3  Plot CD(CL)\002//\002  4  Hardcopy current plot\002/\002  5 "
	    " Change plot settings\002/\002  6  Zoom\002/\002  7  Unzoom\002"
	    "/\002  8  Annotation menu\002//\002  9  Set CD(CL) modifiers\002)"
	    ;
    static char fmt_1010[] = "(/\002 11  Re-read current polars\002/\002 12 "
	    " Re-read current reference data\002)";
    static char fmt_1020[] = "(/\002 13  Plot Vz(V)\002/\002 19  Set aicraft"
	    " parameters\002)";
    static char fmt_1050[] = "(/\002   Select option (0=quit): \002,$)";
    static char fmt_8000[] = "(1x,a)";
    static char fmt_8011[] = "(\002             Ma =\002,f7.3,$)";
    static char fmt_8012[] = "(\002    sqrt(CL)*Ma =\002,f7.3,$)";
    static char fmt_8013[] = "(\002          CL*Ma =\002,f7.3,$)";
    static char fmt_8021[] = "(\002             Re =\002,f7.3,\002 e 6\002,$)"
	    ;
    static char fmt_8022[] = "(\002    sqrt(CL)*Re =\002,f7.3,\002 e 6\002,$)"
	    ;
    static char fmt_8023[] = "(\002          CL*Re =\002,f7.3,\002 e 6\002,$)"
	    ;
    static char fmt_8030[] = "(\002          Ncrit =\002,f6.2)";
    static char fmt_8040[] = "(\002          pi_p  =\002,f8.4,$)";
    static char fmt_8041[] = "(\002          eta_p =\002,f8.4)";
    static char fmt_4900[] = "(/\002 CD_plotted  = (CD  +  CD0 + CD1*CL + CD"
	    "2*CL^2)*CL^expD\002/\002 CL_plotted  =  CL^exp\002)";
    static char fmt_4910[] = "(/\002 Polar\002,i3,\002...\002/\002 Currently"
	    " CD0,CD1,CD2,exp,expD = \002,3f10.6,2f10.4,/\002 Input new CD0,C"
	    "D1,CD2,exp,expD:    \002,$)";
    static char fmt_5910[] = "(/\002 Polar\002,i3,\002...\002/\002 Currently"
	    " W/S,rho,AR,CDo,REref,REexp = \002,g12.4,g12.4,f7.2,f10.6,g12.4,"
	    "f6.2/\002 Input new W/S,rho,AR,CDo,REref,REexp:    \002,$)";

    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2;
    doublereal d__1, d__2;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    double atan(doublereal);
    int f_open(olist *), f_clos(cllist *), s_wsle(cilist *), e_wsle(void),
	     do_lio(int *, int *, char *, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_cmp(char *, char *, ftnlen, ftnlen), s_wsfe(cilist *), e_wsfe(
	    void), s_rsle(cilist *), e_rsle(void), do_fio(int *, char *, 
	    ftnlen);
    double pow_dd(doublereal *, doublereal *), sqrt(doublereal);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int usetzoom_(logical *, logical *);
    static int i__, k;
    extern /* Subroutine */ int newfactor_(real *);
    static real cd;
    static int ia, id;
    static real cl;
    static int ii;
    static real ar, re, pi;
    static int ip, lu;
    static real vz, cd0;
    static int id1, id2, ip1, ip2;
    static real ref, rho, rex, cdp, clm, vel, wos;
    static int nlab;
    extern /* Subroutine */ int asks_(char *, char *, ftnlen, ftnlen);
    static int lerr, iopt;
    static int nname;
    extern /* Subroutine */ int plend_(void), readr_(int *, real *, 
	    logical *);
    static real cpolo[140000]	/* was [500][14][20] */;
    extern /* Subroutine */ int annot_(real *);
    static logical error;
    static real vpolo[20000]	/* was [500][2][20] */;
    static int iopts;
    extern /* Subroutine */ int strip_(char *, int *, ftnlen), getdef_(
	    void);
    static logical lgetfn;
    extern /* Subroutine */ int setinc_(void), polref_(int *, char *, 
	    logical *, int *, int *, real *, char *, ftnlen, ftnlen), 
	    minmax_(int *, int *, int *, real *, real *), getset_(
	    void), plopen_(real *, int *, int *), replot_(int *), 
	    polplt_(int *, int *, int *, real *, real *, real *, 
	    real *, real *, real *, char *, int *, int *, int *, 
	    int *, int *, real *, char *, int *, int *, 
	    int *, int *, real *, int *, int *, char *, char *
	    , real *, real *, real *, real *, real *, real *, real *, real *, 
	    logical *, logical *, logical *, logical *, logical *, logical *, 
	    logical *, real *, char *, int *, ftnlen, ftnlen, ftnlen, 
	    ftnlen, ftnlen), vepplt_(int *, int *, int *, real *, 
	    real *, real *, real *, real *, real *, char *, int *, 
	    int *, int *, int *, char *, char *, real *, real *, 
	    real *, real *, logical *, logical *, logical *, real *, ftnlen, 
	    ftnlen, ftnlen), plrsrt_(int *, int *), getarg0_(int *
	    , char *, ftnlen), getclen_(char *, char *, int *, ftnlen, 
	    ftnlen), polread_(int *, char *, logical *, int *, 
	    int *, real *, real *, real *, real *, real *, real *, real *,
	     char *, int *, int *, int *, int *, real *, char 
	    *, real *, ftnlen, ftnlen, ftnlen), plclose_(void), plotabs_(real 
	    *, real *, int *), setincv_(void), clrzoom_(void);

    /* Fortran I/O blocks */
    static cilist io___4 = { 0, 6, 0, 0, 0 };
    static cilist io___5 = { 0, 6, 0, 0, 0 };
    static cilist io___6 = { 0, 6, 0, 0, 0 };
    static cilist io___7 = { 0, 6, 0, 0, 0 };
    static cilist io___8 = { 0, 6, 0, 0, 0 };
    static cilist io___9 = { 0, 6, 0, 0, 0 };
    static cilist io___10 = { 0, 6, 0, 0, 0 };
    static cilist io___11 = { 0, 6, 0, 0, 0 };
    static cilist io___12 = { 0, 6, 0, 0, 0 };
    static cilist io___13 = { 0, 6, 0, 0, 0 };
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___17 = { 0, 6, 0, fmt_1000, 0 };
    static cilist io___18 = { 0, 6, 0, fmt_1010, 0 };
    static cilist io___19 = { 0, 6, 0, fmt_1020, 0 };
    static cilist io___20 = { 0, 6, 0, fmt_1050, 0 };
    static cilist io___21 = { 1, 5, 0, 0, 0 };
    static cilist io___27 = { 0, 6, 0, 0, 0 };
    static cilist io___28 = { 0, 6, 0, fmt_8000, 0 };
    static cilist io___29 = { 0, 6, 0, fmt_8011, 0 };
    static cilist io___30 = { 0, 6, 0, fmt_8012, 0 };
    static cilist io___31 = { 0, 6, 0, fmt_8013, 0 };
    static cilist io___32 = { 0, 6, 0, fmt_8021, 0 };
    static cilist io___33 = { 0, 6, 0, fmt_8022, 0 };
    static cilist io___34 = { 0, 6, 0, fmt_8023, 0 };
    static cilist io___35 = { 0, 6, 0, fmt_8030, 0 };
    static cilist io___36 = { 0, 6, 0, fmt_8040, 0 };
    static cilist io___37 = { 0, 6, 0, fmt_8041, 0 };
    static cilist io___47 = { 0, 6, 0, 0, 0 };
    static cilist io___48 = { 0, 6, 0, fmt_4900, 0 };
    static cilist io___49 = { 0, 6, 0, fmt_4910, 0 };
    static cilist io___57 = { 0, 6, 0, 0, 0 };
    static cilist io___58 = { 0, 6, 0, 0, 0 };
    static cilist io___59 = { 0, 6, 0, 0, 0 };
    static cilist io___60 = { 0, 6, 0, 0, 0 };
    static cilist io___69 = { 0, 6, 0, fmt_5910, 0 };




/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */









    ppcom_l__1.lplot = FALSE_;

    pi = atan(1.f) * 4.f;

    plinitialize_();

/* ...Get default settings */
    getdef_();

/* ...Try to read default file "pplot.def" for stored plot setup */
    lu = 10;
    o__1.oerr = 1;
    o__1.ounit = lu;
    o__1.ofnmlen = 9;
    o__1.ofnm = "pplot.def";
    o__1.orl = 0;
    o__1.osta = "OLD";
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    i__1 = f_open(&o__1);
    if (i__1 != 0) {
	goto L2;
    }
    rddef_(&lu, &lerr);
    cl__1.cerr = 0;
    cl__1.cunit = lu;
    cl__1.csta = 0;
    f_clos(&cl__1);
    if (lerr != 0) {
	s_wsle(&io___4);
	e_wsle();
	s_wsle(&io___5);
	do_lio(&c__9, &c__1, "Read error on file  pplot.def", (ftnlen)29);
	e_wsle();
	s_wsle(&io___6);
	do_lio(&c__9, &c__1, "Using default settings", (ftnlen)22);
	e_wsle();
	s_wsle(&io___7);
	e_wsle();
	getdef_();
    } else {
	s_wsle(&io___8);
	e_wsle();
	s_wsle(&io___9);
	do_lio(&c__9, &c__1, "Settings read from file  pplot.def", (ftnlen)34)
		;
	e_wsle();
	s_wsle(&io___10);
	e_wsle();
    }
    goto L3;

L2:
    s_wsle(&io___11);
    e_wsle();
    s_wsle(&io___12);
    do_lio(&c__9, &c__1, "No  pplot.def  file found", (ftnlen)25);
    e_wsle();
    s_wsle(&io___13);
    do_lio(&c__9, &c__1, "Using default settings", (ftnlen)22);
    e_wsle();
    s_wsle(&io___14);
    e_wsle();

L3:

/* ---- Check for command line args (load file names) */
    ppcom_i__1.npol = 0;
    for (ii = 1; ii <= 20; ++ii) {
	s_copy(ppcom_c__1.fname, " ", (ftnlen)80, (ftnlen)1);
	getarg0_(&ii, ppcom_c__1.fname, (ftnlen)80);
	if (s_cmp(ppcom_c__1.fname, " ", (ftnlen)80, (ftnlen)1) != 0) {
	    ++ppcom_i__1.npol;
	    s_copy(ppcom_c__1.fnpol + (ppcom_i__1.npol - 1) * 80, 
		    ppcom_c__1.fname, (ftnlen)80, (ftnlen)80);
	} else {
	    if (ppcom_i__1.npol > 0) {
		iopts = 11;
		goto L10;
	    } else {
		goto L5;
	    }
	}
    }

L5:
    s_wsfe(&io___17);
    e_wsfe();
    if (ppcom_i__1.npol > 0) {
	s_wsfe(&io___18);
	e_wsfe();
    }
    s_wsfe(&io___19);
    e_wsfe();
    s_wsfe(&io___20);
    e_wsfe();


    i__1 = s_rsle(&io___21);
    if (i__1 != 0) {
	goto L5;
    }
    i__1 = do_lio(&c__3, &c__1, (char *)&iopts, (ftnlen)sizeof(integer));
    if (i__1 != 0) {
	goto L5;
    }
    i__1 = e_rsle();
    if (i__1 != 0) {
	goto L5;
    }
    iopt = abs(iopts);

    switch (iopt + 1) {
	case 1:  goto L900;
	case 2:  goto L10;
	case 3:  goto L20;
	case 4:  goto L30;
	case 5:  goto L40;
	case 6:  goto L50;
	case 7:  goto L60;
	case 8:  goto L70;
	case 9:  goto L80;
	case 10:  goto L90;
	case 11:  goto L900;
	case 12:  goto L10;
	case 13:  goto L20;
	case 14:  goto L130;
	case 15:  goto L5;
	case 16:  goto L5;
	case 17:  goto L5;
	case 18:  goto L5;
	case 19:  goto L5;
	case 20:  goto L190;
	case 21:  goto L5;
    }
    goto L5;

/* ============================================= */
/* ---- read polars */
L10:
    if (iopts == -1) {
/* ----- read new polars */
	ip1 = 1;
	ip2 = 20;
    } else if (iopts == 1) {
/* ----- read additional polars */
	ip1 = ppcom_i__1.npol + 1;
	ip2 = 20;
    } else {
/* ----- re-read old polars */
	ip1 = 1;
	ip2 = ppcom_i__1.npol;
    }

    i__1 = ip2;
    for (ip = ip1; ip <= i__1; ++ip) {
	if (iopts == 1 || iopts == -1) {
	    asks_("Enter polar data filename or <return>^", ppcom_c__1.fnpol 
		    + (ip - 1) * 80, (ftnlen)38, (ftnlen)80);
	}
	if (*(unsigned char *)&ppcom_c__1.fnpol[(ip - 1) * 80] == ' ') {
	    goto L108;
	}

	lu = 9;
	polread_(&lu, ppcom_c__1.fnpol + (ip - 1) * 80, &error, &c__500, &
		ppcom_i__1.na[ip - 1], &ppcom_r__1.cpol[(ip * 14 + 1) * 500 - 
		7500], &ppcom_r__1.reyn[ip - 1], &ppcom_r__1.mach[ip - 1], &
		ppcom_r__1.acrit[ip - 1], &ppcom_r__1.xtrip[ip * 10 - 10], &
		ppcom_r__1.ptrat[ip - 1], &ppcom_r__1.etap[ip - 1], 
		ppcom_c__1.name__ + (ip - 1 << 5), &ppcom_i__1.iretyp[ip - 1],
		 &ppcom_i__1.imatyp[ip - 1], &c__10, &ppcom_i__1.nbl[ip - 1], 
		&ppcom_r__1.cpolsd[(((ip << 1) + 1) * 10 + 1) * 500 - 15500], 
		ppcom_c__1.code, &ppcom_r__1.version, (ftnlen)80, (ftnlen)32, 
		(ftnlen)16);
	if (error) {
	    s_wsle(&io___27);
	    do_lio(&c__9, &c__1, "Polar file READ error", (ftnlen)21);
	    e_wsle();
	    goto L108;
	}

	s_wsfe(&io___28);
	do_fio(&c__1, ppcom_c__1.name__ + (ip - 1 << 5), (ftnlen)32);
	e_wsfe();
	if (ppcom_i__1.imatyp[ip - 1] == 1) {
	    s_wsfe(&io___29);
	    do_fio(&c__1, (char *)&ppcom_r__1.mach[ip - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}
	if (ppcom_i__1.imatyp[ip - 1] == 2) {
	    s_wsfe(&io___30);
	    do_fio(&c__1, (char *)&ppcom_r__1.mach[ip - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}
	if (ppcom_i__1.imatyp[ip - 1] == 3) {
	    s_wsfe(&io___31);
	    do_fio(&c__1, (char *)&ppcom_r__1.mach[ip - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}
	if (ppcom_i__1.iretyp[ip - 1] == 1) {
	    s_wsfe(&io___32);
	    r__1 = ppcom_r__1.reyn[ip - 1] / 1e6f;
	    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	if (ppcom_i__1.iretyp[ip - 1] == 2) {
	    s_wsfe(&io___33);
	    r__1 = ppcom_r__1.reyn[ip - 1] / 1e6f;
	    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	if (ppcom_i__1.iretyp[ip - 1] == 3) {
	    s_wsfe(&io___34);
	    r__1 = ppcom_r__1.reyn[ip - 1] / 1e6f;
	    do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	    e_wsfe();
	}
	s_wsfe(&io___35);
	do_fio(&c__1, (char *)&ppcom_r__1.acrit[ip - 1], (ftnlen)sizeof(real))
		;
	e_wsfe();
	if (ppcom_r__1.ptrat[ip - 1] != 0.f) {
	    s_wsfe(&io___36);
	    do_fio(&c__1, (char *)&ppcom_r__1.ptrat[ip - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	    s_wsfe(&io___37);
	    do_fio(&c__1, (char *)&ppcom_r__1.etap[ip - 1], (ftnlen)sizeof(
		    real));
	    e_wsfe();
	}


/* L105: */
    }
    ip = ip2 + 1;

L108:
    ppcom_i__1.npol = ip - 1;
    ip2 = min(ip2,ppcom_i__1.npol);

    i__1 = ip2;
    for (ip = ip1; ip <= i__1; ++ip) {
	strip_(ppcom_c__1.name__ + (ip - 1 << 5), &nname, (ftnlen)32);
/* ccc        CALL GETTYP(NAX,NA(IP),CPOL(1,1,IP),IMATYP(IP),IRETYP(IP)) */
/* c        ICOL(IP) = 2 + IP */
/* c        ILIN(IP) = IP */
    }
/* CC   CALL MINMAX(NAX,NPOL,NA,CPOL,CPOLPLF) */
/* o */
/* ---- are these dimensional polars? */
    i__1 = ip2;
    for (ip = ip1; ip <= i__1; ++ip) {
	getclen_(ppcom_c__1.name__ + (ip - 1 << 5), ppcom_c__1.cclen, &
		ppcom_i__1.nclen, (ftnlen)32, (ftnlen)16);
	if (ppcom_i__1.nclen > 0) {
	    ppcom_l__1.lclen = TRUE_;
	    goto L5;
	}
    }
    if (! ppcom_l__1.lplot) {
	goto L30;
    }
    goto L5;

/* ============================================= */
/* ---- read reference data */
L20:
    if (iopts == 12) {
/* ------ re-read old data sets */
	id1 = 1;
	id2 = ppcom_i__1.ndat;
	lgetfn = FALSE_;
    } else if (iopts > 0) {
/* ------ read additional data sets */
	id1 = ppcom_i__1.ndat + 1;
	id2 = 20;
	lgetfn = TRUE_;
    } else {
/* ------ read new data sets */
	id1 = 1;
	id2 = 20;
	lgetfn = TRUE_;
    }

    i__1 = id2;
    for (id = id1; id <= i__1; ++id) {
	if (lgetfn) {
	    asks_("Enter reference data filename or <return>^", 
		    ppcom_c__1.fnref + (id - 1) * 80, (ftnlen)42, (ftnlen)80);
	    if (*(unsigned char *)&ppcom_c__1.fnref[(id - 1) * 80] == ' ') {
		goto L27;
	    }
	}

	lu = 9;
	o__1.oerr = 1;
	o__1.ounit = lu;
	o__1.ofnmlen = 80;
	o__1.ofnm = ppcom_c__1.fnref + (id - 1) * 80;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__2 = f_open(&o__1);
	if (i__2 != 0) {
	    goto L27;
	}
	polref_(&lu, ppcom_c__1.fnref + (id - 1) * 80, &error, &c__128, &
		ppcom_i__1.nf[(id << 2) - 4], &ppcom_r__1.xyref[(((id << 2) + 
		1 << 1) + 1 << 7) - 1408], ppcom_c__1.labref + (id - 1 << 5), 
		(ftnlen)80, (ftnlen)32);
	cl__1.cerr = 0;
	cl__1.cunit = lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
	if (error) {
	    goto L27;
	}

	ppcom_i__1.ndat = id;

	strip_(ppcom_c__1.labref + (id - 1 << 5), &nlab, (ftnlen)32);
	if (nlab == 0) {
	    asks_("Enter label for reference data^", ppcom_c__1.labref + (id 
		    - 1 << 5), (ftnlen)31, (ftnlen)32);
	    strip_(ppcom_c__1.labref + (id - 1 << 5), &nlab, (ftnlen)32);
	}

/* cc     IFCOL(ID) = NCOLOR - ID + 1 */
	ppcom_i__1.ifcol[id - 1] = id + 2;
	ppcom_i__1.ifsym[id - 1] = id % 10;
/* L25: */
    }
L27:
    goto L5;

/* ============================================= */
/* ---- Make the CD(CL) Plot */
L30:
    if (ppcom_i__1.npol == 0 && ppcom_i__1.ndat == 0) {
	goto L5;
    }

/* ---- sort each polar by increasing alpha */
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
	plrsrt_(&ip, &c__1);
    }

/* ---- set modified polars */
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
	i__2 = ppcom_i__1.na[ip - 1];
	for (ia = 1; ia <= i__2; ++ia) {
	    for (i__ = 1; i__ <= 14; ++i__) {
		cpolo[ia + (i__ + ip * 14) * 500 - 7501] = ppcom_r__1.cpol[ia 
			+ (i__ + ip * 14) * 500 - 7501];
	    }
	    cpolo[ia + (ip * 14 + 4) * 500 - 7501] = ppcom_r__1.cpol[ia + (ip 
		    * 14 + 4) * 500 - 7501] + ppcom_r__1.dxmref[ip - 1] * 
		    ppcom_r__1.cpol[ia + (ip * 14 + 2) * 500 - 7501];

/* Computing 2nd power */
	    r__1 = ppcom_r__1.cpol[ia + (ip * 14 + 2) * 500 - 7501];
	    cpolo[ia + (ip * 14 + 3) * 500 - 7501] = ppcom_r__1.cpol[ia + (ip 
		    * 14 + 3) * 500 - 7501] + ppcom_r__1.cdlmod[ip * 5 - 5] + 
		    ppcom_r__1.cdlmod[ip * 5 - 4] * ppcom_r__1.cpol[ia + (ip *
		     14 + 2) * 500 - 7501] + ppcom_r__1.cdlmod[ip * 5 - 3] * (
		    r__1 * r__1);
	    if (ppcom_r__1.cdlmod[ip * 5 - 2] != 1.f) {
		d__1 = (r__1 = ppcom_r__1.cpol[ia + (ip * 14 + 2) * 500 - 
			7501], (doublereal) dabs(r__1));
		d__2 = (doublereal) ppcom_r__1.cdlmod[ip * 5 - 2];
		cpolo[ia + (ip * 14 + 2) * 500 - 7501] = pow_dd(&d__1, &d__2);
	    }
	    if (ppcom_r__1.cdlmod[ip * 5 - 1] != 0.f) {
		d__1 = (r__1 = ppcom_r__1.cpol[ia + (ip * 14 + 2) * 500 - 
			7501], (doublereal) dabs(r__1));
		d__2 = (doublereal) ppcom_r__1.cdlmod[ip * 5 - 1];
		cpolo[ia + (ip * 14 + 3) * 500 - 7501] *= pow_dd(&d__1, &d__2)
			;
	    }
	}
    }
    if (ppcom_l__1.lauto) {
	minmax_(&c__500, &ppcom_i__1.npol, ppcom_i__1.na, cpolo, 
		ppcom_r__1.cpolplf);
	setinc_();
    }

    if (ppcom_l__1.lplot) {
	plend_();
    }
    plopen_(&ppcom_r__1.scrnfr, &ppcom_i__1.ipslu, &ppcom_i__1.idev);
    ppcom_l__1.lplot = TRUE_;

/* ---- set 0.3" left,bottom margins */
    plotabs_(&c_b93, &c_b93, &c_n3);
    newfactor_(&ppcom_r__1.size);
    r__1 = ppcom_r__1.ch * 6.f;
    r__2 = ppcom_r__1.ch * 6.f;
    plot_(&r__1, &r__2, &c_n3);

/*      WRITE(*,*) CPOLPLF(1,ICL),CPOLPLF(2,ICL),CPOLPLF(3,ICL) */
/*      write(*,*) */
    polplt_(&c__500, &ppcom_i__1.npol, ppcom_i__1.na, cpolo, ppcom_r__1.reyn, 
	    ppcom_r__1.mach, ppcom_r__1.acrit, ppcom_r__1.ptrat, 
	    ppcom_r__1.etap, ppcom_c__1.name__, ppcom_i__1.icol, 
	    ppcom_i__1.ilin, &c__128, &ppcom_i__1.ndat, ppcom_i__1.nf, 
	    ppcom_r__1.xyref, ppcom_c__1.labref, ppcom_i__1.ifcol, 
	    ppcom_i__1.ifsym, &c__10, ppcom_i__1.nbl, ppcom_r__1.cpolsd, 
	    ppcom_i__1.imatyp, ppcom_i__1.iretyp, ppcom_c__1.title, 
	    ppcom_c__1.code, &ppcom_r__1.version, &ppcom_r__1.plotar, &
	    ppcom_r__1.xcd, &ppcom_r__1.xal, &ppcom_r__1.xoc, &ppcom_r__1.ch, 
	    &ppcom_r__1.ch2, &ppcom_r__1.cdlmod[3], &ppcom_l__1.lgrid, &
	    ppcom_l__1.lcdw, &ppcom_l__1.llist, &ppcom_l__1.legnd, &
	    ppcom_l__1.laecen, &ppcom_l__1.lcdh, &ppcom_l__1.lcmdot, 
	    ppcom_r__1.cpolplf, ppcom_c__1.cclen, &ppcom_i__1.nclen, (ftnlen)
	    32, (ftnlen)32, (ftnlen)32, (ftnlen)16, (ftnlen)16);

/*      CALL POLFIT(NAX,NPOL,NA,CPOLO, */
/*     &            REYN,MACH,ACRIT, NAME ,ICOL,ILIN, */
/*     &            IMATYP,IRETYP, */
/*     &            PLOTAR, XCD,XAL,XOC, CH,CH2, CDLMOD(4,1), */
/*     &            CPOLPLF, CCLEN,NCLEN ) */

    goto L5;

/* ============================================= */
/* ---- hardcopy output */
L40:
    if (ppcom_l__1.lplot) {
	plend_();
    }
    ppcom_l__1.lplot = FALSE_;
    replot_(&ppcom_i__1.idevrp);
    goto L5;

/* ============================================= */
/* ---- change settings */
L50:
    getset_();
    goto L5;

/* ============================================= */
/* ---- zoom */
L60:
    usetzoom_(&c_false, &c_true);
    replot_(&ppcom_i__1.idev);
    goto L5;

/* ============================================= */
/* ---- unzoom */
L70:
    clrzoom_();
    replot_(&ppcom_i__1.idev);
    goto L5;

/* ============================================= */
/* ---- annotate plot */
L80:
    if (! ppcom_l__1.lplot) {
	s_wsle(&io___47);
	do_lio(&c__9, &c__1, "No active plot to annotate", (ftnlen)26);
	e_wsle();
	goto L5;
    }
    annot_(&ppcom_r__1.ch);
    goto L5;
/* ============================================= */
/* ---- get modifiers */
L90:
    s_wsfe(&io___48);
    e_wsfe();
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
L91:
	s_wsfe(&io___49);
	do_fio(&c__1, (char *)&ip, (ftnlen)sizeof(integer));
	for (k = 1; k <= 5; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.cdlmod[k + ip * 5 - 6], (ftnlen)
		    sizeof(real));
	}
	e_wsfe();
	readr_(&c__5, &ppcom_r__1.cdlmod[ip * 5 - 5], &error);
	if (error) {
	    goto L91;
	}
    }
    goto L5;

/* ============================================= */
/* ---- Make the Vz(V) Plot */
L130:
    if (ppcom_i__1.npol == 0 && ppcom_i__1.ndat == 0) {
	goto L5;
    }

/* ---- sort each polar by increasing alpha */
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
	plrsrt_(&ip, &c__1);
    }

/* ---- set V and Vz for plotting */
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
	wos = ppcom_r__1.vppars[ip * 6 - 6];
	rho = ppcom_r__1.vppars[ip * 6 - 5];
	ar = ppcom_r__1.vppars[ip * 6 - 4];
	cd0 = ppcom_r__1.vppars[ip * 6 - 3];
	ref = ppcom_r__1.vppars[ip * 6 - 2];
	rex = ppcom_r__1.vppars[ip * 6 - 1];

	if (wos == 0.f) {
	    s_wsle(&io___57);
	    do_lio(&c__9, &c__1, "Wing loading W/S not defined.  Using 1.0", (
		    ftnlen)40);
	    e_wsle();
	    wos = 1.f;
	}
	if (rho == 0.f) {
	    s_wsle(&io___58);
	    do_lio(&c__9, &c__1, "Air density RHO not defined.  Using 1.0", (
		    ftnlen)39);
	    e_wsle();
	    rho = 1.f;
	}
	if (ar == 0.f) {
	    s_wsle(&io___59);
	    do_lio(&c__9, &c__1, "Aspect ratio AR not defined.  Using 1.0", (
		    ftnlen)39);
	    e_wsle();
	    ar = 1.f;
	}
	if (ref == 0.f) {
	    s_wsle(&io___60);
	    do_lio(&c__9, &c__1, "Reference REref not defined.  Using 10^6", (
		    ftnlen)40);
	    e_wsle();
	    ref = 1e6f;
	}

	i__2 = ppcom_i__1.na[ip - 1];
	for (ia = 1; ia <= i__2; ++ia) {
	    cdp = ppcom_r__1.cpol[ia + (ip * 14 + 3) * 500 - 7501];
	    cl = ppcom_r__1.cpol[ia + (ip * 14 + 2) * 500 - 7501];
	    re = ppcom_r__1.cpol[ia + (ip * 14 + 9) * 500 - 7501];

	    clm = dmax(cl,.001f);
	    vel = sqrt(wos * 2.f / (rho * clm));

	    d__1 = (doublereal) (re / ref);
	    d__2 = (doublereal) rex;
	    cd = cdp + cl * cl / (pi * ar) + cd0 * pow_dd(&d__1, &d__2);

	    vz = -vel * cd / cl;

	    vpolo[ia + ((ip << 1) + 1) * 500 - 1501] = vel;
	    vpolo[ia + ((ip << 1) + 2) * 500 - 1501] = vz;
	}
    }
    if (ppcom_l__1.lauto) {
	minmax_(&c__500, &ppcom_i__1.npol, ppcom_i__1.na, vpolo, 
		ppcom_r__1.vpolplf);
	setincv_();
    }

    if (ppcom_l__1.lplot) {
	plend_();
    }
    plopen_(&ppcom_r__1.scrnfr, &ppcom_i__1.ipslu, &ppcom_i__1.idev);
    ppcom_l__1.lplot = TRUE_;

/* ---- set 0.3" left,bottom margins */
    plotabs_(&c_b93, &c_b93, &c_n3);
    newfactor_(&ppcom_r__1.size);
    r__1 = ppcom_r__1.ch * 6.f;
    r__2 = ppcom_r__1.ch * 6.f;
    plot_(&r__1, &r__2, &c_n3);

    vepplt_(&c__500, &ppcom_i__1.npol, ppcom_i__1.na, vpolo, ppcom_r__1.reyn, 
	    ppcom_r__1.mach, ppcom_r__1.acrit, ppcom_r__1.ptrat, 
	    ppcom_r__1.etap, ppcom_c__1.name__, ppcom_i__1.icol, 
	    ppcom_i__1.ilin, ppcom_i__1.imatyp, ppcom_i__1.iretyp, 
	    ppcom_c__1.title, ppcom_c__1.code, &ppcom_r__1.version, &
	    ppcom_r__1.plotar, &ppcom_r__1.ch, &ppcom_r__1.ch2, &
	    ppcom_l__1.lgrid, &ppcom_l__1.llist, &ppcom_l__1.legnd, 
	    ppcom_r__1.vpolplf, (ftnlen)32, (ftnlen)32, (ftnlen)16);
    goto L5;

/* ============================================= */
/* ---- get velocity-polar parameters */
L190:
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
L191:
	s_wsfe(&io___69);
	do_fio(&c__1, (char *)&ip, (ftnlen)sizeof(integer));
	for (k = 1; k <= 6; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.vppars[k + ip * 6 - 7], (ftnlen)
		    sizeof(real));
	}
	e_wsfe();
	readr_(&c__6, &ppcom_r__1.vppars[ip * 6 - 6], &error);
	if (error) {
	    goto L191;
	}
    }
    goto L5;

/* ============================================= */
L900:
    plclose_();
    s_stop("", (ftnlen)0);
    return 0;
} /* MAIN__ */

/* Subroutine */ int getclen_(char *name__, char *clen, int *nclen, 
	ftnlen name_len, ftnlen clen_len)
{
    /* System generated locals */
    int i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int i_indx(char *, char *, ftnlen, ftnlen), i_len(char *, ftnlen);

    /* Local variables */
    static int k, k1, k2, nname;

/* -------------------------------------------------- */
/*     Looks for substring  "(c=01234***)" */
/*     in the NAME string.  If found, then */
/*     the "***" string is returned in CLEN. */
/*     If not found, then CLEN is returned blank. */
/* -------------------------------------------------- */

    s_copy(clen, " ", clen_len, (ftnlen)1);

    k1 = i_indx(name__, "(c=", name_len, (ftnlen)3);
    if (k1 == 0) {
	return 0;
    }

    nname = i_len(name__, name_len);
    k2 = i_indx(name__ + (k1 - 1), ")", nname - (k1 - 1), (ftnlen)1) + k1 - 2;
    if (k2 - k1 < 3) {
	return 0;
    }

    i__1 = k2;
    for (k = k1 + 3; k <= i__1; ++k) {
	if (i_indx("0123456789.,)", name__ + (k - 1), (ftnlen)13, (ftnlen)1) 
		== 0) {
	    s_copy(clen, name__ + (k - 1), clen_len, k2 - (k - 1));
	    *nclen = k2 - k + 1;
	    return 0;
	}
    }

    return 0;
} /* getclen_ */

/* Subroutine */ int minmax_(int *nax, int *npol, int *na, real *
	cpol, real *cpolplf)
{
    /* System generated locals */
    int cpol_dim1, cpol_offset, i__1, i__2;
    real r__1, r__2;

    /* Local variables */
    static int i__, k, ip;


/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */


/* -------------------------------------------- */
/*     Determines max and min limits of polar */
/*     quantities among all polars passed in. */
/* -------------------------------------------- */

    /* Parameter adjustments */
    cpol_dim1 = *nax;
    cpol_offset = 1 + cpol_dim1 * 15;
    cpol -= cpol_offset;
    --na;
    cpolplf -= 4;

    /* Function Body */
    if (*npol < 1) {
	return 0;
    }

    for (k = 1; k <= 4; ++k) {
	cpolplf[k * 3 + 1] = cpol[(k + 14) * cpol_dim1 + 1];
	cpolplf[k * 3 + 2] = cpol[(k + 14) * cpol_dim1 + 1];
    }

    i__1 = *npol;
    for (ip = 1; ip <= i__1; ++ip) {
	for (k = 1; k <= 4; ++k) {
	    i__2 = na[ip];
	    for (i__ = 1; i__ <= i__2; ++i__) {
/* Computing MIN */
		r__1 = cpol[i__ + (k + ip * 14) * cpol_dim1], r__2 = cpolplf[
			k * 3 + 1];
		cpolplf[k * 3 + 1] = dmin(r__1,r__2);
/* Computing MAX */
		r__1 = cpol[i__ + (k + ip * 14) * cpol_dim1], r__2 = cpolplf[
			k * 3 + 2];
		cpolplf[k * 3 + 2] = dmax(r__1,r__2);
	    }
	}
    }

    return 0;
} /* minmax_ */

/* Subroutine */ int getdef_(void)
{
    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static int ip;
    extern /* Subroutine */ int getnumcolor_(int *), colormapdefault_(
	    void);


/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */









/* ---- Plotting flag */
    ppcom_i__1.idev = 1;
/*     IDEV = 2   ! B&W PostScript output file only (no color) */
/*     IDEV = 3   ! both X11 and B&W PostScript file */
/*     IDEV = 4   ! Color PostScript output file only */
/*     IDEV = 5   ! both X11 and Color PostScript file */

/* ---- Re-plotting flag (for hardcopy) */
/*      IDEVRP = 2   ! B&W PostScript */
    ppcom_i__1.idevrp = 4;

/* ---- PostScript output logical unit and file specification */
    ppcom_i__1.ipslu = 0;
/*     IPSLU = ?  ! output to file  plot?.ps  on LU 80+? */

/* ---- screen fraction taken up by plot window upon opening */
    ppcom_r__1.scrnfr = .7f;

/* ---- Default plot size in inches */
/* -    (Default plot window is 11.0 x 8.5) */
    ppcom_r__1.size = 10.f;

/* ---- plot aspect ratio V/H */
    ppcom_r__1.plotar = .6f;

/* ---- character height */
    ppcom_r__1.ch = .014f;
    ppcom_r__1.ch2 = .012f;

/* ---- set default color table and get number of colors */
    colormapdefault_();
    getnumcolor_(&ppcom_i__1.ncolor);

/* ---- default polar line types and colors */

/*     1  *****************************  SOLID */
/*     2  **** **** **** **** **** ****  LONG DASHED */
/*     3  ** ** ** ** ** ** ** ** ** **  SHORT DASHED */
/*     4  * * * * * * * * * * * * * * *  DOTTED */
/*     5  ***** * ***** * ***** * *****  DASH-DOT */
/*     6  ***** * * ***** * * ***** * *  DASH-DOT-DOT */
/*     7  ***** * * * ***** * * * *****  DASH-DOT-DOT-DOT */
/*     8  **** **** * * **** **** * *    DASH-DASH-DOT-DOT */

/*     3  red */
/*     4  orange */
/*     5  yellow */
/*     6  green */
/*     7  cyan */
/*     8  blue */
/*     9  violet */
/*    10  magenta */

    for (ip = 1; ip <= 20; ++ip) {
/* cc       ILIN(IP) = 1 + MOD(IP-1,8 */
/* cc       ICOL(IP) = 3 + MOD(IP-1,8) */

/* ------ normally solid, going to dashed after IP=7 */
	ppcom_i__1.ilin[ip - 1] = (ip - 1) / 7 + 1;

/* ------ skip yellow (hard to see on white background) */
	ppcom_i__1.icol[ip - 1] = (ip - 1) % 7 + 3;
	if (ppcom_i__1.icol[ip - 1] >= 5) {
	    ++ppcom_i__1.icol[ip - 1];
	}
    }

    ppcom_l__1.lgrid = TRUE_;
    ppcom_l__1.lcdw = FALSE_;
    ppcom_l__1.llist = TRUE_;
    ppcom_l__1.legnd = TRUE_;
    ppcom_l__1.lclen = FALSE_;
    ppcom_l__1.laecen = FALSE_;
    ppcom_l__1.lcdh = FALSE_;
    ppcom_l__1.lcmdot = FALSE_;

/* ---- automatic scaling for axes */
    ppcom_l__1.lauto = TRUE_;

    ppcom_r__1.cpolplf[3] = 0.f;
    ppcom_r__1.cpolplf[4] = 1.5f;
    ppcom_r__1.cpolplf[5] = .5f;

    ppcom_r__1.cpolplf[6] = 0.f;
    ppcom_r__1.cpolplf[7] = .02f;
    ppcom_r__1.cpolplf[8] = .01f;

    ppcom_r__1.cpolplf[9] = 0.f;
    ppcom_r__1.cpolplf[10] = -.25f;
    ppcom_r__1.cpolplf[11] = .05f;

    ppcom_r__1.cpolplf[0] = -4.f;
    ppcom_r__1.cpolplf[1] = 10.f;
    ppcom_r__1.cpolplf[2] = 2.f;

/* ---- Plot layout (relative X size to CL-CD, CL-alfa, transition plots) */
    ppcom_r__1.xcd = .45f;
    ppcom_r__1.xal = .25f;
    ppcom_r__1.xoc = .2f;

/* ---- Set CL,CD modifiers */
    for (ip = 1; ip <= 20; ++ip) {
	ppcom_r__1.cdlmod[ip * 5 - 5] = 0.f;
	ppcom_r__1.cdlmod[ip * 5 - 4] = 0.f;
	ppcom_r__1.cdlmod[ip * 5 - 3] = 0.f;
	ppcom_r__1.cdlmod[ip * 5 - 2] = 1.f;
	ppcom_r__1.cdlmod[ip * 5 - 1] = 0.f;
    }

/* C---- Set CL,CD quadratic-fit polar parameters */
/*      DO IP = 1, NPX */
/*        CDLFIT(1,IP) = 0. */
/*        CDLFIT(2,IP) = 0. */
/*        CDLFIT(3,IP) = 0. */
/*        CDLFIT(4,IP) = 1.0 */
/*        CDLFIT(5,IP) = 0. */
/*      ENDDO */

/* ---- velocity polar plot axis parameters */
    ppcom_r__1.vpolplf[0] = 0.f;
    ppcom_r__1.vpolplf[1] = 20.f;
    ppcom_r__1.vpolplf[2] = 2.f;

    ppcom_r__1.vpolplf[3] = -5.f;
    ppcom_r__1.vpolplf[4] = 1.f;
    ppcom_r__1.vpolplf[5] = .5f;

/* ---- Set Vz(V) parameters */
    for (ip = 1; ip <= 20; ++ip) {
	ppcom_r__1.vppars[ip * 6 - 6] = 0.f;
	ppcom_r__1.vppars[ip * 6 - 5] = 0.f;
	ppcom_r__1.vppars[ip * 6 - 4] = 0.f;
	ppcom_r__1.vppars[ip * 6 - 3] = 0.f;
	ppcom_r__1.vppars[ip * 6 - 2] = 0.f;
	ppcom_r__1.vppars[ip * 6 - 1] = 0.f;
    }

/* ---- no CM location shift by default */
    for (ip = 1; ip <= 20; ++ip) {
	ppcom_r__1.dxmref[ip - 1] = 0.f;
    }

    s_copy(ppcom_c__1.title, "                                ", (ftnlen)32, (
	    ftnlen)32);
/* CC            12345678901234567890123456789012 */

    return 0;
} /* getdef_ */

/* Subroutine */ 
int rddef_(int *lu, logical *lerr)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    int i__1;
    icilist ici__1;

    /* Builtin functions */
    int s_rsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_rsle(void), s_rsfe(cilist *), do_fio(int *, char *, ftnlen),
	     e_rsfe(void), i_indx(char *, char *, ftnlen, ftnlen), i_len(char 
	    *, ftnlen), s_rsli(icilist *), e_rsli(void);

    /* Local variables */
    static int k, ip, kbar;
    static char line[256];
    static real size0;
    static logical lcolh;

    /* Fortran I/O blocks */
    static cilist io___80 = { 1, 0, 1, 0, 0 };
    static cilist io___81 = { 1, 0, 1, 0, 0 };
    static cilist io___82 = { 1, 0, 1, 0, 0 };
    static cilist io___83 = { 1, 0, 1, 0, 0 };
    static cilist io___84 = { 1, 0, 1, 0, 0 };
    static cilist io___85 = { 1, 0, 1, 0, 0 };
    static cilist io___86 = { 1, 0, 1, 0, 0 };
    static cilist io___87 = { 1, 0, 1, 0, 0 };
    static cilist io___88 = { 1, 0, 1, 0, 0 };
    static cilist io___89 = { 1, 0, 1, 0, 0 };
    static cilist io___90 = { 1, 0, 1, 0, 0 };
    static cilist io___91 = { 1, 0, 1, 0, 0 };
    static cilist io___92 = { 1, 0, 1, fmt_1000, 0 };
    static cilist io___96 = { 1, 0, 1, fmt_1000, 0 };
    static cilist io___97 = { 1, 0, 1, fmt_1000, 0 };
    static cilist io___98 = { 1, 0, 1, 0, 0 };
    static cilist io___100 = { 1, 0, 1, 0, 0 };


/* --- Read PPLOT plot parameters from save file */

/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */










    lcolh = ppcom_i__1.idevrp == 4;
    size0 = ppcom_r__1.size;

/* L1000: */

    io___80.ciunit = *lu;
    i__1 = s_rsle(&io___80);
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[3], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[4], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[5], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = e_rsle();
L100001:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___81.ciunit = *lu;
    i__1 = s_rsle(&io___81);
    if (i__1 != 0) {
	goto L100002;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[6], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100002;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[7], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100002;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[8], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100002;
    }
    i__1 = e_rsle();
L100002:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___82.ciunit = *lu;
    i__1 = s_rsle(&io___82);
    if (i__1 != 0) {
	goto L100003;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[9], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100003;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[10], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100003;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[11], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100003;
    }
    i__1 = e_rsle();
L100003:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___83.ciunit = *lu;
    i__1 = s_rsle(&io___83);
    if (i__1 != 0) {
	goto L100004;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[0], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100004;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[1], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100004;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.cpolplf[2], (ftnlen)
	    sizeof(real));
    if (i__1 != 0) {
	goto L100004;
    }
    i__1 = e_rsle();
L100004:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___84.ciunit = *lu;
    i__1 = s_rsle(&io___84);
    if (i__1 != 0) {
	goto L100005;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.xcd, (ftnlen)sizeof(real))
	    ;
    if (i__1 != 0) {
	goto L100005;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.xal, (ftnlen)sizeof(real))
	    ;
    if (i__1 != 0) {
	goto L100005;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.xoc, (ftnlen)sizeof(real))
	    ;
    if (i__1 != 0) {
	goto L100005;
    }
    i__1 = e_rsle();
L100005:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___85.ciunit = *lu;
    i__1 = s_rsle(&io___85);
    if (i__1 != 0) {
	goto L100006;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.size, (ftnlen)sizeof(real)
	    );
    if (i__1 != 0) {
	goto L100006;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.plotar, (ftnlen)sizeof(
	    real));
    if (i__1 != 0) {
	goto L100006;
    }
    i__1 = e_rsle();
L100006:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___86.ciunit = *lu;
    i__1 = s_rsle(&io___86);
    if (i__1 != 0) {
	goto L100007;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.ch, (ftnlen)sizeof(real));
    if (i__1 != 0) {
	goto L100007;
    }
    i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.ch2, (ftnlen)sizeof(real))
	    ;
    if (i__1 != 0) {
	goto L100007;
    }
    i__1 = e_rsle();
L100007:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }

    io___87.ciunit = *lu;
    i__1 = s_rsle(&io___87);
    if (i__1 != 0) {
	goto L100008;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.lauto, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100008;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.lcdw, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100008;
    }
    i__1 = e_rsle();
L100008:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___88.ciunit = *lu;
    i__1 = s_rsle(&io___88);
    if (i__1 != 0) {
	goto L100009;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.llist, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100009;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.legnd, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100009;
    }
    i__1 = e_rsle();
L100009:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___89.ciunit = *lu;
    i__1 = s_rsle(&io___89);
    if (i__1 != 0) {
	goto L100010;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.laecen, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100010;
    }
    i__1 = e_rsle();
L100010:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___90.ciunit = *lu;
    i__1 = s_rsle(&io___90);
    if (i__1 != 0) {
	goto L100011;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.lcmdot, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100011;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.lcdh, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100011;
    }
    i__1 = e_rsle();
L100011:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___91.ciunit = *lu;
    i__1 = s_rsle(&io___91);
    if (i__1 != 0) {
	goto L100012;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&ppcom_l__1.lgrid, (ftnlen)sizeof(
	    logical));
    if (i__1 != 0) {
	goto L100012;
    }
    i__1 = do_lio(&c__8, &c__1, (char *)&lcolh, (ftnlen)sizeof(logical));
    if (i__1 != 0) {
	goto L100012;
    }
    i__1 = e_rsle();
L100012:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }

    io___92.ciunit = *lu;
    i__1 = s_rsfe(&io___92);
    if (i__1 != 0) {
	goto L100013;
    }
    i__1 = do_fio(&c__1, line, (ftnlen)256);
    if (i__1 != 0) {
	goto L100013;
    }
    i__1 = e_rsfe();
L100013:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    kbar = i_indx(line, "|", (ftnlen)256, (ftnlen)1) - 1;
    if (kbar <= 0) {
	kbar = i_len(line, (ftnlen)256);
    }
    ici__1.icierr = 1;
    ici__1.iciend = 1;
    ici__1.icirnum = 1;
    ici__1.icirlen = kbar;
    ici__1.iciunit = line;
    ici__1.icifmt = 0;
    i__1 = s_rsli(&ici__1);
    if (i__1 != 0) {
	goto L100014;
    }
    for (ip = 1; ip <= 20; ++ip) {
	i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.dxmref[ip - 1], (
		ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L100014;
	}
    }
    i__1 = e_rsli();
L100014:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }

    io___96.ciunit = *lu;
    i__1 = s_rsfe(&io___96);
    if (i__1 != 0) {
	goto L100015;
    }
    i__1 = do_fio(&c__1, line, (ftnlen)256);
    if (i__1 != 0) {
	goto L100015;
    }
    i__1 = e_rsfe();
L100015:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    kbar = i_indx(line, "|", (ftnlen)256, (ftnlen)1) - 1;
    if (kbar <= 0) {
	kbar = i_len(line, (ftnlen)256);
    }
    ici__1.icierr = 1;
    ici__1.iciend = 1;
    ici__1.icirnum = 1;
    ici__1.icirlen = kbar;
    ici__1.iciunit = line;
    ici__1.icifmt = 0;
    i__1 = s_rsli(&ici__1);
    if (i__1 != 0) {
	goto L100016;
    }
    for (ip = 1; ip <= 20; ++ip) {
	i__1 = do_lio(&c__3, &c__1, (char *)&ppcom_i__1.icol[ip - 1], (ftnlen)
		sizeof(integer));
	if (i__1 != 0) {
	    goto L100016;
	}
    }
    i__1 = e_rsli();
L100016:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }

    io___97.ciunit = *lu;
    i__1 = s_rsfe(&io___97);
    if (i__1 != 0) {
	goto L100017;
    }
    i__1 = do_fio(&c__1, line, (ftnlen)256);
    if (i__1 != 0) {
	goto L100017;
    }
    i__1 = e_rsfe();
L100017:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    kbar = i_indx(line, "|", (ftnlen)256, (ftnlen)1) - 1;
    if (kbar <= 0) {
	kbar = i_len(line, (ftnlen)256);
    }
    ici__1.icierr = 1;
    ici__1.iciend = 1;
    ici__1.icirnum = 1;
    ici__1.icirlen = kbar;
    ici__1.iciunit = line;
    ici__1.icifmt = 0;
    i__1 = s_rsli(&ici__1);
    if (i__1 != 0) {
	goto L100018;
    }
    for (ip = 1; ip <= 20; ++ip) {
	i__1 = do_lio(&c__3, &c__1, (char *)&ppcom_i__1.ilin[ip - 1], (ftnlen)
		sizeof(integer));
	if (i__1 != 0) {
	    goto L100018;
	}
    }
    i__1 = e_rsli();
L100018:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }

    io___98.ciunit = *lu;
    i__1 = s_rsle(&io___98);
    if (i__1 != 0) {
	goto L100019;
    }
    for (k = 1; k <= 3; ++k) {
	i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.vpolplf[k - 1], (
		ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L100019;
	}
    }
    i__1 = e_rsle();
L100019:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }
    io___100.ciunit = *lu;
    i__1 = s_rsle(&io___100);
    if (i__1 != 0) {
	goto L100020;
    }
    for (k = 1; k <= 3; ++k) {
	i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.vpolplf[k + 2], (
		ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L100020;
	}
    }
    i__1 = e_rsle();
L100020:
    if (i__1 < 0) {
	goto L80;
    }
    if (i__1 > 0) {
	goto L90;
    }


    if (lcolh) {
	ppcom_i__1.idevrp = 4;
    } else {
	ppcom_i__1.idevrp = 2;
    }
    if (ppcom_r__1.size <= 0.f) {
	ppcom_r__1.size = size0;
    }

    *lerr = FALSE_;
    return 0;

L80:
L90:
    *lerr = TRUE_;
    return 0;
} /* rddef_ */

/* Subroutine */ int wrtdef_(int *lu)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";
    static char fmt_1030[] = "(1x,3f9.4,\002 | \002,a)";
    static char fmt_1020[] = "(1x,2f9.4,9x,\002 | \002,a)";
    static char fmt_1120[] = "(1x,2(l4,1x),5x,\002 | \002,a)";
    static char fmt_1110[] = "(1x,l4,1x,5x,5x,\002 | \002,a)";
    static char fmt_1300[] = "(1x,80(f7.3))";
    static char fmt_1400[] = "(1x,80i4)";

    /* System generated locals */
    address a__1[2];
    int i__1[2];

    /* Builtin functions */
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void),
	     s_wsfi(icilist *), e_wsfi(void);
    /* Subroutine */ int s_cat(char *, char **, int *, int *, ftnlen);

    /* Local variables */
    static int k, ip;
    static char line[256];
    static logical lcolh;
    static int nline;
    extern /* Subroutine */ int strip_(char *, int *, ftnlen);

    /* Fortran I/O blocks */
    static cilist io___102 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___103 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___104 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___105 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___106 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___107 = { 0, 0, 0, fmt_1020, 0 };
    static cilist io___108 = { 0, 0, 0, fmt_1020, 0 };
    static cilist io___109 = { 0, 0, 0, fmt_1120, 0 };
    static cilist io___110 = { 0, 0, 0, fmt_1120, 0 };
    static cilist io___111 = { 0, 0, 0, fmt_1110, 0 };
    static cilist io___112 = { 0, 0, 0, fmt_1120, 0 };
    static cilist io___113 = { 0, 0, 0, fmt_1120, 0 };
    static icilist io___115 = { 0, line, 0, fmt_1300, 256, 1 };
    static cilist io___118 = { 0, 0, 0, fmt_1000, 0 };
    static icilist io___119 = { 0, line, 0, fmt_1400, 256, 1 };
    static cilist io___120 = { 0, 0, 0, fmt_1000, 0 };
    static icilist io___121 = { 0, line, 0, fmt_1400, 256, 1 };
    static cilist io___122 = { 0, 0, 0, fmt_1000, 0 };
    static cilist io___123 = { 0, 0, 0, fmt_1030, 0 };
    static cilist io___125 = { 0, 0, 0, fmt_1030, 0 };


/* --- Write PPLOT plot parameters to save file */

/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */









    lcolh = ppcom_i__1.idevrp == 4;

/* L1000: */

    io___102.ciunit = *lu;
    s_wsfe(&io___102);
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[3], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[4], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[5], (ftnlen)sizeof(real));
    do_fio(&c__1, "CLmin   CLmax    dCL", (ftnlen)20);
    e_wsfe();
    io___103.ciunit = *lu;
    s_wsfe(&io___103);
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[6], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[7], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[8], (ftnlen)sizeof(real));
    do_fio(&c__1, "CDmin   CDmax    dCD", (ftnlen)20);
    e_wsfe();
    io___104.ciunit = *lu;
    s_wsfe(&io___104);
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[9], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[10], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[11], (ftnlen)sizeof(real));
    do_fio(&c__1, "CMmin   CMmax    dCM", (ftnlen)20);
    e_wsfe();
    io___105.ciunit = *lu;
    s_wsfe(&io___105);
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[0], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[1], (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[2], (ftnlen)sizeof(real));
    do_fio(&c__1, "ALmin   ALmax    dAL", (ftnlen)20);
    e_wsfe();
    io___106.ciunit = *lu;
    s_wsfe(&io___106);
    do_fio(&c__1, (char *)&ppcom_r__1.xcd, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.xal, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.xoc, (ftnlen)sizeof(real));
    do_fio(&c__1, "CL-CD   CL-alpha  CL-Xtr  (widths)", (ftnlen)34);
    e_wsfe();
    io___107.ciunit = *lu;
    s_wsfe(&io___107);
    do_fio(&c__1, (char *)&ppcom_r__1.size, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.plotar, (ftnlen)sizeof(real));
    do_fio(&c__1, "width    height/width", (ftnlen)21);
    e_wsfe();
    io___108.ciunit = *lu;
    s_wsfe(&io___108);
    do_fio(&c__1, (char *)&ppcom_r__1.ch, (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&ppcom_r__1.ch2, (ftnlen)sizeof(real));
    do_fio(&c__1, "char_ht1 char_ht2", (ftnlen)17);
    e_wsfe();
/* L1010: */

    io___109.ciunit = *lu;
    s_wsfe(&io___109);
    do_fio(&c__1, (char *)&ppcom_l__1.lauto, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lcdw, (ftnlen)sizeof(logical));
    do_fio(&c__1, "auto_scale?  CDp_plot?", (ftnlen)22);
    e_wsfe();
    io___110.ciunit = *lu;
    s_wsfe(&io___110);
    do_fio(&c__1, (char *)&ppcom_l__1.llist, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.legnd, (ftnlen)sizeof(logical));
    do_fio(&c__1, "airf_list?   legend_box?", (ftnlen)24);
    e_wsfe();
    io___111.ciunit = *lu;
    s_wsfe(&io___111);
    do_fio(&c__1, (char *)&ppcom_l__1.laecen, (ftnlen)sizeof(logical));
    do_fio(&c__1, "x_AC_plot?", (ftnlen)10);
    e_wsfe();
    io___112.ciunit = *lu;
    s_wsfe(&io___112);
    do_fio(&c__1, (char *)&ppcom_l__1.lcmdot, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lcdh, (ftnlen)sizeof(logical));
    do_fio(&c__1, "HX_mass?     HX_CD?", (ftnlen)19);
    e_wsfe();
    io___113.ciunit = *lu;
    s_wsfe(&io___113);
    do_fio(&c__1, (char *)&ppcom_l__1.lgrid, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&lcolh, (ftnlen)sizeof(logical));
    do_fio(&c__1, "grid_plot?   color_PS?", (ftnlen)22);
    e_wsfe();
/* L1130: */

    s_wsfi(&io___115);
    for (ip = 1; ip <= 20; ++ip) {
	do_fio(&c__1, (char *)&ppcom_r__1.dxmref[ip - 1], (ftnlen)sizeof(real)
		);
    }
    e_wsfi();
    strip_(line, &nline, (ftnlen)256);
/* Writing concatenation */
    i__1[0] = nline, a__1[0] = line;
    i__1[1] = 12, a__1[1] = " | dXmom_ref";
    s_cat(line, a__1, i__1, &c__2, (ftnlen)256);
    strip_(line, &nline, (ftnlen)256);
    io___118.ciunit = *lu;
    s_wsfe(&io___118);
    do_fio(&c__1, line, nline);
    e_wsfe();

    s_wsfi(&io___119);
    for (ip = 1; ip <= 20; ++ip) {
	do_fio(&c__1, (char *)&ppcom_i__1.icol[ip - 1], (ftnlen)sizeof(
		integer));
    }
    e_wsfi();
    strip_(line, &nline, (ftnlen)256);
/* Writing concatenation */
    i__1[0] = nline, a__1[0] = line;
    i__1[1] = 13, a__1[1] = " | line_color";
    s_cat(line, a__1, i__1, &c__2, (ftnlen)256);
    strip_(line, &nline, (ftnlen)256);
    io___120.ciunit = *lu;
    s_wsfe(&io___120);
    do_fio(&c__1, line, nline);
    e_wsfe();

    s_wsfi(&io___121);
    for (ip = 1; ip <= 20; ++ip) {
	do_fio(&c__1, (char *)&ppcom_i__1.ilin[ip - 1], (ftnlen)sizeof(
		integer));
    }
    e_wsfi();
    strip_(line, &nline, (ftnlen)256);
/* Writing concatenation */
    i__1[0] = nline, a__1[0] = line;
    i__1[1] = 12, a__1[1] = " | line_type";
    s_cat(line, a__1, i__1, &c__2, (ftnlen)256);
    strip_(line, &nline, (ftnlen)256);
    io___122.ciunit = *lu;
    s_wsfe(&io___122);
    do_fio(&c__1, line, nline);
    e_wsfe();


    io___123.ciunit = *lu;
    s_wsfe(&io___123);
    for (k = 1; k <= 3; ++k) {
	do_fio(&c__1, (char *)&ppcom_r__1.vpolplf[k - 1], (ftnlen)sizeof(real)
		);
    }
    do_fio(&c__1, "V_scale", (ftnlen)7);
    e_wsfe();
    io___125.ciunit = *lu;
    s_wsfe(&io___125);
    for (k = 1; k <= 3; ++k) {
	do_fio(&c__1, (char *)&ppcom_r__1.vpolplf[k + 2], (ftnlen)sizeof(real)
		);
    }
    do_fio(&c__1, "Vz_scale", (ftnlen)8);
    e_wsfe();

    return 0;
} /* wrtdef_ */

/* Subroutine */ int getset_(void)
{
    /* Format strings */
    static char fmt_1000[] = "(/\002  1   Change CL scaling\002/\002  2   Ch"
	    "ange CD scaling\002/\002  3   Change CM scaling\002/\002  4   Ch"
	    "ange ALPHA scaling\002//\002  5   Plot Layout\002/\002  6   Plot"
	    " Title\002/\002  7   Plot Size\002//\002 10\002,l3,\002 autoscal"
	    "ing?\002/\002 11\002,l3,\002 plot pressure-CD?\002/\002 12\002,l"
	    "3,\002 plot airfoil list?\002/\002 13\002,l3,\002 plot CL-CD leg"
	    "end box?\002/\002 14\002,l3,\002 plot aero. center?\002/\002 1"
	    "5\002,l3,\002 plot streamtube mass coeff.?\002/\002 16\002,l3"
	    ",\002 plot streamtube thrust?\002/\002 18\002,l3,\002 plot grid "
	    "overlay?\002/\002 19\002,l3,\002 color hardcopy?\002//\002 20   "
	    "Rescale forces by chord factor\002/\002 21   Change reference-le"
	    "ngth unit\002/\002 22   Change moment-reference x/c\002/\002 23 "
	    "  Change polar colors\002/\002 24   Change polar line styles\002"
	    "//\002 26   Change V  scaling\002/\002 27   Change Vz scaling"
	    "\002//\002 30   Read  settings from defaults file\002/\002 31   "
	    "Write settings to   defaults file\002//\002    Select option: "
	    " \002,$)";
    static char fmt_1005[] = "(a)";
    static char fmt_1100[] = "(/\002 Current   CLmin, CLmax, dCL = \002,3f10"
	    ".5/\002 Enter new CLmin, CLmax, dCL:  \002,$)";
    static char fmt_1200[] = "(/\002 Current   CDmin, CDmax, dCD = \002,3f10"
	    ".5/\002 Enter new CDmin, CDmax, dCD:  \002,$)";
    static char fmt_1300[] = "(/\002 Current   CMmin, CMmax, dCM = \002,3f10"
	    ".5/\002 Enter new CMmin, CMmax, dCM:  \002,$)";
    static char fmt_1400[] = "(/\002 Current   ALmin, ALmax, dAL = \002,3f10"
	    ".5/\002 Enter new ALmin, ALmax, dAL:  \002,$)";
    static char fmt_1700[] = "(/\002  Current layout offsets  xCD =\002,f8"
	    ".4,\002  xALPHA = \002,f8.4,\002  xTR = \002,f8.4/\002 Enter new"
	    " xCD, xALPHA, xTR:  \002,$)";
    static char fmt_1500[] = "(/\002 Current   plot size = \002,f10.5/\002 E"
	    "nter new plot size:  \002,$)";
    static char fmt_1900[] = "(/\002Enter chord scale factor for forces: "
	    "\002,$)";
    static char fmt_2000[] = "(/\002Current reference length unit: \002,a)";
    static char fmt_8010[] = "(\002  New dXref for polar\002,i3,\002 [\002,f"
	    "9.4,\002 ] : \002,$)";
    static char fmt_5020[] = "(/\002   1  black (white in revVideo)\002/\002"
	    "   2  white (invisible)\002/\002   3  red\002/\002   4  orang"
	    "e\002/\002   5  yellow\002/\002   6  green\002/\002   7  cyan"
	    "\002/\002   8  blue\002/\002   9  violet\002/\002  10  magent"
	    "a\002)";
    static char fmt_3100[] = "(\002 Currently \002,a,\002 =\002,20i3)";
    static char fmt_3105[] = "(\002 Enter new \002,a,\002:  \002,$)";
    static char fmt_5030[] = "(/\002   1  -----------------------------  sol"
	    "id\002/\002   2  ---- ---- ---- ---- ---- ----  long dashed\002"
	    "/\002   3  -- -- -- -- -- -- -- -- -- --  short dashed\002/\002 "
	    "  4  - - - - - - - - - - - - - - -  dotted\002/\002   5  ----- -"
	    " ----- - ----- - -----  dash-dot\002/\002   6  ----- - - ----- -"
	    " - ----- - -  dash-dot-dot\002/\002   7  ----- - - - ----- - - -"
	    " -----  dash-dot-dot-dot\002/\002   8  ---- ---- - - ---- ---- -"
	    " -    dash-dash-dot-dot\002)";
    static char fmt_2100[] = "(/\002 Current   Vmin, Vmax, dV = \002,3f10.5"
	    "/\002 Enter new Vmin, Vmax, dV:  \002,$)";
    static char fmt_2200[] = "(/\002 Current   Vzmin, Vzmax, dVz = \002,3f10"
	    ".5/\002 Enter new Vzmin, Vzmax, dVz:  \002,$)";
    static char fmt_1001[] = "(a)";

    /* System generated locals */
    int i__1;
    real r__1;
    olist o__1;
    cllist cl__1;
    alist al__1;

    /* Builtin functions */
    int s_wsfe(cilist *), do_fio(int *, char *, ftnlen), e_wsfe(void),
	     s_rsfe(cilist *), e_rsfe(void), s_cmp(char *, char *, ftnlen, 
	    ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_rsli(icilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_rsli(void), s_wsle(cilist *), e_wsle(void), s_wsfi(icilist *), 
	    e_wsfi(void), f_open(olist *), f_clos(cllist *), i_indx(char *, 
	    char *, ftnlen, ftnlen), f_rew(alist *);

    /* Local variables */
    static int k, ip, lu;
    static char ans[1];
    static real scal;
    static char line[80];
    extern /* Subroutine */ int asks_(char *, char *, ftnlen, ftnlen);
    static int ninp;
    static real rinp[10], cscal;
    static logical lcolh, error;
    static int ntitle;
    static char option[2];

    /* Fortran I/O blocks */
    static cilist io___127 = { 0, 6, 0, fmt_1000, 0 };
    static cilist io___128 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___130 = { 0, 6, 0, fmt_1100, 0 };
    static cilist io___132 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___136 = { 0, 6, 0, fmt_1200, 0 };
    static cilist io___137 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___138 = { 0, 6, 0, fmt_1300, 0 };
    static cilist io___139 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___140 = { 0, 6, 0, fmt_1400, 0 };
    static cilist io___141 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___142 = { 0, 6, 0, fmt_1700, 0 };
    static cilist io___143 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___146 = { 0, 6, 0, fmt_1500, 0 };
    static cilist io___147 = { 0, 5, 0, fmt_1005, 0 };
    static icilist io___148 = { 1, line, 0, 0, 80, 1 };
    static cilist io___149 = { 0, 6, 0, fmt_1900, 0 };
    static cilist io___151 = { 0, 5, 0, fmt_1005, 0 };
    static icilist io___152 = { 1, line, 1, 0, 80, 1 };
    static cilist io___154 = { 0, 6, 0, fmt_2000, 0 };
    static cilist io___155 = { 0, 6, 0, 0, 0 };
    static cilist io___156 = { 0, 6, 0, 0, 0 };
    static cilist io___157 = { 0, 6, 0, 0, 0 };
    static cilist io___159 = { 0, 6, 0, fmt_8010, 0 };
    static cilist io___160 = { 0, 6, 0, 0, 0 };
    static cilist io___161 = { 0, 6, 0, fmt_5020, 0 };
    static icilist io___162 = { 0, line, 0, fmt_3100, 80, 1 };
    static cilist io___163 = { 0, 6, 0, fmt_1005, 0 };
    static cilist io___164 = { 0, 6, 0, fmt_3105, 0 };
    static cilist io___165 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___166 = { 0, 6, 0, 0, 0 };
    static cilist io___167 = { 0, 6, 0, fmt_5030, 0 };
    static icilist io___168 = { 0, line, 0, fmt_3100, 80, 1 };
    static cilist io___169 = { 0, 6, 0, fmt_1005, 0 };
    static cilist io___170 = { 0, 6, 0, fmt_3105, 0 };
    static cilist io___171 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___172 = { 0, 6, 0, fmt_2100, 0 };
    static cilist io___173 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___174 = { 0, 6, 0, fmt_2200, 0 };
    static cilist io___175 = { 0, 5, 0, fmt_1005, 0 };
    static cilist io___177 = { 0, 6, 0, 0, 0 };
    static cilist io___178 = { 0, 6, 0, 0, 0 };
    static cilist io___179 = { 0, 6, 0, 0, 0 };
    static cilist io___180 = { 0, 6, 0, 0, 0 };
    static cilist io___181 = { 0, 5, 0, fmt_1001, 0 };
    static cilist io___183 = { 0, 6, 0, 0, 0 };
    static cilist io___184 = { 0, 6, 0, 0, 0 };
    static cilist io___185 = { 0, 6, 0, 0, 0 };
    static cilist io___186 = { 0, 6, 0, 0, 0 };



/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */









/* ---- Change plotting parameters */

L1:
    lcolh = ppcom_i__1.idevrp == 4;

    s_wsfe(&io___127);
    do_fio(&c__1, (char *)&ppcom_l__1.lauto, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lcdw, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.llist, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.legnd, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.laecen, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lcmdot, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lcdh, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&ppcom_l__1.lgrid, (ftnlen)sizeof(logical));
    do_fio(&c__1, (char *)&lcolh, (ftnlen)sizeof(logical));
    e_wsfe();


    s_rsfe(&io___128);
    do_fio(&c__1, option, (ftnlen)2);
    e_rsfe();

    if (s_cmp(option, " ", (ftnlen)2, (ftnlen)1) == 0 || s_cmp(option, "0 ", (
	    ftnlen)2, (ftnlen)2) == 0) {

	return 0;

    } else if (s_cmp(option, "1 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get CL min,max,delta */
	s_wsfe(&io___130);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[k + 2], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L20:
	s_rsfe(&io___132);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, &ppcom_r__1.cpolplf[3], &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L20;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "2 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get CD min,max,delta */
	s_wsfe(&io___136);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[k + 5], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L30:
	s_rsfe(&io___137);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, &ppcom_r__1.cpolplf[6], &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L30;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "3 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get CM min,max,delta */
	s_wsfe(&io___138);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[k + 8], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L40:
	s_rsfe(&io___139);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, &ppcom_r__1.cpolplf[9], &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L40;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "4 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get ALFA min,max,delta */
	s_wsfe(&io___140);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.cpolplf[k - 1], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L50:
	s_rsfe(&io___141);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, ppcom_r__1.cpolplf, &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L50;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "5 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get Layout offsets for CL-CD,CL-alfa,transition plot sections */
L80:
	s_wsfe(&io___142);
	do_fio(&c__1, (char *)&ppcom_r__1.xcd, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&ppcom_r__1.xal, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&ppcom_r__1.xoc, (ftnlen)sizeof(real));
	e_wsfe();
	s_rsfe(&io___143);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	rinp[0] = ppcom_r__1.xcd;
	rinp[1] = ppcom_r__1.xal;
	rinp[2] = ppcom_r__1.xoc;
	ninp = 3;
	getflt_(line, rinp, &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L80;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_r__1.xcd = rinp[0];
	ppcom_r__1.xal = rinp[1];
	ppcom_r__1.xoc = rinp[2];

    } else if (s_cmp(option, "6 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get plot title */
	s_copy(ppcom_c__1.title, " ", (ftnlen)32, (ftnlen)1);
	asks_("Enter plot title (80 chars)^", ppcom_c__1.title, (ftnlen)28, (
		ftnlen)32);
	strip_(ppcom_c__1.title, &ntitle, (ftnlen)32);

    } else if (s_cmp(option, "7 ", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get plot size */
L60:
	s_wsfe(&io___146);
	do_fio(&c__1, (char *)&ppcom_r__1.size, (ftnlen)sizeof(real));
	e_wsfe();
	s_rsfe(&io___147);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	if (s_cmp(line, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    goto L1;
	}
	i__1 = s_rsli(&io___148);
	if (i__1 != 0) {
	    goto L60;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&ppcom_r__1.size, (ftnlen)sizeof(
		real));
	if (i__1 != 0) {
	    goto L60;
	}
	i__1 = e_rsli();
	if (i__1 != 0) {
	    goto L60;
	}

    } else if (s_cmp(option, "10", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.lauto = ! ppcom_l__1.lauto;

    } else if (s_cmp(option, "11", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.lcdw = ! ppcom_l__1.lcdw;

    } else if (s_cmp(option, "12", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.llist = ! ppcom_l__1.llist;

    } else if (s_cmp(option, "13", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.legnd = ! ppcom_l__1.legnd;

    } else if (s_cmp(option, "14", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.laecen = ! ppcom_l__1.laecen;

    } else if (s_cmp(option, "15", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.lcmdot = ! ppcom_l__1.lcmdot;

    } else if (s_cmp(option, "16", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.lcdh = ! ppcom_l__1.lcdh;

    } else if (s_cmp(option, "18", (ftnlen)2, (ftnlen)2) == 0) {
	ppcom_l__1.lgrid = ! ppcom_l__1.lgrid;

    } else if (s_cmp(option, "19", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Color hardcopy toggle */
	if (ppcom_i__1.idevrp == 2) {
	    ppcom_i__1.idevrp = 4;
	} else {
	    ppcom_i__1.idevrp = 2;
	}

    } else if (s_cmp(option, "20", (ftnlen)2, (ftnlen)2) == 0) {
/* --- rescale forces and moments */
	s_wsfe(&io___149);
	e_wsfe();
	scal = 1.f;
	s_rsfe(&io___151);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	if (s_cmp(line, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    goto L1;
	}
	i__1 = s_rsli(&io___152);
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = do_lio(&c__4, &c__1, (char *)&cscal, (ftnlen)sizeof(real));
	if (i__1 != 0) {
	    goto L1;
	}
	i__1 = e_rsli();
	if (i__1 != 0) {
	    goto L1;
	}
	if (scal != 0.f) {
	    r__1 = 1.f / scal;
	    rescal_(&r__1);
	}

    } else if (s_cmp(option, "21", (ftnlen)2, (ftnlen)2) == 0) {
/* --- change reference length unit */
	s_wsfe(&io___154);
	e_wsfe();
	asks_("Enter new reference length unit (<return> if none)^", 
		ppcom_c__1.cclen, (ftnlen)51, (ftnlen)16);
	strip_(ppcom_c__1.cclen, &ppcom_i__1.nclen, (ftnlen)16);

    } else if (s_cmp(option, "22", (ftnlen)2, (ftnlen)2) == 0) {
/* --- change moment reference locations */
	if (ppcom_i__1.npol == 0) {
	    s_wsle(&io___155);
	    do_lio(&c__9, &c__1, "No current polars", (ftnlen)17);
	    e_wsle();
	    goto L1;
	} else {
	    s_wsle(&io___156);
	    e_wsle();
	    s_wsle(&io___157);
	    do_lio(&c__9, &c__1, "Enter new moment-reference location shifts"
		    "...", (ftnlen)45);
	    e_wsle();
	    i__1 = ppcom_i__1.npol;
	    for (ip = 1; ip <= i__1; ++ip) {
		s_wsfe(&io___159);
		do_fio(&c__1, (char *)&ip, (ftnlen)sizeof(integer));
		do_fio(&c__1, (char *)&ppcom_r__1.dxmref[ip - 1], (ftnlen)
			sizeof(real));
		e_wsfe();
		readr_(&c__1, &ppcom_r__1.dxmref[ip - 1], &error);
	    }
	}

    } else if (s_cmp(option, "23", (ftnlen)2, (ftnlen)2) == 0) {
/* ------ change polar colors */
	if (ppcom_i__1.npol == 0) {
	    s_wsle(&io___160);
	    do_lio(&c__9, &c__1, "No current polars to change", (ftnlen)27);
	    e_wsle();
	    goto L1;
	} else {
	    s_wsfe(&io___161);
	    e_wsfe();

L820:
	    s_wsfi(&io___162);
	    do_fio(&c__1, "polar colors", (ftnlen)12);
	    i__1 = ppcom_i__1.npol;
	    for (ip = 1; ip <= i__1; ++ip) {
		do_fio(&c__1, (char *)&ppcom_i__1.icol[ip - 1], (ftnlen)
			sizeof(integer));
	    }
	    e_wsfi();
	    s_wsfe(&io___163);
	    do_fio(&c__1, line, (ftnlen)80);
	    e_wsfe();
	    s_wsfe(&io___164);
	    do_fio(&c__1, "polar colors", (ftnlen)12);
	    e_wsfe();
	    s_rsfe(&io___165);
	    do_fio(&c__1, line, (ftnlen)80);
	    e_rsfe();
	    ninp = ppcom_i__1.npol;
	    getint_(line, ppcom_i__1.icol, &ninp, &error, (ftnlen)80);
	    if (error) {
		goto L820;
	    }
	}

    } else if (s_cmp(option, "24", (ftnlen)2, (ftnlen)2) == 0) {
/* ------ change polar line styles */
	if (ppcom_i__1.npol == 0) {
	    s_wsle(&io___166);
	    do_lio(&c__9, &c__1, "No current polars to change", (ftnlen)27);
	    e_wsle();
	    goto L1;
	} else {
	    s_wsfe(&io___167);
	    e_wsfe();

L830:
	    s_wsfi(&io___168);
	    do_fio(&c__1, "current polar line styles", (ftnlen)25);
	    i__1 = ppcom_i__1.npol;
	    for (ip = 1; ip <= i__1; ++ip) {
		do_fio(&c__1, (char *)&ppcom_i__1.ilin[ip - 1], (ftnlen)
			sizeof(integer));
	    }
	    e_wsfi();
	    s_wsfe(&io___169);
	    do_fio(&c__1, line, (ftnlen)80);
	    e_wsfe();
	    s_wsfe(&io___170);
	    do_fio(&c__1, " select polar line styles", (ftnlen)25);
	    e_wsfe();
	    s_rsfe(&io___171);
	    do_fio(&c__1, line, (ftnlen)80);
	    e_rsfe();
	    ninp = ppcom_i__1.npol;
	    getint_(line, ppcom_i__1.ilin, &ninp, &error, (ftnlen)80);
	    if (error) {
		goto L830;
	    }
	}

    } else if (s_cmp(option, "26", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get V min,max,delta */
	s_wsfe(&io___172);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.vpolplf[k - 1], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L210:
	s_rsfe(&io___173);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, ppcom_r__1.vpolplf, &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L210;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "27", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Get Vz min,max,delta */
	s_wsfe(&io___174);
	for (k = 1; k <= 3; ++k) {
	    do_fio(&c__1, (char *)&ppcom_r__1.vpolplf[k + 2], (ftnlen)sizeof(
		    real));
	}
	e_wsfe();
L220:
	s_rsfe(&io___175);
	do_fio(&c__1, line, (ftnlen)80);
	e_rsfe();
	ninp = 3;
	getflt_(line, &ppcom_r__1.vpolplf[3], &ninp, &error, (ftnlen)80);
	if (error) {
	    goto L220;
	}
	if (ninp == 0) {
	    goto L1;
	}
	ppcom_l__1.lauto = FALSE_;

    } else if (s_cmp(option, "30", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Read defaults from pplot.def file */
	s_copy(line, "Enter settings filename  [pplot.def] ^", (ftnlen)80, (
		ftnlen)38);
	asks_(line, ppcom_c__1.fname, (ftnlen)80, (ftnlen)80);
	if (s_cmp(ppcom_c__1.fname, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    s_copy(ppcom_c__1.fname, "pplot.def", (ftnlen)80, (ftnlen)9);
	}
	lu = 10;
	o__1.oerr = 1;
	o__1.ounit = lu;
	o__1.ofnmlen = 80;
	o__1.ofnm = ppcom_c__1.fname;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L703;
	}
	rddef_(&lu, &error);
	cl__1.cerr = 0;
	cl__1.cunit = lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
	goto L1;
L703:
	s_wsle(&io___177);
	e_wsle();
	s_wsle(&io___178);
	do_lio(&c__9, &c__1, "Open error on pplot defaults file", (ftnlen)33);
	e_wsle();
	goto L1;

    } else if (s_cmp(option, "31", (ftnlen)2, (ftnlen)2) == 0) {
/* --- Save defaults to parameter file */
	lu = 10;
	s_copy(line, "Enter settings filename  [ pplot.def ] ^", (ftnlen)80, (
		ftnlen)40);
	asks_(line, ppcom_c__1.fname, (ftnlen)80, (ftnlen)80);
	if (s_cmp(ppcom_c__1.fname, " ", (ftnlen)80, (ftnlen)1) == 0) {
	    s_copy(ppcom_c__1.fname, "pplot.def", (ftnlen)80, (ftnlen)9);
	}
	o__1.oerr = 1;
	o__1.ounit = lu;
	o__1.ofnmlen = 80;
	o__1.ofnm = ppcom_c__1.fname;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L803;
	}
	s_wsle(&io___179);
	e_wsle();
	s_wsle(&io___180);
	do_lio(&c__9, &c__1, "File exists.  Overwrite?  Y", (ftnlen)27);
	e_wsle();
	s_rsfe(&io___181);
	do_fio(&c__1, ans, (ftnlen)1);
	e_rsfe();
	if (i_indx("Nn", ans, (ftnlen)2, (ftnlen)1) == 0) {
	    goto L806;
	}
	s_wsle(&io___183);
	e_wsle();
	s_wsle(&io___184);
	do_lio(&c__9, &c__1, "No action taken", (ftnlen)15);
	e_wsle();
	cl__1.cerr = 0;
	cl__1.cunit = lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
	goto L1;

L803:
	o__1.oerr = 0;
	o__1.ounit = lu;
	o__1.ofnmlen = 80;
	o__1.ofnm = ppcom_c__1.fname;
	o__1.orl = 0;
	o__1.osta = "UNKNOWN";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	f_open(&o__1);
L806:
	al__1.aerr = 0;
	al__1.aunit = lu;
	f_rew(&al__1);
	wrtdef_(&lu);
	s_wsle(&io___185);
	e_wsle();
	s_wsle(&io___186);
	do_lio(&c__9, &c__1, "PPLOT plot settings written to file", (ftnlen)
		35);
	e_wsle();
	cl__1.cerr = 0;
	cl__1.cunit = lu;
	cl__1.csta = 0;
	f_clos(&cl__1);

    }
    goto L1;

/* L1800: */
/* L1910: */

/* L3000: */

} /* getset_ */

/* Subroutine */ int plrsrt_(int *ip, int *idsort)
{
    static int id, is;
    static real atmp[500];
    static int indx[500];
    extern /* Subroutine */ int asort_(int *, real *, int *, real *), 
	    hsort_(int *, real *, int *);


/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */









/* ---- sort polar in increasing variable IDSORT */
    hsort_(&ppcom_i__1.na[*ip - 1], &ppcom_r__1.cpol[(*idsort + *ip * 14) * 
	    500 - 7500], indx);

/* ---- do the actual reordering */
    for (id = 1; id <= 14; ++id) {
	asort_(&ppcom_i__1.na[*ip - 1], &ppcom_r__1.cpol[(id + *ip * 14) * 
		500 - 7500], indx, atmp);
    }
    for (id = 1; id <= 2; ++id) {
	for (is = 1; is <= 2; ++is) {
	    asort_(&ppcom_i__1.na[*ip - 1], &ppcom_r__1.cpolsd[(is + (id + (*
		    ip << 1)) * 10) * 500 - 15500], indx, atmp);
	}
    }

    return 0;
} /* plrsrt_ */

/* Subroutine */ int gettyp_(int *nax, int *na, real *cpol, int *
	imatyp, int *iretyp)
{

    /* System generated locals */
    int cpol_dim1, cpol_offset;

    /* Builtin functions */
    double log(doublereal);

    /* Local variables */
    static real ex;


/* ---- Determines type of Ma(CL) and Re(CL) dependence */



/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */




    /* Parameter adjustments */
    cpol_dim1 = *nax;
    cpol_offset = 1 + cpol_dim1;
    cpol -= cpol_offset;

    /* Function Body */
    if (cpol[(0 + (0 + (*na + 2 * cpol_dim1 << 2))) / 4] * cpol[(0 + (0 + (1 
	    + 2 * cpol_dim1 << 2))) / 4] <= 0.f) {
	*imatyp = 1;
	*iretyp = 1;
	return 0;
    }

    if (cpol[*na + (cpol_dim1 << 3)] * cpol[(cpol_dim1 << 3) + 1] <= 0.f) {
	*imatyp = 1;
    } else {
	ex = log(cpol[*na + (cpol_dim1 << 3)] / cpol[(cpol_dim1 << 3) + 1]) / 
		log(cpol[*na + (cpol_dim1 << 1)] / cpol[(cpol_dim1 << 1) + 1])
		;
	if (dabs(ex) < .25f) {
	    *imatyp = 1;
	} else if (dabs(ex) < .75f) {
	    *imatyp = 2;
	} else {
	    *imatyp = 3;
	}
    }

    if (cpol[*na + cpol_dim1 * 9] * cpol[cpol_dim1 * 9 + 1] <= 0.f) {
	*iretyp = 1;
    } else {
	ex = log(cpol[*na + cpol_dim1 * 9] / cpol[cpol_dim1 * 9 + 1]) / log(
		cpol[*na + (cpol_dim1 << 1)] / cpol[(cpol_dim1 << 1) + 1]);
	if (dabs(ex) < .25f) {
	    *iretyp = 1;
	} else if (dabs(ex) < .75f) {
	    *iretyp = 2;
	} else {
	    *iretyp = 3;
	}
    }

    return 0;
} /* gettyp_ */

/* Subroutine */ int rescal_(real *scal)
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    static int i__, ip;


/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */








/* -------------------------------------------- */
/*     Rescales forces and moments */
/* -------------------------------------------- */
/* ---- rescale polar forces by SCAL, moments by SCAL**2 */
    i__1 = ppcom_i__1.npol;
    for (ip = 1; ip <= i__1; ++ip) {
	i__2 = ppcom_i__1.na[ip - 1];
	for (i__ = 1; i__ <= i__2; ++i__) {
	    ppcom_r__1.cpol[i__ + (ip * 14 + 2) * 500 - 7501] *= *scal;
	    ppcom_r__1.cpol[i__ + (ip * 14 + 3) * 500 - 7501] *= *scal;
	    ppcom_r__1.cpol[i__ + (ip * 14 + 5) * 500 - 7501] *= *scal;
	    ppcom_r__1.cpol[i__ + (ip * 14 + 4) * 500 - 7501] = 
		    ppcom_r__1.cpol[i__ + (ip * 14 + 4) * 500 - 7501] * *scal 
		    * *scal;
	}
	ppcom_r__1.dxmref[ip - 1] *= *scal;
    }

    return 0;
} /* rescal_ */

/* Subroutine */ int setinc_(void)
{
    static real dcd, dal, dcl, dcm, cdmin, cdmax, clmin, clmax, cmmax, cmmin, 
	    almax, almin, cdspan, alspan, clspan, cmspan;
    static int ncdtics, naltics, ncltics, ncmtics;
    extern /* Subroutine */ int axisadj2_(real *, real *, real *, real *, 
	    int *);


/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */








/* -------------------------------------------- */
/*     Determines axes increments for polars */
/*     from quantities for all polars read in. */
/* -------------------------------------------- */

    clmax = ppcom_r__1.cpolplf[4];
    clmin = ppcom_r__1.cpolplf[3];
    cdmax = ppcom_r__1.cpolplf[7];
    cdmin = ppcom_r__1.cpolplf[6];
    cmmax = ppcom_r__1.cpolplf[10];
    cmmin = ppcom_r__1.cpolplf[9];
    almax = ppcom_r__1.cpolplf[1];
    almin = ppcom_r__1.cpolplf[0];

/* --- CL axes */
    axisadj2_(&clmin, &clmax, &clspan, &dcl, &ncltics);
/* --- CD axes */
    cdmin = 0.f;
    axisadj2_(&cdmin, &cdmax, &cdspan, &dcd, &ncdtics);
/* --- CM axes */
    if (dabs(cmmax) > dabs(cmmin)) {
	cmmin = 0.f;
    } else {
	cmmax = 0.f;
    }
    axisadj2_(&cmmin, &cmmax, &cmspan, &dcm, &ncmtics);
/*      write(*,*) 'cmmin,cmmax ',cmmin,cmmax */
/*      write(*,*) 'dcm,ncmtics ',dcm,ncmtics */
/* --- ALFA axes */
    almin = dmin(0.f,almin);
    axisadj2_(&almin, &almax, &alspan, &dal, &naltics);
    if (almin == 0.f) {
	almin = -dal;
    }

    ppcom_r__1.cpolplf[4] = clmax;
    ppcom_r__1.cpolplf[3] = clmin;
    ppcom_r__1.cpolplf[5] = dcl;
    ppcom_r__1.cpolplf[7] = cdmax;
    ppcom_r__1.cpolplf[6] = cdmin;
    ppcom_r__1.cpolplf[8] = dcd;
    ppcom_r__1.cpolplf[10] = cmmax;
    ppcom_r__1.cpolplf[9] = cmmin;
    ppcom_r__1.cpolplf[11] = dcm;
    ppcom_r__1.cpolplf[1] = almax;
    ppcom_r__1.cpolplf[0] = almin;
    ppcom_r__1.cpolplf[2] = dal;

    return 0;
} /* setinc_ */

/* Subroutine */ int setincv_(void)
{
    static real dvh, dvz, vhmin, vhmax, vzmin, vzmax, vhspan, vzspan;
    static int nvhtics, nvztics;
    extern /* Subroutine */ int axisadj2_(real *, real *, real *, real *, 
	    int *);


/*   PPLOT array limits */

/*     NAX    number of points in one polar */
/*     NPX    number of polars */
/*     NFX    number of points in one reference polar */
/*     NDX    number of reference polars */
/*     ISX    number of airfoil sides */




/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */








/* -------------------------------------------- */
/*     Determines axes increments for polars */
/*     from quantities for all polars read in. */
/* -------------------------------------------- */

    vhmax = ppcom_r__1.vpolplf[1];
    vhmin = ppcom_r__1.vpolplf[0];
    vzmax = ppcom_r__1.vpolplf[4];
    vzmin = ppcom_r__1.vpolplf[3];

/* ---- V axes */
    axisadj2_(&vhmin, &vhmax, &vhspan, &dvh, &nvhtics);

/* ---- Vz axes */
    vzmin = 0.f;
    axisadj2_(&vzmin, &vzmax, &vzspan, &dvz, &nvztics);

    ppcom_r__1.vpolplf[1] = vhmax;
    ppcom_r__1.vpolplf[0] = vhmin;
    ppcom_r__1.vpolplf[2] = dvh;
    ppcom_r__1.vpolplf[4] = vzmax;
    ppcom_r__1.vpolplf[3] = vzmin;
    ppcom_r__1.vpolplf[5] = dvz;

    return 0;
} /* setincv_ */

/* Subroutine */ int axisadj2_(real *xmin, real *xmax, real *xspan, real *
	deltax, int *ntics)
{
    /* Initialized data */

    static real xinctbl[4] = { .1f,.2f,.5f,1.f };

    /* System generated locals */
    real r__1;
    doublereal d__1;

    /* Builtin functions */
    double r_lg10(real *), pow_dd(doublereal *, doublereal *);

    /* Local variables */
    extern int iceiling2_(real *);
    static int i__;
    static real xinc, xpon, xspan1;
    extern int ifloor2_(real *);

/* ...Make scaled axes with engineering increments between tics */

/*   Input:    xmin, xmax - input range for which scaled axis is desired */

/*   Output:   xmin, xmax - adjusted range for scaled axis */
/*             xspan      - adjusted span of scaled axis */
/*             deltax     - increment to be used for scaled axis */
/*             nincr      - number of tics to be used on axis */
/*                          note that ntics=1+(xspan/deltax) */


    xspan1 = *xmax - *xmin;
    if (xspan1 == 0.f) {
	xspan1 = 1.f;
    }

    xpon = (real) ((integer) r_lg10(&xspan1));
    d__1 = (doublereal) xpon;
    *xspan = xspan1 / pow_dd(&c_b533, &d__1);

    for (i__ = 1; i__ <= 4; ++i__) {
	xinc = xinctbl[i__ - 1];
	*ntics = (integer) (*xspan / xinc + .1f) + 1;
	if (*ntics <= 6) {
	    goto L1;
	}
    }

L1:
    d__1 = (doublereal) xpon;
    *deltax = xinc * pow_dd(&c_b533, &d__1);
    r__1 = *xmin / *deltax;
    *xmin = *deltax * ifloor2_(&r__1);
    r__1 = *xmax / *deltax;
    *xmax = *deltax * iceiling2_(&r__1);
    *xspan = *xmax - *xmin;
    *ntics = (integer) (*xspan / xinc + .1f) + 1;
    return 0;
} /* axisadj2_ */

int iceiling2_(real *x)
{
    /* System generated locals */
    int ret_val;

    /* Local variables */
    static int i__;

/* --- returns next highest int value if fraction is non-zero */
    i__ = (integer) (*x);
    if (*x - i__ > 0.f) {
	++i__;
    }
    ret_val = i__;
    return ret_val;
} /* iceiling2_ */

int ifloor2_(real *x)
{
    /* System generated locals */
    int ret_val;

    /* Local variables */
    static int i__;

/* --- returns next lowest int value if fraction is negative, non-zero */
    i__ = (integer) (*x);
    if (*x - i__ < 0.f) {
	--i__;
    }
    ret_val = i__;
    return ret_val;
} /* ifloor2_ */

/* Main program alias */ int pplot_ () { MAIN__ (); return 0; }
