/* f/aread.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__1 = 1;
static int c__9 = 9;

/* Subroutine */ int aread_(int *lu, char *fname, int *nmax, real *x, 
	real *y, int *n, char *name__, char *ispars, int *itype, 
	int *info, ftnlen fname_len, ftnlen name_len, ftnlen ispars_len)
{
    /* Format strings */
    static char fmt_1000[] = "(a)";
    static char fmt_5030[] = "(/\002 Buffer array size exceeded\002/\002 Max"
	    "imum number of points: \002,i4)";
    static char fmt_5900[] = "(\002 *** LOAD NOT COMPLETED ***\002)";
    static char fmt_5050[] = "(/\002 File OPEN error.  Nonexistent file: "
	    " \002,a)";
    static char fmt_5100[] = "(/\002 File READ error.  Unrecognizable file f"
	    "ormat\002)";

    /* System generated locals */
    int i__1, i__2;
    olist o__1;
    cllist cl__1;
    alist al__1;

    /* Builtin functions */
    int f_open(olist *), s_rsfe(cilist *), do_fio(int *, char *, 
	    ftnlen), e_rsfe(void), i_indx(char *, char *, ftnlen, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_wsle(cilist *), e_wsle(void), do_lio(int *, int *, char 
	    *, ftnlen), f_rew(alist *), s_wsfe(cilist *), e_wsfe(void), 
	    f_clos(cllist *);

    /* Local variables */
    static real a[10];
    static int i__, na, iel, nel, nfn;
    static char line[80];
    extern /* Subroutine */ int aski_(char *, int *, ftnlen);
    static char line1[80], line2[80];
    static logical lopen, error;
    extern /* Subroutine */ int getflt_(char *, real *, int *, logical *, 
	    ftnlen);

    /* Fortran I/O blocks */
    static cilist io___4 = { 1, 0, 1, fmt_1000, 0 };
    static cilist io___6 = { 0, 0, 1, fmt_1000, 0 };
    static cilist io___12 = { 0, 6, 0, 0, 0 };
    static cilist io___13 = { 0, 6, 0, 0, 0 };
    static cilist io___14 = { 0, 6, 0, 0, 0 };
    static cilist io___15 = { 0, 6, 0, 0, 0 };
    static cilist io___16 = { 0, 0, 1, fmt_1000, 0 };
    static cilist io___17 = { 0, 6, 0, 0, 0 };
    static cilist io___18 = { 0, 6, 0, 0, 0 };
    static cilist io___19 = { 0, 0, 1, fmt_1000, 0 };
    static cilist io___21 = { 0, 6, 0, fmt_5030, 0 };
    static cilist io___22 = { 0, 6, 0, fmt_5900, 0 };
    static cilist io___24 = { 0, 6, 0, fmt_5050, 0 };
    static cilist io___25 = { 0, 6, 0, fmt_5900, 0 };
    static cilist io___26 = { 0, 6, 0, fmt_5100, 0 };
    static cilist io___27 = { 0, 6, 0, fmt_5900, 0 };


/* -------------------------------------------------------- */
/*     Reads in several types of airfoil coordinate file. */

/*  Input: */
/*       LU      logical unit to use for reading */
/*       FNAME   name of coordinate file to be read, */
/*               if FNAME(1:1).eq.' ', unit LU is assumed */
/*               to be already open */
/*       INFO   0 keep quiet */
/*              1 print info on airfoil */
/*  Output: */
/*       X,Y     coordinates */
/*       N       number of X,Y coordinates */
/*       NAME    character name string        (if ITYPE > 1) */
/*       ISPARS  ISES/MSES domain-size string (if ITYPE > 2) */
/*       ITYPE returns type of file: */
/*           0  None.  Read error occurred. */
/*           1  Generic. */
/*           2  Labeled generic. */
/*           3  MSES single element. */
/*           4  MSES multi-element. */
/* -------------------------------------------------------- */

    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    iel = 0;
    nel = 0;

/* ---- assume read error will occur */
    *itype = 0;

    lopen = *(unsigned char *)fname != ' ';
    if (lopen) {
	o__1.oerr = 1;
	o__1.ounit = *lu;
	o__1.ofnmlen = fname_len;
	o__1.ofnm = fname;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L98;
	}
    }

L11:
    io___4.ciunit = *lu;
    i__1 = s_rsfe(&io___4);
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = do_fio(&c__1, line1, (ftnlen)80);
    if (i__1 != 0) {
	goto L100001;
    }
    i__1 = e_rsfe();
L100001:
    if (i__1 < 0) {
	goto L99;
    }
    if (i__1 > 0) {
	goto L98;
    }
    if (i_indx("#!", line1, (ftnlen)2, (ftnlen)1) != 0) {
	goto L11;
    }

L12:
    io___6.ciunit = *lu;
    i__1 = s_rsfe(&io___6);
    if (i__1 != 0) {
	goto L99;
    }
    i__1 = do_fio(&c__1, line2, (ftnlen)80);
    if (i__1 != 0) {
	goto L99;
    }
    i__1 = e_rsfe();
    if (i__1 != 0) {
	goto L99;
    }
    if (i_indx("#!", line2, (ftnlen)2, (ftnlen)1) != 0) {
	goto L12;
    }

    i__ = 1;

/* ---- try to read two numbers from first line */
    na = 2;
    getflt_(line1, a, &na, &error, (ftnlen)80);
    if (error || na < 2) {
/* ------ must be a name string */
	s_copy(name__, line1, name_len, (ftnlen)80);
    } else {
/* ------ no name, just two valid numbers... must be plain airfoil file */
	if (*info > 0) {
	    s_wsle(&io___12);
	    e_wsle();
	    s_wsle(&io___13);
	    do_lio(&c__9, &c__1, "Plain airfoil file", (ftnlen)18);
	    e_wsle();
	}
	*itype = 1;
	al__1.aerr = 0;
	al__1.aunit = *lu;
	f_rew(&al__1);
	goto L50;
    }

/* ---- if we got here, there's a name line, */
/* -    so now try to read four MSES domain numbers from second line */
    na = 4;
    getflt_(line2, a, &na, &error, (ftnlen)80);
    if (error || na < 2) {
/* ------ less than two valid numbers... not a valid format */
	goto L99;

    } else if (na == 2) {
/* ------ only two numbers... usual .dat labeled file */
	s_copy(name__, line1, name_len, (ftnlen)80);
	if (*info > 0) {
	    s_wsle(&io___14);
	    e_wsle();
	    s_wsle(&io___15);
	    do_lio(&c__9, &c__1, "Labeled airfoil file.  Name:  ", (ftnlen)30)
		    ;
	    do_lio(&c__9, &c__1, name__, name_len);
	    e_wsle();
	}
	*itype = 2;
	al__1.aerr = 0;
	al__1.aunit = *lu;
	f_rew(&al__1);
	io___16.ciunit = *lu;
	i__1 = s_rsfe(&io___16);
	if (i__1 != 0) {
	    goto L99;
	}
	i__1 = do_fio(&c__1, line1, (ftnlen)80);
	if (i__1 != 0) {
	    goto L99;
	}
	i__1 = e_rsfe();
	if (i__1 != 0) {
	    goto L99;
	}
	goto L50;

    } else {
/* ------ four or more numbers... MSES or MISES file */
	if (*info > 0) {
	    s_wsle(&io___17);
	    e_wsle();
	    s_wsle(&io___18);
	    do_lio(&c__9, &c__1, "MSES airfoil file.  Name:  ", (ftnlen)27);
	    do_lio(&c__9, &c__1, name__, name_len);
	    e_wsle();
	}
	*itype = 3;
	s_copy(ispars, line2, ispars_len, (ftnlen)80);
    }

/* ---- read each element until 999.0 or end of file is encountered */
L50:
    ++nel;
    i__1 = *nmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
L51:
	io___19.ciunit = *lu;
	i__2 = s_rsfe(&io___19);
	if (i__2 != 0) {
	    goto L60;
	}
	i__2 = do_fio(&c__1, line, (ftnlen)80);
	if (i__2 != 0) {
	    goto L60;
	}
	i__2 = e_rsfe();
	if (i__2 != 0) {
	    goto L60;
	}

/* ------ skip comment line */
	if (i_indx("#!", line, (ftnlen)2, (ftnlen)1) != 0) {
	    goto L51;
	}

	na = 2;
	getflt_(line, a, &na, &error, (ftnlen)80);
	if (error) {
	    goto L99;
	}

/* ------ skip line without at least two numbers */
	if (na < 2) {
	    goto L51;
	}

	x[i__] = a[0];
	y[i__] = a[1];

	if (x[i__] == 999.f && y[i__] == 999.f) {
/* -------- if this is the element we want, just exit */
	    if (iel == nel) {
		goto L60;
	    }

	    if (iel == 0) {
		aski_("Enter element number^", &iel, (ftnlen)21);
		*itype = 4;
	    }

/* -------- if this is the specified element, exit. */
	    if (iel == nel) {
		goto L60;
	    }
	    goto L50;
	}
/* L55: */
    }
    s_wsfe(&io___21);
    do_fio(&c__1, (char *)&(*nmax), (ftnlen)sizeof(integer));
    e_wsfe();
    s_wsfe(&io___22);
    e_wsfe();
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    *itype = 0;
    return 0;

L60:
    *n = i__ - 1;
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    return 0;

L98:
    nfn = i_indx(fname, " ", fname_len, (ftnlen)1) + 1;
    s_wsfe(&io___24);
    do_fio(&c__1, fname, nfn);
    e_wsfe();
    s_wsfe(&io___25);
    e_wsfe();
    *itype = 0;
    return 0;

L99:
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    s_wsfe(&io___26);
    e_wsfe();
    s_wsfe(&io___27);
    e_wsfe();
    *itype = 0;
    return 0;
/* ............................................................... */
} /* aread_ */
