/* f/iopol.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static int c__1 = 1;
static int c__4 = 4;
static int c__3 = 3;
static int c__9 = 9;
static int c__2 = 2;

/* *********************************************************************** */
/*    Module:  iopol.f */

/*    Copyright (C) 2000 Mark Drela, Harold Youngren */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int polread_(int *lu, char *fnpol, logical *error, 
	int *nax, int *na, real *cpol, real *reyn1, real *mach1, real 
	*acrit, real *xtrip, real *ptrat, real *etap, char *name__, int *
	iretyp, int *imatyp, int *isx, int *nbl, real *cpolsd, 
	char *code, real *version, ftnlen fnpol_len, ftnlen name_len, ftnlen 
	code_len)
{
    /* Initialized data */

    static char cpolname[10*14] = "alpha     " "CL        " "CD        " 
	    "CM        " "CDw       " "CDv       " "CDp       " "Mach      " 
	    "Re        " "Ncrit     " "Chinge    " "Cpmin     " "CDh       " 
	    "Cmdot     ";
    static char cpolsname[5*2] = "Xtrip" "Xtr  ";

    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    address a__1[2];
    int cpol_dim1, cpol_offset, cpolsd_dim1, cpolsd_dim2, cpolsd_offset, 
	    i__1, i__2, i__3[2];
    real r__1;
    icilist ici__1;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    int s_cmp(char *, char *, ftnlen, ftnlen), f_open(olist *), s_rsfe(
	    cilist *), do_fio(int *, char *, ftnlen), e_rsfe(void), 
	    i_indx(char *, char *, ftnlen, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int s_rsli(icilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_rsli(void), s_wsle(cilist *), e_wsle(void);
    /* Subroutine */ int s_cat(char *, char **, int *, int *, ftnlen);
    double sqrt(doublereal);
    int f_clos(cllist *);

    /* Local variables */
    static int k, n, k1, k2, ia, kb, ke, kf, km, ip, jp, kp, is, kr, ks, 
	    kt, is1, is2;
    static real acl;
    static int ipt, kend;
    static logical lima, linc;
    static char line[128];
    static logical lire;
    static int ipol[14], ninp;
    static real rinp[19];
    static int itmp[18];
    static logical ljtp;
    static int itmp0[18];
    static logical lhead, ldlab;
    static int nname;
    static logical lopen;
    static int ipass, nipol, ispol[4]	/* was [2][2] */;
    extern /* Subroutine */ int strip_(char *, int *, ftnlen);
    static int itmpp1;
    static char cpname[20];
    extern /* Subroutine */ int getflt_(char *, real *, int *, logical *, 
	    ftnlen);

    /* Fortran I/O blocks */
    static cilist io___12 = { 0, 0, 1, fmt_1000, 0 };
    static cilist io___19 = { 0, 6, 0, 0, 0 };



/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */


/* -------------------------------------------------------- */
/*     Reads in polar save file */

/*  Input: */
/*     LU      logical unit to use for reading */
/*     FNPOL   name of polar file to be read, */
/*               if FNPOL(1:1).eq.' ', unit LU will be read */
/*               if it is already open */
/*     NAX     polar point array dimension */
/*     ISX     airfoil side array dimension */

/*  Output: */
/*     ERROR   T if a READ error occurred */
/*     NA      number polar points */
/*     CPOL    polar coefficients and parameters */
/*     REYN1   Reynolds number for CL=1 */
/*     MACH1   Mach number for CL=1 */
/*     ACRIT   Critical amplification ratio */
/*     XTRIP   Trip locations */
/*     PTRAT   Actuator disk total-pressure ratio */
/*     ETAP    Actuator disk thermal efficiency */
/*     NAME    airfoil name string */
/*     IRETYP  flag giving type of Re variation with CL */
/*     IMATYP  flag giving type of Ma variation with CL */
/*     NBL     number of airfoil elements */
/*     CPOLSD  airfoil side-related parameters */
/*     CODE    code used to compute polar */
/*     VERSION code version */
/* -------------------------------------------------------- */




    /* Parameter adjustments */
    cpol_dim1 = *nax;
    cpol_offset = 1 + cpol_dim1;
    cpol -= cpol_offset;
    cpolsd_dim1 = *nax;
    cpolsd_dim2 = *isx;
    cpolsd_offset = 1 + cpolsd_dim1 * (1 + cpolsd_dim2);
    cpolsd -= cpolsd_offset;
    --xtrip;

    /* Function Body */
    *error = FALSE_;
    lhead = TRUE_;

    *na = 0;
    *nbl = 1;

/*      KCH = 0 */
/*      KMC = 0 */

    nipol = 0;
    for (ip = 1; ip <= 14; ++ip) {
	ipol[ip - 1] = 0;
    }
    for (jp = 1; jp <= 2; ++jp) {
	ispol[(jp << 1) - 2] = 0;
	ispol[(jp << 1) - 1] = 0;
    }

/* ---- assume Re,Mach will not be given in header */
    *iretyp = 0;
    *imatyp = 0;

/* ---- do we have to open the file? */
    lopen = s_cmp(fnpol, " ", fnpol_len, (ftnlen)1) != 0;

    if (lopen) {
	o__1.oerr = 1;
	o__1.ounit = *lu;
	o__1.ofnmlen = fnpol_len;
	o__1.ofnm = fnpol;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L90;
	}
    }

/* ============================================================= */
/* ---- start data reading loop */
L500:
    io___12.ciunit = *lu;
    i__1 = s_rsfe(&io___12);
    if (i__1 != 0) {
	goto L80;
    }
    i__1 = do_fio(&c__1, line, (ftnlen)128);
    if (i__1 != 0) {
	goto L80;
    }
    i__1 = e_rsfe();
    if (i__1 != 0) {
	goto L80;
    }
    if (s_cmp(line, " ", (ftnlen)128, (ftnlen)1) == 0) {
	goto L500;
    }

    if (lhead) {
/* ----- parse to get header info */

/* ----- assume this will be the data-label line */
	ldlab = TRUE_;

/* -------------------------------------------- */
	k = i_indx(line, "Version", (ftnlen)128, (ftnlen)7);
	if (k != 0) {
/* ------ code,version line */
	    for (k1 = 1; k1 <= 128; ++k1) {
		if (*(unsigned char *)&line[k1 - 1] != ' ') {
		    goto L10;
		}
	    }

L10:
	    if (k > k1) {
		s_copy(code, line + (k1 - 1), code_len, k - 1 - (k1 - 1));
		i__2 = k + 6;
		ici__1.icierr = 1;
		ici__1.iciend = 0;
		ici__1.icirnum = 1;
		ici__1.icirlen = 128 - i__2;
		ici__1.iciunit = line + i__2;
		ici__1.icifmt = 0;
		i__1 = s_rsli(&ici__1);
		if (i__1 != 0) {
		    goto L11;
		}
		i__1 = do_lio(&c__4, &c__1, (char *)&(*version), (ftnlen)
			sizeof(real));
		if (i__1 != 0) {
		    goto L11;
		}
		i__1 = e_rsli();
		if (i__1 != 0) {
		    goto L11;
		}
	    }
L11:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	kf = i_indx(line, "for:", (ftnlen)128, (ftnlen)4);
	if (kf != 0) {
/* ------ airfoil name line */
	    i__1 = kf + 4;
	    s_copy(name__, line + i__1, name_len, 128 - i__1);
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	ke = i_indx(line, "elements", (ftnlen)128, (ftnlen)8);
	if (ke > 0) {
/* ------ element-number line */
	    i__2 = ke - 5;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = ke - 1 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L60;
	    }
	    i__1 = do_lio(&c__3, &c__1, (char *)&(*nbl), (ftnlen)sizeof(
		    integer));
	    if (i__1 != 0) {
		goto L60;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L60;
	    }
/* ------ truncate name line to eliminate elements # */
	    i__1 = kf + 4;
	    s_copy(name__, line + i__1, name_len, ke - 4 - i__1);

	    if (*nbl << 1 > *isx) {
		*nbl = *isx / 2;
		s_wsle(&io___19);
		do_lio(&c__9, &c__1, "POLREAD: Number of elements set to arr"
			"ay limit", (ftnlen)46);
		do_lio(&c__3, &c__1, (char *)&(*nbl), (ftnlen)sizeof(integer))
			;
		e_wsle();
	    }
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	kr = i_indx(line, "Reynolds number", (ftnlen)128, (ftnlen)15);
	km = i_indx(line, "Mach number", (ftnlen)128, (ftnlen)11);

	if (kr != 0) {
/* ------ Re-type line */
	    if (km > kr) {
		kend = km - 1;
	    } else {
		kend = 128;
	    }
	    if (i_indx(line + (kr - 1), "fixed", kend - (kr - 1), (ftnlen)5) 
		    != 0) {
		*iretyp = 1;
	    } else if (i_indx(line + (kr - 1), "1/sqrt(CL)", kend - (kr - 1), 
		    (ftnlen)10) != 0) {
		*iretyp = 2;
	    } else if (i_indx(line + (kr - 1), "1/CL", kend - (kr - 1), (
		    ftnlen)4) != 0) {
		*iretyp = 3;
	    }
	    ldlab = FALSE_;
	}

	if (km != 0) {
/* ------ Ma-type line */
	    if (kr > km) {
		kend = kr - 1;
	    } else {
		kend = 128;
	    }
	    if (i_indx(line + (km - 1), "fixed", kend - (km - 1), (ftnlen)5) 
		    != 0) {
		*imatyp = 1;
	    } else if (i_indx(line + (km - 1), "1/sqrt(CL)", kend - (km - 1), 
		    (ftnlen)10) != 0) {
		*imatyp = 2;
	    } else if (i_indx(line + (km - 1), "1/CL", kend - (km - 1), (
		    ftnlen)4) != 0) {
		*imatyp = 3;
	    }
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
/* ---- find specified BL trip location */
	k = i_indx(line, "xtrf", (ftnlen)128, (ftnlen)4);
	if (k != 0) {
/* ------ new style xtrip line */
	    kt = i_indx(line, "(top)", (ftnlen)128, (ftnlen)5);
	    kb = i_indx(line, "(bottom)", (ftnlen)128, (ftnlen)8);
	    ke = i_indx(line, "element ", (ftnlen)128, (ftnlen)8);
/* --- check for old style trip line */
	    ks = i_indx(line, "(suc", (ftnlen)128, (ftnlen)4);
	    kp = i_indx(line, "(pre", (ftnlen)128, (ftnlen)4);

	    if (ke != 0) {
		i__2 = ke + 6;
		ici__1.icierr = 1;
		ici__1.iciend = 0;
		ici__1.icirnum = 1;
		ici__1.icirlen = ke + 12 - i__2;
		ici__1.iciunit = line + i__2;
		ici__1.icifmt = 0;
		i__1 = s_rsli(&ici__1);
		if (i__1 != 0) {
		    goto L21;
		}
		i__1 = do_lio(&c__3, &c__1, (char *)&n, (ftnlen)sizeof(
			integer));
		if (i__1 != 0) {
		    goto L21;
		}
		i__1 = e_rsli();
		if (i__1 != 0) {
		    goto L21;
		}
	    } else {
		n = 1;
	    }
	    if (n <= *nbl) {
		is1 = (n << 1) - 1;
		is2 = n << 1;
		xtrip[is1] = 1.f;
		xtrip[is2] = 1.f;
		if (kt > 0) {
		    i__2 = k + 5;
		    ici__1.icierr = 1;
		    ici__1.iciend = 0;
		    ici__1.icirnum = 1;
		    ici__1.icirlen = kt - 1 - i__2;
		    ici__1.iciunit = line + i__2;
		    ici__1.icifmt = 0;
		    i__1 = s_rsli(&ici__1);
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = do_lio(&c__4, &c__1, (char *)&xtrip[is1], (ftnlen)
			    sizeof(real));
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = e_rsli();
		    if (i__1 != 0) {
			goto L21;
		    }
		}
		if (kb > kt) {
		    i__2 = kt + 4;
		    ici__1.icierr = 1;
		    ici__1.iciend = 0;
		    ici__1.icirnum = 1;
		    ici__1.icirlen = kb - 1 - i__2;
		    ici__1.iciunit = line + i__2;
		    ici__1.icifmt = 0;
		    i__1 = s_rsli(&ici__1);
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = do_lio(&c__4, &c__1, (char *)&xtrip[is2], (ftnlen)
			    sizeof(real));
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = e_rsli();
		    if (i__1 != 0) {
			goto L21;
		    }
		}
		if (ks > 0) {
		    i__2 = k + 5;
		    ici__1.icierr = 1;
		    ici__1.iciend = 0;
		    ici__1.icirnum = 1;
		    ici__1.icirlen = ks - 1 - i__2;
		    ici__1.iciunit = line + i__2;
		    ici__1.icifmt = 0;
		    i__1 = s_rsli(&ici__1);
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = do_lio(&c__4, &c__1, (char *)&xtrip[is1], (ftnlen)
			    sizeof(real));
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = e_rsli();
		    if (i__1 != 0) {
			goto L21;
		    }
		}
		if (kp > ks) {
		    i__2 = ks + 4;
		    ici__1.icierr = 1;
		    ici__1.iciend = 0;
		    ici__1.icirnum = 1;
		    ici__1.icirlen = kp - 1 - i__2;
		    ici__1.iciunit = line + i__2;
		    ici__1.icifmt = 0;
		    i__1 = s_rsli(&ici__1);
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = do_lio(&c__4, &c__1, (char *)&xtrip[is2], (ftnlen)
			    sizeof(real));
		    if (i__1 != 0) {
			goto L21;
		    }
		    i__1 = e_rsli();
		    if (i__1 != 0) {
			goto L21;
		    }
		}
	    }
L21:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	k = i_indx(line, "Mach =", (ftnlen)128, (ftnlen)6);
	if (k != 0) {
	    i__2 = k + 5;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 128 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L31;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&(*mach1), (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L31;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L31;
	    }
L31:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	k = i_indx(line, "Re =", (ftnlen)128, (ftnlen)4);
	if (k != 0) {
	    i__2 = k + 3;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 128 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L32;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&(*reyn1), (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L32;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L32;
	    }
	    *reyn1 *= 1e6f;
L32:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	k = i_indx(line, "Ncrit =", (ftnlen)128, (ftnlen)7);
	if (k != 0) {
	    i__2 = k + 6;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 128 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L33;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&(*acrit), (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L33;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L33;
	    }
L33:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	k = i_indx(line, "pi_p =", (ftnlen)128, (ftnlen)6);
	if (k != 0) {
	    i__2 = k + 5;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 128 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L34;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&(*ptrat), (ftnlen)sizeof(
		    real));
	    if (i__1 != 0) {
		goto L34;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L34;
	    }
L34:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	k = i_indx(line, "eta_p =", (ftnlen)128, (ftnlen)7);
	if (k != 0) {
	    i__2 = k + 6;
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = 128 - i__2;
	    ici__1.iciunit = line + i__2;
	    ici__1.icifmt = 0;
	    i__1 = s_rsli(&ici__1);
	    if (i__1 != 0) {
		goto L35;
	    }
	    i__1 = do_lio(&c__4, &c__1, (char *)&(*etap), (ftnlen)sizeof(real)
		    );
	    if (i__1 != 0) {
		goto L35;
	    }
	    i__1 = e_rsli();
	    if (i__1 != 0) {
		goto L35;
	    }
L35:
	    ldlab = FALSE_;
	}

/* -------------------------------------------- */
	if (ldlab && nipol == 0) {
/* ------ process line for possible data labels */
	    for (ip = 1; ip <= 14; ++ip) {
		strip_(cpolname + (ip - 1) * 10, &nname, (ftnlen)10);

/* -------- mark this parameter for reading */
		k = i_indx(line, cpolname + (ip - 1) * 10, (ftnlen)128, nname)
			;
		itmp0[ip - 1] = k;
		itmp[ip - 1] = k;
	    }

	    for (jp = 1; jp <= 2; ++jp) {
		strip_(cpolsname + (jp - 1) * 5, &nname, (ftnlen)5);

/* Writing concatenation */
		i__3[0] = 4, a__1[0] = "Top ";
		i__3[1] = 5, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(cpname, a__1, i__3, &c__2, (ftnlen)20);
		k1 = i_indx(line, cpname, (ftnlen)128, nname + 4);
/* Writing concatenation */
		i__3[0] = 4, a__1[0] = "Top_";
		i__3[1] = 5, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(cpname, a__1, i__3, &c__2, (ftnlen)20);
		k2 = i_indx(line, cpname, (ftnlen)128, nname + 4);
		itmp0[jp + 13] = max(k1,k2);
		itmp[jp + 13] = max(k1,k2);

/* Writing concatenation */
		i__3[0] = 4, a__1[0] = "Bot ";
		i__3[1] = 5, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(cpname, a__1, i__3, &c__2, (ftnlen)20);
		k1 = i_indx(line, cpname, (ftnlen)128, nname + 4);
/* Writing concatenation */
		i__3[0] = 4, a__1[0] = "Bot_";
		i__3[1] = 5, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(cpname, a__1, i__3, &c__2, (ftnlen)20);
		k2 = i_indx(line, cpname, (ftnlen)128, nname + 4);
		itmp0[jp + 15] = max(k1,k2);
		itmp[jp + 15] = max(k1,k2);
	    }

/* ------ bubble-sort data label positions in line string */
	    for (ipass = 1; ipass <= 18; ++ipass) {
		for (ip = 1; ip <= 17; ++ip) {
		    if (itmp[ip - 1] > itmp[ip]) {
			itmpp1 = itmp[ip];
			itmp[ip] = itmp[ip - 1];
			itmp[ip - 1] = itmpp1;
		    }
		}
	    }

/* ------ assign data position to each parameter */
	    for (ipt = 1; ipt <= 18; ++ipt) {
		if (itmp[ipt - 1] > 0) {
		    ++nipol;
		    for (ip = 1; ip <= 14; ++ip) {
			if (itmp[ipt - 1] == itmp0[ip - 1]) {
			    ipol[ip - 1] = nipol;
			}
		    }
		    for (jp = 1; jp <= 2; ++jp) {
			if (itmp[ipt - 1] == itmp0[jp + 13]) {
			    ispol[(jp << 1) - 2] = nipol;
			}
			if (itmp[ipt - 1] == itmp0[jp + 15]) {
			    ispol[(jp << 1) - 1] = nipol;
			}
		    }
		}
	    }

	}

/* -------------------------------------------- */
	if (i_indx(line, "-----", (ftnlen)128, (ftnlen)5) != 0) {
	    lhead = FALSE_;
	}

/* -------------------------------------------------------------- */
    } else {
/* ----- read polar data lines */
	ia = *na + 1;

	ninp = 18;
	getflt_(line, &rinp[1], &ninp, error, (ftnlen)128);
	if (*error) {
	    goto L90;
	}

	for (ip = 1; ip <= 14; ++ip) {
	    cpol[ia + ip * cpol_dim1] = rinp[ipol[ip - 1]];
	}

	for (jp = 1; jp <= 2; ++jp) {
	    i__1 = *nbl;
	    for (n = 1; n <= i__1; ++n) {
		is1 = (n << 1) - 1;
		is2 = n << 1;
		cpolsd[ia + (is1 + jp * cpolsd_dim2) * cpolsd_dim1] = rinp[
			ispol[(jp << 1) - 2] + (n - 1 << 1)];
		cpolsd[ia + (is2 + jp * cpolsd_dim2) * cpolsd_dim1] = rinp[
			ispol[(jp << 1) - 1] + (n - 1 << 1)];
	    }
	}

/* Computing MAX */
	r__1 = cpol[ia + (cpol_dim1 << 1)];
	acl = dmax(r__1,.001f);


/* ----- try to find Re, Ma, Ncrit, Xtrip  in polar data */
	lire = FALSE_;
	lima = FALSE_;
	linc = FALSE_;
	ljtp = FALSE_;
	i__1 = nipol;
	for (kp = 1; kp <= i__1; ++kp) {
	    if (ipol[kp - 1] == 9) {
		lire = TRUE_;
	    }
	    if (ipol[kp - 1] == 8) {
		lima = TRUE_;
	    }
	    if (ipol[kp - 1] == 10) {
		linc = TRUE_;
	    }
	    if (ispol[(kp << 1) - 2] == 1) {
		ljtp = TRUE_;
	    }
	}

	if (! lire) {
/* ------ Re was not in polar data... set using header info */
	    if (*iretyp == 1) {
		cpol[ia + cpol_dim1 * 9] = *reyn1;
	    } else if (*iretyp == 2) {
		cpol[ia + cpol_dim1 * 9] = *reyn1 / sqrt(acl);
	    } else if (*iretyp == 3) {
		cpol[ia + cpol_dim1 * 9] = *reyn1 / acl;
	    }
	}

	if (! lima) {
/* ------ Mach was not in polar data... set using header info */
	    if (*imatyp == 1) {
		cpol[ia + (cpol_dim1 << 3)] = *mach1;
	    } else if (*imatyp == 2) {
		cpol[ia + (cpol_dim1 << 3)] = *mach1 / sqrt(acl);
	    } else if (*imatyp == 3) {
		cpol[ia + (cpol_dim1 << 3)] = *mach1 / acl;
	    }
	}

	if (! linc) {
/* ------ Ncrit was not in polar data... set using header info */
	    cpol[ia + cpol_dim1 * 10] = *acrit;
	}

	if (! ljtp) {
/* ------ set trip data using header info */
	    i__1 = *nbl << 1;
	    for (is = 1; is <= i__1; ++is) {
		cpolsd[ia + (is + cpolsd_dim2) * cpolsd_dim1] = xtrip[is];
	    }
	}

	*na = ia;
    }

L60:
/* ---- go read next line */
    goto L500;
/* ============================================================= */

L80:
/* ---- if file was opened here, then close it */
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    return 0;

L90:
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    *error = TRUE_;
    return 0;

/* .......................................... */
} /* polread_ */

/* Subroutine */ int polwrit_(int *lu, char *fnpol, logical *error, 
	logical *lhead, int *nax, int *ia1, int *ia2, real *cpol, 
	int *ipol, int *nipol, real *reyn1, real *mach1, real *acrit, 
	real *xtrip, real *ptrat, real *etap, char *name__, int *iretyp, 
	int *imatyp, int *isx, int *nbl, real *cpolsd, int *
	jpol, int *njpol, char *code, real *version, logical *lquery, 
	ftnlen fnpol_len, ftnlen name_len, ftnlen code_len)
{
    /* Initialized data */

    static char cpolname[10*14] = "alpha     " "CL        " "CD        " 
	    "CM        " "CDw       " "CDv       " "CDp       " "Mach      " 
	    "Re        " "Ncrit     " "Chinge    " "Cpmin     " "CDh       " 
	    "Cmdot     ";
    static char cpolform[6*14] = "F7.3  " "F9.4  " "F10.5 " "F9.4  " "F10.5 " 
	    "F10.5 " "F10.5 " "F8.4  " "E11.3 " "F7.3  " "F10.5 " "F9.4  " 
	    "F11.5 " "F9.5  ";
    static char cpolsname[5*2] = "Xtrip" "Xtr  ";
    static char cpolsform[6*2] = "F9.4  " "F9.4  ";

    /* Format strings */
    static char fmt_1000[] = "(a)";
    static char fmt_8000[] = "(7x,a,9x,\002Version\002,f5.2)";
    static char fmt_9001[] = "(1x,\002Calculated polar for: \002,a)";
    static char fmt_9002[] = "(1x,\002Calculated polar for: \002,a,i4,\002 e"
	    "lements\002)";
    static char fmt_9006[] = "(1x,3x,2a29)";
    static char fmt_9005[] = "(1x,i1,i2,2a29)";
    static char fmt_9011[] = "(1x,\002xtrf = \002,f7.3,\002 (top)    \002,f9"
	    ".3,\002 (bottom)  \002)";
    static char fmt_9012[] = "(1x,\002xtrf = \002,f7.3,\002 (top)    \002,f9"
	    ".3,\002 (bottom)     element\002,i3)";
    static char fmt_9015[] = "(1x,\002Mach = \002,f7.3,5x,\002Re = \002,f9"
	    ".3,\002 e 6\002,5x,\002Ncrit = \002,f7.3)";
    static char fmt_9017[] = "(1x,\002pi_p = \002,f7.4,5x,\002eta_p = \002,f"
	    "9.4)";

    /* System generated locals */
    address a__1[2];
    int cpol_dim1, cpol_offset, cpolsd_dim1, cpolsd_dim2, cpolsd_offset, 
	    i__1, i__2, i__3, i__4[2], i__5;
    real r__1;
    icilist ici__1;
    olist o__1;
    cllist cl__1;
    alist al__1;

    /* Builtin functions */
    int s_cmp(char *, char *, ftnlen, ftnlen), f_open(olist *), s_wsle(
	    cilist *), e_wsle(void), do_lio(int *, int *, char *, 
	    ftnlen), s_rsfe(cilist *), do_fio(int *, char *, ftnlen), 
	    e_rsfe(void), i_indx(char *, char *, ftnlen, ftnlen), f_clos(
	    cllist *), f_rew(alist *), s_wsfe(cilist *), e_wsfe(void);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int i_len(char *, ftnlen), s_rsli(icilist *), e_rsli(void);
    /* Subroutine */ int s_cat(char *, char **, int *, int *, ftnlen),
	     s_stop(char *, ftnlen);

    /* Local variables */
    static int n, ia, kd, kf, nf, kl, ip, jp, kp, is, is1, is2;
    static char ans[1];
    static int kdot;
    static char line1[29], line2[29];
    static int iffbc;
    static char lined[128], linef[128];
    static int nname;
    static char linel[128];
    static logical lopen;
    static int nform, ismom;
    extern /* Subroutine */ int strip_(char *, int *, ftnlen);
    static int nblank;

    /* Fortran I/O blocks */
    static cilist io___52 = { 0, 6, 0, 0, 0 };
    static cilist io___53 = { 0, 6, 0, 0, 0 };
    static cilist io___54 = { 0, 5, 0, fmt_1000, 0 };
    static cilist io___56 = { 0, 6, 0, 0, 0 };
    static cilist io___57 = { 0, 0, 0, 0, 0 };
    static cilist io___58 = { 0, 0, 0, fmt_8000, 0 };
    static cilist io___59 = { 0, 0, 0, 0, 0 };
    static cilist io___60 = { 0, 0, 0, fmt_9001, 0 };
    static cilist io___61 = { 0, 0, 0, fmt_9002, 0 };
    static cilist io___66 = { 0, 0, 0, fmt_9006, 0 };
    static cilist io___67 = { 0, 0, 0, 0, 0 };
    static cilist io___68 = { 0, 0, 0, fmt_9005, 0 };
    static cilist io___69 = { 0, 0, 0, 0, 0 };
    static cilist io___73 = { 0, 0, 0, fmt_9011, 0 };
    static cilist io___74 = { 0, 0, 0, fmt_9012, 0 };
    static cilist io___75 = { 0, 0, 0, fmt_9015, 0 };
    static cilist io___76 = { 0, 0, 0, fmt_9017, 0 };
    static cilist io___77 = { 0, 0, 0, 0, 0 };
    static cilist io___89 = { 0, 0, 0, fmt_1000, 0 };
    static cilist io___90 = { 0, 0, 0, fmt_1000, 0 };
    static cilist io___95 = { 0, 0, 0, linef, 0 };
    static cilist io___97 = { 0, 6, 0, 0, 0 };



/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */


/* -------------------------------------------------------- */
/*     Writes polar save file */

/*  Input: */
/*     LU       logical unit to use for writing */
/*     FNPOL    name of polar file to be read, */
/*                if FNPOL(1:1).eq.' ', unit LU is assumed */
/*                to be already open */
/*     NAX      polar point array dimension */
/*     ISX      airfoil side array dimension */
/*     IA1,IA2  only polar points IA1..IA2 are written */
/*     CPOL     polar coefficients and parameters */
/*     IPOL(.)  indices of data quantities to be written */
/*     NIPOL    number  of data quantities to be written */
/*     REYN1    Reynolds number for CL=1 */
/*     MACH1    Mach number for CL=1 */
/*     ACRIT    Critical amplification ratio */
/*     XTRIP    Trip locations */
/*     PTRAT   Actuator disk total-pressure ratio */
/*     ETAP    Actuator disk thermal efficiency */
/*     NAME     airfoil name string */
/*     IRETYP   flag giving type of Re variation with CL */
/*     IMATYP   flag giving type of Ma variation with CL */
/*     NBL      number of airfoil elements */
/*     CPOLSD   airfoil side-related parameters */
/*     JPOL(.)  indices of side data quantities to be written */
/*     NJPOL    number  of side data quantities to be written */
/*     LHEAD    T if header and column label are to be written */
/*     CODE     code used to compute polar */
/*     VERSION  code version */
/*     LQUERY   if T, asks permission to overwrite existing file */

/*  Output: */
/*     ERROR   T if a OPER or WRITE error occurred */
/* -------------------------------------------------------- */


    /* Parameter adjustments */
    cpol_dim1 = *nax;
    cpol_offset = 1 + cpol_dim1;
    cpol -= cpol_offset;
    --ipol;
    cpolsd_dim1 = *nax;
    cpolsd_dim2 = *isx;
    cpolsd_offset = 1 + cpolsd_dim1 * (1 + cpolsd_dim2);
    cpolsd -= cpolsd_offset;
    --xtrip;
    --jpol;

    /* Function Body */
    *error = FALSE_;

/* ---- do we have to open the file? */
    lopen = s_cmp(fnpol, " ", fnpol_len, (ftnlen)1) != 0;

    if (lopen) {
	o__1.oerr = 1;
	o__1.ounit = *lu;
	o__1.ofnmlen = fnpol_len;
	o__1.ofnm = fnpol;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L20;
	}

	if (*lquery) {
	    s_wsle(&io___52);
	    e_wsle();
	    s_wsle(&io___53);
	    do_lio(&c__9, &c__1, "Output file exists.  Overwrite?  Y", (
		    ftnlen)34);
	    e_wsle();
	    s_rsfe(&io___54);
	    do_fio(&c__1, ans, (ftnlen)1);
	    e_rsfe();

	    if (i_indx("Nn", ans, (ftnlen)2, (ftnlen)1) == 0) {
		goto L22;
	    }

	    cl__1.cerr = 0;
	    cl__1.cunit = *lu;
	    cl__1.csta = 0;
	    f_clos(&cl__1);
	    s_wsle(&io___56);
	    do_lio(&c__9, &c__1, "Polar file not saved", (ftnlen)20);
	    e_wsle();
	    return 0;
	}

L20:
	o__1.oerr = 1;
	o__1.ounit = *lu;
	o__1.ofnmlen = fnpol_len;
	o__1.ofnm = fnpol;
	o__1.orl = 0;
	o__1.osta = "UNKNOWN";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L90;
	}
L22:
	al__1.aerr = 0;
	al__1.aunit = *lu;
	f_rew(&al__1);
    }

    if (*lhead) {
	io___57.ciunit = *lu;
	s_wsle(&io___57);
	do_lio(&c__9, &c__1, " ", (ftnlen)1);
	e_wsle();
	io___58.ciunit = *lu;
	s_wsfe(&io___58);
	do_fio(&c__1, code, code_len);
	do_fio(&c__1, (char *)&(*version), (ftnlen)sizeof(real));
	e_wsfe();
	io___59.ciunit = *lu;
	s_wsle(&io___59);
	do_lio(&c__9, &c__1, " ", (ftnlen)1);
	e_wsle();
	if (*nbl == 1) {
	    io___60.ciunit = *lu;
	    s_wsfe(&io___60);
	    do_fio(&c__1, name__, name_len);
	    e_wsfe();
	} else {
	    io___61.ciunit = *lu;
	    s_wsfe(&io___61);
	    do_fio(&c__1, name__, name_len);
	    do_fio(&c__1, (char *)&(*nbl), (ftnlen)sizeof(integer));
	    e_wsfe();
	}

	iffbc = 0;
	ismom = 0;

	if (iffbc != 0 && ismom != 0) {
	    if (iffbc == 1) {
		s_copy(line1, " Solid wall far field        ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (iffbc == 2) {
		s_copy(line1, " Vortex + doublet far field  ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (iffbc == 3) {
		s_copy(line1, " Constant pressure far field ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (iffbc == 4) {
		s_copy(line1, " Supersonic wave far field   ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (iffbc >= 5) {
		s_copy(line1, "                             ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (ismom == 1) {
		s_copy(line2, "   S-momentum conserved      ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (ismom == 2) {
		s_copy(line2, "   Entropy conserved         ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (ismom == 3) {
		s_copy(line2, "   Entropy conserved near LE ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (ismom == 4) {
		s_copy(line2, "   S-mom conserved at shocks ", (ftnlen)29, (
			ftnlen)29);
	    }
	    if (ismom >= 5) {
		s_copy(line2, "                             ", (ftnlen)29, (
			ftnlen)29);
	    }
	    io___66.ciunit = *lu;
	    s_wsfe(&io___66);
	    do_fio(&c__1, line1, (ftnlen)29);
	    do_fio(&c__1, line2, (ftnlen)29);
	    e_wsfe();
	}

	io___67.ciunit = *lu;
	s_wsle(&io___67);
	do_lio(&c__9, &c__1, " ", (ftnlen)1);
	e_wsle();

	s_copy(line1, " ", (ftnlen)29, (ftnlen)1);
	s_copy(line2, " ", (ftnlen)29, (ftnlen)1);
	if (*iretyp == 1) {
	    s_copy(line1, " Reynolds number fixed       ", (ftnlen)29, (
		    ftnlen)29);
	}
	if (*iretyp == 2) {
	    s_copy(line1, " Reynolds number ~ 1/sqrt(CL)", (ftnlen)29, (
		    ftnlen)29);
	}
	if (*iretyp == 3) {
	    s_copy(line1, " Reynolds number ~ 1/CL      ", (ftnlen)29, (
		    ftnlen)29);
	}
	if (*imatyp == 1) {
	    s_copy(line2, "   Mach number fixed         ", (ftnlen)29, (
		    ftnlen)29);
	}
	if (*imatyp == 2) {
	    s_copy(line2, "   Mach number ~ 1/sqrt(CL)  ", (ftnlen)29, (
		    ftnlen)29);
	}
	if (*imatyp == 3) {
	    s_copy(line2, "   Mach number ~ 1/CL        ", (ftnlen)29, (
		    ftnlen)29);
	}
	io___68.ciunit = *lu;
	s_wsfe(&io___68);
	do_fio(&c__1, (char *)&(*iretyp), (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&(*imatyp), (ftnlen)sizeof(integer));
	do_fio(&c__1, line1, (ftnlen)29);
	do_fio(&c__1, line2, (ftnlen)29);
	e_wsfe();

	io___69.ciunit = *lu;
	s_wsle(&io___69);
	do_lio(&c__9, &c__1, " ", (ftnlen)1);
	e_wsle();
	i__1 = *nbl;
	for (n = 1; n <= i__1; ++n) {
	    is1 = (n << 1) - 1;
	    is2 = n << 1;
	    if (*nbl == 1) {
		io___73.ciunit = *lu;
		s_wsfe(&io___73);
		do_fio(&c__1, (char *)&xtrip[is1], (ftnlen)sizeof(real));
		do_fio(&c__1, (char *)&xtrip[is2], (ftnlen)sizeof(real));
		e_wsfe();
	    } else {
		io___74.ciunit = *lu;
		s_wsfe(&io___74);
		do_fio(&c__1, (char *)&xtrip[is1], (ftnlen)sizeof(real));
		do_fio(&c__1, (char *)&xtrip[is2], (ftnlen)sizeof(real));
		do_fio(&c__1, (char *)&n, (ftnlen)sizeof(integer));
		e_wsfe();
	    }
	}
	io___75.ciunit = *lu;
	s_wsfe(&io___75);
	do_fio(&c__1, (char *)&(*mach1), (ftnlen)sizeof(real));
	r__1 = *reyn1 / 1e6f;
	do_fio(&c__1, (char *)&r__1, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&(*acrit), (ftnlen)sizeof(real));
	e_wsfe();
	if (*ptrat != 0.f) {
	    io___76.ciunit = *lu;
	    s_wsfe(&io___76);
	    do_fio(&c__1, (char *)&(*ptrat), (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&(*etap), (ftnlen)sizeof(real));
	    e_wsfe();
	}
	io___77.ciunit = *lu;
	s_wsle(&io___77);
	do_lio(&c__9, &c__1, " ", (ftnlen)1);
	e_wsle();

	s_copy(linel, " ", (ftnlen)128, (ftnlen)1);
	s_copy(lined, " ", (ftnlen)128, (ftnlen)1);

	kl = 1;
	kd = 1;

	i__1 = *nipol;
	for (kp = 1; kp <= i__1; ++kp) {
	    ip = ipol[kp];
	    if (ip == 0) {
		goto L30;
	    }

	    kdot = i_indx(cpolform + (ip - 1) * 6, ".", (ftnlen)6, (ftnlen)1);
	    if (kdot == 0) {
		kdot = i_len(cpolform + (ip - 1) * 6, (ftnlen)6);
	    }
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = kdot - 2;
	    ici__1.iciunit = cpolform + ((ip - 1) * 6 + 1);
	    ici__1.icifmt = 0;
	    i__2 = s_rsli(&ici__1);
	    if (i__2 != 0) {
		goto L95;
	    }
	    i__2 = do_lio(&c__3, &c__1, (char *)&nform, (ftnlen)sizeof(
		    integer));
	    if (i__2 != 0) {
		goto L95;
	    }
	    i__2 = e_rsli();
	    if (i__2 != 0) {
		goto L95;
	    }

	    strip_(cpolname + (ip - 1) * 10, &nname, (ftnlen)10);
/* Computing MAX */
	    i__2 = (nform - nname + 2) / 2;
	    nblank = max(i__2,0);

	    i__2 = kl + 1 + nblank - 1;
	    s_copy(linel + i__2, cpolname + (ip - 1) * 10, kl + nname + 
		    nblank - i__2, nname);
	    kl += nform;

	    i__2 = kd + 1;
	    s_copy(lined + i__2, "--------------------------------", kd + 
		    nform - i__2, (ftnlen)32);
	    kd += nform;
L30:
	    ;
	}

	i__1 = *njpol;
	for (kp = 1; kp <= i__1; ++kp) {
	    jp = jpol[kp];
	    if (jp == 0) {
		goto L32;
	    }

	    kdot = i_indx(cpolsform + (jp - 1) * 6, ".", (ftnlen)6, (ftnlen)1)
		    ;
	    if (kdot == 0) {
		kdot = i_len(cpolsform + (jp - 1) * 6, (ftnlen)6);
	    }
	    ici__1.icierr = 1;
	    ici__1.iciend = 0;
	    ici__1.icirnum = 1;
	    ici__1.icirlen = kdot - 2;
	    ici__1.iciunit = cpolsform + ((jp - 1) * 6 + 1);
	    ici__1.icifmt = 0;
	    i__2 = s_rsli(&ici__1);
	    if (i__2 != 0) {
		goto L95;
	    }
	    i__2 = do_lio(&c__3, &c__1, (char *)&nform, (ftnlen)sizeof(
		    integer));
	    if (i__2 != 0) {
		goto L95;
	    }
	    i__2 = e_rsli();
	    if (i__2 != 0) {
		goto L95;
	    }

	    strip_(cpolsname + (jp - 1) * 5, &nname, (ftnlen)5);
/* Computing MAX */
	    i__2 = (nform - nname - 2) / 2;
	    nblank = max(i__2,0);

	    i__2 = *nbl;
	    for (n = 1; n <= i__2; ++n) {
		i__3 = kl + 1 + nblank - 1;
/* Writing concatenation */
		i__4[0] = 4, a__1[0] = "Top_";
		i__4[1] = nname, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(linel + i__3, a__1, i__4, &c__2, kl + 4 + nname + 
			nblank - i__3);
		kl += nform;

		i__3 = kd + 1;
		s_copy(lined + i__3, "--------------------------------", kd + 
			nform - i__3, (ftnlen)32);
		kd += nform;

		i__3 = kl + 1 + nblank - 1;
/* Writing concatenation */
		i__4[0] = 4, a__1[0] = "Bot_";
		i__4[1] = nname, a__1[1] = cpolsname + (jp - 1) * 5;
		s_cat(linel + i__3, a__1, i__4, &c__2, kl + 4 + nname + 
			nblank - i__3);
		kl += nform;

		i__3 = kd + 1;
		s_copy(lined + i__3, "--------------------------------", kd + 
			nform - i__3, (ftnlen)32);
		kd += nform;
	    }
L32:
	    ;
	}



/*       LINEL = */
/*     & '  alpha     CL        CD       CDp       CM    Top_Xtr Bot_Xtr' */
/* CC     1234567890123456789012345678901234567890123456789012345678901234567890 */
/*       K = 62 */


/*       LINEL = */
/*     & ' ------- -------- --------- --------- -------- ------- -------' */
/* CC       3.453   1.3750   0.00921   0.00512  -0.1450  0.9231  0.5382 */
/* CC       3.453   1.3750   0.00921   0.00213  -0.1450  0.9231  0.5382 */
/*       K = 62 */
	io___89.ciunit = *lu;
	s_wsfe(&io___89);
	do_fio(&c__1, linel, kl);
	e_wsfe();
	io___90.ciunit = *lu;
	s_wsfe(&io___90);
	do_fio(&c__1, lined, kd);
	e_wsfe();

    }

    s_copy(linef, "(1X", (ftnlen)128, (ftnlen)3);
    kf = 3;
    i__1 = *nipol;
    for (kp = 1; kp <= i__1; ++kp) {
	ip = ipol[kp];
	nf = i_len(cpolform + (ip - 1) * 6, (ftnlen)6);

	i__2 = kf;
/* Writing concatenation */
	i__4[0] = 1, a__1[0] = ",";
	i__4[1] = 6, a__1[1] = cpolform + (ip - 1) * 6;
	s_cat(linef + i__2, a__1, i__4, &c__2, kf + nf + 1 - i__2);
	kf = kf + nf + 1;
    }
    i__1 = *njpol;
    for (kp = 1; kp <= i__1; ++kp) {
	jp = jpol[kp];
	nf = i_len(cpolsform + (jp - 1) * 6, (ftnlen)6);

	i__2 = *nbl;
	for (n = 1; n <= i__2; ++n) {
	    i__3 = kf;
/* Writing concatenation */
	    i__4[0] = 1, a__1[0] = ",";
	    i__4[1] = 6, a__1[1] = cpolsform + (jp - 1) * 6;
	    s_cat(linef + i__3, a__1, i__4, &c__2, kf + nf + 1 - i__3);
	    kf = kf + nf + 1;

	    i__3 = kf;
/* Writing concatenation */
	    i__4[0] = 1, a__1[0] = ",";
	    i__4[1] = 6, a__1[1] = cpolsform + (jp - 1) * 6;
	    s_cat(linef + i__3, a__1, i__4, &c__2, kf + nf + 1 - i__3);
	    kf = kf + nf + 1;
	}
    }
    i__1 = kf;
    s_copy(linef + i__1, ")", kf + 1 - i__1, (ftnlen)1);
    ++kf;


    i__1 = *ia2;
    for (ia = *ia1; ia <= i__1; ++ia) {
	io___95.ciunit = *lu;
	s_wsfe(&io___95);
	i__2 = *nipol;
	for (kp = 1; kp <= i__2; ++kp) {
	    do_fio(&c__1, (char *)&cpol[ia + ipol[kp] * cpol_dim1], (ftnlen)
		    sizeof(real));
	}
	i__3 = *njpol;
	for (kp = 1; kp <= i__3; ++kp) {
	    i__5 = *nbl << 1;
	    for (is = 1; is <= i__5; ++is) {
		do_fio(&c__1, (char *)&cpolsd[ia + (is + jpol[kp] * 
			cpolsd_dim2) * cpolsd_dim1], (ftnlen)sizeof(real));
	    }
	}
	e_wsfe();
/* L40: */
    }


/* L80: */
/* ---- if file was opened here, then close it */
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    return 0;

L90:
    *error = TRUE_;
    return 0;

L95:
    s_wsle(&io___97);
    do_lio(&c__9, &c__1, "? Bad format specification in PINDEX.INC", (ftnlen)
	    40);
    e_wsle();
    s_stop("", (ftnlen)0);

/* ...................................................................... */
/* L9100: */
/* CC      3.453   1.3750   0.00921     0.500  -0.1450  0.9231  0.5382 -0.00942 */
/* CC      3.453   1.3750   0.00921     0.500  -0.1450  0.9231  0.5382 */
    return 0;
} /* polwrit_ */

/* Subroutine */ int polref_(int *lu, char *fnref, logical *error, 
	int *nfx, int *nf, real *xyref, char *labref, ftnlen 
	fnref_len, ftnlen labref_len)
{

    /* Format strings */
    static char fmt_1000[] = "(a)";

    /* System generated locals */
    int xyref_dim1, xyref_offset, i__1, i__2;
    olist o__1;
    cllist cl__1;
    alist al__1;

    /* Builtin functions */
    int f_open(olist *), s_rsfe(cilist *), do_fio(int *, char *, 
	    ftnlen), e_rsfe(void);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    int f_rew(alist *), s_rsle(cilist *), do_lio(int *, int *, 
	    char *, ftnlen), e_rsle(void), f_clos(cllist *);

    /* Local variables */
    static int i__, k;
    static char line[80];
    static logical lopen;

    /* Fortran I/O blocks */
    static cilist io___103 = { 0, 0, 1, fmt_1000, 0 };
    static cilist io___107 = { 1, 0, 1, 0, 0 };



/* ---- Pointers for referencing polar force coefficients */
/*     First 4 pointers must be main polar plot variables. */



/* --------------------- */
/*  Pointers for referencing polar airfoil-side quantities */


/* -------------------------------------------------------- */
/*     Reads in polar reference data file */

/*  Input: */
/*     LU      logical unit to use for reading */
/*     FNREF   name of polar file to be read, */
/*               if FNREF(1:1).eq.' ', unit LU is assumed */
/*               to be already open */
/*     NFX     polar point array dimension */

/*  Output: */
/*     ERROR      T if a READ error occurred */
/*     NF(.)      number of points in each data block */
/*     XYREF(...) reference polar data */
/*     LABREF(.)  reference polar label */
/* -------------------------------------------------------- */


    /* Parameter adjustments */
    xyref_dim1 = *nfx;
    xyref_offset = 1 + xyref_dim1 * 3;
    xyref -= xyref_offset;
    --nf;

    /* Function Body */
    *error = FALSE_;
    lopen = *(unsigned char *)fnref != ' ';
    if (lopen) {
	o__1.oerr = 1;
	o__1.ounit = *lu;
	o__1.ofnmlen = fnref_len;
	o__1.ofnm = fnref;
	o__1.orl = 0;
	o__1.osta = "OLD";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	i__1 = f_open(&o__1);
	if (i__1 != 0) {
	    goto L900;
	}
    }

/* ---- try to read data label */
    io___103.ciunit = *lu;
    i__1 = s_rsfe(&io___103);
    if (i__1 != 0) {
	goto L900;
    }
    i__1 = do_fio(&c__1, line, (ftnlen)80);
    if (i__1 != 0) {
	goto L900;
    }
    i__1 = e_rsfe();
    if (i__1 != 0) {
	goto L900;
    }

/* ---- set data label if present */
    if (*(unsigned char *)line == '#') {
	s_copy(labref, line + 1, labref_len, (ftnlen)79);
    } else {
	s_copy(labref, " ", labref_len, (ftnlen)1);
	al__1.aerr = 0;
	al__1.aunit = *lu;
	f_rew(&al__1);
    }

    for (k = 1; k <= 4; ++k) {
	i__1 = *nfx;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    io___107.ciunit = *lu;
	    i__2 = s_rsle(&io___107);
	    if (i__2 != 0) {
		goto L100001;
	    }
	    i__2 = do_lio(&c__4, &c__1, (char *)&xyref[i__ + ((k << 1) + 1) * 
		    xyref_dim1], (ftnlen)sizeof(real));
	    if (i__2 != 0) {
		goto L100001;
	    }
	    i__2 = do_lio(&c__4, &c__1, (char *)&xyref[i__ + ((k << 1) + 2) * 
		    xyref_dim1], (ftnlen)sizeof(real));
	    if (i__2 != 0) {
		goto L100001;
	    }
	    i__2 = e_rsle();
L100001:
	    if (i__2 < 0) {
		goto L11;
	    }
	    if (i__2 > 0) {
		goto L900;
	    }
	    if (xyref[i__ + ((k << 1) + 1) * xyref_dim1] == 999.f) {
		goto L11;
	    }
/* L10: */
	}
L11:
	nf[k] = i__ - 1;
/* L100: */
    }
    if (lopen) {
	cl__1.cerr = 0;
	cl__1.cunit = *lu;
	cl__1.csta = 0;
	f_clos(&cl__1);
    }
    return 0;

L900:
    *error = TRUE_;

    return 0;
} /* polref_ */
