/* f/profil.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = 1.f;
static int c__9 = 9;
static int c__1 = 1;
static int c__4 = 4;
static int c__3 = 3;

/* *********************************************************************** */
/*    Module:  profil.f */

/*    Copyright (C) 2000 Mark Drela */

/*    This program is free software; you can redistribute it and/or modify */
/*    it under the terms of the GNU General Public License as published by */
/*    the Free Software Foundation; either version 2 of the License, or */
/*    (at your option) any later version. */

/*    This program is distributed in the hope that it will be useful, */
/*    but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/*    GNU General Public License for more details. */

/*    You should have received a copy of the GNU General Public License */
/*    along with this program; if not, write to the Free Software */
/*    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
/* *********************************************************************** */
/* Subroutine */ int prwall_(real *dstar, real *theta, real *uo, real *rt, 
	real *ms, real *ct, real *bb, real *do__, real *do_ds__, real *
	do_th__, real *do_uo__, real *do_rt__, real *do_ms__, real *ui, real *
	ui_ds__, real *ui_th__, real *ui_uo__, real *ui_rt__, real *ui_ms__, 
	real *hs, real *hs_ds__, real *hs_th__, real *hs_uo__, real *hs_rt__, 
	real *hs_ms__, real *cf, real *cf_ds__, real *cf_th__, real *cf_uo__, 
	real *cf_rt__, real *cf_ms__, real *cd, real *cd_ds__, real *cd_th__, 
	real *cd_uo__, real *cd_rt__, real *cd_ms__, real *cd_ct__)
{
    /* Initialized data */

    static real hpi = 1.570796327f;
    static real ak = .09f;
    static real vkap = .4f;
    static real vb = 5.f;

    /* System generated locals */
    real r__1, r__2, r__3, r__4;
    doublereal d__1, d__2;

    /* Builtin functions */
    double r_sign(real *, real *), sqrt(doublereal), exp(doublereal), log(
	    doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    double pow_dd(doublereal *, doublereal *);

    /* Local variables */
    static real g[65];
    static int i__;
    static real u, a11, a12, a21, ga, a22, b11, b12, b21, b22, hk, dp, et, uk,
	     up, ut, yp, bb1, bb2, bb3, dc2, dc3, ebk, ale, ddo, eta[65], arg,
	     etb;
    extern /* Subroutine */ int cft_(real *, real *, real *, real *, real *, 
	    real *, real *);
    static real det, dsn, sgn, upd, upe, duo, thn, uip[65], dut, rez, exu, 
	    rlx, rez1, rez2, g_bb__[65], u_bb__, deta, u_do__, dp_u__, u_dp__,
	     dmax__, updd, dupe, uipa, u_th__;
    static int iter;
    static real dexu, u_ms__, u_rt__, yp_u__, u_ut__;
    static int itup;
    static real z1_hk__, z2_hk__, z1_th__, z2_th__, z1_ms__, ga_bb__, z2_ms__,
	     z1_rt__, z2_rt__, bb_hk__, cf_hk__, cf_do__, bb_th__, bb_ms__, 
	    do_hk__, dp_do__, bb_rt__, dp_th__, dp_ms__, cf_ut__, dp_ut__, 
	    dp_rt__, dp_uu__, bb1_bb__, bb2_bb__, bb3_bb__, exupe, ut_hk__, 
	    ut_th__, dc2_dp__, dc3_dp__, ut_rt__, ut_ms__, ui_ut__, ui_do__, 
	    yp_uu__, ui_hk__, dsn_bb__, thn_bb__, dsn_do__, duo_do__, 
	    duo_dp__, upd_dp__, upe_dp__, thn_do__, dsn_th__, uip_dp__[65], 
	    duo_th__, dsn_ms__, thn_th__, duo_ms__, thn_ms__, dsn_rt__, 
	    duo_rt__, dsn_ut__, thn_rt__, duo_ut__, dp_uuu__, thn_ut__, 
	    updd_dp__, uipa_dp__;

    /* Fortran I/O blocks */
    static cilist io___29 = { 0, 6, 0, 0, 0 };
    static cilist io___111 = { 0, 6, 0, 0, 0 };


/* ================================================================ */
/*     Returns wall slip velocity and thickness of wall BL profile */

/*     Input: */
/*        DSTAR  kinematic displacement thickness */
/*        THETA  kinematic momentum thickness */
/*        RT     momentum thickness based on ue and THETA */
/*        MS     Mach^2 based on ue */

/*        UO     uo/ue outer velocity;  assumed = 1  in this version */

/*     Output: */
/*        BB     outer profile exponent */
/*        DO     thickness of profile deck */
/*        UI     inner "slip" velocity */
/*        CF     wall skin friction */
/* ================================================================ */


/* ---- pi/2 ,  2/pi */


/* ---- TCON = ( atan(T^1/2) / T^1/2  -  1/(1+T)) / (2T)  +  0.5/(1.0 + T) */
/*                - atan(1/T^1/2) / 2T^1/2 */

/* ---- slip velocity coefficient */

/* ---- log-law constants */

    hk = *dstar / *theta;

    *uo = 1.f;
    *bb = 1.f;

/* ---- initialize variables */
    cft_(&hk, rt, ms, cf, &cf_hk__, cf_rt__, cf_ms__);
    sgn = r_sign(&c_b2, cf);
    ut = sgn * sqrt(dabs(*cf) * .5f);

/* Computing MIN */
    r__1 = ut / ak * hpi;
    *ui = dmin(r__1,.9f);
    *do__ = hk * *theta / (1.f - (*uo + *ui) * .5f);

    ebk = exp(-vb * vkap);

    for (iter = 1; iter <= 12; ++iter) {

	sgn = r_sign(&c_b2, &ut);

/* ------ set d+ = DP(UT DO ; RT TH) */
	dp = sgn * ut * *rt * *do__ / *theta;
	dp_do__ = sgn * ut * *rt / *theta;
	dp_ut__ = sgn * *rt * *do__ / *theta;

	dp_th__ = -dp / *theta;
	dp_rt__ = sgn * ut * *do__ / *theta;
	dp_ms__ = 0.f;

/* ------ estimate inner profile edge velocity Ui+ using log-law */
	upe = log(dp) / vkap + vb;

/* ------ converge exact Ui+ using Spalding formula */
	for (itup = 1; itup <= 5; ++itup) {
	    uk = upe * vkap;
	    arg = uk - vb * vkap;
	    exu = exp(arg);
	    rez = upe + exu - ebk * (uk + 1.f + uk * uk / 2.f + uk * uk * uk /
		     6.f) - dp;
	    dp_u__ = (exu - ebk * (uk + 1.f + uk * uk / 2.f)) * vkap + 1.f;

	    if ((r__1 = rez / dp, dabs(r__1)) < 1e-5f) {
		goto L11;
	    }

	    dupe = -rez / dp_u__;
	    upe += dupe;
/* L10: */
	}
	s_wsle(&io___29);
	do_lio(&c__9, &c__1, "PRWALL: Ue+ convergence failed,  Res =", (
		ftnlen)38);
	r__1 = rez / dp;
	do_lio(&c__4, &c__1, (char *)&r__1, (ftnlen)sizeof(real));
	e_wsle();
L11:

	upe_dp__ = 1.f / dp_u__;

/*            2      2        3      3 */
/* ------ set d y+/du+   and  d y+/du+   at BL edge */
/* Computing 2nd power */
	r__1 = vkap;
	dp_uu__ = (exu - ebk * (uk + 1.f)) * (r__1 * r__1);
/* Computing 3rd power */
	r__1 = vkap;
	dp_uuu__ = (exu - ebk) * (r__1 * (r__1 * r__1));

/* ------ set  du+/dy+  at BL edge */
	upd = 1.f / dp_u__;
/* Computing 3rd power */
	r__1 = dp_u__;
	upd_dp__ = -1.f / (r__1 * (r__1 * r__1)) * dp_uu__;

/*             2      2 */
/* ------ set  d u+/dy+   at BL edge */
/* CC     UPD_DP = (-1.0/DP_U**3) * DP_UU */
	updd = upd_dp__;
/* Computing 4th power */
	r__1 = dp_u__, r__1 *= r__1;
/* Computing 5th power */
	r__2 = dp_u__, r__3 = r__2, r__2 *= r__2;
/* Computing 2nd power */
	r__4 = dp_uu__;
	updd_dp__ = -1.f / (r__1 * r__1) * dp_uuu__ + 3.f / (r__3 * (r__2 * 
		r__2)) * (r__4 * r__4);

/* ------ set coefficients for Spalding profile correction polynomial */
	dc2 = dp * .5f * dp * updd - dp * upd;
	dc2_dp__ = dp * updd - upd + dp * .5f * dp * updd_dp__ - dp * 
		upd_dp__;

	dc3 = -(dp * dp * updd - dp * upd) / 3.f;
	dc3_dp__ = -(dp * 2.f * updd - upd) / 3.f - (dp * dp * updd_dp__ - dp 
		* upd_dp__) / 3.f;

/* ------ set outer profile amplitude DUO */
	duo = *uo - ut * (upe + dc2 + dc3);
	duo_dp__ = -ut * (upe_dp__ + dc2_dp__ + dc3_dp__);

	duo_ut__ = -(upe + dc2 + dc3) + duo_dp__ * dp_ut__;
	duo_do__ = duo_dp__ * dp_do__;

	duo_th__ = duo_dp__ * dp_th__;
	duo_rt__ = duo_dp__ * dp_rt__;
	duo_ms__ = duo_dp__ * dp_ms__;

/*        write(*,*) 'dUo', duo, duo_dp, duo_ut, duo_do */
/*        read(*,*) ddo, dut */
/*        if(ddo.ne.0.0 .or. dut.ne.0.0) then */
/*          do = do+ddo */
/*          ut = ut+dut */
/*          write(*,*) 'new', duo + duo_do*ddo + duo_ut*dut */
/*          go to 666 */
/*        endif */

/* ------ set wake profile coefficients */
	bb1 = (*bb + 2.f) * 3.f * (*bb + 3.f) / (*bb + 7.f);
	bb1_bb__ = (*bb * 2.f + 5.f) * 3.f / (*bb + 7.f) - bb1 / (*bb + 7.f);
	bb2 = (*bb + 1.f) * -5.f * (*bb + 3.f) / (*bb + 7.f);
	bb2_bb__ = (*bb * 2.f + 4.f) * -5.f / (*bb + 7.f) - bb2 / (*bb + 7.f);
	bb3 = (*bb + 1.f) * 2.f * (*bb + 2.f) / (*bb + 7.f);
	bb3_bb__ = (*bb * 2.f + 3.f) * 2.f / (*bb + 7.f) - bb3 / (*bb + 7.f);

/* ------ fill eta coordinate and inner profile arrays */
/* CC     EXUPE = EXP(UPE*VKAP - VB*VKAP) */
	exupe = exu;

	dexu = (exupe - ebk) / 64.f;

	i__ = 1;
	uip[i__ - 1] = 0.f;
	uip_dp__[i__ - 1] = 0.f;
	g[i__ - 1] = 0.f;
	g_bb__[i__ - 1] = 0.f;

	for (i__ = 2; i__ <= 65; ++i__) {
/* cc       EXU = EBK + DEXU*FLOAT(I-1) */
	    exu = ebk + (dexu - dexu * .75f * (real) (65 - i__) / 64.f) * (
		    real) (i__ - 1);

/* CC       UK = UP*VKAP */
	    uk = log(exu) + vb * vkap;

	    up = uk / vkap;

/* -------- set "inverse" Spalding profile  y+(u+)  and derivatives */
	    yp = up + exu - ebk * (uk + 1.f + uk * uk / 2.f + uk * uk * uk / 
		    6.f);
	    yp_u__ = (exu - ebk * (uk + 1.f + uk * uk / 2.f)) * vkap + 1.f;
/* Computing 2nd power */
	    r__1 = vkap;
	    yp_uu__ = (exu - ebk * (uk + 1.f)) * (r__1 * r__1);

	    et = yp / dp;

/* -------- set final inner profile (fudged Spalding) */
/* Computing 2nd power */
	    r__1 = et;
/* Computing 3rd power */
	    r__2 = et;
	    uip[i__ - 1] = up + dc2 * (r__1 * r__1) + dc3 * (r__2 * (r__2 * 
		    r__2));
/* Computing 2nd power */
	    r__1 = et;
/* Computing 3rd power */
	    r__2 = et;
	    uip_dp__[i__ - 1] = dc2_dp__ * (r__1 * r__1) + dc3_dp__ * (r__2 * 
		    (r__2 * r__2));

/* cc          UIPD(I)    = 1.0/YP_U + 2.0*DC2   *ET    + 3.0*DC3   *ET**2 */
/* cc          UIPD_DP(I) = (-1.0/YP_U**3)*YPUU */
/* cc     &                          + 2.0*DC2_DP*ET    + 3.0*DC3_DP*ET**2 */

/* -------- set outer profile */
	    d__1 = (doublereal) et;
	    d__2 = (doublereal) (*bb);
	    etb = pow_dd(&d__1, &d__2);
	    ale = log(et);

/* cc          G(I)    =  2.0*ETB -     ETB**2 */
/* cc          G_BB(I) = (2.0*ETB - 2.0*ETB**2)*ALE */

/* Computing 2nd power */
	    r__1 = et;
/* Computing 3rd power */
	    r__2 = et;
	    g[i__ - 1] = (bb1 * et + bb2 * (r__1 * r__1) + bb3 * (r__2 * (
		    r__2 * r__2))) * etb;
/* Computing 2nd power */
	    r__1 = et;
/* Computing 3rd power */
	    r__2 = et;
	    g_bb__[i__ - 1] = (bb1_bb__ * et + bb2_bb__ * (r__1 * r__1) + 
		    bb3_bb__ * (r__2 * (r__2 * r__2))) * etb + g[i__ - 1] * 
		    ale;

	    eta[i__ - 1] = et;

/* L20: */
	}


	dsn = 0.f;
	dsn_do__ = 0.f;
	dsn_ut__ = 0.f;
	dsn_bb__ = 0.f;

	dsn_th__ = 0.f;
	dsn_rt__ = 0.f;
	dsn_ms__ = 0.f;


	thn = 0.f;
	thn_do__ = 0.f;
	thn_ut__ = 0.f;
	thn_bb__ = 0.f;

	thn_th__ = 0.f;
	thn_rt__ = 0.f;
	thn_ms__ = 0.f;

/*        TSN    = 0.0 */
/*        TSN_DO = 0.0 */
/*        TSN_UT = 0.0 */
/*        TSN_BB = 0.0 */

/*        TSN_TH = 0.0 */
/*        TSN_RT = 0.0 */
/*        TSN_MS = 0.0 */

/* ------ perform integration */
	for (i__ = 1; i__ <= 64; ++i__) {
	    deta = eta[i__] - eta[i__ - 1];
	    ga = (g[i__] + g[i__ - 1]) * .5f;
	    ga_bb__ = (g_bb__[i__] + g_bb__[i__ - 1]) * .5f;

	    uipa = (uip[i__] + uip[i__ - 1]) * .5f;
	    uipa_dp__ = (uip_dp__[i__] + uip_dp__[i__ - 1]) * .5f;

	    u = ut * uipa + duo * ga;
	    u_dp__ = ut * uipa_dp__;

	    u_do__ = duo_do__ * ga + u_dp__ * dp_do__;
	    u_ut__ = uipa + duo_ut__ * ga + u_dp__ * dp_ut__;
	    u_bb__ = duo * ga_bb__;

	    u_th__ = duo_th__ * ga + u_dp__ * dp_th__;
	    u_rt__ = duo_rt__ * ga + u_dp__ * dp_rt__;
	    u_ms__ = duo_ms__ * ga + u_dp__ * dp_ms__;


	    dsn += (1.f - u) * deta;
	    dsn_do__ -= u_do__ * deta;
	    dsn_ut__ -= u_ut__ * deta;
	    dsn_bb__ -= u_bb__ * deta;

	    dsn_th__ -= u_th__ * deta;
	    dsn_rt__ -= u_rt__ * deta;
	    dsn_ms__ -= u_ms__ * deta;


	    thn += (u - u * u) * deta;
	    thn_do__ += (1.f - u * 2.f) * u_do__ * deta;
	    thn_ut__ += (1.f - u * 2.f) * u_ut__ * deta;
	    thn_bb__ += (1.f - u * 2.f) * u_bb__ * deta;

	    thn_th__ += (1.f - u * 2.f) * u_th__ * deta;
	    thn_rt__ += (1.f - u * 2.f) * u_rt__ * deta;
	    thn_ms__ += (1.f - u * 2.f) * u_ms__ * deta;

/*          TSN    = TSN    + (U   -   U*U*U)     *DETA */
/*          TSN_DO = TSN_DO + (1.0 - 3.0*U*U)*U_DO*DETA */
/*          TSN_UT = TSN_UT + (1.0 - 3.0*U*U)*U_UT*DETA */
/*          TSN_BB = TSN_BB + (1.0 - 3.0*U*U)*U_BB*DETA */

/*          TSN_TH = TSN_TH + (1.0 - 3.0*U*U)*U_TH*DETA */
/*          TSN_RT = TSN_RT + (1.0 - 3.0*U*U)*U_RT*DETA */
/*          TSN_MS = TSN_MS + (1.0 - 3.0*U*U)*U_MS*DETA */

/* L100: */
	}

/* ------ set up 2x2 system for DO UT */
	rez1 = *do__ * dsn - *theta * hk;
	a11 = *do__ * dsn_do__ + dsn;
	a12 = *do__ * dsn_ut__;
/* c        A12  = DO*DSN_BB */

	rez2 = *do__ * thn - *theta;
	a21 = *do__ * thn_do__ + thn;
	a22 = *do__ * thn_ut__;
/* c        A22  = DO*THN_BB */

/* c      IF(ABS(REZ1/THETA) .LT. 2.0E-5 .AND. */
/* c   &     ABS(REZ2/THETA) .LT. 2.0E-5      ) GO TO 1010 */
	if ((r__1 = rez1 / *theta, dabs(r__1)) < .001f && (r__2 = rez2 / *
		theta, dabs(r__2)) < .001f) {
	    goto L1010;
	}

	det = a11 * a22 - a12 * a21;
	b11 = a22 / det;
	b12 = -a12 / det;
	b21 = -a21 / det;
	b22 = a11 / det;

	ddo = -(b11 * rez1 + b12 * rez2);
	dut = -(b21 * rez1 + b22 * rez2);
/* c        DBB = -(B21*REZ1 + B22*REZ2) */

/* Computing MAX */
	r__3 = (r__1 = ddo / *do__, dabs(r__1)), r__4 = (r__2 = dut / .05f, 
		dabs(r__2));
	dmax__ = dmax(r__3,r__4);
/* c        DMAX = MAX( ABS(DDO/DO) , ABS(DBB/BB  ) ) */
	rlx = 1.f;
	if (dmax__ > .5f) {
	    rlx = .5f / dmax__;
	}

	*do__ += rlx * ddo;
	ut += rlx * dut;
/* c        BB = BB + RLX*DBB */

/* c        write(*,*) iter, do, ut, rez1, rez2 */
/* c        write(*,*) iter, do, bb, rez1, rez2 */

/* L1000: */
    }

    s_wsle(&io___111);
    do_lio(&c__9, &c__1, "PRWALL: Convergence failed. Res =", (ftnlen)33);
    do_lio(&c__4, &c__1, (char *)&rez1, (ftnlen)sizeof(real));
    do_lio(&c__4, &c__1, (char *)&rez2, (ftnlen)sizeof(real));
    e_wsle();

L1010:



/* CC   REZ1  = DO*DSN    - THETA*HK */
    z1_hk__ = -(*theta);
    z1_th__ = *do__ * dsn_th__ - hk;
    z1_rt__ = *do__ * dsn_rt__;
    z1_ms__ = *do__ * dsn_ms__;

/* CC   REZ2  = DO*THN    - THETA */
    z2_hk__ = 0.f;
    z2_th__ = *do__ * thn_th__ - 1.f;
    z2_rt__ = *do__ * thn_rt__;
    z2_ms__ = *do__ * thn_ms__;

    do_hk__ = -(b11 * z1_hk__ + b12 * z2_hk__);
    *do_th__ = -(b11 * z1_th__ + b12 * z2_th__);
    *do_rt__ = -(b11 * z1_rt__ + b12 * z2_rt__);
    *do_ms__ = -(b11 * z1_ms__ + b12 * z2_ms__);

    ut_hk__ = 0.f;
    ut_th__ = 0.f;
    ut_rt__ = 0.f;
    ut_ms__ = 0.f;

    bb_hk__ = 0.f;
    bb_th__ = 0.f;
    bb_rt__ = 0.f;
    bb_ms__ = 0.f;

    ut_hk__ = -(b21 * z1_hk__ + b22 * z2_hk__);
    ut_th__ = -(b21 * z1_th__ + b22 * z2_th__);
    ut_rt__ = -(b21 * z1_rt__ + b22 * z2_rt__);
    ut_ms__ = -(b21 * z1_ms__ + b22 * z2_ms__);

/* c      BB_HK = -(B21*Z1_HK + B22*Z2_HK) */
/* c      BB_TH = -(B21*Z1_TH + B22*Z2_TH) */
/* c      BB_RT = -(B21*Z1_RT + B22*Z2_RT) */
/* c      BB_MS = -(B21*Z1_MS + B22*Z2_MS) */


/* ---- set and linearize Cf */
/* Computing 2nd power */
    r__1 = ut;
    *cf = sgn * 2.f * (r__1 * r__1);
    cf_ut__ = sgn * 4.f * ut;
    cf_do__ = 0.f;

    cf_hk__ = cf_ut__ * ut_hk__ + cf_do__ * do_hk__;
    *cf_th__ = cf_ut__ * ut_th__ + cf_do__ * *do_th__;
    *cf_rt__ = cf_ut__ * ut_rt__ + cf_do__ * *do_rt__;
    *cf_ms__ = cf_ut__ * ut_ms__ + cf_do__ * *do_ms__;


/* ---- set and linearize "slip" velocity UI = UI( DUO(DO UT TH RT MS) ) */
    *ui = *uo - duo;
    ui_ut__ = -duo_ut__;
    ui_do__ = -duo_do__;

    ui_hk__ = ui_ut__ * ut_hk__ + ui_do__ * do_hk__;
    *ui_th__ = ui_ut__ * ut_th__ + ui_do__ * *do_th__ - duo_th__;
    *ui_rt__ = ui_ut__ * ut_rt__ + ui_do__ * *do_rt__ - duo_rt__;
    *ui_ms__ = ui_ut__ * ut_ms__ + ui_do__ * *do_ms__ - duo_ms__;

    return 0;
} /* prwall_ */

/* Subroutine */ int uwall_(real *th, real *uo, real *do__, real *ui, real *
	rt, real *cf, real *bb, real *y, real *u, int *n)
{
    /* Initialized data */

    static real vkap = .4f;
    static real vb = 5.f;

    /* System generated locals */
    int i__1;
    real r__1, r__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double exp(doublereal), r_sign(real *, real *), sqrt(doublereal), log(
	    doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    double pow_dd(doublereal *, doublereal *);

    /* Local variables */
    static real g;
    static int i__;
    static real dp;
    static int ne;
    static real et, uk, up, ut, yp, bb1, bb2, bb3, dc2, dc3, ebk, arg, etb, 
	    sgn, upd, upe, duo, sqe, uip, rez, exu, dp_u__, updd, dupe, dexu;
    static int itup;
    static real dp_uu__, exupe, yp_up__, dp_uuu__;

    /* Fortran I/O blocks */
    static cilist io___150 = { 0, 6, 0, 0, 0 };


/* ------------------------------------------ */
/*     Returns wall BL profile U(Y). */

/*     Input: */
/*        TH    kinematic momentum thickness */
/*        UO    uo/ue outer velocity  (= 1 for normal BL) */
/*        DO    BL thickness */
/*        UI    inner "slip" velocity */
/*        RT    momentum thickness based on ue and THETA */
/*        CF    wall skin friction */
/*        BB    outer profile exponent */
/*        N     number of profile array points */

/*     Output: */
/*        Y(i)  normal coordinate array */
/*        U(i)  u/ue velocity profile array */
/* ------------------------------------------- */

    /* Parameter adjustments */
    --u;
    --y;

    /* Function Body */

/* ---- log-law constants */

    ebk = exp(-vb * vkap);

    sgn = r_sign(&c_b2, cf);
    ut = sgn * sqrt(dabs(*cf) * .5f);


/* ---- set d+ = DP(UT DO ; RT TH) */
    dp = sgn * ut * *rt * *do__ / *th;

/* ---- estimate inner profile edge velocity Ui+ using log-law */
    upe = log(dp) / vkap + vb;

/* ---- converge exact Ui+ using Spalding formula */
    for (itup = 1; itup <= 5; ++itup) {
	uk = upe * vkap;
	arg = uk - vb * vkap;
	exu = exp(arg);
	rez = upe + exu - ebk * (uk + 1.f + uk * uk / 2.f + uk * uk * uk / 
		6.f) - dp;
	dp_u__ = (exu - ebk * (uk + 1.f + uk * uk / 2.f)) * vkap + 1.f;

	if ((r__1 = rez / dp, dabs(r__1)) < 1e-5f) {
	    goto L11;
	}

	dupe = -rez / dp_u__;
	upe += dupe;
/* L10: */
    }
    s_wsle(&io___150);
    do_lio(&c__9, &c__1, "UWALL: Ue+ convergence failed,  Res =", (ftnlen)37);
    r__1 = rez / dp;
    do_lio(&c__4, &c__1, (char *)&r__1, (ftnlen)sizeof(real));
    e_wsle();
L11:

/*          2      2        3      3 */
/* ---- set d y+/du+   and  d y+/du+   at BL edge */
/* Computing 2nd power */
    r__1 = vkap;
    dp_uu__ = (exu - ebk * (uk + 1.f)) * (r__1 * r__1);
/* Computing 3rd power */
    r__1 = vkap;
    dp_uuu__ = (exu - ebk) * (r__1 * (r__1 * r__1));

/*                         2      2 */
/* ---- set  du+/dy+  and  d u+/dy+   at BL edge */
    upd = 1.f / dp_u__;
/* Computing 3rd power */
    r__1 = dp_u__;
    updd = -1.f / (r__1 * (r__1 * r__1)) * dp_uu__;

/* ---- set coefficients for Spalding profile correction polynomial */
    dc2 = dp * .5f * dp * updd - dp * upd;
    dc3 = -(dp * dp * updd - dp * upd) / 3.f;

/* ---- set outer profile amplitude DUO */
    duo = *uo - ut * (upe + dc2 + dc3);


    bb1 = (*bb + 2.f) * 3.f * (*bb + 3.f) / (*bb + 7.f);
    bb2 = (*bb + 1.f) * -5.f * (*bb + 3.f) / (*bb + 7.f);
    bb3 = (*bb + 1.f) * 2.f * (*bb + 2.f) / (*bb + 7.f);

/*      NE = (N*9)/10 */
    ne = *n;

/* ---- fill Y coordinate and U profile arrays */
/* CC   EXUPE = EXP(UPE*VKAP - VB*VKAP) */
    exupe = exu;

    dexu = (exupe - ebk) / (real) (ne - 1);

    i__ = 1;
    y[i__] = 0.f;
    u[i__] = 0.f;
    i__1 = ne;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* cc     EXU = EBK +  DEXU*FLOAT(I-1) */
	exu = ebk + (dexu - dexu * .75f * (real) (ne - i__) / (real) (ne - 1))
		 * (real) (i__ - 1);

/* CC     UK = UP*VKAP */
	uk = log(exu) + vb * vkap;

	up = uk / vkap;

/* ------ set "inverse" Spalding profile  y+(u+) */
	yp = up + exu - ebk * (uk + 1.f + uk * uk / 2.f + uk * uk * uk / 6.f);
	yp_up__ = (exu - ebk * (uk + 1.f + uk * uk / 2.f)) * vkap + 1.f;

	et = yp / dp;

/* ------ set final inner profile (fudged Spalding) */
/* Computing 2nd power */
	r__1 = et;
/* Computing 3rd power */
	r__2 = et;
	uip = up + dc2 * (r__1 * r__1) + dc3 * (r__2 * (r__2 * r__2));

/* ------ set outer profile */
	sqe = sqrt(et);
	d__1 = (doublereal) et;
	d__2 = (doublereal) (*bb);
	etb = pow_dd(&d__1, &d__2);

/* cc        G = 2.0*ETB - ETB**2 */

/* Computing 2nd power */
	r__1 = et;
/* Computing 3rd power */
	r__2 = et;
	g = (bb1 * et + bb2 * (r__1 * r__1) + bb3 * (r__2 * (r__2 * r__2))) * 
		etb;

	y[i__] = et * *do__;
	u[i__] = ut * uip + duo * g;

/* L20: */
    }

/*      DETA = 0.1 / FLOAT(N - NE - 1) */
/*      DO 300 I=NE+1, N */
/*        ETA = 1.0 + DETA*FLOAT(I-NE) */
/*        Y(I) = DO*ETA */
/*        U(I) = 1.0 */
/* 300  CONTINUE */

    return 0;
} /* uwall_ */

/* Subroutine */ int fs_(int *inorm, int *ispec, real *bspec, real *
	hspec, int *n, real *etae, real *geo, real *eta, real *f, real *u,
	 real *s, real *delta)
{
    /* Initialized data */

    static int nrhs = 3;

    /* System generated locals */
    int i__1, i__2;
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    /* Subroutine */ int s_stop(char *, ftnlen);
    double atan(doublereal);
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    double sin(doublereal), cos(doublereal), sqrt(doublereal);

    /* Local variables */
    static real a[2313]	/* was [3][3][257] */, b[2313]	/* was [3][3][257] */,
	     c__[2313]	/* was [3][3][257] */, h__;
    static int i__;
    static real r__[2313]	/* was [3][3][257] */, r1, r2, df;
    static int ii;
    static real q11, q12, q21, q22, bu, ds, pi, du, tn, us;
    static int iii;
    static real det, dbu, dsi, thi, dtn, rms, rlx, dsi1, dsi2, dsi3, thi1, 
	    thi2, thi3, efac, ebar, deta, betn, betu;
    static int iter;
    static real rmax;
    static int ijoin, itmax;
    extern /* Subroutine */ int b3solv_(real *, real *, real *, real *, 
	    int *, int *, int *);
    static real dsi_us__, etjoin, thi_us__, etjoin1, etjoin2, betn_bu__, 
	    betu_bu__;

    /* Fortran I/O blocks */
    static cilist io___178 = { 0, 6, 0, 0, 0 };
    static cilist io___225 = { 0, 6, 0, 0, 0 };


/* ----------------------------------------------------- */
/*     Routine for solving the Falkner-Skan equation. */

/*     Input: */
/*     ------ */
/*      INORM   1: eta = y / sqrt(vx/Ue)  "standard" Falkner-Skan coordinate */
/*              2: eta = y / sqrt(2vx/(m+1)Ue)  Hartree's coordinate */
/*              3: eta = y / Theta  momentum thickness normalized coordinate */
/*      ISPEC   1: BU  = x/Ue dUe/dx ( = "m")  specified */
/*              2: H12 = Dstar/Theta  specified */
/*      BSPEC   specified pressure gradient parameter  (if ISPEC = 1) */
/*      HSPEC   specified shape parameter of U profile (if ISPEC = 2) */
/*      N       total number of points in profiles */
/*      ETAE    edge value of normal coordinate */
/*      GEO     exponential stretching factor for ETA: */

/*     Output: */
/*     ------- */
/*      BSPEC   calculated pressure gradient parameter  (if ISPEC = 2) */
/*      HSPEC   calculated shape parameter of U profile (if ISPEC = 1) */
/*      ETA     normal BL coordinate */
/*      F,U,S   Falkner Skan profiles */
/*      DELTA   normal coordinate scale  y = eta * Delta */
/* ----------------------------------------------------- */


/* ---- set number of righthand sides. */
    /* Parameter adjustments */
    --s;
    --u;
    --f;
    --eta;

    /* Function Body */

    itmax = 20;

    if (*n > 257) {
	s_stop("FS: Array overflow.", (ftnlen)19);
    }

    pi = atan(1.f) * 4.f;

/* CC      if(u(n) .ne. 0.0) go to 9991 */

/* ---- initialize H or BetaU with empirical curve fits */
    if (*ispec == 1) {
	h__ = 2.6f;
	bu = *bspec;
    } else {
	h__ = *hspec;
	if (h__ <= 2.17f) {
	    s_wsle(&io___178);
	    do_lio(&c__9, &c__1, "FS: Specified H too low", (ftnlen)23);
	    e_wsle();
	    h__ = 2.17f;
	}
/* Computing 2nd power */
	r__1 = h__ - 4.f;
/* Computing 2nd power */
	r__2 = h__;
	bu = (r__1 * r__1 * .058f / (h__ - 1.f) - .068f) / (h__ * 6.54f - 
		14.07f) * (r__2 * r__2);
	if (h__ > 4.f) {
	    bu = dmin(bu,0.f);
	}
    }

/* ---- initialize TN = Delta^2 Ue / vx */
    if (*inorm == 3) {
/* Computing 2nd power */
	r__1 = h__;
	tn = (h__ * 6.54f - 14.07f) / (r__1 * r__1);
    } else {
	tn = 1.f;
    }

/* ---- set eta array */
    deta = 1.f;
    eta[1] = 0.f;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	eta[i__] = eta[i__ - 1] + deta;
	deta = *geo * deta;
/* L5: */
    }

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	eta[i__] = eta[i__] * *etae / eta[*n];
/* L6: */
    }


/* ---- initial guess for profiles using a sine loop for U for half near wall */
    if (h__ <= 3.f) {

	if (*inorm == 3) {
	    etjoin = 7.3f;
	} else {
	    etjoin = 5.f;
	}

	efac = pi * .5f / etjoin;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    u[i__] = sin(efac * eta[i__]);
	    f[i__] = 1.f / efac * (1.f - cos(efac * eta[i__]));
	    s[i__] = efac * cos(efac * eta[i__]);
	    if (eta[i__] > etjoin) {
		goto L11;
	    }
/* L10: */
	}
L11:
	ijoin = i__;

/* ----- constant U for outer half */
	i__1 = *n;
	for (i__ = ijoin + 1; i__ <= i__1; ++i__) {
	    u[i__] = 1.f;
	    f[i__] = f[ijoin] + eta[i__] - eta[ijoin];
	    s[i__] = 0.f;
/* L12: */
	}

    } else {

	if (*inorm == 3) {
	    etjoin1 = 0.f;
	    etjoin2 = 8.f;
	    if (h__ > 4.f) {
		etjoin1 = h__ - 4.f;
		etjoin2 = etjoin1 + 8.f;
	    }
	} else {
	    etjoin1 = 0.f;
	    etjoin2 = 8.f;
	}

	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    u[i__] = 0.f;
	    s[i__] = 0.f;
	    f[i__] = 0.f;
	    if (eta[i__] >= etjoin1) {
		goto L14;
	    }
/* L13: */
	}
L14:
	ijoin = i__;

	efac = pi * .5f / (etjoin2 - etjoin1);
	i__1 = *n;
	for (i__ = ijoin + 1; i__ <= i__1; ++i__) {
	    ebar = eta[i__] - etjoin1;
	    u[i__] = .5f - cos(efac * 2.f * ebar) * .5f;
	    f[i__] = ebar * .5f - .25f / efac * sin(efac * 2.f * ebar);
	    s[i__] = efac * sin(efac * 2.f * ebar);
	    if (eta[i__] >= etjoin2) {
		goto L16;
	    }
/* L15: */
	}
L16:
	ijoin = i__;

/* ----- constant U for outer half */
	i__1 = *n;
	for (i__ = ijoin + 1; i__ <= i__1; ++i__) {
	    u[i__] = 1.f;
	    f[i__] = f[ijoin] + eta[i__] - eta[ijoin];
	    s[i__] = 0.f;
/* L17: */
	}

    }

/* L9991: */


/* ---- Newton iteration loop */
    i__1 = itmax;
    for (iter = 1; iter <= i__1; ++iter) {

/* ------ zero out A,B,C blocks and righthand sides R */
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    for (ii = 1; ii <= 3; ++ii) {
		for (iii = 1; iii <= 3; ++iii) {
		    a[ii + (iii + i__ * 3) * 3 - 13] = 0.f;
		    b[ii + (iii + i__ * 3) * 3 - 13] = 0.f;
		    c__[ii + (iii + i__ * 3) * 3 - 13] = 0.f;
/* L2001: */
		}
		r__[ii + (i__ * 3 + 1) * 3 - 13] = 0.f;
		r__[ii + (i__ * 3 + 2) * 3 - 13] = 0.f;
		r__[ii + (i__ * 3 + 3) * 3 - 13] = 0.f;
/* L201: */
	    }
/* L20: */
	}

/* ................................................... */

	a[0] = 1.f;
	a[4] = 1.f;
	a[(*n * 3 + 2) * 3 - 10] = 1.f;
	r__[0] = f[1];
	r__[1] = u[1];
	r__[(*n * 3 + 1) * 3 - 10] = u[*n] - 1.f;

	if (*inorm == 2) {
	    betu = bu * 2.f / (bu + 1.f);
	    betu_bu__ = (2.f - betu / (bu + 1.f)) / (bu + 1.f);
	    betn = 1.f;
	    betn_bu__ = 0.f;
	} else {
	    betu = bu;
	    betu_bu__ = 1.f;
	    betn = (bu + 1.f) * .5f;
	    betn_bu__ = .5f;
	}

	i__2 = *n - 1;
	for (i__ = 1; i__ <= i__2; ++i__) {

	    deta = eta[i__ + 1] - eta[i__];
	    r__[((i__ + 1) * 3 + 1) * 3 - 12] = f[i__ + 1] - f[i__] - deta * 
		    .5f * (u[i__ + 1] + u[i__]);
	    r__[((i__ + 1) * 3 + 1) * 3 - 11] = u[i__ + 1] - u[i__] - deta * 
		    .5f * (s[i__ + 1] + s[i__]);
/* Computing 2nd power */
	    r__1 = u[i__ + 1];
/* Computing 2nd power */
	    r__2 = u[i__];
	    r__[(i__ * 3 + 1) * 3 - 10] = s[i__ + 1] - s[i__] + tn * (betn * 
		    deta * .5f * (f[i__ + 1] * s[i__ + 1] + f[i__] * s[i__]) 
		    + betu * deta * (1.f - (r__1 * r__1 + r__2 * r__2) * .5f))
		    ;

	    a[(i__ * 3 + 1) * 3 - 10] = tn * betn * .5f * deta * s[i__];
	    c__[(i__ * 3 + 1) * 3 - 10] = tn * betn * .5f * deta * s[i__ + 1];
	    a[(i__ * 3 + 2) * 3 - 10] = -tn * betu * deta * u[i__];
	    c__[(i__ * 3 + 2) * 3 - 10] = -tn * betu * deta * u[i__ + 1];
	    a[(i__ * 3 + 3) * 3 - 10] = tn * betn * .5f * deta * f[i__] - 1.f;
	    c__[(i__ * 3 + 3) * 3 - 10] = tn * betn * .5f * deta * f[i__ + 1] 
		    + 1.f;

	    b[((i__ + 1) * 3 + 1) * 3 - 12] = -1.f;
	    a[((i__ + 1) * 3 + 1) * 3 - 12] = 1.f;
	    b[((i__ + 1) * 3 + 2) * 3 - 12] = deta * -.5f;
	    a[((i__ + 1) * 3 + 2) * 3 - 12] = deta * -.5f;

	    b[((i__ + 1) * 3 + 2) * 3 - 11] = -1.f;
	    a[((i__ + 1) * 3 + 2) * 3 - 11] = 1.f;
	    b[((i__ + 1) * 3 + 3) * 3 - 11] = deta * -.5f;
	    a[((i__ + 1) * 3 + 3) * 3 - 11] = deta * -.5f;

/* Computing 2nd power */
	    r__1 = u[i__ + 1];
/* Computing 2nd power */
	    r__2 = u[i__];
	    r__[(i__ * 3 + 2) * 3 - 10] = tn * (betn_bu__ * deta * .5f * (f[
		    i__ + 1] * s[i__ + 1] + f[i__] * s[i__]) + betu_bu__ * 
		    deta * (1.f - (r__1 * r__1 + r__2 * r__2) * .5f));
/* Computing 2nd power */
	    r__1 = u[i__ + 1];
/* Computing 2nd power */
	    r__2 = u[i__];
	    r__[(i__ * 3 + 3) * 3 - 10] = betn * deta * .5f * (f[i__ + 1] * s[
		    i__ + 1] + f[i__] * s[i__]) + betu * deta * (1.f - (r__1 *
		     r__1 + r__2 * r__2) * .5f);

/* L30: */
	}
/* ........................................................... */


/* ---- solve Newton system for the three solution vectors */
	b3solv_(a, b, c__, r__, n, &nrhs, &c__3);


/* ---- calculate and linearize Dstar, Theta, in computational space */
	dsi = 0.f;
	dsi1 = 0.f;
	dsi2 = 0.f;
	dsi3 = 0.f;

	thi = 0.f;
	thi1 = 0.f;
	thi2 = 0.f;
	thi3 = 0.f;

	i__2 = *n - 1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    us = u[i__] + u[i__ + 1];
	    deta = eta[i__ + 1] - eta[i__];

	    dsi += (1.f - us * .5f) * deta;
	    dsi_us__ = deta * -.5f;

	    thi += (1.f - us * .5f) * .5f * us * deta;
	    thi_us__ = (.5f - us * .5f) * deta;

	    dsi1 += dsi_us__ * (r__[(i__ * 3 + 1) * 3 - 11] + r__[((i__ + 1) *
		     3 + 1) * 3 - 11]);
	    dsi2 += dsi_us__ * (r__[(i__ * 3 + 2) * 3 - 11] + r__[((i__ + 1) *
		     3 + 2) * 3 - 11]);
	    dsi3 += dsi_us__ * (r__[(i__ * 3 + 3) * 3 - 11] + r__[((i__ + 1) *
		     3 + 3) * 3 - 11]);

	    thi1 += thi_us__ * (r__[(i__ * 3 + 1) * 3 - 11] + r__[((i__ + 1) *
		     3 + 1) * 3 - 11]);
	    thi2 += thi_us__ * (r__[(i__ * 3 + 2) * 3 - 11] + r__[((i__ + 1) *
		     3 + 2) * 3 - 11]);
	    thi3 += thi_us__ * (r__[(i__ * 3 + 3) * 3 - 11] + r__[((i__ + 1) *
		     3 + 3) * 3 - 11]);
/* L40: */
	}


	if (*ispec == 1) {

/* ----- set and linearize  Bu = Bspec  residual */
	    r1 = *bspec - bu;
	    q11 = 1.f;
	    q12 = 0.f;

	} else {

/* ----- set and linearize  H = Hspec  residual */
	    r1 = dsi - *hspec * thi - dsi1 + *hspec * thi1;
	    q11 = -dsi2 + *hspec * thi2;
	    q12 = -dsi3 + *hspec * thi3;

	}


	if (*inorm == 3) {

/* ----- set and linearize  normalized Theta = 1  residual */
	    r2 = thi - 1.f - thi1;
	    q21 = -thi2;
	    q22 = -thi3;

	} else {

/* ----- set eta scaling coefficient to unity */
	    r2 = 1.f - tn;
	    q21 = 0.f;
	    q22 = 1.f;

	}


	det = q11 * q22 - q12 * q21;
	dbu = -(r1 * q22 - q12 * r2) / det;
	dtn = -(q11 * r2 - r1 * q21) / det;


/* ---- calculate changes in F,U,S, and the max and rms change */
	rmax = 0.f;
	rms = 0.f;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    df = -r__[(i__ * 3 + 1) * 3 - 12] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    12] - dtn * r__[(i__ * 3 + 3) * 3 - 12];
	    du = -r__[(i__ * 3 + 1) * 3 - 11] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    11] - dtn * r__[(i__ * 3 + 3) * 3 - 11];
	    ds = -r__[(i__ * 3 + 1) * 3 - 10] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    10] - dtn * r__[(i__ * 3 + 3) * 3 - 10];

/* Computing MAX */
	    r__1 = rmax, r__2 = dabs(df), r__1 = max(r__1,r__2), r__2 = dabs(
		    du), r__1 = max(r__1,r__2), r__2 = dabs(ds);
	    rmax = dmax(r__1,r__2);
/* Computing 2nd power */
	    r__1 = df;
/* Computing 2nd power */
	    r__2 = du;
/* Computing 2nd power */
	    r__3 = ds;
	    rms = r__1 * r__1 + r__2 * r__2 + r__3 * r__3 + rms;
/* L50: */
	}
	rms = sqrt(rms / ((real) (*n) * 3.f + 3.f));

/* Computing MAX */
	r__3 = rmax, r__4 = (r__1 = dbu / .5f, dabs(r__1)), r__3 = max(r__3,
		r__4), r__4 = (r__2 = dtn / tn, dabs(r__2));
	rmax = dmax(r__3,r__4);

/* ---- set underrelaxation factor if necessary by limiting max change to 0.5 */
	rlx = 1.f;
	if (rmax > .5f) {
	    rlx = .5f / rmax;
	}

/* ---- update F,U,S */
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    df = -r__[(i__ * 3 + 1) * 3 - 12] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    12] - dtn * r__[(i__ * 3 + 3) * 3 - 12];
	    du = -r__[(i__ * 3 + 1) * 3 - 11] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    11] - dtn * r__[(i__ * 3 + 3) * 3 - 11];
	    ds = -r__[(i__ * 3 + 1) * 3 - 10] - dbu * r__[(i__ * 3 + 2) * 3 - 
		    10] - dtn * r__[(i__ * 3 + 3) * 3 - 10];

	    f[i__] += rlx * df;
	    u[i__] += rlx * du;
	    s[i__] += rlx * ds;
/* L60: */
	}

/* ---- update BetaU and Theta */
	bu += rlx * dbu;
	tn += rlx * dtn;

/* ---- check for convergence */
	if (iter > 3 && rms < 1e-5f) {
	    goto L105;
	}

/* L100: */
    }
    s_wsle(&io___225);
    do_lio(&c__9, &c__1, "FS: Convergence failed", (ftnlen)22);
    e_wsle();

L105:

    *hspec = dsi / thi;
    *bspec = bu;

    *delta = sqrt(tn);

    return 0;

/*     The */
} /* fs_ */

/* Subroutine */ int b3solv_(real *a, real *b, real *c__, real *r__, int *
	n, int *nrhs, int *nrmax)
{
    /* System generated locals */
    int r_dim2, r_offset, i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    int s_wsle(cilist *), do_lio(int *, int *, char *, ftnlen), 
	    e_wsle(void);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static int i__, k, l, im, ip, kx, kp1;
    static real temp;
    static int kpiv;
    static real pivot;

    /* Fortran I/O blocks */
    static cilist io___233 = { 0, 6, 0, 0, 0 };
    static cilist io___236 = { 0, 6, 0, 0, 0 };


/*     ********************************************************************** */
/*      This routine solves a 3x3 block-tridiagonal system with an arbitrary */
/*      number of righthand sides by a standard block elimination scheme. */
/*      The solutions are returned in the Rj vectors. */

/*      |A C      ||d|   |R..| */
/*      |B A C    ||d|   |R..| */
/*      |  B . .  ||.| = |R..| */
/*      |    . . C||.|   |R..| */
/*      |      B A||d|   |R..| */
/*                                                  Mark Drela   10 March 86 */
/*     ********************************************************************** */

/* CC** Forward sweep: Elimination of lower block diagonal (B's). */
    /* Parameter adjustments */
    c__ -= 13;
    b -= 13;
    a -= 13;
    r_dim2 = *nrmax;
    r_offset = 1 + 3 * (1 + r_dim2);
    r__ -= r_offset;

    /* Function Body */
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {

	im = i__ - 1;

/* ------ don't eliminate B1 block because it doesn't exist */
	if (i__ == 1) {
	    goto L12;
	}

/* ------ eliminate Bi block, thus modifying Ai and Ci blocks */
	for (k = 1; k <= 3; ++k) {
	    for (l = 1; l <= 3; ++l) {
		a[k + (l + i__ * 3) * 3] -= b[k + (i__ * 3 + 1) * 3] * c__[(l 
			+ im * 3) * 3 + 1] + b[k + (i__ * 3 + 2) * 3] * c__[(
			l + im * 3) * 3 + 2] + b[k + (i__ * 3 + 3) * 3] * c__[
			(l + im * 3) * 3 + 3];
/* L111: */
	    }
	    i__2 = *nrhs;
	    for (l = 1; l <= i__2; ++l) {
		r__[k + (l + i__ * r_dim2) * 3] -= b[k + (i__ * 3 + 1) * 3] * 
			r__[(l + im * r_dim2) * 3 + 1] + b[k + (i__ * 3 + 2) *
			 3] * r__[(l + im * r_dim2) * 3 + 2] + b[k + (i__ * 3 
			+ 3) * 3] * r__[(l + im * r_dim2) * 3 + 3];
/* L112: */
	    }
/* L11: */
	}

/*                                                              -1 */
/* CC---- multiply Ci block and righthand side Ri vectors by (Ai) */
/*       using Gaussian elimination. */

L12:
	for (kpiv = 1; kpiv <= 2; ++kpiv) {
	    kp1 = kpiv + 1;

/* -------- find max pivot index KX */
	    kx = kpiv;
	    for (k = kp1; k <= 3; ++k) {
		if ((r__1 = a[k + (kpiv + i__ * 3) * 3], dabs(r__1)) <= (r__2 
			= a[kx + (kpiv + i__ * 3) * 3], dabs(r__2))) {
		    goto L131;
		} else {
		    goto L1311;
		}
L1311:
		kx = k;
L131:
		;
	    }

	    if (a[kx + (kpiv + i__ * 3) * 3] == 0.f) {
		s_wsle(&io___233);
		do_lio(&c__9, &c__1, "Singular A block, i = ", (ftnlen)22);
		do_lio(&c__3, &c__1, (char *)&i__, (ftnlen)sizeof(integer));
		e_wsle();
		s_stop("", (ftnlen)0);
	    }

	    pivot = 1.f / a[kx + (kpiv + i__ * 3) * 3];

/* -------- switch pivots */
	    a[kx + (kpiv + i__ * 3) * 3] = a[kpiv + (kpiv + i__ * 3) * 3];

/* -------- switch rows & normalize pivot row */
	    for (l = kp1; l <= 3; ++l) {
		temp = a[kx + (l + i__ * 3) * 3] * pivot;
		a[kx + (l + i__ * 3) * 3] = a[kpiv + (l + i__ * 3) * 3];
		a[kpiv + (l + i__ * 3) * 3] = temp;
/* L132: */
	    }

	    for (l = 1; l <= 3; ++l) {
		temp = c__[kx + (l + i__ * 3) * 3] * pivot;
		c__[kx + (l + i__ * 3) * 3] = c__[kpiv + (l + i__ * 3) * 3];
		c__[kpiv + (l + i__ * 3) * 3] = temp;
/* L133: */
	    }

	    i__2 = *nrhs;
	    for (l = 1; l <= i__2; ++l) {
		temp = r__[kx + (l + i__ * r_dim2) * 3] * pivot;
		r__[kx + (l + i__ * r_dim2) * 3] = r__[kpiv + (l + i__ * 
			r_dim2) * 3];
		r__[kpiv + (l + i__ * r_dim2) * 3] = temp;
/* L134: */
	    }
/* B */
/* -------- forward eliminate everything */
	    for (k = kp1; k <= 3; ++k) {
		for (l = kp1; l <= 3; ++l) {
		    a[k + (l + i__ * 3) * 3] -= a[k + (kpiv + i__ * 3) * 3] * 
			    a[kpiv + (l + i__ * 3) * 3];
/* L1351: */
		}
		c__[k + (i__ * 3 + 1) * 3] -= a[k + (kpiv + i__ * 3) * 3] * 
			c__[kpiv + (i__ * 3 + 1) * 3];
		c__[k + (i__ * 3 + 2) * 3] -= a[k + (kpiv + i__ * 3) * 3] * 
			c__[kpiv + (i__ * 3 + 2) * 3];
		c__[k + (i__ * 3 + 3) * 3] -= a[k + (kpiv + i__ * 3) * 3] * 
			c__[kpiv + (i__ * 3 + 3) * 3];
		i__2 = *nrhs;
		for (l = 1; l <= i__2; ++l) {
		    r__[k + (l + i__ * r_dim2) * 3] -= a[k + (kpiv + i__ * 3) 
			    * 3] * r__[kpiv + (l + i__ * r_dim2) * 3];
/* L1352: */
		}
/* L135: */
	    }

/* L13: */
	}

/* ------ solve for last row */
	if (a[(i__ * 3 + 3) * 3 + 3] == 0.f) {
	    s_wsle(&io___236);
	    do_lio(&c__9, &c__1, "Singular A block, i = ", (ftnlen)22);
	    do_lio(&c__3, &c__1, (char *)&i__, (ftnlen)sizeof(integer));
	    e_wsle();
	    s_stop("", (ftnlen)0);
	}
	pivot = 1.f / a[(i__ * 3 + 3) * 3 + 3];
	c__[(i__ * 3 + 1) * 3 + 3] *= pivot;
	c__[(i__ * 3 + 2) * 3 + 3] *= pivot;
	c__[(i__ * 3 + 3) * 3 + 3] *= pivot;
	i__2 = *nrhs;
	for (l = 1; l <= i__2; ++l) {
	    r__[(l + i__ * r_dim2) * 3 + 3] *= pivot;
/* L14: */
	}

/* ------ back substitute everything */
	for (kpiv = 2; kpiv >= 1; --kpiv) {
	    kp1 = kpiv + 1;
	    for (k = kp1; k <= 3; ++k) {
		c__[kpiv + (i__ * 3 + 1) * 3] -= a[kpiv + (k + i__ * 3) * 3] *
			 c__[k + (i__ * 3 + 1) * 3];
		c__[kpiv + (i__ * 3 + 2) * 3] -= a[kpiv + (k + i__ * 3) * 3] *
			 c__[k + (i__ * 3 + 2) * 3];
		c__[kpiv + (i__ * 3 + 3) * 3] -= a[kpiv + (k + i__ * 3) * 3] *
			 c__[k + (i__ * 3 + 3) * 3];
		i__2 = *nrhs;
		for (l = 1; l <= i__2; ++l) {
		    r__[kpiv + (l + i__ * r_dim2) * 3] -= a[kpiv + (k + i__ * 
			    3) * 3] * r__[k + (l + i__ * r_dim2) * 3];
/* L1511: */
		}
/* L151: */
	    }
/* L15: */
	}
/* L1: */
    }

/* CC** Backward sweep: Back substitution using upper block diagonal (Ci's). */
    for (i__ = *n - 1; i__ >= 1; --i__) {
	ip = i__ + 1;
	i__1 = *nrhs;
	for (l = 1; l <= i__1; ++l) {
	    for (k = 1; k <= 3; ++k) {
		r__[k + (l + i__ * r_dim2) * 3] -= r__[(l + ip * r_dim2) * 3 
			+ 1] * c__[k + (i__ * 3 + 1) * 3] + r__[(l + ip * 
			r_dim2) * 3 + 2] * c__[k + (i__ * 3 + 2) * 3] + r__[(
			l + ip * r_dim2) * 3 + 3] * c__[k + (i__ * 3 + 3) * 3]
			;
/* L211: */
	    }
/* L21: */
	}
/* L2: */
    }

    return 0;
} /* b3solv_ */
